#include <bits/stdc++.h>

#define int long long

using namespace std;

int k;

vector<int> good;

vector<int> cur;

set<pair<int, int>> pairs;

void foo() {
    if (cur.size() == good.size()) {
        int fi = 0, se = 0;
        for (int i = 0; i < good.size(); ++i) {
            if (cur[i] == 0) {
                fi += good[i];
            } else if (cur[i] == 1) {
                se += good[i];
            }
        }
        pairs.insert({fi, se});
        return;
    }

    for (int i = 0; i < 3; ++i) {
        cur.push_back(i);
        foo();
        cur.pop_back();
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (auto &i: w) {
        cin >> i;
    }
    int z;
    cin >> z;
    if (n <= 10 && q <= 10) {
        while (q--) {
            int a, b;
            cin >> k >> a >> b;
            good.clear();
            for (int i = 0; i < n; ++i) {
                if (w[i] <= k) {
                    good.push_back(w[i]);
                }
            }
            pairs.clear();
            foo();
            bool ok = true;
            for (int x = 0; x <= a; ++x) {
                for (int y = 0; y <= b; ++y) {
                    if (!pairs.count({x, y})) {
                        ok = false;
                        break;
                    }
                }
                if (!ok) {
                    break;
                }
            }
            if (ok) {
                cout << "Yes" << '\n';
            } else {
                cout << "No" << '\n';
            }
        }
    } else {
        sort(w.begin(), w.end());
        vector<tuple<int, int, int>> req(q);

        int A = 0;
        int B = 0;
        for (int i = 0; i < q; ++i) {
            cin >> get<0>(req[i]) >> get<1>(req[i]) >> get<2>(req[i]);
            A = max(A, get<1>(req[i]));
            B = max(B, get<2>(req[i]));
        }
        A += 1;
        B += 1;
        if (B == 1) {
            vector<vector<bool>> dp(n + 1, vector<bool> (A));
            dp[0][0] = true;
            for (int i = 1; i <= n; ++i) {
                for (int j = 0; j <= A; ++j) {
                    dp[i][j] = dp[i - 1][j];
                    if (j - w[i - 1] >= 0 && dp[i - 1][j - w[i - 1]]) {
                        dp[i][j] = 1;
                    }
                }
            }

            int i = 0;
            while (i + 1 <= A) {
                if (dp.back()[i + 1]) {
                    i += 1;
                } else {
                    break;
                }
            }

            for (auto [k, a, b]: req) {
                if (a > i) {
                    cout << "No" << '\n';
                } else {
                    cout << "Yes" << '\n';
                }
            }
        } else {
            vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(A, vector<bool>(B)));
            dp[0][0][0] = 1;
            for (int i = 1; i <= n; ++i) {
                for (int j = 0; j < A; ++j) {
                    for (int l = 0; l < B; ++l) {
                        if (dp[i - 1][j][l]) {
                            dp[i][j][l] = 1;
                        }
                        if (j - w[i - 1] >= 0 && dp[i - 1][j - w[i - 1]][l]) {
                            dp[i][j][l] = 1;
                        }
                        if (l - w[i - 1] >= 0 && dp[i - 1][j][l - w[i - 1]]) {
                            dp[i][j][l] = 1;
                        }
                    }
                }
            }


            vector<vector<vector<bool>>> ok(n, vector<vector<bool>>(A, vector<bool>(B)));
            for (int c = 0; c < n; ++c) {
                for (int i = 0; i < A; ++i) {
                    for (int j = 0; j < B; ++j) {
                        bool now = true;
                        if (i - 1 >= 0) {
                            now &= ok[c][i - 1][j];
                        }
                        if (j - 1 >= 0) {
                            now &= ok[c][i][j - 1];
                        }
                        now &= dp[c + 1][i][j];
                        ok[c][i][j] = now;
                    }
                }
            }


            for (auto [k, a, b]: req) {
                int j = distance(w.begin(), upper_bound(w.begin(), w.end(), k));
                if (j == 0) {
                    if (a == 0 && b == 0) {
                        cout << "Yes" << '\n';
                    } else {
                        cout << "No" << '\n';
                    }
                } else {
                    cout << (ok[j - 1][a][b] ? "Yes" : "No") << '\n';
                }
            }
        }
    }

}

int32_t main() {
#ifdef DDD
    freopen("../input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif

    solve();

    return 0;
}
