#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }
#define all(a) a.begin(), a.end()
const long long INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

ll n, k;
vector<ll> dp;
vector<vector<ll>> g;

void dfslist(ll v, ll nap, ll kolv) {
	if (g[v].size() == 0) {
		dp[v] = (kolv <= k);
		return;
	}
	dfslist(g[v][0], 0, kolv + (nap != 0 && nap != -1));
	dfslist(g[v][1], 1, kolv + (nap != 1 && nap != -1));
	dp[v] = dp[g[v][0]] + dp[g[v][1]];
}

int main() {
	fastio();
	ll q;
	cin >> n >> k >> q;
	dp.resize(n, 0);
	g.resize(n);
	for (ll i = 0; i < n; i++) {
		ll t;
		cin >> t;
		g[i].resize(t);
		for (ll j = 0; j < t; j++) {
			cin >> g[i][j];
			g[i][j]--;
		}
	}
	dfslist(0, -1, 0);
	while (q--) {
		ll v;
		cin >> v;
		cout << dp[v - 1] << "\n";
	}
	return 0;
}