#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int h, w, n;
    cin >> h >> w >> n;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        --x[i];
        --y[i];
    }
    auto solve = [&](vector<int> v, int mod) -> pair<int, int> {
        sort(v.begin(), v.end());
        int ans1 = v[n - 1] - v[0], ans2 = 0;
        auto v1 = v;
        for (int i = 0; i < n; ++i) {
            v1.push_back(v[i] + mod);
        }
        for (int i = 0; i < n; ++i) {
//            int st = lower_bound(v1.begin(), v1.end(), dx) - v1.begin();
//            int en = lower_bound(v1.begin(), v1.end(), dx + mod) - v1.begin() - 1;
            int dx = (i == 0 ? 0 : v[i - 1] + 1);
            int cur = v1[i + n - 1] - v1[i];
            if (cur < ans1 || (cur == ans1 && dx < ans2)) {
                ans1 = cur;
                ans2 = dx;
            }
        }
        vector<int> v2;
        for (int i = 0; i < n; ++i) {
            v2.push_back(v[i]);
            v2.push_back(v[i] - mod);
        }
        sort(v2.begin(), v2.end());
        for (int dx = mod - 1; dx >= 0; --dx) {
            int en = lower_bound(v2.begin(), v2.end(), dx) - v2.begin() - 1;
            int st = lower_bound(v2.begin(), v2.end(), dx - mod) - v2.begin();
            int cur = v2[en] - v2[st];
            if (cur < ans1 || (cur == ans1 && mod - dx < ans2)) {
                ans1 = cur;
                ans2 = mod - dx;
            }
        }
        return {ans1, ans2};
    };
    auto [s1, cnt1] = solve(x, h);
    auto [s2, cnt2] = solve(y, w);
    cout << (s1 + 1) * (s2 + 1) << " " << cnt1 + cnt2 << "\n";
}
