#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
#define int int64_t
#define double long double
#define MULTITASK
#define NO_INTERACTIVE
using namespace std;
using namespace __gnu_pbds;
void solve1();
void solve2();
int32_t main() {
#ifdef NO_INTERACTIVE
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
#ifdef BIBIKOV
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
#endif
    int tp;
    cin >> tp;
    int tt;
    cin >> tt;
    while (tt--) {
        if (tp == 1)
            solve1();
        else
            solve2();
        cout << endl;
    }
}

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> f(2);
    int &a = f[0], &b = f[1];
    cin >> a >> b;
    if (a + 1 == b)
        a = (a + 1) % n + 1, b =  (b + 1) % n + 1;
    else
        a = a % n + 1, b = b % n + 1;
    sort(f.begin(), f.end());
    for (int i : f)
        cout << i << ' ';
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector<int> f(2);
    int &a = f[0], &b = f[1];
    cin >> a >> b;
    if (a + 1 == b)
        a = (a + 2 * n - 3) % n + 1, b = (b + 2 * n - 3) % n + 1;
    else
        a = (a + n - 2) % n + 1, b = (b + n - 2) % n + 1;
    sort(f.begin(), f.end());
    for (int i : f)
        cout << i << ' ';
}