#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(),(x).end()

using pii = pair<int, int>;
using ll = long long;
const int MAXN = 5000 + 5;
const int MAXQ = 3e5 + 5;
const int MAXA = 5000 + 1;
const ll inf = 1e18;
string ans[MAXQ];
vector<pair<pii, int>> ask[MAXN];
ll w[MAXN], dp[2][MAXA];
ll mx[MAXA];

void solve() {
    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    sort(w, w + n);

    ll z;
    cin >> z;

    for (int i = 0; i < q; i++) {
        ll k, ai, bi;
        cin >> k >> ai >> bi;
        int ind = (upper_bound(w, w + n, k) - w);
        ask[ind].push_back({{ai, bi}, i});
    }

    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < MAXA; j++) {
            dp[i][j] = -inf;
        }
    }

    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        int cur = i & 1;
        int nxt = cur ^ 1;
        fill(dp[nxt], dp[nxt] + MAXA, -inf);
        mx[0] = dp[cur][0];
        for (int j = 1; j < MAXA; j++)mx[j] = min(dp[cur][j], mx[j - 1]);
        for (auto [sk, _]: ask[i]) {
            ans[_] = (mx[sk.first] >= sk.second ? "Yes" : "No");
        }
        for (int a = 0; a < MAXA; a++) {
            dp[nxt][a] = max(dp[nxt][a], dp[cur][a]);
            if (a + w[i] < MAXA)dp[nxt][a + w[i]] = max(dp[nxt][a + w[i]], dp[cur][a]);
            if (dp[cur][a] >= w[i] - 1)dp[nxt][a] = max(dp[nxt][a], dp[cur][a] + w[i]);
        }
    }

    for (int i = 0; i < q; i++) {
        cout << ans[i] << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
    while (t--)
        solve();
    return 0;
}