#include <bits/stdc++.h>

using namespace std;
const int MAXN = 10000 + 10;
int dp[MAXN][MAXN];

inline int get_ans(int n, vector <int>& a) {
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            dp[i][j] = 0;
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = n - 1; j >= 0; --j) {
            dp[i][j] = max(dp[i][j + 1], dp[i + 1][j]);
            if (a[i] >= j) dp[i][j] = max(dp[i + 1][a[i]] + 1, dp[i][j]);
        }
    }
    vector <int> dp2(n), mn(n + 1, n + 1);
    mn[0] = -1;
    for (int i = n - 1; i >= 0; --i) {
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (mn[m] < a[i]) l = m;
            else r = m;
        }
        dp2[i] = l + 1;
        mn[l + 1] = a[i];
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int cur = 0, cur_mx = -1, cur_mn = n + 1;
        for (int j = 0; j <= i; ++j) {
            if (a[j] <= a[i]) {
                if (a[j] > cur_mx) {
                    cur_mx = a[j];
                    cur++;
                }
            } else {
                if (a[j] < cur_mn) {
                    cur_mn = a[j];
                    cur++;
                }
            }
        }
        ans = max(ans, cur);
        for (int j = i + 1; j < n; ++j) {
            if (a[j] < a[i]) {
                ans = max(ans, cur + dp2[j] + dp[j + 1][a[i]]);
            }
            if (a[j] > a[i]) {
                if (a[j] < cur_mn) {
                    cur++;
                    cur_mn = a[j];
                }
            }
        }
    }
    return ans;
}

inline void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; --a[i];
    }
    int ans = get_ans(n, a);
    for (int i = 0; i < n; ++i) {
        a[i] = n - a[i] - 1;
    }
    cout << max(ans, get_ans(n, a)) << "\n";
}


signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    if (1) {
        int t = 1;
        cin >> t;
        while (t--) {
            solve();
        }
    }
    return 0;
}
