#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int h, w, k;
	cin >> h >> w >> k;
	set<int> not_empty_str, not_empty_stolb;
	for (int _ = 0; _ < k; ++_) {
		int r, c;
		cin >> r >> c;
		not_empty_str.insert(r);
		not_empty_stolb.insert(c);
	}
	long long min_y = (*prev(not_empty_str.end())) - (*not_empty_str.begin()) + 1;
	int min_cnt = 0;
	for (int i : not_empty_str) {
		if (i == *prev(not_empty_str.end())) continue;
		int cur_y = h - (*next(not_empty_str.find(i)) - i) + 1;
		int cur_cnt = min(i, h - i);
		if (cur_y < min_y || (cur_y == min_y && cur_cnt < min_cnt)) {
			min_y = cur_y;
			min_cnt = cur_cnt;
		}
	}
	long long min_x = (*prev(not_empty_stolb.end())) - (*not_empty_stolb.begin()) + 1;
	int min_cnt2 = 0;
	for (int i : not_empty_stolb) {
		if (i == *prev(not_empty_stolb.end())) continue;
		int cur_x = w - (*next(not_empty_stolb.find(i)) - i) + 1;
		int cur_cnt = min(i, w - i);
		if (cur_x < min_x || (cur_x == min_x && cur_cnt < min_cnt2)) {
			min_x = cur_x;
			min_cnt2 = cur_cnt;
		}
	}
	cout << min_x * min_y << " " << min_cnt + min_cnt2;

	return 0;
}