#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

struct event {
	int l, r, i;
};
bool comp(event a, event b) {
	if (a.r == b.r && a.l == b.l) return a.i < b.i;
	else if (a.r == b.r) return a.l > b.r;
	return (a.r < b.r);
}
vector<int> used;
vector<event> mas;
int check() {
	int m = 0;
	int prevt = 0;
	for (int i = 0; i < mas.size(); ++i) {
		if (used[i] && prevt < mas[i].l) {
			m++;
			prevt = mas[i].r;
		}
	}
	return m;
}
bool flag = false;
void my_gen(int i, int cnt_ost, int n, int m) {
	if (flag) return;
	if (n - i < cnt_ost) return;
	if (cnt_ost < 0) return;
	if (i == n) {
		if (cnt_ost == 0) {
			if (check() == m / 2) {
				for (int i = 0; i < n; ++i) {
					if (used[i]) {
						cout << mas[i].i + 1 << " ";
					}
				}
				cout << "\n";
				flag = true;
			}
		}
		return;
	}
	used[i] = 0;
	my_gen(i + 1, cnt_ost, n, m);
	used[i] = 1;
	my_gen(i + 1, cnt_ost - 1, n, m);
	used[i] = 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n;
		cin >> n;
		mas.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> mas[i].l >> mas[i].r;
			mas[i].i = i;
		}
		sort(mas.begin(), mas.end(), comp);
		int m = 0;
		int prevt = 0;
		for (int i = 0; i < n; ++i) {
			if (prevt < mas[i].l) {
				m++;
				prevt = mas[i].r;
			}
		}
		used.resize(n, 0);
		flag = false;
		my_gen(0, n / 2, n, m);
	}

	return 0;
}