#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
typedef long long ll;

vector<int> used;
vector<ll> w;
set<pair<ll, ll>> mas;
void my_gen(int i, ll k) {
	if (i == used.size()) {
		ll cur1 = 0, cur2 = 0;
		for (int j = 0; j < used.size(); ++j) {
			if (w[j] > k) continue;
			if (used[j] == 1) cur1 += w[j];
			else if (used[j] == 2) cur2 += w[j];
		}
		mas.insert({ cur1, cur2 });
		return;
	}
	used[i] = 0;
	my_gen(i + 1, k);
	used[i] = 1;
	my_gen(i + 1, k);
	used[i] = 2;
	my_gen(i + 1, k);
	used[i] = 0;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	w.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> w[i];
	ll z; cin >> z; 
	ll v = 0;
	for (int _ = 0; _ < q; ++_) {
		ll j, c, d;
		cin >> j >> c >> d;
		ll k = j - v * z;
		ll a = c - v * z;
		ll b = d - v * z;
		used.assign(n, 0);
		mas.clear();
		my_gen(0, k);
		bool flag = true;
		for (ll i = 0; i <= a; ++i) {
			for (ll j = 0; j <= b; ++j) {
				if (mas.find({ i, j }) == mas.end()) {
					cout << "No\n";
					flag = false;
					break;
				}
			}
			if (!flag) break;
		}
		if (flag) {
			cout << "Yes\n";
			v++;
		}
	}

	return 0;
}