#include <bits\stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    int z;
    cin >> z;
    vector<vector<int>> s(301, vector<int>(301));
    s[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        ll v = w[i];
        for (int x = 300; x >= 0; --x) {
            for (int y = 300; y >= 0; --y) {
                if (s[x][y] == 1) {
                    if (x + v <= 300) s[x + v][y] = 1;
                    if (y + v <= 300) s[x][y + v] = 1;
                }
            }
        }
    }
    for (int y = 1; y <= 300; ++y) {
        s[0][y] += s[0][y - 1];
    }
    for (int x = 1; x <= 300; ++x) {
        s[x][0] += s[x - 1][0];
    }
    for (int x = 1; x <= 300; ++x) {
        for (int y = 1; y <= 300; ++y) {
            s[x][y] += s[x - 1][y] + s[x][y - 1] - s[x - 1][y - 1];
        }
    }
    while (q--) {
        ll k, a, b;
        cin >> k >> a >> b;
        if (s[a][b] == (a + 1) * (b + 1)) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
