#include <iostream>
#include <deque>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;

ll inf = 1e9;

#define mod(a, m) ((a%m)+m)%m

ll mods(ll a, ll m)
{
	a %= m;
	if (!a) a = m;
	return a;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll a, m;
	cin >> a >> m;
	for (int i = 0; i < m; i++)
	{
		ll n, k, x1, x2;
		cin >> n >> k;
		
		if (a == 1)
		{
			vector<ll> v(k), a(k), ans(k), dpv;
			map<ll, ll> mp;
			set<ll> st; // not used
			set<ll> ste, stt; // exist in v
			queue<ll> q;
			for (int i = 0; i < k; i++)
			{
				cin >> v[i];
				st.insert(i + 1);
				ste.insert(v[i]);
			}
			a = v;
			sort(v.begin(), v.end());
			ll cur = 1, all = 1;
			q.push(v[0]);
			for (int i = v[0]+1; i <= n || cur; i++)
			{
				i %= n;
				if (i == 0) i = n;
				if (all >= k && cur <= 0)
					break;
				if (cur == 0 && all < k)
				{
					i = v[all];
					cur++;
					q.push(v[all]);
					all++;
				}
				else if (ste.find(i) != ste.end())
				{
					if (stt.find(i) != stt.end())
						continue;
					q.push(v[all]);
					cur++, all++;
				}
				else if (cur > 0 && st.find(i) == st.end())
				{
					st.insert(i);
					stt.insert(q.front());
					q.pop();
					cur--;
				}
			}
			for (int i = 0; i < k; i++)
			{
				st.erase(v[i]);
			}
			for (int i = 0; i < k; i++)
			{
				auto dp = st.upper_bound(v[i]);
				if (dp == st.end())
					dp = st.begin();
				dpv.push_back(*dp);
				mp[v[i]] = i;
				st.erase(dp);
			}
			sort(dpv.begin(), dpv.end());
			for (int i = 0; i < k; i++)
			{
				ans[i] = dpv[mp[a[i]]];
			}
			for (int i = 0; i < k; i++)
			{
				cout << ans[i] << " ";
			}
		}
		else
		{
			vector<ll> v(k), a(k), ans(k), dpv;
			map<ll, ll> mp;
			set<ll> st, ste, stt; // not used
			queue<ll> q;
			for (int i = 0; i < k; i++)
			{
				cin >> v[i];
				ste.insert(v[i]);
			}
			a = v;
			sort(v.begin(), v.end());
			ll cur = 1, all = 1;
			q.push(v[k - 1]);
			for (int i = v[k-1] - 1; i > 0 || cur; i--)
			{
				i = ((i % n) + n) % n;
				if (i == 0) i = n;
				if (all >= k && cur <= 0)
					break;
				if (cur == 0 && all < k)
				{
					i = v[k-all-1];
					cur++;
					q.push(v[k-all-1]);
					all++;
				}
				else if (ste.find(i) != ste.end())
				{
					if (stt.find(i) != stt.end())
						continue;
					q.push(v[k-all-1]);
					cur++, all++;
				}
				else if (cur > 0 && st.find(-i)==st.end())
				{
					st.insert(-i);
					stt.insert(q.front());
					q.pop();
					cur--;
				}
			}
			for (int i = 0; i < k; i++)
			{
				st.erase(-v[i]);
			}
			for (int i = 0; i < k; i++)
			{
				auto dp = st.upper_bound(-v[i]);
				if (dp == st.end())
					dp = st.begin();
				dpv.push_back(-(*dp));
				mp[v[i]] = i;
				st.erase(dp);
			}
			sort(dpv.begin(), dpv.end());
			for (int i = 0; i < k; i++)
			{
				cout << dpv[mp[a[i]]] << " ";
			}
		}
		cout << endl;
	}
}


