#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f(n) for(int i = 0; i < n; ++i)
#define pb push_back
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;
typedef vector<int> vei;

struct query {
    int k, a, b, ind;
};

bool cmp(query a, query b) {
    return a.k < b.k;
}

const int K = 5001;

void solve() {
    int n, q;
    cin >> n >> q;
    vei w(n);
    f(n) cin>>w[i];
    sort(all(w));
    int z;
    cin >> z;
    vector<query> qs;
    for(int _ = 0; _ < q; ++_) {
        int k, a, b;
        cin>>k>>a>>b;
        qs.pb({k, a, b, _});
    }
    sort(all(qs), cmp);
    vector<bool> ans(q);
    vector<int> dp(K, -1);
    dp[0] = 1;
    int curr = 0;
    for(auto e : w) {
        while(curr<q && qs[curr].k < e) {
            if(dp[qs[curr].a] > qs[curr].b) ans[qs[curr].ind] = 1;
            curr++;
        }
        if(curr==q) break;
        vector<int> pdp = dp;
        for(int i = 0; i < K; ++i) {
            if(dp[i] >= e) dp[i] += e;
        }
        for(int i = K-1; i >= e; --i) dp[i] = max(dp[i], pdp[i-e]);
        int mnn = K;
        for(auto &ee : dp) {
            mnn = min(mnn, ee);
            ee = mnn;
        }
    }
    while(curr<q) {
        if(dp[qs[curr].a] > qs[curr].b) ans[qs[curr].ind] = 1;
        curr++;
    }
//    cout<<dp[35];
//    f(10) cout<<dp[i]<<' ';
    for(auto e : ans){
        if(e) cout<<"Yes\n";
        else cout<<"No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
//    cin >> tc;
    for(int i = 0; i < tc; ++i) solve();
}