#include <bits/stdc++.h>
#define int long long
#define all(x) x.begin(),x.end()
#define ff first
#define ss second
#define vi vector<int>
#define pii pair<int, int>
#define lb lower_bound
#define pb push_back
#define len(x) (int)x.size()
typedef long long ll;
using namespace std;

int dp[2002][2002];
int n;
int T = 1;
vi trH[2002];
vi trV[2002];
vi fH[2002];
vi fV[2002];

void pushV(int i, int j) {
    if(fV[i][j] == 1) {
        fV[i][j] = 0;
        if(i < T) {
            trV[i*2][j] = -n-10;
            trV[i*2+1][j] = -n-10;
            fV[i*2+1][j] = 1;
            fV[i*2][j] = 1;
        }
    }
    return;
}

void pushH(int i, int j) {
    if(fH[i][j] == 1) {
        fH[i][j] = 0;
        if(i < T) {
            trH[i*2][j] = -n-10;
            trH[i*2+1][j] = -n-10;
            fH[i*2+1][j] = 1;
            fH[i*2][j] = 1;
        }
    }
    return;
}

void upd(int i, int j, int v){
    int u = j+T;
    //cout << u << ' '<<i<<' '<<j<<'\n';


    trH[u][i] = v;

    u /= 2;
    while(u > 0) {
        trH[u][i] = max(trH[u*2][i], trH[u*2+1][i]);
        u /= 2;
    }

    u = i+T;
    trV[u][j] = v;
    u /= 2;
    while(u > 0) {
        trV[u][j] = max(trV[u*2][j], trV[u*2+1][j]);
        u /= 2;
    }
    return;
}

void CLR_V(int lq, int rq, int w, int l = 0, int r = T-1, int i = 1) {
    if(lq > r || rq < l) return;
    if(lq <= l && rq >= r) {
        trV[i][w] = -n-10;
        fV[i][w] = 1;
        return;
    }
    pushV(i, w);
    int C =  (l+r)/2;
    CLR_V(lq,rq,w,l,C,i*2);
    CLR_V(lq,rq,w,C+1,r,i*2+1);
    trV[i][w] = max(trV[i*2][w], trV[i*2+1][w]);
}

void CLR_H(int lq, int rq, int w, int l = 0, int r = T-1, int i = 1) {
    if(lq > r || rq < l) return;
    if(lq <= l && rq >= r) {
        trH[i][w] = -n-10;
        fH[i][w] = 1;
        return;
    }
    pushH(i, w);
    int C =  (l+r)/2;
    CLR_H(lq,rq,w,l,C,i*2);
    CLR_H(lq,rq,w,C+1,r,i*2+1);
    trH[i][w] = max(trH[i*2][w], trH[i*2+1][w]);
}

void clr(int x, int y) {
    for (int i = 0; i <= x; ++i) {
        CLR_V(y, n+1, i);
        //for (int j = y; j <= n+1; ++j) dp[j][i] = -n-10;
    }
    for (int j = y; j <= n+1; ++j){
        CLR_H(0, x, j);
    }
}

int askG(int lq, int rq, int row) {
    int mx = -n-10;
    for (int i = lq; i <= rq; ++i) mx = max(mx, dp[row][i]);
    return mx;
}

int askV(int lq, int rq, int st) {
    int mx = -n-10;
    for (int i = lq; i <= rq; ++i) mx = max(mx, dp[i][st]);
    return mx;
}

void solve(){
     cin >> n;
     T = n+2;
     for (int i = 0; i < 2002; ++i) {
        trH[i].assign(T*2, -n-10);
        trV[i].assign(T*2, -n-10);
        fV[i].assign(T*2, 0);
        fH[i].assign(T*2, 0);
     }
    vi a(n);
    for (int i =0; i < n; ++i) {
        cin >> a[i];
    }

    for (int i = 0; i <= n+1; ++i) {
        for (int j = 0; j <= n+1; ++j) dp[i][j] = -n-10;
    }

    dp[n+1][0] = 0;
    upd(n+1, 0, 0);


    for (int i = 0; i < n; ++i) {
        int y = a[i];
        for (int j = 0; j <= n+1; ++j) {
            if(y != j){
                dp[y][j] = max(dp[y][j], askV(y+1, n+1, j) + 1);
                upd(y, j, dp[y][j]);
            }
        }
        for (int j = 0; j <= n+1; ++j) {
            if(y != j){
                dp[j][y] = max(dp[j][y], askG(0, y-1, j) + 1);
                upd(j, y, dp[j][y]);
            }
        }
        clr(a[i]-1, a[i]+1);
            /*
        int dp2[n+2][n+2];
        for (int i1 = 0; i1 <= n+1; ++i1) {
            for (int j = 0; j <= n+1; ++j) dp2[i1][j] = -n-10;//dp[i1][j];
        }
        for (int j = 0; j < n+2; ++j) {
            for (int k = 0; k <= n+1; ++k) {
                if(a[i] > j) {
                    dp2[a[i]][k] = max(dp2[a[i]][k], dp[j][k] + 1);
                }
                else if(a[i] != j){
                    dp2[j][k] = max(dp2[j][k], dp[j][k]);
                }
                if(a[i] < k) {
                    dp2[j][a[i]] = max(dp2[j][a[i]], dp[j][k] + 1);
                }
                else if(a[i] != k){
                    dp2[j][k] = max(dp2[j][k], dp[j][k]);
                }
            }
        }
        for (int i1 = 0; i1 <= n+1; ++i1) {
            for (int j = 0; j <= n+1; ++j) dp[i1][j] = dp2[i1][j];
        }
        */
    }

    int ans = 0;
    for (int i = 0; i < n+1; ++i) {
        for (int j = 0; j < n+1; ++j) ans = max(ans, dp[i][j]);
    }
    cout << ans <<'\n';
}

int32_t main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("TASK.in", "r", stdin);
        freopen("TASK.out", "w", stdout);
    #endif // LOCAL
    int ctt = 1;
    //srand(time(0));
    cin >> ctt;
    for (int O = 0; O < ctt; ++O) {
        solve();
        //cout << endl;
    }
    return 0;
}
