#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 2e5 + 7;

int n, q;
vector<int> g[N];
ll X, Y, M;
ll V[N];
ll l[N], r[N];
vector<int> kek;
ll dp[N][2];
ll a[N];
ll k[N];
ll rofl[N];
int par[N];
vector<int> ord;

void dfs(int v, int p = -1) {
	par[v] = p;
	for (int u : g[v]) {
		if (u != p) {
			dfs(u, v);
		}
	}
	ord.push_back(v);
}

void build(ll d) {
	for (int i = 0; i < n; ++i) {
		a[i] = l[i];
		ll mn = min(d, r[i] - l[i]);
		a[i] += mn;
		d -= mn;
	}
}

ll get(ll d) {
	build(d);
	for (int i = 0; i < n; ++i) {
		dp[i][0] = 0;
		dp[i][1] = a[i];
	}
	for (int v : ord) {
		dp[v][1] = max(dp[v][1], dp[v][0]);
		if (par[v] != -1) {
			dp[par[v]][0] += dp[v][1];
			dp[par[v]][1] += dp[v][0];
		}
	}
	return dp[0][1];
}

void solve() {
	cin >> n >> q;
	cin >> X >> Y >> M;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < n - 1; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}
	for (int i = 0; i < q; ++i) {
		cin >> V[i];
	}
	ll sum = 0;
	for (int i = 0; i < n; ++i) {
		sum += r[i] - l[i];
	}
	ord.clear();
	dfs(0);
	ll mn = get(0);
	ll mx = get(sum); 
	for (int i = 0; i < q; ++i) {
		if (mn > V[i]) {
			k[i] = -1;
			continue;
		}
		if (mx < V[i]) {
			k[i] = -1;
			continue;
		}
		ll L = 0, R = sum + 1;
		while (R - L > 1) {
			ll mid = (L + R) / 2;
			if (get(mid) <= V[i]) {
				L = mid;
			} else {
				R = mid;
			}
		}
		rofl[i] = L;
		build(L);
		ll cert = 0;
		for (int j = 0; j < n; ++j) {
			cert ^= (X * (j + 1) + Y * a[j] % M * a[j]) % M;
		}
		k[i] = cert;
	}
	for (int i = 0; i < q; ++i) {
		cout << k[i] << " ";
	}
	cout << endl;
	while (true) {
		int id;
		cin >> id;
		if (id == 0) {
			break;
		}
		--id;
		if (k[id] == -1) {
			cout << -1; 
		} else {
			build(rofl[id]);
			for (int i = 0; i < n; ++i) {
				cout << a[i] << " ";
			}
		}
		cout << endl;
	}
}	

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}