#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <random>
#include <math.h>
#include <deque>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll h, w, k;
	cin >> h >> w >> k;
	vector<ll> x1(k), y1(k);
	for (int i = 0; i < k; ++i) {
		cin >> x1[i] >> y1[i];
	}
	sort(x1.begin(), x1.end());
	sort(y1.begin(), y1.end());
	vector<ll> x = { x1[0] }, y = { y1[0] };
	for (int i = 1; i < k; ++i) {
		if (x1[i] != x1[i - 1]) {
			x.push_back(x1[i]);
		}
		if (y1[i] != y1[i - 1]) {
			y.push_back(y1[i]);
		}
	}
	int k1 = x.size(), k2 = y.size();
	ll a = x[k1 - 1] - x[0] + 1, md = 0;
	for (int i = 1; i < k1; ++i) {
		if (h - (x[i] - x[i - 1]) + 1 < a || (h - (x[i] - x[i - 1]) + 1 == a && md > x[i-1])) {
			a = h - (x[i] - x[i - 1]) + 1;
			md = x[i - 1];
		}
	}
	for (int i = k1 - 2; i >= 0; --i) {
		if (x[i] + (h - x[i + 1])+1 < a || (x[i] + (h - x[i + 1]) + 1 == a && md > h - x[i+1] + 1)) {
			a = x[i] + (h - x[i + 1])+1;
			md = h - x[i + 1]+1;
		}
	}
	ll b = y[k2 - 1] - y[0] + 1, md1 = 0;
	for (int i = 1; i < k2; ++i) {
		if (w - (y[i] - y[i - 1]) + 1 < b || (w - (y[i] - y[i - 1]) + 1 == b && md1 > y[i - 1])) {
			b = w - (y[i] - y[i - 1]) + 1;
			md1 = y[i - 1];
		}
	}
	for (int i = k2 - 2; i >= 0; --i) {
		if (y[i] + (w - y[i + 1]) + 1 < b || (y[i] + (w - y[i + 1]) + 1 == b && md1 > w - y[i+1] + 1)) {
			b = y[i] + (w - y[i + 1]) + 1;
			md1 = w - y[i + 1] + 1;
		}
	}
	cout << a * b << ' ' << md + md1 << '\n';
	return 0;
}