#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

const int INF = 2e9;

inline void slave() {
    int n;
    std::cin >> n;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    std::vector<int> dp(n + 1, +INF);
    dp[0] = -INF;
    for (auto e : a) {
        *std::lower_bound(dp.begin(), dp.end(), e) = e;
    }
    int len = std::lower_bound(dp.begin(), dp.end(), +INF) - dp.begin() - 1;
    std::cout << std::min(n, len + 2) << '\n';
}

signed main() {
    //std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t --> 0) {
        slave();
    }
    return 0;
}