#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve(){
    int n;
    cin >> n;

    vector < pair <int, pair <int, int> > > a(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i].first >> a[i].second.first;
        a[i].second.second = i;
    }

    sort(a.begin(), a.end());

    int m = 0;
    vector <int> dp(n, 1);
    for(int i = 1; i < n; ++i){
        dp[i] = dp[i - 1];
        for(int j = 0; j < i; ++j){
            if(a[i].first > a[j].second.first){
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
    }
    m = dp[n - 1];

    for(int mask = 0; mask < (1 << n); ++mask){
        int kol = 0;
        vector < pair <int, pair <int, int> > > b;
        for(int i = 0; i < n; ++i){
            if((mask >> i) & 1){
                kol++;
                b.push_back(a[i]);
            }
        }

        if(kol != n / 2){
            continue;
        }

        dp.clear();
        dp.assign(kol, 1);
        for(int i = 1; i < kol; ++i){
            dp[i] = dp[i - 1];
            for(int j = 0; j < i; ++j){
                if(b[i].first > b[j].second.first){
                    dp[i] = max(dp[i], dp[j] + 1);
                }
            }
        }

        if(dp[kol - 1] == m / 2){
            for(auto x : b){
                cout << x.second.second + 1 << " ";
            }
            cout << '\n';
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    cin >> tests;
    while(tests--){
        solve();
    }
}
