from functools import lru_cache
def get_pov(i, last):
    if rod[i] == -1 or rod[i] == 1:
        pov[i] = 0
    else:
        rod_p = rod[i]
        fatha = i == tree[rod_p][0]
        grand_fatha = rod_p == tree[rod[rod_p]][0]
        if fatha == grand_fatha:
            pov[i] = last
        else:
            pov[i] = last + 1
    if tree[i] == (0, 0):
        return
    get_pov(tree[i][0], pov[i])
    get_pov(tree[i][1], pov[i])


@lru_cache(None)
def get_count(i):
    if tree[i] == (0, 0):
        return 1
    c = 0
    a, b = tree[i]
    if pov[a] <= k:
        c += get_count(a)
    if pov[b] <= k:
        c += get_count(b)
    return c


n, k, q = list(map(int, input().split()))
rod = [0] * (n + 1)
pov = [n] * (n + 1)
tree = [(0, 0)] + [0] * n
for i in range(1, n + 1):
    l = list(map(int, input().split()))
    if l == [0]:
        tree[i] = (0, 0)
    else:
        c, a, b = l
        tree[i] = (a, b)
        rod[a], rod[b] = i, i

rod[1] = -1
get_pov(1, 0)

for i in range(q):
    d = int(input())
    if pov[d] > k:
        print(0)
    else:
        if tree[d] == 0:
            print(1)
        else:
            print(get_count(d))
