#include <iostream>
#include "vector"
#include "set"
#include "deque"
#include "algorithm"

#define int long long
#define vec vector
using namespace std;

int to(int i, int n) {
    if (i == n)return 1;
    return i + 1;
}

int from(int i, int n) {
    if (i == 1) {
        return n;
    }
    return i - 1;
}

vec<int> to_0_index(vec<int> z) {
    vec<int> ans;
    for (auto elem: z)ans.emplace_back(elem - 1);
    return ans;
}

vec<int> to_1_index(vec<int> z) {
    vec<int> ans;
    for (auto elem: z)ans.emplace_back(elem + 1);
    return ans;
}

void solve1() {
    int n, k;
    cin >> n >> k;
    vec<int> t(k);
    std::sort(t.begin(), t.end());
    for (auto &i: t)cin >> i;
    set<int> nums;
    for (auto i: t)nums.emplace(i);
    set<int> coded;
    set<int> used;
    for (int i = 0; i < k; ++i) {
        int z = t[i];
        while (nums.count(z) || used.count(z)) {
            z = from(z, n);
        }
        used.emplace(z);
    }
    for (auto i: used)cout << i << ' ';
    cout << endl;
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vec<int> r(k);
    for (auto &i: r)cin >> i;
    std::sort(r.begin(), r.end());
    set<int> cant_be;
    set<int> ans;
    for (auto &i: r)cant_be.emplace(i);
    for (int i = 0; i < k; ++i) {
        int now = r[i];
        while (cant_be.count(now)) {
            now = to(now, n);
        }
        ans.emplace(now);
        cant_be.emplace(now);
    }
    for (auto i: ans)cout << i << ' ';
    cout << endl;
}

signed main() {
    int t;
    cin >> t;
    int m;
    cin >> m;
    while (m--) {
        if (t == 1)solve1();
        if (t == 2)solve2();
    }
    return 0;
}
