#include <iostream>
#include <random>
#include <chrono>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
ll INF = 2e18, L_INF = 2e9, mod = 1e9 + 7;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forall(aa, aaa) for(auto& aa: aaa)

void print(vector<ll> &a) {
    forall(i, a) cout << i << ' ';
    cout << '\n';
}

struct p{
    ll x, y, id;

    bool operator<(p& other) {
        if (y != other.y) return y < other.y;
        return x < other.x;
    }
};

void solve() {
    ll n, q;
    bool fl = true;
    cin >> n >> q;
    vector < ll > a(n);
    vector < vector < ll >> need(n, vector < ll > (3));
    forall(i, a) cin >> i;
    forall(i, need) {
        cin >> i[0] >> i[1] >> i[2];
        if (i[2]) fl = false;
    }
    sort(all(a));

    if (fl) {
        ll s = 0;
        forall(i, a) {
            if (s >= i - 1) s += i;
            else break;
        }

        vector < ll > pref(n + 1, 0);
        for (ll i = 0; i < n; i++) pref[i + 1] = pref[i] + a[i];

        ll mx = s;
        ll k;
        cin >> k;
        for (ll i = 0; i < q; i++) {
            ll x=need[i][0], y=need[i][1], z=need[i][2];
//            cin >> x >> y >> z;
            if (mx >= min(y, pref[upper_bound(all(a), x) - a.begin()])) cout << "Yes\n";
            else cout << "No\n";
        }
        return;
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
