#include <bits/stdc++.h>

using namespace std;

struct seg{
    int l, r, i;
};

bool comp(seg a, seg b){
    return a.r < b.r;
}

int mx(vector<seg> a){
    int n = (int)a.size();
    int dp[n], mx[n];
    fill(dp, dp + n, 1);
    fill(mx, mx + n, 0);
    mx[0] = 1;
    for(int i = 1; i < n; i++){
        int l = 0, r = i - 1;
        while(r - l > 1){
            int mid = (l + r) / 2;
            if(a[mid].r < a[i].l)
                l = mid;
            else
                r = mid;
        }
        if(r >= 0 && r < i && a[r].r < a[i].l && mx[r] + 1 > dp[i])
            dp[i] = mx[r] + 1;
        else if(l >= 0 && l < i && a[l].r < a[i].l && mx[l] + 1 > dp[i])
            dp[i] = mx[l] + 1;
        mx[i] = mx[i - 1];
        if(dp[i] > mx[i])
            mx[i] = dp[i];
    }
    return *max_element(dp, dp + n);
}

int n, m;
vector<seg> ans, a;
vector<seg> cur;

void rec(int v){
    if(!ans.empty())
        return;
    if(v >= n)
        return;
    if((int)cur.size() == n / 2){
        if(mx(cur) == m / 2)
            ans = cur;
        return;
    }
    cur.emplace_back(a[v]);
    rec(v + 1);
    cur.pop_back();
    if((int)cur.size() + (n - (v + 1)) < m / 2)
        return;
    if(!ans.empty())
        return;
    rec(v + 1);
    if(!ans.empty())
        return;
}

void sol(){
    cin >> n;
    a.resize(n);
    for(int i = 0; i < n; i++)
        cin >> a[i].l >> a[i].r, a[i].i = i;
    sort(a.begin(), a.end(), comp);
    m = mx(a);
    rec(0);
    for(auto c : ans)
        cout << c.i + 1 << " ";
    cout << '\n';
    ans.clear();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    while(t--){
        sol();
    }
    return 0;
}