#include <iostream>
#include "vector"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

const int MAXA = 1001;

bool psbl[MAXA][MAXA];
int n;
vector<ll> a;

void calc(int sum, vector<int> &was) {
    vector<bool> used(n);
    for (auto el: was) {
        used[el] = true;
    }
    for (int i = 0; i < n; ++i) {
        if (used[i] or a[i] >= (ll)MAXA) continue;
        bool psbl1[MAXA];
        for (int j = 0; j < MAXA; ++j) {
            psbl1[j] = false;
        }
        for (int j = 0; j + a[i] < MAXA; ++j) {
            if (psbl[j][sum] and not psbl[j + a[i]][sum]) {
                psbl1[j + a[i]] = true;
            }
        }
        for (int j = 0; j < MAXA; ++j) {
            if (psbl1[j]) psbl[j][sum] = true;
        }
    }
}

void solve() {
    int q; cin >> n >> q;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int z; cin >> z;
    for (int i = 0; i < MAXA; ++i) {
        for (int j = 0; j < MAXA; ++j) {
            psbl[i][j] = false;
        }
    }
    vector<int> how[MAXA];
    psbl[0][0] = true;
    for (int i = 0; i < n; ++i) {
        if (a[i] >= (ll)MAXA) continue;
        bool psbl1[MAXA];
        for (int j = 0; j < MAXA; ++j) {
            psbl1[j] = false;
        }
        for (int j = 0; j + a[i] < MAXA; ++j) {
            if (psbl[0][j] and not psbl[0][j + a[i]]) {
                psbl1[j + a[i]] = true;
                how[j + a[i]] = how[j];
                how[j + a[i]].push_back(i);
            }
        }
        for (int j = 0; j < MAXA; ++j) {
            if (psbl1[j]) {
                psbl[0][j] = true;
                calc(j, how[j]);
            }
        }
    }
    bool tab[MAXA][MAXA];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            tab[i][j] = ((i == 0 or tab[i - 1][j]) and (j == 0 or tab[i][j - 1]) and psbl[i][j]);
        }
    }
    while (q--) {
        ll k; cin >> k; int a1, b1; cin >> a1 >> b1;
        if (tab[a1][b1]) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
    }
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test = 1;
    while (test--) {
        solve();
    }
}
