#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <random>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define len(a) (ll) a.size()

const ll INF = 1e18;

void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    vector <ll> x(k), y(k);
    for (ll i = 0; i < k; i++) {
        cin >> x[i] >> y[i];
        x[i]--, y[i]--;
    }
    if (k == 1) {
        cout << "1 0";
        return;
    }
    sort(all(x)), sort(all(y));
    x.resize(unique(all(x)) - x.begin());
    y.resize(unique(all(y)) - y.begin());
    ll xMn = x.back() - x[0] + 1, yMn = y.back() - y[0] + 1;
    ll xD = INF, yD = INF;
    ll q = 0;
    for (ll i = 0; i <= len(x); i++) {
        if (x[len(x) - 1 - i] + q < xMn) {
            xMn = x[len(x) - 1 - i] + 1 + q;
            xD = min(q, n - q);
        } else if (x[len(x) - 1 - i] + q == xMn) {
            xD = min(q, n - q);
        }
        q += n - x[len(x) - 1 - i];
    }
    q = 0;
    for (ll i = 0; i <= len(y); i++) {
        if (y[len(y) - 1 - i] + q < yMn) {
            yMn = y[len(y) - 1 - i] + 1 + q;
            yD = min(q, m - q);
        } else if (y[len(y) - 1 - i] + q == yMn) {
            yD = min(q, m - q);
        }
        q += m - y[len(y) - 1 - i];
    }
    cout << xMn * yMn << ' ' << xD + yD;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll T = 1;
    while (T--) {
        solve();
    }
    return 0;
}
