#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <random>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define len(a) (ll) a.size()

const ll INF = 1e18;
ll MOD;

ll last;
vector <ll> now, q;

ll k, n, p, ans;

ll func() {
    for (ll i = 0; i < len(q); i++)
        q[i] = q[i] ^ (last - 1);
    sort(all(q));
    ll c = 0;
    for (ll i = 0; i < len(q); i++) {
        if (q[i] == c) {
            c++;
        } else {
            break;
        }
    }
    return c;
}

void pereb() {
    if (len(now) == n) {
        ll mex = 0;
        for (ll i = 0; i < len(now); i++) {
            if (now[i] == mex) {
                mex++;
            } else {
                break;
            }
        }
        last = mex;
        q = now;
        while (true) {
            mex = func();
            if (mex == last)
                break;
            last = mex;
        }
        if (last == p)
            ans = (ans + 1) % MOD;
        return;
    }
    for (ll i = now.back() + 1; i < (1ll << k); i++) {
        now.emplace_back(i);
        pereb();
        now.pop_back();
    }
}

void solve() {
    cin >> k >> n >> p;
    ans = 0;
    now = {0};
    pereb();
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll T = 1;
    cin >> MOD;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}