#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

#ifdef LOCAL
#define debug(x) cerr << #x << " " << x << endl;
#else
#define debug(x) ;
#endif

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    cin >> n;
    while (n--) solve();
}

int get(vector<pii> &a){
    int res = 1;
    int lst = 0;
    for (int i = 1; i < sz(a); i++){
        if (a[i].ff <= a[lst].ss) continue;
        lst = i;
        res++;
    }
    return res;
}

void calc(vector<pii> &a){
    sort(all(a));
    vector<pii> nw;
    for (int i = sz(a) - 1; i >= 0; i--){
        if (nw.empty() || a[i].ss < nw.back().ss) nw.pb(a[i]);
    }
    reverse(all(nw));
    swap(a, nw);
}

int get1(vector<pii> a){
    calc(a);
    return get(a);
}

void solve() {
    int n;
    cin >> n;
    vector<pii> tmp;
    vector<pair<pii, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].ff.ff >> a[i].ff.ss;
        a[i].ss = i;
        tmp.pb(a[i].ff);
    }
    int m = get1(tmp);
    sort(all(a));
    vector<vi> dp(n, vi(m, 1e6));
    vector<vi> p(n, vi(m, -1));
    dp[0][1] = 0;
    for (int i = 1; i < n; i++){
        int c1 = 0;
        for (auto k : a){
            if (k == a[i]) continue;
            if (k.ff.ff < a[i].ff.ff) c1++;
            else if (k.ff.ff >= a[i].ff.ff && k.ff.ss <= a[i].ff.ss) c1++;
        }
        dp[i][0] = c1;
        for (int j = 0; j < i; j++){
            if (a[j].ff.ss >= a[i].ff.ff) continue;
            int cr = 0;
            for (auto k : a){
                if (k == a[i] || k == a[j]) continue;
                if (k.ff.ff < a[i].ff.ff && k.ff.ff > a[j].ff.ss) cr++;
                else if (k.ff.ff >= a[i].ff.ff && k.ff.ss <= a[i].ff.ss) cr++;
            }
            for (int k = 1; k < m; k++){
                dp[i][k] = min(dp[i][k], dp[j][k - 1] + cr);
                if (dp[i][k] == dp[j][k - 1] + cr) p[i][k] = j;
            }
        }
        if (dp[i][m / 2 - 1] <= n / 2){
            int res = dp[i][m / 2 - 1];
            for (auto k: a){
                if (k.ff.ff > a[i].ff.ss) res++;
            }
            if (res > n / 2) continue;
            vector<bool> ans(n, false);
            vi r;
            int cur = i, y = m / 2 - 1;
            while (cur != -1){
                ans[a[cur].ss] = true;
                r.pb(a[cur].ss);
                cur = p[cur][y];
                y--;
            }
            for (auto k : a){
                if (ans[k.ss]) continue;
                bool cn = true;
                for (int j = 0; j < sz(r); j++){
                    if (!ans[a[j].ss]) continue;
                    if (a[j].ff.ff <= k.ff.ff && a[j].ff.ss >= k.ff.ss) cn = false;
                    if (j > 0 && a[j].ff.ff > k.ff.ff && a[j - 1].ff.ss < k.ff.ff && k.ff.ss < a[j].ff.ff) cn = false;
                }
                if (sz(r) == n / 2) break;
                if (cn) r.pb(k.ss);
            }
            for (int j : r) cout << j + 1 << " ";
            cout<< endl;
            return;
        }
    }

}