#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

#ifdef LOCAL
#define debug(x) cerr << #x << " " << x << endl;
#else
#define debug(x) ;
#endif

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    //cin >> n;
    while (n--) solve();
}

void solve() {
    int n, q;
    cin >> n >> q;
    vll a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int mx = 5000 + 1;
    vll h(mx + 1, -1);
    h[0] = 0;
    sort(all(a));
    for (int i = 0; i < n; i++){
        for (int j = mx; j >= 0; j--){
            if (h[j] >= a[i] - 1) h[j] += a[i];
            if (j - a[i] >= 0) h[j] = max(h[j], h[j - a[i]]);
        }
    }
    vll mn(mx + 1);
    mn[0] = h[0];
    for (int i = 1; i <= mx; i++) {
        mn[i] = min(mn[i - 1], h[i]);
    }
    ll z;
    cin >> z;
    for (int i = 0; i < q; i++){
        ll k, x, y;
        cin >> k >> x >> y;
        if (mn[x] < y){
            cout << "No" << endl;
            continue;
        }
        cout << "Yes" << endl;
    }
}