#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>
#include <string>
#include <map>
#include <unordered_map>
#include <fstream>
#include <bitset>

using namespace std;

typedef long long ll;

const ll INF = 1e18;


//umap optimizer
//#include <ext/pb_ds/assoc_container.cpp>
//using namespace __gnu_pbds;
//unordered_map gp_hash_table

ll check(vector<pair<ll, ll>>& vec) {
	ll r = INF;
	ll ans = 0;
	for (ll i = vec.size() - 1; i >= 0; i--) {
		if (vec[i].second < r) {
			r = vec[i].first;
			ans++;
		}
	}
	return ans;
}

mt19937 rnd;

int main() {
	ll t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		vector<pair<ll, ll>> vec;
		for (ll i = 0; i < n; i++) {
			ll a, b; cin >> a >> b;
			vec.push_back({ a, b });
		}
		sort(vec.begin(), vec.end());
		ll m = check(vec);

		for (ll i = 0; i < 1e5; i++) {
			vector<pair<ll, ll>> v;
			vector<ll> ids;
			ll cnt = 0;
			for (ll j = 0; j < n; j++) {
				if (rnd() % 2 == 1) {
					v.push_back(vec[j]);
					ids.push_back(j);
					cnt++;
					if (cnt == n / 2) break;
				}
			}
			if (cnt != n / 2) continue;
			ll nm = check(v);
			if (nm == m / 2) {
				for (auto p : ids) cout << p + 1 << " "; cout << endl;
				break;
			}
		}
	}
}
