#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>
#include <string>
#include <map>
#include <unordered_map>
#include <fstream>
#include <bitset>

using namespace std;

typedef long long ll;


//umap optimizer
//#include <ext/pb_ds/assoc_container.cpp>
//using namespace __gnu_pbds;
//unordered_map gp_hash_table

const ll bssize = 310;

int main() {
	ll n, q; cin >> n >> q;
	vector<ll> vec(n);
	for (ll i = 0; i < n; i++) cin >> vec[i];
	sort(vec.begin(), vec.end());

	ll z; cin >> z;
	ll V = 0;
	ll num = 1;

	vector<vector<bitset<bssize>>> precalc;
	for (ll i = 0; i < n + 1; i++) {
		ll k = 0;
		if (i > 0) k = vec[i - 1];

		vector<bitset<bssize>> v;
		if (i > 0) v = *precalc.rbegin();
		else v.resize(bssize);
		v[0][0] = true;

		ll p = 0;
		if (i > 0) p = vec[i - 1];
		vector<bitset<bssize>> newv = v;

		for (ll i = 0; i < newv.size(); i++) {
			newv[i] |= v[i] << p;
			if (i - p >= 0) newv[i] |= v[i - p];
		}

		v = newv;
		precalc.push_back(v);
	}

	while (q--) {
		ll j, c, d; cin >> j >> c >> d;

		ll k = j - V * z;
		ll a = c - V * z;
		ll b = d - V * z;

		ll id = 0;
		while (id < vec.size() && vec[id] <= k) id++;

		//vector<bitset<bssize>> v = precalc[id];
		bool check = true;
		for (ll i = 0; i <= a; i++) {
			for (ll j = 0; j <= b; j++) {
				check &= precalc[id][i][j];
			}
		}

		if (check) {
			cout << "Yes" << endl;
			V += num;
		} else {
			cout << "No" << endl;
		}

		num++;
	}
}
