#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

void logvec(vector<int> a, string s) {
	for (int el : a) cout << el << s;
	cout << "\n";
}

int n, k, q;
vector<int> l, r, par, way, turns;
vector<int> ans;

void dfs(int v) {
	if (par[v] != -1 and par[par[v]] != -1) {
		turns[v] = turns[par[v]] + (way[v] != way[par[v]]);
	}
	else turns[v] = 0;
	if (l[v] == -1) {
		ans[v] = (turns[v] <= k);
	}
	else {
		dfs(l[v]);
		dfs(r[v]);
		ans[v] = ans[l[v]] + ans[r[v]];
	}
}

int main() {

	cin >> n >> k >> q;
	l.assign(n, -1);
	r.assign(n, -1);
	par.assign(n, -1);
	way.assign(n, -1);
	int t1;
	for (int i = 0; i < n; ++i) {
		cin >> t1;
		if (t1 == 2) {
			cin >> l[i] >> r[i];
			--l[i];
			--r[i];
			par[l[i]] = i;
			par[r[i]] = i;
			way[l[i]] = 0;
			way[r[i]] = 1;
		}
	}

	turns.assign(n, 0);
	ans.assign(n, 0);
	dfs(0);

	/*for (int i = 0; i < n; ++i) {
		logvec(mst[i], ", ");
	}*/
	int u;
	while (q--) {
		cin >> u;
		--u;
		cout << ans[u] << "\n";
	}

	return 0;
}