#include <bits/stdc++.h>


using namespace std;
//#define int long long
const int mod = 1e9 + 7;


void solve() {
    int n;
    cin >> n;
    vector<int> l(n);
    vector<int> r(n);
    vector <pair<int, int>> qr;
    vector <pair<int, int>> ql;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        qr.emplace_back(r[i], i);
        ql.emplace_back(l[i], i);
    }
    sort(qr.begin(), qr.end());
    sort(ql.begin(), ql.end());


    vector<int> calc_m(n + 1);
    int maxm = 0;
    calc_m[0] = 1;
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (qr[j].first < l[qr[i].second]) {
                calc_m[i] = max(calc_m[i], calc_m[j] + 1);
                maxm = max(maxm, calc_m[i]);
            }
        }
    }

    vector <vector<int>> u(n + 1, vector<int>(n + 1));
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (j) {
                for (int h = 0; h < n; ++h) {
                    if (l[h] > qr[j - 1].first && r[h] < l[qr[i - 1].second]) {
                        u[i][j]++;
                    }
                }
            } else {
                for (int h = 0; h < n; ++h) {
                    if (r[h] < l[qr[i - 1].second]) {
                        u[i][j]++;
                    }
                }
            }
        }
    }

//    cout << maxm << '\n';
    vector <vector<int>> dp(n + 1, vector<int>(maxm / 2 + 1, 1e9));
    vector <vector<int>> par(n + 1, vector<int>(maxm / 2 + 1, 1e9));
    dp[0][0] = 0;
    par[0][0] = -1;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= maxm / 2; ++j) {
            for (int k = 0; k < i; ++k) {
                if (k != 0 && l[qr[i - 1].second] <= qr[k - 1].first) {
                    continue;
                }
                if (dp[k][j - 1] + u[i][k] < dp[i][j]) {
                    dp[i][j] = dp[k][j - 1] + u[i][k];
                    par[i][j] = k;
                }
            }
        }
    }
//    cout << "ther" << endl;
    for (int i = 1; i <= n; ++i) {
        int cnt = dp[i][maxm / 2] +
                  (ql.end() - upper_bound(ql.begin(), ql.end(), pair < int, int > {qr[i - 1].first, 0}));
        if (cnt <= n / 2) {
            vector<int> path;
            int f = i;
            int s = maxm / 2;
            vector<int> get(n + 1);
            while (par[f][s] != -1) {
                path.push_back(qr[f - 1].second);
                get[qr[f - 1].second] = 1;
                f = par[f][s];
                s--;
            }

            for (int j = 0; j < n; ++j) {
                if (get[j]) continue;
                if (path.size() == n / 2) break;
                for (int h: path) {
                    if (!(l[j] > r[h] || r[j] < l[h])) {
                        path.push_back(j);
                        get[j] = 1;
                        break;
                    }
                }
            }

            for (int el: path) {
                cout << el + 1 << " ";
            }
            cout << '\n';
            return;
        }
    }
}


signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}