#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 2e5;

vector<ll> g[N];
vector<bool> used(N);
vector<ll> dp(N);

void dfs(ll v, ll has, ll go = -1) {
    if (has < 0) {
        return;
    }
    used[v] = true;
    ll ans = (g[v].size() == 0);
    for (int i = 0; i < g[v].size(); i++) {
        ll to = g[v][i];
        if (!used[to]) {
            if (i == 0) {
                dfs(to, has - (go == 1), 0);
                ans += dp[to];
            } else {
                dfs(to, has - (go == 0), 1);
                ans += dp[to];
            }
        }
    }
    // cout << v << " " << ans << '\n';
    dp[v] = ans;
}

void solve() {
    ll n, k, q; cin >> n >> k >> q;
    for (int i = 0; i < n; i++) {
        ll t; cin >> t;
        if (t == 2) {
            ll u, v; cin >> u >> v;
            u--; v--;
            g[i].push_back(v);
            g[i].push_back(u);
        }
    }
    dfs(0, k);
    while (q--) {
        ll v; cin >> v;
        v--;
        cout << dp[v] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();
}
