#include <bits/stdc++.h>
#define int long long
using namespace std;

struct solve {
    int x, y, m;
    int n, q;
    vector<pair<int, int>> seg;
    vector<vector<int>> g;
    array<int, 2> dp(int u, int p = -1) {
        array<int, 2> cur{};
        cur[1] += seg[u].second;
        for (int v : g[u]) {
            if (v != p) {
                auto res = dp(v, u);
                cur[0] += max(res[0], res[1]);
                cur[1] += res[0];
            }
        }
        return cur;
    }
    solve() {
        cin >> n >> q;
        cin >> x >> y >> m;
        g.resize(n);
        for (int i = 0; i < n - 1; i++) {
            int u, v;
            cin >> u >> v;
            u--;
            v--;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        seg.resize(n);
        for (auto &[l, r] : seg) {
            cin >> l >> r;
        }

        auto res = dp(1);
        int mx = max(res[0], res[1]);
        int serf = 0;
        for (int i = 0; i < n; i++) {
            serf ^= (x * (i + 1) + y * seg[i].second * seg[i].second) % m;
        }
        vector<int> Q;
        for (int i = 0; i < q; i++) {
            int u;
            cin >> u;
            Q.push_back(u);
            if (u == mx) {
                cout << serf << " ";
            } else {
                cout << -1 << " ";
            }
        }
        cout << endl;

        int i;
        while (true) {
            cin >> i;
            if (i == 0) {
                break;
            } else {
                int u = Q[i - 1];
                if (u == mx) {
                    for (int j = 0; j < n; j++) {
                        cout << seg[j].second << " ";
                    }
                    cout << endl;
                } else {
                    cout << -1 << endl;
                }
            }
        }
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}