#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <queue>

using std::cin;
using std::cout;
using std::vector;
using std::string;
using ll = long long;
using ld  = long double;
using pl = std::pair<ll, ll>;
using sl = std::pair<ll, vector<pl>>;
#define all(x) x.begin(),x.end()

ll ttime;

struct compare
{
	bool operator()(pl a, pl b)const
	{
		return a.first + ttime - a.second < b.first + ttime - b.second;
	}
};

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll h, w; cin >> h >> w;
	ll n; cin >> n;
	vector<ll> vc(n); for (ll& i : vc) { cin >> i; cin >> i; }
	std::sort(all(vc));

	ll asz = 1e9;
	ll ast = 0;

	std::set<pl, compare> st;

	for (ll& i : vc)
	{
		st.insert({ i,0 });
	}

	asz = (--st.end())->first - st.begin()->first + 1;

	ttime = 0;
	ll stp = 0;
	for (ll g = 0; g < 4 * n; ++g)
	{
		pl x = *(--st.end());
		ll ps = x.first + ttime - x.second;
		pl f = *st.begin();
		ll fp = f.first + ttime - f.second;

		if (asz > ps - fp + 1)
		{
			asz = ps - fp + 1;
			ast = stp;
		}
		else if (asz == ps - fp + 1 && ast > stp)
		{
			ast = stp;
		}

		stp += w - ps + 1;
		st.erase(--st.end());
		ttime += w - ps + 1;
		st.insert({ 1,ttime });
	}

	st.clear();
	for (ll& i : vc)
	{
		st.insert({ i,0 });
	}

	ttime = 0;
	stp = 0;
	for (ll g = 0; g < 4 * n; ++g)
	{
		pl x = *(--st.end());
		ll ps = x.first + ttime - x.second;
		pl f = *st.begin();
		ll fp = f.first + ttime - f.second;

		if (asz > ps - fp + 1)
		{
			asz = ps - fp + 1;
			ast = stp;
		}
		else if (asz == ps - fp + 1 && ast > stp)
		{
			ast = stp;
		}

		stp += fp;
		st.erase(st.begin());
		ttime -= fp;
		st.insert({ w,ttime });
	}

	cout << asz << ' ' << ast;
}