///pandemonica, modeus, cerberus, malina, zdrada, azazel, justice, lucifer, judgement, beelzebub
#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
using namespace std;

#define ll __int128
//#define int __int128
#define int long long
#define f first
#define s second
#define double long double
//#define endl '\n'

vector <vector <int> > g;
vector <int> l,r;
vector <int> dp0,dp1;
vector <int> used;
vector <vector <int> > take;

void dfs(int v)
{
    used[v]=1;
    dp1[v]+=r[v];
    for (int u:g[v]){
        if (used[u])continue;
        dfs(u);
        if (dp1[u]>=dp0[u]){
            take[v].push_back(u);
        }
        dp0[v]+=max(dp0[u],dp1[u]);
        dp1[v]+=dp0[u];
    }
}

vector <int> w;
void dfs_v(int v, bool t)
{
    used[v]=1;
    if (t){
        w.push_back(v);
        for (int u:g[v]){
            if (used[u])continue;
            dfs_v(u,0);
        }
    }
    else {
        for (int i:take[v]){
            dfs_v(i,1);
        }
        for (int u:g[v]){
            if (used[u])continue;
            dfs_v(u,0);
        }
    }
}

void solve()
{
    int n,q;
    cin >> n >> q;
    int x,y,m;
    cin >> x >> y >> m;
    g.resize(0);
    g.resize(n);
    for (int i=0; i<n-1; i++){
        int v,u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    l.resize(n);
    r.resize(n);
    for (int i=0; i<n; i++){
        cin >> l[i] >> r[i];
        if (l[i]!=0 || r[i]>1)assert(0);
    }
    vector <int> a(q);
    for (int i=0; i<q; i++){
        cin >> a[i];
    }
    used.assign(n,0);
    dp1.assign(n,0);
    dp0.assign(n,0);
    take.resize(0);
    take.resize(n);
    dfs(0);
    int ans=max(dp0[0],dp1[0]);

    used.assign(n,0);
    w.resize(0);
    if (dp0[0]>dp1[0])dfs_v(0,0);
    else dfs_v(0,1);

    //if (w.size()!=ans)assert(0);

    vector <int> answer(n,0);
    for (int i:w){
        answer[i]=r[i];
    }
    vector <int> pref1(n,0),suf0(n,0);
    pref1[0]=(x*1+answer[0]*answer[0]*y)%m;
    for (int i=1; i<n; i++){
        pref1[i]=pref1[i-1]^((x*(i+1)+y*answer[i]*answer[i])%m);
    }
    suf0[n-1]=(x*n+answer[n-1]*answer[n-1]*y)%m;
    for (int i=n-2; i>=0; i--){
        suf0[i]=suf0[i+1]^(x*(i+1)%m);
    }
    vector <int> pref=answer;
    for (int i=1; i<n; i++){
        pref[i]+=pref[i-1];
    }
    for (int i=0; i<q; i++){
        if (a[i]>ans){
            cout << -1 << " ";
            continue;
        }
        int k=0;
        int need=a[i];
        int lef=-1,righ=n;
        while (lef+1<righ){
            int mid=(lef+righ)>>1;
            if (pref[mid]<=need)lef=mid;
            else righ=mid;
        }
        k=pref1[lef];
        if (lef!=n-1)k^=suf0[lef+1];
        /*for (int i=0; i<n; i++){
            if (need && answer[i]){
                k^=(x*(i+1)+y)%m;
                need--;
            }
            else {
                k^=(x*(i+1))%m;
            }
        }*/
        cout << k << " ";
    }
    cout << endl;

    while (1){
        int i;
        cin >> i;
        i--;
        if (i==-1)break;
        if (a[i]>ans){
            cout << -1 << endl;
            continue;
        }

        int need=a[i];
        for (int i=0; i<n; i++){
            if (need && answer[i]){
                cout << 1 << " ";
                need--;
            }
            else {
                cout << 0 << " ";
            }
        }
        cout << endl;
    }
}

signed main()
{
#ifdef LOCAL
#else
    /*ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);*/
#endif // LOCAL
    int n=1;
    cin >> n;
    while (n--){
        solve();
    }
}
