#include <bits/stdc++.h>
#define ff first
#define ss second
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

const int N = 200010;
vector <int> g[N];
int le[N], ri[N], k;
int prf[N];
ll cnt[N];
ll dp0[N], dp1[N], cer[N];
pair <ll, int> qr[N];

void prep(int v, int r){
    if (r != -1) {
        int i = find(g[v].begin(), g[v].end(), r) - g[v].begin();
        swap(g[v][i], g[v].back());
        g[v].pop_back();
    }
    for (auto u : g[v]) prep(u, v);
}

void dfs(int v){
    dp0[v] = 0, dp1[v] = ri[v];
    for (auto u : g[v]){
        dfs(u);
        dp1[v] += dp0[u];
        dp0[v] += max(dp0[u], dp1[u]);
    }
}

vector <int> opt;
void get(int v, int t){
    if (t == 1) opt.push_back(v);
    for (auto u : g[v]){
        if (t == 1) get(u, 0);
        else get(u, dp1[u] > dp0[u]);
    }
}

void solve(){
    int n, q;
    ll x, y, m;
    cin >> n >> q >> x >> y >> m;
    for (int i = 0; i < n; i++) g[i].clear();
    for (int i = 0; i < n - 1; i++){
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (int i = 0; i < n; i++) cin >> le[i] >> ri[i];
    for (int i = 0; i < q; i++) cin >> qr[i].ff, qr[i].ss = i, cer[i] = 0;
    sort(qr, qr + q);
    prep(0, -1);
    dfs(0);
    get(0, dp1[0] > dp0[0]);
    ll cer0 = 0;
    for (int i = 1; i <= n; i++) cer0 ^= x * i % m;
    ll sum = 0;
    int ind = 0;
    for (int j = 0; j < opt.size(); j++){
        int i = opt[j];
        cer0 ^= x * (i + 1) % m;
        while (ind < q && qr[ind].ff <= sum + ri[i]){
            int l = qr[ind].ss;
            prf[l] = j;
            cnt[l] = qr[ind].ff - sum;
            cer[l] = cer0 ^ (x * (i + 1) + y * cnt[l] % m * cnt[l]) % m;
            ind++;
        }
        sum += ri[i];
        cer0 ^= (x * (i + 1) + y * ri[i] % m * ri[i]) % m;
    }
    while (ind < q) cer[qr[ind++].ss] = -1;
    for (int i = 0; i < q; i++) cout << cer[i] << " ";
    cout << endl;
    int t;
    cin >> t;
    while (t != 0){
        t--;
        if (cer[t] == -1) cout << -1 << endl;
        else{
            vector <int> ans(n);
            for (int j = 0; j < prf[t]; j++) ans[opt[j]] = ri[opt[j]];
            ans[opt[prf[t]]] = cnt[t];
            for (int i = 0; i < n; i++) cout << ans[i] << " ";
            cout << endl;
        }
        cin >> t;
    }
}

int32_t main(){
#ifdef LOCAL
    auto start = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int ttt = 1;
    cin >> ttt;
    while (ttt--) solve();
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - start) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}