#include <bits/stdc++.h>

using namespace std;

#define rall(x) x.rbegin(), x.rend()
#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)1e18;

void solve() {
    ll n, q;
    cin >> n >> q;

    vector<ll> w(n);
    for (ll i = 0; i < n; ++i) cin >> w[i];

    ll z;
    cin >> z;

    ll MAXAB = 300;

    sort(all(w));

    vector<vector<ll>> dp(MAXAB + 1, vector<ll> (MAXAB + 1, -1)); // minimum max element

    dp[0][0] = 0;

    for (auto i : w) {
        auto new_dp = dp;
        for (ll a = 0; a <= MAXAB; ++a) {
            for (ll b = 0; b <= MAXAB; ++b) {
                if (new_dp[a][b] != -1) continue;
                if (a >= i && dp[a - i][b] != -1) {
                    new_dp[a][b] = i;
                }
                if (b >= i && dp[a][b - i] != -1) {
                    new_dp[a][b] = i;
                }
            }
        }

        swap(dp, new_dp);
    }

    while (q--) {
        ll k, a, b;
        cin >> k >> a >> b;

        if (dp[a][b] != -1 && dp[a][b] <= k) {
            cout << "Yes\n";
        }
        else {
            cout << "No\n";
        }

//        cout << endl;
    }
}

signed main() {
    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}
