// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ld=long double;

#define allv(x) x.begin(),x.end()

template<typename T>
struct smartlist
{
	vector <T> mem;
	ll l;

	smartlist() :l(0) {}
	smartlist(ll l, ll r, const T& val) :l(l), mem(r - l, val) {}

	// [l,r)
	void init(ll l, ll r, const T& val)
	{
		mem.assign(r - l, val);
		this->l = l;
	}

	T& operator[](ll x)
	{
		return mem[x - l];
	}
};

void solve()
{
	ll n;
	cin >> n;
	vector <ll> p(n);
	for (auto& i : p)
	{
		cin >> i;
	}
	ll maxcnt = 0;
	for (size_t mask = 0; mask < (1ll << n); mask++)
	{
		vector <ll>q, r;
		for (size_t i = 0; i < n; i++)
		{
			if (mask & (1ll << i))
				q.push_back(p[i]);
			else
				r.push_back(p[i]);
		}
		ll cur = 0, cnt = 0;
		for (auto& i : q)
		{
			if (i > cur)
				cnt++;
			cur = max(cur, i);
		}
		cur = 1e9;
		for (auto& i : r)
		{
			if (i < cur)
				cnt++;
			cur = min(cur, i);
		}
		maxcnt = max(maxcnt, cnt);
	}
	cout << maxcnt << '\n';
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	ll t;
	cin >> t;
	while (t--)
		solve();
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
