// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstring>

using namespace std;
using ll=long long;

#include <bitset>
#define allv(x) x.begin(),x.end()

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll n, m;
	cin >> n >> m;
	vector <ll> w(n);
	for (auto& i : w)
	{
		cin >> i;
	}
	sort(allv(w));
	ll _t;
	cin >> _t;
	ll mk = 0, ma = 0, mb = 0;
	vector <tuple<ll, ll, ll>> q;
	for (size_t i = 0; i < m; i++)
	{
		ll k, a, b;
		cin >> k >> a >> b;
		mk = max(mk, k);
		ma = max(ma, a);
		mb = max(mb, b);
		q.emplace_back(k, a, b);
	}
	/*bitset<100001> backpack, dp;
	backpack[0] = 1;
	for (auto& i : w)
	{
		backpack |= (backpack << i);
	}
	dp[0] = 1;
	for (size_t i = 1; i < 100001; i++)
	{
		dp[i] = dp[i - 1] && backpack[i];
	}
	for (size_t i = 0; i < m; i++)
	{
		ll k, a, b;
		cin >> k >> a >> b;
		if (dp[a])
			cout << "Yes";
		else
			cout << "No";
		cout << '\n';
	}*/
		/*ll curmx = 0;
		for (auto& i : w)
		{
			if (curmx + 1 < i)
				break;
			curmx += i;
		}*/
		vector <ll> curmx;
		curmx.push_back(0);
		for (auto& i : w)
		{
			if (curmx.back() + 1 < i)
				curmx.push_back(curmx.back());
			else
				curmx.push_back(curmx.back() + i);
		}
		for (size_t i = 0; i < m; i++)
		{
			ll k, a, b;
			k = get<0>(q[i]);
			a = get<1>(q[i]);
			b = get<2>(q[i]);
			auto it = upper_bound(w.begin(), w.end(), a);
			if (curmx[it - w.begin()] < a)
				cout << "No";
			else
				cout << "Yes";
			cout << '\n';
		}
		return _t;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
