#include<bits/stdc++.h>

using namespace std;

using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int pr[8][1 << 7], rev[8][1 << 7];

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    for (int N = 1; N <= 7; ++N) {
        vector<vector<int>> g(1 << N);
        for (int mask = 0; mask < (1 << N); ++mask) {
            for (int m0 = 0; m0 < (1 << N); ++m0) {
                if (__builtin_popcount(mask) == __builtin_popcount(m0) && (mask & m0) == 0) {
                    g[mask].push_back(m0);
                }
            }
        }
        fill(pr[N], pr[N] + (1 << N), -1);
        vector<int> used(1 << N);
        int tim = 0;
        auto kuhn = [&](auto kuhn, int u) -> bool {
            used[u] = tim;
            for (auto to: g[u]) {
                if (pr[N][to] == -1 || (used[to] < tim && kuhn(kuhn, to))) {
                    pr[N][to] = u;
                    return 1;
                }
            }
            return 0;
        };
        for (int i = 0; i < (1 << N); ++i) {
            ++tim;
            kuhn(kuhn, i);
        }
        for (int i = 0; i < (1 << N); ++i) {
            assert(pr[N][i] != -1);
            rev[N][pr[N][i]] = i;
        }
    }

    int in;
    cin >> in;
    if (in == 1) {
        int tc;
        cin >> tc;
        while (tc--) {
            int n, k;
            cin >> n >> k;
            int m = 0;
            for (int i = 0; i < k; ++i) {
                int x;
                cin >> x;
                --x;
                m |= (1 << x);
            }
            m = pr[n][m];
            for (int i = 0; i < n; ++i) {
                if (m >> i & 1) cout << i + 1 << ' ';
            }
            cout << endl;
        }
    } else {
        int tc;
        cin >> tc;
        while (tc--) {
            int n, k;
            cin >> n >> k;
            int m = 0;
            for (int i = 0; i < k; ++i) {
                int x;
                cin >> x;
                --x;
                m |= (1 << x);
            }
            m = rev[n][m];
            for (int i = 0; i < n; ++i) {
                if (m >> i & 1) cout << i + 1 << ' ';
            }
            cout << endl;
        }
    }
}