#include<bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
}

struct SegTree {
    int R;
    vector<int> tr;

    SegTree() = default;
    SegTree(int n) {
        R = 1;
        while (R < n) R <<= 1;
        tr.assign(2 * R, 0);
    }

    void update(int k, int x) {
        k += R;
        tr[k] = x;
        while (k > 1) {
            k >>= 1;
            tr[k] = max(tr[k << 1], tr[k << 1 | 1]);
        }
    }

    int get(int l, int r) {
        int res = 0;
        for (l += R, r += R; l <= r; l >>= 1, r >>=1) {
            if (l & 1) res = max(res, tr[l++]);
            if (~r & 1) res = max(res, tr[r--]);
        }
        return res;
    }
};

int go(vector<pair<int, int>> seg) {
    sort(all(seg), [&](auto x, auto y) {
        return x.second < y.second;
    });
    SegTree tr(seg.back().second + 1);
    for (auto [x, y] : seg) {
        tr.update(y, tr.get(0, x - 1) + 1);
    }
    return tr.get(0, seg.back().second);
}

//Больше не читай, плиз
void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> seg(n);
    vector<int> val;
    for (int i = 0; i < n; ++i) {
        cin >> seg[i].first >> seg[i].second;
        val.push_back(seg[i].first);
        val.push_back(seg[i].second);
    }
    sort(all(val));
    val.resize(unique(all(val)) - val.begin());
    for (auto& [x, y] : seg) {
        x = lower_bound(all(val), x) - val.begin();
        y = lower_bound(all(val), y) - val.begin();
    }
    int m = go(seg);
    int res = -1;
    for (int mask = 0; mask < (1 << n); ++mask) {
        if (__builtin_popcount(mask) != n / 2) continue;
        vector<pair<int, int>> cur;
        for (int i = 0; i < n; ++i) {
            if (mask >> i & 1) cur.push_back(seg[i]);
        }
        if (go(cur) == m / 2) res = mask;
    }
    for (int i = 0; i < n; ++i) if (res >> i & 1) cout << i + 1 << ' ';
    cout << '\n';
}