#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <bitset>
using namespace std;
typedef long long ll;

const int lim = 1e5 + 1;

void dfs(ll v, ll prev, vector <ll>& r, vector <vector <ll>>& dp, vector <vector <ll>>& g)
{
	for (auto i : g[v])
	{
		if (i != prev)
		{
			dfs(i, v, r, dp, g);
			dp[v][0] += max(dp[i][0], dp[i][1]);
			dp[v][1] += dp[i][0];
		}
	}
	dp[v][1] += r[v];
}
ll x, y, m;
void f(ll v, vector <ll>& l, vector <ll>& r, vector <ll>& h, vector <vector <ll>>& g, map <ll, vector <ll>>& mp, map <ll, ll>& k)
{
	if (v == l.size())
	{
		vector <vector <ll>> dp(l.size(), vector <ll>(2));
		dfs(0, 0, h, dp, g);
		ll d = 0;
		for (ll i = 0; i < l.size(); i++)
		{
			d ^= (x * (i + 1) + y * (h[i] * h[i] % m) % m);
		}
		ll ma = max(dp[0][0], dp[0][1]);
		k[ma] = d;
		mp[ma] = h;
		return;
	}
	for (ll u = l[v]; u <= r[v]; u++)
	{
		h.push_back(u);
		f(v + 1, l, r, h, g);
		h.pop_back();
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t;
	cin >> t;
	while (t--)
	{
		ll n, q;
		cin >> n >> q;
		cin >> x >> y >> m;
		vector <vector <ll>> g(n);
		for (ll i = 1; i < n; i++)
		{
			ll u, v;
			cin >> u >> v;
			u--;
			v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		vector <ll> l(n), r(n), ans;
		vector <vector <ll>> dp(n, vector <ll>(2));
		for (ll i = 0; i < n; i++) cin >> l[i] >> r[i];
		map <ll, vector <ll>> mp;
		map <ll, ll> k;
		vector <ll> h;
		f(0, l, r, h, g, mp, k);
		vector <ll> v(q);
		for (ll i = 0; i < q; i++) cin >> v[i];
		for (ll i = 0; i < q; i++)
		{
			if (k.find(v[i]) != k.end()) cout << k[v[i]] << " ";
			else cout << "-1 ";
		}
		cout << endl;
		while (1)
		{
			ll i;
			cin >> i;
			if (i == 0) break;
			i--;
			if (mp.find(v[i]) != mp.end())
			{
				for (auto j : r) cout << j << " ";
			}
			else cout << -1;
			cout << endl;
		}
	}

	return 0;
}
/*



*/