#include <bits/stdc++.h>

#define ll long long
using namespace std;
#pragma optimize GCC ("Ofast", "avx2")
const size_t nMax = 1e2 + 228;
const size_t aMax = 1e2 + 228;
ll n, q;
ll a[nMax];
const size_t maxRes = 10000;
bool good[maxRes][maxRes];

void dfs(ll i, ll aa, ll bb, ll k) {
    if (i >= n)return;
    if (a[i] > k)return;
    if (aa + a[i] < maxRes) {
        good[aa + a[i]][bb] = true;
        dfs(i + 1, aa + a[i], bb, k);
    }
    if (bb + a[i] < maxRes) {
        good[aa][bb + a[i]] = true;
        dfs(i + 1, aa, bb + a[i], k);
    }
    dfs(i + 1, aa, bb, k);
}

void precalc() {
    cin >> n >> q;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    sort(a + 1, a + n + 1);

    ll z;
    cin >> z;

}

void solve() {
    for (int i = 0; i < q; i++) {
        ll k, a, b;
        cin >> k >> a >> b;
        if (a >= maxRes || b >= maxRes) {
            cout << "No\n";
            continue;
        }
        memset(good, 0, sizeof good);
        good[0][0] = true;
        dfs(1, 0, 0, k);
        bool f = true;
        for (ll i = 0; i <= a; i++) {
            for (ll j = 0; j <= b; j++)
                if (!good[i][j])
                    f = false;
        }
        if (f)
            cout << "Yes\n";
        else
            cout << "No\n";
    }
}

int main() {
#ifdef VNT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    precalc();
    int q = 1;
    //cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
        cout << endl;
    }
    return 0;
}
