#include "bits/stdc++.h"

using namespace std;

#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(x) cout << #x << " = " << x << endl;

const int infll = 1e18;

const int N = 2e2 + 10;

int dp[N][N];

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int j = 0; j < n; j++) {
        cin >> a[j];
    }
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
            dp[i][j] = -infll;
        }
    }
    dp[0][0] = 0;
    dp[1][0] = 1;
    dp[0][1] = 1;
    int ans = 0;
    for (int i = 2; i <= n; i++) {
        for (int j = 0; j < i; j++) {
            for (int k = 0; k < i; k++) {
                if (j == k) continue;
                // dp[j][k] -> dp[i][k]
                if (j == 0 || a[i - 1] > a[j - 1]) {
                    dp[i][k] = max(dp[i][k], dp[j][k] + 1);
                }
                if (k == 0 || a[i - 1] < a[k - 1]) {
                    dp[j][i] = max(dp[j][i], dp[j][k] + 1);
                }
            }
        }
    }
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++) {
//            cout << "dp[" << i << "][" << j << "] = " << dp[i][j] << endl;
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans << '\n';
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}