#include<iostream>
#include<vector>
#include<algorithm>
#include<random>
using namespace std;

#define int long long

vector<int> hes;
vector<int> wes;

pair<int, int> func(int h, int k) {
	pair<int, int> besth;
	int tmin, tmax;
	tmin = hes[0]; tmax = hes.back();
	besth = { tmax - tmin + 1, 0 };
	int sd = 0;
	for (int i = 0; i < hes.size() - 1; i++) {
		sd = hes[i];
		besth = min(besth, { h - hes[i + 1] + sd + 1, min(sd, h - hes[i + 1] + 1) });
	}
	return besth;
}



void solve() {
	int h, w, k;
	cin >> h >> w >> k;
	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y;
		hes.push_back(x);
		wes.push_back(y);
	}

	sort(hes.begin(), hes.end());
	hes.resize(unique(hes.begin(), hes.end()) - hes.begin());
	sort(wes.begin(), wes.end());
	wes.resize(unique(wes.begin(), wes.end()) - wes.begin());
	auto bh = func(h, k);
	swap(hes, wes);
	auto bw = func(w, k);
	cout << bh.first * bw.first << " " << bh.second + bw.second << "\n";
	return;
}

signed main() {
	solve();
}

/*5 2 2
2 1
5 2*/