#include <bits/stdc++.h>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define fi first
#define se second
#define all(v) (v).begin(), (v).end()

using namespace std;
using ll = long long;
using pii = pair <int, int>;

void f_g1(int n, int k, vector <int>& a){
    cout << a[0]%n + 1 << endl;
    return;
}

void s_g1(int n, int k, vector <int>& a){
    cout << (a[0] == 1 ? n : a[0] - 1) << endl;
    return;
}

void f_g3(int n, int k, vector <int>& a){
    vector <bool> is(n, 0);
    for(auto& x : a){
        is[x - 1] = 1;
    }
    for(int i = 0; i < n; ++i){
        if(!is[i]){
            cout << i + 1 << ' ';
        }
    }
    cout << endl;
    return;
}

void s_g3(int n, int k, vector <int>& a){
    vector <bool> is(n, 0);
    for(auto& x : a){
        is[x - 1] = 1;
    }
    for(int i = 0; i < n; ++i){
        if(!is[i]){
            cout << i + 1 << ' ';
        }
    }
    cout << endl;
    return;
}

void f_try(int n, int k, vector <int>& a){
    vector <bool> is(n, 0);
    for(auto& x : a){
        is[x - 1] = 1;
    }
    vector <int> nw;
    for(int i = 0; i < n; ++i){
        if(!is[i]){
            nw.push_back(i + 1);
        }
        if((int)nw.size() == k){ break;}
    }
    for(auto w : nw){
        cout << w << ' ';
    }
    cout << endl;
    return;
}

void s_try(int n, int k, vector <int>& a){
    vector <bool> is(n, 0);
    for(auto& x : a){
        is[x - 1] = 1;
    }
    vector <int> nw;
    for(int i = n - 1; i >= 0; --i){
        while(!is[i]){
            --i;
        }
        if(!is[i]){
            nw.push_back(i + 1);
        }
        if((int)nw.size() == k){ break;}
    }
    reverse(all(nw));
    for(auto w : nw){
        cout << w << ' ';
    }
    cout << endl;
    return;
}

inline int gt(int x, int d, int n){
    --x;
    x = (x + d)%n;
    return x + 1;
}

inline int _gt(int x, int d, int n){
    --x;
    x = (x - d + n)%n;
    return x + 1;
}

void f_g2(int n, int k, vector <int>& a){
    if(gt(a[0], 1, n) == a[1] or gt(a[1], 1, n) == a[0]){
        cout << min(gt(a[0], 2, n), gt(a[1], 2, n)) << ' ' << max(gt(a[0], 2, n), gt(a[1], 2, n));
    }
    else{
        cout << min(gt(a[0], 1, n), gt(a[1], 1, n)) << ' ' << max(gt(a[0], 1, n), gt(a[1], 1, n));
    }
    cout << endl;
    return;
}

void s_g2(int n, int k, vector <int>& a){
    if(gt(a[0], 1, n) == a[1] or gt(a[1], 1, n) == a[0]){
        cout << min(_gt(a[0], 2, n), _gt(a[1], 2, n)) << ' ' << max(_gt(a[0], 2, n), _gt(a[1], 2, n));
    }
    else{
        cout << min(_gt(a[0], 1, n), _gt(a[1], 1, n)) << ' ' << max(_gt(a[0], 1, n), _gt(a[1], 1, n));
    }
    cout << endl;
    return;
}

void f_g5(int n, int k, vector <int>& a){
    vector <int> vec;
    for(auto x : a){
        vec.push_back(gt(x, 1, n));
    }
    sort(all(vec));
    for(auto w : vec){
        cout << w << ' ';
    }
    cout << endl;
    return;
}

void s_g5(int n, int k, vector <int>& a){
    vector <int> vec;
    for(auto x : a){
        vec.push_back(_gt(x, 1, n));
    }
    sort(all(vec));
    for(auto w : vec){
        cout << w << ' ';
    }
    cout << endl;
    return;
}

void f_g6(int n, int k, vector <int>& a){
    vector <int> v;
    int d = a[k - 1] - a[0] + 1;
    for(auto x : a){
        v.push_back(gt(x, d, n));
    }
    sort(all(v));
    for(auto x : v){
        cout << x << ' ';
    }
    cout << endl;
    return;
}

void s_g6(int n, int k, vector <int>& a){
    vector <int> v;
    int mx = a[k - 1] - a[0];
    for(int i = 0; i < k - 1; ++i){
        mx = max(mx, a[i + 1] - a[i]);
    }
    //cout << mx << endl;
    int d = n - mx + 1;
    for(auto x : a){
        v.push_back(_gt(x, d, n));
    }
    sort(all(v));
    for(auto x : v){
        cout << x << ' ';
    }
    cout << endl;
    return;
}

void fir(){
    int n, k;
    cin >> n >> k;
    vector <int> a(k);
    for(auto& x : a){
        cin >> x;
    }
    f_g6(n, k, a);
}

void sec(){
    int n, k;
    cin >> n >> k;
    vector <int> a(k);
    for(auto& x : a){
        cin >> x;
    }
    s_g6(n, k, a);
}

signed main(){
    ibase;
    int ty, t;
    cin >> ty >> t;
    while(t --> 0){
        if(ty == 1){
            fir();
        }
        else{
            sec();
        }
    }
}
/**
1
1
6 2
2 4

2
1
6 2
1 5

**/
