#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define len(x)(int)(x).size()

typedef long long ll;
using namespace std;

const int INF = 1e9 + 100;

#define MT
void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (auto &el : a) cin >> el;

    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 2, vector<int>(n + 2, -INF)));

    dp[0][0][n + 1] = 0;

    for (int it = 0; it < n; ++it) {
//        dp[it + 1] = dp[it];

        for (int j = a[it] + 1; j < n + 2; ++j) {
            for (int k = 0; k < a[it]; ++k) {
                dp[it + 1][j][k] = dp[it][j][k];
            }
        }

        for (int k = 0; k < n + 2; ++k) {
            for (int j = 0; j < a[it]; ++j) {
                dp[it + 1][a[it]][k] = max(dp[it][j][k] + 1, dp[it + 1][a[it]][k]);
            }
        }

        for (int j = 0; j < n + 2; ++j) {
            for (int k = a[it] + 1; k < n + 2; ++k) {
                dp[it + 1][j][a[it]] = max(dp[it][j][k] + 1, dp[it + 1][j][a[it]]);
            }
        }
    }

    int ans = 0;
    for (int j = 0; j < n + 2; ++j) {
        for (int k = 0; k < n + 2; ++k) {
            ans = max(ans, dp.back()[j][k]);
        }
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
//    cin >> TYPE;
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}