#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;

int z, u = 0, n;
vector<long long> arr;
vector<long long> ra, rb;

void perebor(long long k, int i, vector<int>& mask) {
	if (n == i) {
		long long a = 0, b = 0;
		for (int j = 0; j < n; ++j) {
			if (mask[j] == 1) {
				a += arr[j];
			}
			if (mask[j] == 2) {
				b += arr[j];
			}
		}
		ra.push_back(a);
		rb.push_back(b);
		return;
	}
	else {
		if (arr[i] > k) {
			mask[i] = 0;
			perebor(k, i + 1, mask);
		}
		for (int j = 0; j < 3; ++j) {
			mask[i] = j;
			perebor(k, i + 1, mask);
		}
	}
}

vector<bool> dp(1e5 + 113, false);

void solve() {
	long long j, c, d;
	cin >> j >> c >> d;
	long long k = j - u * z,
		a = c - u * z,
		b = d - u * z;
	vector<int> mask(10);
	ra = vector<long long> ();
	rb = vector<long long> ();
	perebor(k, 0, mask);
	sort(ra.begin(), ra.end());
	sort(rb.begin(), rb.end());

	int __j = 0;
	for (int i = 0; i <= a; ++i) {
		if (ra[__j] == i) ++__j;
	}

	int _j = 0;
	for (int i = 0; i <= b; ++i) {
		if (rb[_j] == i) ++_j;
	}
	if (__j >= a && _j >= b) {
		cout << "Yes\n";
		++u;
	}
	else {
		cout << "No\n";
	}
}

signed main() {
	int q;
	cin >> n >> q;
	arr.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> arr[i];
	cin >> z;
	sort(arr.begin(), arr.end());

	while (q--) solve();
	return 0x0;
}
