#include<bits/stdc++.h>
#define S second
#define F first
typedef long long ll;
using namespace std;

const int SZ = 2e5 + 1;
int n, a[SZ], ans;

void input()
{
    cin >> n;
    a[0] = 0;
    for(int i = 1; i <= n; i++) cin >> a[i];
}

void output()
{
    cout << ans << endl;
}

void solve()
{
    a[n] = -1;
    vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(n + 1));
    dp[1][0] = {1, 1};
    dp[1][1] = {1, 0};
    for (int i = 2; i <= n; i++)
    {
        for (int last = 0; last < i; last++)
        {
            int cur = dp[i - 1][last].F + 1;
            if (last == 0 || (cur > dp[i][i].F && a[last] > a[i]))
            {
                dp[i][i].F = cur;
                dp[i][i].S = dp[i - 1][last].S;
            }
            else if (cur == dp[i][i].F && a[last] > a[i])
            {
                if (a[dp[i][i].S] > a[dp[i - 1][last].S]) dp[i][i].S = dp[i - 1][last].S;
            }
            dp[i][last] = dp[i - 1][last];
            if (a[i] > a[dp[i - 1][last].S])
            {
                dp[i][last].F++;
                dp[i][last].S = i;
            }
        }
    }
    ans = 0;
    for (int i = 0; i <= n; i++) ans = max(ans, dp[n][i].F);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int k = 1;
    cin >> k;
    for (int i = 0; i < k; i++)
    {
        input();
        solve();
        output();
    }
}