#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define int ll

map<tuple<ll, ll, ll>, bool> can;

void gen(vector<int> & t, vector<ll> & w) {
    if (t.size() == w.size()) {
        ll sum1 = 0, sum2 = 0, k = 0;
        for (int i = 0; i < (int)t.size(); i++) {
            if (t[i] == 1) sum1 += w[i];
            if (t[i] == 2) sum2 += w[i];
            if (t[i] != 3) k = i + 1;
        }
        for (int nk = k; nk <= (int)w.size(); nk++) {
            can[{nk, sum1, sum2}] = true;
        }
        return;
    }
    for (int i = 1; i <= 3; i++) {
        t.push_back(i);
        gen(t, w);
        t.pop_back();
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    sort(w.begin(), w.end());
    vector<int> t;
    gen(t, w);
    int z;
    cin >> z;
    for (int i = 0; i < q; i++) {
        ll k, a, b;
        cin >> k >> a >> b;
        k = upper_bound(w.begin(), w.end(), k) - w.begin();
        bool res = true;
        for (ll a1 = a; a1 >= 0; a1--) {
            for (ll b1 = b; b1 >= 0; b1--) {
                if (!can.count({k, a1, b1})) res = false;
                if (!res) break;
            }
            if (!res) break;
        }
        if (res) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    t = 1;
    for (int i = 0; i < t; i++) solve();
}
