// 7f priv
// vot by prizera

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()
#define sz(a) (int) a.size()
#define f(i, l, r) for (int i = (l); i < (r); i++)
#define pb push_back
#define sc second
#define ff first
#define pii pair<int, int>
#define int long long

mt19937 rnd(time(NULL));

vector<vector<int>> g;
vector<pii> a;
vector<int> dp, dp2;

void dfs(int v, int p) {
    int fir = 0, fir2 = 0, sec = a[v].sc, sec2 = a[v].ff;
    for (auto &u : g[v]) {
        if (u != p) {
            dfs(u, v);
            fir += dp[u];
            fir2 += dp2[u];
        }
    }

    for (auto &u : g[v]) {
        if (u == p) continue;
        for (auto &u2 : g[u]) {
            if (u2 != v) sec += dp[u2];
            if (u2 != v) sec2 += dp2[u2];
        }
    }
    dp[v] = max(fir, sec);
    dp2[v] = max(fir2, sec2);
}

vector<int> gen(int v, int p) {
    int fir = 0, sec = a[v].sc;
    for (auto &u : g[v]) {
        if (u != p) {
            dfs(u, v);
            fir += dp[u];
        }
    }

    for (auto &u : g[v]) {
        if (u == p) continue;
        for (auto &u2 : g[u]) {
            if (u2 != v) sec += dp[u2];
        }
    }
    if (fir > sec) {
        vector<int> ans;
        for (auto &u : g[v]) {
            if (u == p) continue;
            vector<int> result = gen(u, v);
            for (auto & V : result) ans.pb(V);
        }
        return ans;
    } else {
        vector<int> ans = {v};
        for (auto &u : g[v]) {
            if (u == p) continue;
            for (auto &u2 : g[u]) {
                if (u2 == v) continue;
                vector<int> result = gen(u2, u);
                for (auto & V : result) ans.pb(V);
            }
        }
        return ans;
    }
}

void solve() {
    int n, q; cin >> n >> q;
    int x, y, m; cin >> x >> y >> m;
    g.assign(n, {});
    f (i, 0, n - 1) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].pb(v);
        g[v].pb(u);
    }

    a.assign(n, {0, 0});
    f (i, 0, n) cin >> a[i].ff >> a[i].sc;
    vector<int> reqs(q);
    f (i, 0, q) cin >> reqs[i];
    dp.assign(n, 0);
    dp2.assign(n, 0);

    dfs(0, 0);
    vector<int> ch = gen(0, 0), ch2;
    f (i, 0, sz(ch)) {
        if (a[ch[i]].sc == 1) ch2.pb(ch[i]);
    }
    swap(ch, ch2);

    int K = 0;
    f (i, 0, n) {
        K ^= ((x * (i + 1)) % m + ((y * a[i].ff) % m * a[i].ff)%m)%m;
    }

    for (auto &i : ch2) {
        K ^= ((x * (i + 1)) % m + ((y * a[i].ff) % m * a[i].ff)%m)%m;
        K ^= ((x * (i + 1)) % m + ((y * a[i].sc) % m * a[i].sc)%m)%m;
    }

    vector<int> KK(dp[0] + 1, K);
    for (int i = dp[0] - 1; i >= 0; i--) {
        K ^= ((x * (ch[i] + 1)) % m + ((y * a[ch[i]].sc) % m * a[ch[i]].sc)%m)%m;
        K ^= ((x * (ch[i] + 1)) % m + ((y * a[ch[i]].ff) % m * a[ch[i]].ff)%m)%m;
        KK[i]=K;
    }


    for (int i = 0; i < q; i++) {
        if (dp2[0] <= reqs[i] && reqs[i] <= dp[0]) cout << KK[reqs[i]] << ' ';
        else cout << "-1 ";
    }
    cout << endl;

    int numb; cin >> numb;
    while (numb != 0) {
        if (dp2[0] <= reqs[numb - 1] && reqs[numb - 1] <= dp[0]) {
            vector<int> answer(n, 0);
            for (int j = 0; j < reqs[numb - 1]; j++) answer[ch[j]] = 1;
            for (auto &u : answer) cout << u << ' ';
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> numb;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int tt = 1; cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}