#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define all(x) begin(x), end(x)
#define ll long long

int n;

struct node {
	int l = -1, r = -1;
	bool sz = 0;
	node() {};
};



int getmx(int l, int r, vector<int>& a) {
	int ret = 0;
	for (int i = l; i <= r; i++) ret = max(ret, a[i]);
	return ret;
}

void add1(vector<int>& a) {
	for (int i = 0; i <= n; i++) a[i]++;
}


int solve(vector<int>& a) {

	int n = a.size();
	int ret = 0;
	for (int mask = 0; mask < (1 << n); mask++) {

		int mn = 1e9, mx = 0;
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				if (a[i] < mn) {
					cnt++;
					mn = a[i];
				}
				
			}
			else {
				if (a[i] > mx) {
					cnt++;
					mx = a[i];
				}
			}
		}
		ret = max(ret, cnt);

		mn = 1e9, mx = 0;
		cnt = 0;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				if (a[i] > mx) {
					cnt++;
					mx = a[i];
				}

			}
			else {
				if (a[i] < mn) {
					cnt++;
					mn = a[i];
				}
				
			}
		}
	}
	return ret;
}

int main() {


	int t;

	cin >> t;
	while (t--) {

		cin >> n;

		vector<int> p(n);

		for (int i = 0; i < n; i++)cin >> p[i];

		cout << solve(p) << "\n";
	}




	return 0;
}