#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define all(x) begin(x), end(x)
#define ll long long

int n;

struct node {
	int l = -1, r = -1;
	bool sz = 0;
	node() {};
};



int getmx(int l, int r, vector<int>& a) {
	int ret = 0;
	for (int i = l; i <= r; i++) ret = max(ret, a[i]);
	return ret;
}

void add1(vector<int>& a) {
	for (int i = 0; i <= n; i++) a[i]++;
}


int solve(vector<int>& a) {

	int n = a.size();
	int ret = 0;
	for (int mask = 0; mask < (1 << n); mask++) {

		int mn = 1e9, mx = 0;
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				if (a[i] < mn) {
					cnt++;
					mn = a[i];
				}

			}
			else {
				if (a[i] > mx) {
					cnt++;
					mx = a[i];
				}
			}
		}
		ret = max(ret, cnt);

		mn = 1e9, mx = 0;
		cnt = 0;
		for (int i = 0; i < n; i++) {
			if (mask & (1 << i)) {
				if (a[i] > mx) {
					cnt++;
					mx = a[i];
				}

			}
			else {
				if (a[i] < mn) {
					cnt++;
					mn = a[i];
				}

			}
		}
	}
	return ret;
}

#define N 1000


int used[N];
int k;

int mx(int mask) {
	int mex = 0;

	for (int i = 0; i < k; i++) {
		if (!(mask & (1 << i))) {
			mex = i;
			break;
		}
	}
	return mex;
}

int gg = -1;
bool fl = 1;
int cur = -1;
bool stop = 0;

void dfs(int mask) {
	
	if (used[mask]) {
		cur = mask;
		gg = mx(mask);
		return;
	}
	used[mask] = 1;

	int mex = 0;

	for (int i = 0; i < k; i++) {
		if (!(mask & (1 << i))) {
			mex = i;
			break;
		}
	}

	int nmask = 0;
	for (int i = 0; i < k; i++) {
		if (mask & (1 << i)) {
			nmask |= (1 << (i ^ mex));
		}
	}

	dfs(nmask);
	if (stop) return;
	if (mex != mx(nmask)) {
		fl = 0;
	}

	if (cur == mask) {
		stop = 1;
	}
}

int main() {
	/*
	for (int i = 0; i <N; i++) used[i] = 0;
	int n, p;
	cin >> k >> n >> p;
	int ans = 0;

	for (int mask = 0; mask < (1 << k); mask++) {


		stop = 0;
		fl = 0;
		gg = -1;
		dfs(mask);
		if (!(mask & 1)) continue;
		
		if (fl && gg == p) ans++;

	}

	cout << ans;*/

	int n, k, p;
	cin >> n >> k >> p;
	if (n == 1 && p == 1) cout << 1;
	else cout << 0;


	return 0;
}