#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9;
const ll INF_ll = 1e18;
const int mod = 1e9 + 7;

vector<vector<int> > g;
vector<int> l, r;

vector<vector<int> > dp;
vector<int> a;

void dfs(int v, int p = -1) {
    dp[v][1] = r[v];
    for (auto to : g[v]) {
        if (to == p) continue;
        dfs(to, v);
        dp[v][0] += max(dp[to][0], dp[to][1]);
        dp[v][1] += dp[to][0];
    }
}

void dfs1(int v, int k = 0, int p = -1) {
    bool f = 0;
    if (k == 0) {
        if (dp[v][0] > dp[v][1]) {
            a[v] = 0;
        } else {
            a[v] = r[v];
            f = 1;
        }
    } else {
        a[v] = 0;
    }
    for (auto to : g[v]) {
        if (to == p) continue;
        dfs1(to, f, v);
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    g.resize(n);
    l.resize(n);
    r.resize(n);
    a.resize(n);
    dp.resize(n, vector<int>(2));
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    dfs(0);
    dfs1(0);
    vector<int> b;
    for (int i = 0; i < n; i++) {
        if (a[i]) {
            b.push_back(i);
        }
    }
    vector<ll> plan(n + 1);
    for (int i = 0; i < n; i++) {
        plan[0] ^= x * (i + 1) % m;
    }
    for (int i = 1; i <= b.size(); i++) {
        ll old = x * b[i - 1] % m, _new = (old + y) % m;
        plan[i] = plan[i - 1] ^ old ^ _new;
    }
    vector<int> v(q);
    for (int i = 0; i < q; i++) {
        cin >> v[i];
        if (max(dp[0][0], dp[0][1]) < v[i]) {
            cout << -1 << ' ';
        } else {
            cout << plan[v[i]] << ' ';
        }
    }
    cout << endl;
    while (1) {
        int x;
        cin >> x;
        if (x == 0) {
            return;
        }
        x--;
        if (max(dp[0][0], dp[0][1]) < v[x]) {
            cout << -1;
        } else {
            vector<int> cur_a(n);
            for (int i = 0; i < v[x]; i++) {
                cur_a[b[i]] = 1;
            }
            for (int i = 0; i < n; i++) {
                cout << cur_a[i] << ' ';
            }
        }
        cout << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
        g.clear(), a.clear(), dp.clear(), l.clear(), r.clear();
    }
    return 0;
}