#include <vector>
#include <iostream>
#include <algorithm>
#include <cassert>
#include <set>

using namespace std;

vector<int> solve1(vector<int> v, int n, int k);
vector<int> solve2(vector<int> v, int n, int k);

using ll = long long;

bool check(vector<int> v, vector<int> w){
    if (v.size() != w.size()){
        return false;
    }
    for (int i = 0; i < w.size(); ++i) {
        v.push_back(w[i]);
    }
    sort(v.begin(), v.end());
    return (unique(v.begin(), v.end()) == v.end());
}

signed main() {
    int z;
    cin >> z;
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<int> v(k);
        for (int i = 0; i < k; ++i) {
            cin >> v[i];
        }
        sort(v.begin(), v.end());
        if (z == 1) {
            vector<int> w = solve1(v, n, k);
            for (auto el : w){
                cout << el << ' ';
            }
            cout << endl;
        } else if (z == 2) {
            vector<int> w = solve2(v, n, k);
            for (auto el : w){
                cout << el << ' ';
            }
            cout << endl;
        }
        vector<int> v1 = solve1(v, n, k);
        vector<int> v2 = solve2(v1, n, k);
        if (v != v2 || !check(v, v1) || !check(v1, v2)){
            while (true){

            }
        }
    }
}

vector<int> solve1(vector<int> v, int n, int k) {
    set<int> st;
    for (int i = 0; i < n; ++i) {
        st.insert(i);
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j <= i; ++j) {
            st.erase(v[i] - v[j]);
        }
    }
//    if (st.empty()) {
//        while (true) {
//
//        }
//    }
    int x = *st.begin();
    cerr << x << endl;
    vector<int> w(k);
    for (int i = 0; i < k; ++i) {
        w[i] = (v[i] + x > n ? v[i] + x - n : v[i] + x);
    }
    sort(w.begin(), w.end());
    return w;
}

vector<int> solve2(vector<int> v, int n, int k) {
    set<int> st;
    for (int i = 0; i < n; ++i) {
        st.insert(i);
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j <= i; ++j) {
            st.erase(v[i] - v[j]);
        }
    }
//    if (st.empty()) {
//        while (true) {
//
//        }
//    }
    int x = *st.begin();
    cerr << x << endl;
    vector<int> w(k);
    for (int i = 0; i < k; ++i) {
        w[i] = (v[i] - x < 1 ? v[i] - x + n : v[i] - x);
    }
    sort(w.begin(), w.end());
    return w;
}
/*
1 10
5 2
2 3
4 5

5 2
3 4
5 1

5 2
4 5
1 2

5 2
5 1
2 3

5 2
1 2
3 4






2 10
5 2
4 5

5 2
5 1

5 2
1 2

5 2
2 3

5 2
3 4


2
2
2 1
2
5 2
2 5
 3
    2
    2 1
    1
    5 2
    1 4
 */