//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;

void solve();

int main(){
    int t;
    cin >> t;
    while (t--){
        solve();
    }
}

bool cmp(pair<int, pair<int, int>> x, pair<int, pair<int, int>> y) {
    return make_pair(x.second.second, x.second.first) < make_pair(y.second.second, y.second.first);
}


vector<int> ind;

int get(vector<pair<int, pair<int, int>>> w){
    int n = w.size();
    int mx = -1;
    int cnt = 0;
    ind.clear();
    for (int i = 0; i < n; ++i) {
        if (w[i].second.first > mx){
            mx = w[i].second.second;
            cnt++;
            ind.push_back(w[i].first);
        }
    }
    return cnt;
}

void solve() {
    int n;
    cin >> n;
    vector<int> l(n);
    vector<int> r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        v[i] = {l[i], r[i]};
    }
    vector<pair<int, int>> order(n);
    for (int i = 0; i < n; ++i) {
        order[i] = {r[i], i};
    }
    sort(order.begin(), order.end());
    sort(v.begin(), v.end(),
         [&](pair<int, int> a, pair<int, int> b) {
             return make_pair(a.second, a.first) < make_pair(b.second, b.first);
         });
    vector<pair<int, pair<int, int>>> w(n);
    for (int i = 0; i < n; ++i) {
        w[i] = {i, v[i]};
    }
    get(w);
    set<int> bad0;
    set<int> bad1;
    for (int i = 0; i < n; ++i) {
        if (i % 2 == 0){
            bad0.insert(ind[i]);
        } else{
            bad1.insert(ind[i]);
        }
    }
    for (int i = 0; i < ind.size(); i += 2){
        int L = v[ind[i]].second;
        int R = 1e9 + 5;
        if (i + 2 < ind.size()){
            R = v[ind[i + 2]].first;
        }
        int jj = n;
        if (i + 2 < n){
            jj = ind[i + 2];
        }
        for (int j = ind[i] + 1; j < jj; ++j){
            if (v[i].first > L && v[i].second < R){
                bad1.insert(j);
            }
        }
    }
    for (int i = 1; i < ind.size(); i += 2){
        int L = -1;
        int R = v[ind[i]].first;
        if (i > 2){
            R = v[ind[i - 2]].second;
        }
        int jj = 0;
        if (i - 2 > 0){
            jj = ind[i - 2];
        }
        for (int j = jj + 1; j < ind[i]; ++j){
            if (v[i].first > L && v[i].second < R){
                bad0.insert(j);
            }
        }
    }
    vector<int> take(n, 1);
    int cnt = n / 2;
    if (bad0.size() <= n / 2){
        for (auto el : bad0){
            take[el] = 0;
        }
        for (int i = 1; i < ind.size(); i += 2){
            take[ind[i]] = 2;

        cnt--;
        }
    } else{
        for (auto el : bad1){
            take[el] = 0;
        }
        for (int i = 0; i < ind.size(); i += 2){
        cnt--;
               take[ind[i]] = 2;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (take[i] == 2){
            cout << order[i].second + 1 << ' ';
        } else if (take[i] == 1 && cnt > 0){
            --cnt;
            cout << order[i].second + 1 << ' ';
        }
    }
    cout << endl;
}
