#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cassert>
#include <iomanip>
#include <cstdio>
#include <bitset>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <ctime>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
ll M;
ll k, n, p, ans;
vector <ll> a;

ll mex(vector <ll> a) {
	ll t = 0;
	for (ll i = 0; i <= (1ll << k); i++) {
		if (t == a.size() || a[t] != i)
			return i;
		else
			t++;
	}
	assert(0);
}

vector <ll> ultra(vector <ll> a, ll m) {
	for (auto& r : a)
		r ^= m;
	sort(a.begin(), a.end());
	return a;
}

void rec(ll mx, ll kl) {
	if (kl == n) {
		vector <ll> x = a;
		ll m = mex(x);
		set < pair <ll, vector<ll>> > st;
		st.insert({ m, x });
		while (1ll) {
			vector <ll> b = x;
			ll pm = m;

			x = ultra(x, m - 1ll);
			m = mex(x);
			if (m == p && m == pm && x == b) {
				ans++;
				break;
			}
			if (st.count({ m, x }))
				break;

			st.insert({ m, x });
		}
		return;
	}
	for (ll i = mx + 1ll; i < (1ll << k); i++) {
		a.push_back(i);
		rec(i, kl + 1ll);
		a.pop_back();
	}
}

void solve() {
	cin >> k >> n >> p;
	ans = 0;
	a.push_back(0);
	rec(0, 1);
	a.pop_back();
	cout << ans % M;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif  
	ll t;
	cin >> M >> t;
	while (t--) {
		solve();
		cout << endl;
	}
}