#include <bits/stdc++.h>

#define x first
#define y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define ll int64_t
#define ld long double

#define int ll
#define double ld
#define endl '\n'


using namespace std;

const int inf = 1e9 + 10;

struct Seg {
    int l, r, i;
};

void solve() {
    int n;
    cin >> n;
    vector<Seg> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].l >> arr[i].r;
        arr[i].i = i;
    }

    sort(all(arr), [&](auto & a, auto & b) {
        if (a.r != b.r)
            return a.r < b.r;
        return a.l < b.l;
    });

    vector<bool> good(n);

    vector<int> flex;
    for (int i = 0, r = 0; i < n; ++i) {
        if (arr[i].l > r) {
            good[i] = true;
            r = arr[i].r;
            flex.push_back(i);
        }
    }

    int m = flex.size();

    vector<int> cost(n);

    vector<int> le(n), re(n);

    for (int i = 0; i < m; ++i) {
        int l = 1;
        if (i != 0)
            l = arr[flex[i - 1]].r + 1;

        int r = inf;
        if (i != m - 1)
            r = arr[flex[i + 1]].l - 1;

        le[flex[i]] = l;
        re[flex[i]] = r;

        for (int j = 0; j < n; ++j) {
            if (l <= arr[j].l and arr[j].r <= r) {
                assert(!good[j] or j == flex[i]);
                ++cost[flex[i]];
            }
        }
    }

    vector<int> tmp = flex;
    int a = 0;
    for (int i = 0; i < m; i += 2)
        a += cost[tmp[i]];

    if (a > n / 2) {
        for (int i = 0; i < m; i += 2)
            swap(tmp[i], tmp[i + 1]);
    }

    int st = 0;

    vector<bool> used(n);

    for (int i = 0; i < m; i += 2) {
        int l = le[tmp[i]];
        int r = re[tmp[i]];

        for (int i = 0; i < n; ++i) {
            if (l <= arr[i].l and arr[i].r <= r) {
                used[i] = true;
                ++st;
            }
        }
    }
    assert(st <= n / 2);

    int j = 0;
    while (st < n / 2) {
        while ((good[j] or used[j]) and j < n)
            ++j;
        assert(j < n);
        used[j] = true;
        ++st;
    }

    for (int i = 0; i < n; ++i) {
        if (!used[i])
            cout << arr[i].i + 1 << " ";
    }
    cout << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}