#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

long long fw[700][700];
const long long sz = 500;
long long askin(long long out, long long r) {
	long long ans = 0;
	while (r >= 0) {
		ans += fw[out][r];
		r = (r & (r + 1)) - 1;
	}
	return ans;
}
long long askin(long long out, long long l, long long r) {
	return askin(out, r) - askin(out, l - 1);
}
void addin(long long out, long long pos,long long val) {
	while (pos < sz) {
		fw[out][pos] += val;
		pos = pos | (pos + 1);
	}
}
long long ask(long long r, long long lin, long long rin) {
	long long ans = 0;
	while (r >= 0) {
		ans += askin(r, lin, rin);
		r = (r & (r + 1)) - 1;
	}
	return ans;
}
long long ask(long long l, long long r, long long lin, long long rin) {
	return ask(r, lin, rin) - ask(l - 1, lin, rin);
}
void add(long long pos, long long posin, long long val) {
	while (pos < sz) {
		addin(pos, posin, val);
		pos = pos | (pos + 1);
	}
}
int fw2[700][700];
int  main() {
	long long n,q;
	cin >> n>>q;
	vector<long long> w(n);
	for (long long i = 0; i < n; i++) {
		cin >> w[i];
	}
	sort(w.begin(), w.end());
	vector<long long> k(q);
	vector<long long> a(q), b(q);
	vector<long long> rqs(q);
	long long z;
	cin >> z;
	for (long long i = 0; i < q; i++) {
		cin >> k[i] >> a[i] >> b[i];
		rqs[i] = i;
	}
	sort(rqs.begin(), rqs.end(), [&](long long aa, long long bb) {
		return k[aa] < k[bb]; });


	vector<long long> ans(q);
	long long proc = -1;
	//add(0, 0, 1);
	fw[0][0] = 1;
	
	for (int zz = 0; zz < n; zz++) {
		
			for (long long i = sz - 1; i >= 0; i--) {
				for (long long j = sz - 1; j >= 0; j--) {
					if (i >= w[zz]) {
						if (!fw[i][j] && fw[i - w[zz]][j]) {
							fw[i][j] = 1;;
						}
					}
					if (j >= w[zz]) {
						if (!fw[i][j] && fw[i][j - w[zz]]) {
							fw[i][j] = 1;;
						}
					}
				}
			}
		
	}
	for (long long i = 0; i < sz; i++) {
		for (long long j = 0; j < sz; j++) {
			if (i != 0) {
				fw[i][j] += fw[i - 1][j];
			}
			if (j != 0) {
				fw[i][j] += fw[i][j - 1];
			}
			if (i != 0 && j != 0) {
				fw[i][j] -= fw[i - 1][j - 1];
			}
		}
	}
	for (long long qq = 0; qq < q; qq++) {
		long long kk = k[rqs[qq]];
		long long aa = a[rqs[qq]];
		long long bb = b[rqs[qq]];
		
	
		
		long long exp = (aa + 1) * (bb + 1);
		long long real = fw[aa][bb];
		
		if (exp == real) {
			ans[rqs[qq]] = 1;
		}

	}
	for (auto h : ans) {
		if (h) {
			cout << "Yes"<<endl;
		}
		else {
			cout << "No"<<endl;
		}
	}
}