#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")
#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
typedef long long ll;

vector<vector<ll> > g;
vector<ll> l, r, dp[2];

void dfs(ll v, ll p) {
    if (r[v] == 1) dp[1][v] = 1;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
            if (r[v] == 1) dp[1][v] += dp[0][u];
            dp[0][v] += max(dp[0][u], dp[1][u]);
        }
    }
    //cout << " " << v << " " << dp[0][v] << " " << dp[1][v] << endl;
}

vector<ll> p;
void find_p(ll v, ll prev, ll x) {
    ll y = 0;
    if (x == 0) {
        if (dp[0][v] <= dp[1][v] && r[v] == 1) {
            p.pb(v);
            y = 1;
        }
    }

    for (auto u : g[v]) {
        if (u != prev) {
            find_p(u, v, y);
        }
    }
}

signed main() {
    ll tt; cin >> tt;
    while (tt--) {
        ll n, q; cin >> n >> q;
        ll x, y, m; cin >> x >> y >> m;
        g.assign(n, vector<ll>(0));
        for (ll i = 0; i < n - 1; i++) {
            ll v, u; cin >> v >> u; v--, u--;
            g[v].pb(u);
            g[u].pb(v);
        }
        l.resize(n), r.resize(n);
        for (ll i = 0; i < n; i++) cin >> l[i] >> r[i];
        dp[0].assign(n, 0);
        dp[1].assign(n, 0);
        dfs(0, -1);
        ll mx = max(dp[0][0], dp[1][0]);
        p.resize(0);
        find_p(0, -1, 0);
        //cout << mx << endl;
        //for (ll i = 0; i < p.size(); i++) cout << p[i] << " "; cout << endl;
        vector<ll> k(n + 1);
        for (ll i = 1; i <= n; i++) {
            k[0] ^= ((x * i) % m);
        }
        for (ll i = 1; i <= p.size(); i++) {
            k[i] = k[i - 1];
            k[i] ^= ((x * (p[i - 1] + 1)) % m);
            k[i] ^= ((x * (p[i - 1] + 1) + y) % m);
        }
        vector<ll> v(q);
        for (ll qq = 0; qq < q; qq++) {
            cin >> v[qq];
            if (v[qq] > mx) {
                cout << "-1 ";
                continue;
            }
            cout << k[v[qq]] << " ";
        }
        cout << endl;
        for (ll qq = 0; qq <= q; qq++) {
            ll i; cin >> i;
            if (i == 0) break;
            i--;
            if (v[i] > mx) {
                cout << "-1" << endl;
                continue;
            }
            vector<ll> a(n);
            for (ll j = 0; j < v[i]; j++) {
                a[p[j]] = 1;
            }
            for (ll i = 0; i < n; i++) cout << a[i] << " ";
            cout << endl;
        }
    }
    return 0;
}
/*
 1
12 12
0 0 0
1 2
1 3
2 4
2 5
2 6
4 12
6 7
6 8
8 9
3 10
3 11
0 1
0 1
0 1
0 1
0 1
0 1
0 0
0 1
0 0
0 0
0 0
0 1
 */



