#include<iostream>
#include<cmath>
#include<map>
#include<set>
#include<vector>
#include<algorithm>

using namespace std;
typedef long long ll; 
#define all(x) begin(x), end(x)
#define vdeb(x) cout << "** "; for(auto __i: x) cout << __i << " "; cout << endl;
#define vvdeb(x) for(auto __j: x){vdeb(__j);} cout << endl;

const ll INF = 1e18;
ll c, d, k, n, m, ans, t, z, a, b;
string s;

struct input{
    ll k;
    ll a;
    ll b;
};

int main(){
    cin >> n >> t;
    vector<ll> v(n);
    for(int i = 0; i < n; i++){
        cin >> v[i];
    }
    sort(all(v));
    cin >> z;
    
    vector<input> inp(t);
    ll maxa = 0, maxb = 0;
    for(int i = 0; i < t; i++){
        cin >> inp[i].k >> inp[i].a >> inp[i].b;
        maxa = max(maxa, inp[i].a);
        maxb = max(maxb, inp[i].b);
    }

    vector<vector<vector<bool>>> dp(n, vector<vector<bool>>(maxa+1, vector<bool>(maxb+1, 0)));
    dp[0][0][0] = 1;
    if(v[0] <= maxa)
        dp[0][v[0]][0] = 1;
    if(v[0] <= maxb)
        dp[0][0][v[0]] = 1;
    for(int i = 0; i < n-1; i++){
        for(int x = 0; x <= maxa; x++){
            for(int y = 0; y <= maxb; y++){
                if(dp[i][x][y]){
                    dp[i+1][x][y] = 1;
                    if(x + v[i+1] <= maxa)
                        dp[i+1][x + v[i+1]][y] = 1;
                    if(y + v[i+1] <= maxb)
                        dp[i+1][x][y + v[i+1]] = 1;
                }
            }
        }
    }
    // while(1){
    //     cout << endl;
    // }

    vector<vector<bool>> res(maxa+1, vector<bool>(maxb+1));
    res[0][0] = 1;
    for(int i = 1; i <= maxa; i++){
        res[i][0] = (res[i-1][0] && dp[n-1][i][0]);
    }
    for(int i = 1; i <= maxb; i++){
        res[0][i] = (res[0][i-1] && dp[n-1][0][i]);
    }
    for(int i = 1; i <= maxa; i++){
        for(int j = 1; j <= maxb; j++){
            res[i][j] = (res[i-1][j] && res[i][j-1] && dp[n-1][i][j]);
        }
    }
    // vvdeb(dp[n-1]);
    // vvdeb(res);

    for(auto i: inp){
        cout << (res[i.a][i.b] ? "Yes" : "No") << '\n';
    }
}