#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
ofstream debug;

template <typename T>
istream& operator>>(istream& i, vector<T> &v) {
    for (T& e: v) i >> e;
    return i;
}

template <typename T>
ostream& operator<<(ostream& o, vector<T> &v) {
    for (T& e: v) o << e << " ";
    return o;
}

using event = tuple<int, int, int>; // time, type, index

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    debug.open("debug.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    vector<pair<int, int>> a;
    vector<event> events;
    vector<int> result;
    vector<int> disposed;
    vector<int> answer;
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        a.resize(n);
        events.resize(2*n);
        for (int i = 0; i < n; i++) {
            int l, r;
            cin >> l >> r;
            a[i] = {l, r};
            events[2*i] = {l, -1, i};
            events[2*i+1] = {r, 1, i};
        }
        sort(events.begin(), events.end());
        for (auto [time, type, ind]: events) {
            if (type == 1) continue;
            if (result.empty()) {
                result.push_back(ind);
                continue;
            }
            auto [l, r] = a[result.back()];
            if (r < time) {
                result.push_back(ind);
            }
            else if (a[ind].second <= r) {
                result.pop_back();
                result.push_back(ind);
            }
        }
        int m = result.size();
        result.clear();
        for (auto [time, type, ind]: events) {
            if (type == 1) continue;
            if (result.size() * 2 > m) break;
            if (result.size() * 2 == m &&
                (result.size() + disposed.size()) * 2 >= n) {
                while ((result.size() + disposed.size()) * 2 > n) {
                    disposed.pop_back();
                }
                answer = disposed;
                for (int i: result) answer.push_back(i);
                break;
            }
            if (result.empty()) {
                result.push_back(ind);
                continue;
            }
            auto [l, r] = a[result.back()];
            if (r < time) {
                result.push_back(ind);
            }
            else if (a[ind].second <= r) {
                disposed.push_back(result.back());
                result.pop_back();
                result.push_back(ind);
            }
            else {
                disposed.push_back(ind);
            }
        }
        if (answer.empty()) {
            result.clear();
            disposed.clear();
            std::reverse(events.begin(), events.end());
            for (auto [time, type, ind]: events) {
                if (type == -1) continue;
                if (result.size() * 2 > m) break;
                if (result.size() * 2 == m &&
                    (result.size() + disposed.size()) * 2 >= n) {
                    while ((result.size() + disposed.size()) * 2 > n) {
                        disposed.pop_back();
                    }
                    answer = disposed;
                    for (int i: result) answer.push_back(i);
                    break;
                }
                if (result.empty()) {
                    result.push_back(ind);
                    continue;
                }
                auto [l, r] = a[result.back()];
                if (time < l) {
                    result.push_back(ind);
                }
                else if (l < a[ind].first) {
                    disposed.push_back(result.back());
                    result.pop_back();
                    result.push_back(ind);
                }
                else {
                    disposed.push_back(ind);
                }
            }
        }
        for (int i: answer) cout << i + 1 << " ";
        cout << "\n";
        a.clear();
        events.clear();
        result.clear();
        disposed.clear();
        answer.clear();
    }
    return 0;
}
