#include <bits/stdc++.h>

using namespace std;

#define sz(a) int((a).size())

typedef long long ll;

vector<vector<int>> gr;
vector<int> l, r;

vector<ll> dp0_lo, dp0_hi, dp1_lo, dp1_hi;

void dfs(int v, int pr) {
    dp0_lo[v] = dp0_hi[v] = 0;
    dp1_lo[v] = l[v];
    dp1_hi[v] = r[v];
    for (auto to : gr[v]) {
        if (to == pr) continue;
        dfs(to, v);
        dp0_lo[v] += max(dp0_lo[to], dp1_lo[to]);
        dp0_hi[v] += max(dp0_hi[to], dp1_hi[to]);
        dp1_lo[v] += dp0_lo[to];
        dp1_hi[v] += dp0_hi[to];
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    gr.assign(n, {});
    ll x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    l.resize(n), r.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dp0_lo.resize(n), dp0_hi.resize(n), dp1_lo.resize(n), dp1_hi.resize(n);
    dfs(0, -1);
    ll res_lo = max(dp0_lo[0], dp1_lo[0]);
    ll res_hi = max(dp0_hi[0], dp1_hi[0]);
    vector<ll> v(q);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < q; ++i) {
        if (res_lo <= v[i] && v[i] <= res_hi) {
            cout << 0 << ' ';
        } else {
            cout << -1 << ' ';
        }
    }
    cout << endl;
    while (true) {
        int i;
        cin >> i;
        if (i == 0) break;
        cout << -1 << endl;
    }
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    //    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}