#include <bits/stdc++.h>
#define FOR_(i, s, n) for(int i = s; i < n; ++i)
#define FOR(i, n) FOR_(i, 0, n)
#define FORR(x, a) for(auto &x : a)
#define IN(a) FORR(x, a) cin >> x;
#define OUT(a) FORR(x, a) cout << x << " "; cout << "\n";
#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;
using ll = long long;

const int N = 200005;
vector<int> g[N];
vector<int> rot[N];

int here[N];

void ans(int v, bool left = false, bool right = false, int rots = 0){
    here[v] = rots;
    if (g[v].empty()){
        rot[v].push_back(1);
        return;
    }
    int l = g[v][0], r = g[v][1];
    ans(l, true, false, rots + right);
    ans(r, false, true, rots + left);
    rot[v] = vector<int>(max(rot[l].size(), rot[r].size()) + 1, 0);

    if (left) FOR(i, rot[l].size()) rot[v][i] += rot[l][i];
    else FOR(i, rot[l].size()) rot[v][i + right] += rot[l][i];

    if (right) FOR(i, rot[r].size()) rot[v][i] += rot[r][i];
    else FOR(i, rot[r].size()) rot[v][i + left] += rot[r][i];
}

int main(){
    FAST
    int n, k, q;
    cin >> n >> k >> q;
    FOR(i, n){
        int r, x;
        cin >> r;
        FOR(j, r){
            cin >> x;
            --x;
            g[i].push_back(x);
        }
    }
    ans(0);
    FOR(i, n){
        FOR_(j, 1, rot[i].size()) rot[i][j] += rot[i][j - 1];
    }
    FOR(i, q){
        int u;
        cin >> u;
        --u;
        int idx = k - here[u];
        if (idx < 0) { cout << "0\n"; continue; }
        if (idx >= rot[u].size()) idx = rot[u].size() - 1;
        cout << rot[u][idx] << "\n";
    }
    return 0;
}
