#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

#define int ll

void solve_case() {
	int h, w, k; cin >> h >> w >> k;
	vector<pair<int, int>> a(k);
	for (auto& [x, y] : a)
		cin >> x >> y;

	set<int> X, Y;
	for (auto& [x, y] : a) {
		X.insert(x);
		Y.insert(y);
	}

	int res = 2e18;
	int need = -1;

	for (auto& [x, y] : a) {
		int minX = x, minY = y;
		int maxX = x, maxY = y;

		maxX = max(maxX, *(--X.end()));
		maxY = max(maxY, *(--Y.end()));

		int now_need = 0;

		auto it = X.lower_bound(x);
		if (it != X.begin()) {
			--it;

			int cx = *it + h;
			now_need += *it;
			maxX = max(maxX, cx);
		}

		it = Y.lower_bound(y);
		if (it != Y.begin()) {
			--it;

			int cy = *it + w;
			now_need += *it;
			maxY = max(maxY, cy);
		}


		int now = (maxX - minX + 1) * (maxY - minY + 1);
		if (now < res) {
			res = now;
			need = now_need;
		} else if (now == res) {
			need = min(need, now_need);
		}
	}

	cout << res << " " << need << "\n";
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	//cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
