#include <bits/stdc++.h>

#define int long long

using namespace std;

struct p {int l, r, i;};
struct elem {int r, x, i;};

bool cmp(p a, p b) {
    if (a.l == b.l) {
        return a.r < b.r;
    }
    return a.l < b.l;
}

bool operator<(elem a, elem b) {
    if (a.r == b.r) {
        return a.x < b.x;
    }
    return a.r < b.r;
}

int get(vector <p> &s) {
    int n = (int)s.size();
    // set <elem> q;
    vector <int> dp(n, 0);
    sort(s.begin(), s.end(), cmp);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (s[j].r < s[i].l) {
                dp[i] = max(dp[i], dp[j]);
            }
        }
        dp[i]++;
        /*dp[s[i].i] = 1;
        auto it = q.lower_bound({s[i].l, 0, 0});
        if (it != q.begin()) {
            it = prev(it);
            if (it != q.begin() && it->r < s[i].l) {
                // cout << it->r << " " << s[i].l << '\n';
                // cout << i + 1 << " " << it->i + 1 << '\n';
                dp[i] += dp[it->i];
                q.insert({s[i].r, dp[s[i].i], s[i].i});
            }
        }
        q.insert({s[i].r, 1, s[i].i});*/
    }
    // if (n == 8) {for (int i = 0; i < n; ++i) cout << dp[i] << " "; cout << '\n';}
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans = max(ans, dp[i]);
    }
    return ans;
}

void solve() {
    int n; cin >> n;
    vector <p> a(n);
    vector <p> s;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].l >> a[i].r;
        a[i].i = i;
        s.push_back(a[i]);
    }
    assert(n <= 20);
    int m = get(s);
    // int m = 2;
    // cout << m << '\n';
    for (int mask = 7; mask < (1<<n); ++mask) {
        vector <p> x;
        for (int i = 0; i < n; ++i) {
            if (mask & (1<<i)) {
                x.push_back(s[i]);
            }
        }
        // cout << mask << '\n';
        cout.flush();
        if (2 * (int)x.size() != n) continue;
        int g = get(x);
        // cout << g << '\n';
        if (2 * g == m) {
            for (int i = 0; i < n; ++i) {
                if (mask & (1<<i)) {
                    cout << i + 1 << " ";
                }
            }
            cout << '\n';
            return;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int t; cin >> t;
    // int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
