#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <set>

using namespace std;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long t;
    cin >> t;
    for (long h = 0; h < t; ++h) {
        long n;
        cin >> n;
        vector<array<long, 3>> data;
        for (long i = 0; i < n; ++i) {
            long l, r;
            cin >> l >> r;
            data.push_back({l, r, i});
        }
        sort(data.begin(), data.end());
        long last = -1;
        set<long> m;
        for (long i = 0; i < n; ++i) {
            if (data[i][0] > last) {
                last = data[i][1];
                m.insert(data[i][2]);
            }
        }
        set<long> other;
        for (long i = 0; i < n; ++i) {
            if (m.find(i) == m.end()) {
                other.insert(i);
            }
        }
        long sz1 = other.size() / 2;
        long sz2 = m.size() / 2;
        for (long i = 0; i < sz1; ++i) {
            long curr = *other.begin();
            other.erase(other.begin());
            cout << curr + 1 << " ";
        }
        for (long i = 0; i < sz2; ++i) {
            long curr = *m.begin();
            m.erase(m.begin());
            cout << curr + 1 << " ";
        }
        cout << endl;

    }
    return 0;
}
