#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
using namespace std;

const int N = 2e5 + 10;
int l[N], r[N], val[N], k;

void dfs(int v, int curk, int last) {
	if (curk > k) {
		return;
	}
	if (l[v] == 0) {
		val[v] = 1;
	}
	else {
		dfs(l[v], curk + (last <= 0 ? 0 : 1), -1);
		dfs(r[v], curk + (last >= 0 ? 0 : 1), 1);
		val[v] = val[l[v]] + val[r[v]];
	}
}

inline void solve() {
	int n, q;
	cin >> n >> k >> q;
	for (int i = 1; i <= n; i++) {
		int t;
		cin >> t;
		if (t == 2) {
			cin >> l[i] >> r[i];
		}
	}
	dfs(1, 0, 0);
	while (q--) {
		int v;
		cin >> v;
		cout << val[v] << '\n';
	}
}

int main() {
#ifdef OPIUMCAT
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}