#include <iostream>

using namespace std;

typedef long long ll;
constexpr ll N = 700;

int main()
{
	ll n, q, k, a, b;
	cin >> n >> q;
	auto arr = new ll[n];
	for (ll i = 0; i < n; i++)
	{
		cin >> arr[i];
	}
	cin >> k; // Skip z

	auto good = new bool**[n + 1];
	for (ll i = 0; i <= n; i++)
	{
		good[i] = new bool*[N];
		for (ll j = 0; j < N; j++)
		{
			good[i][j] = new bool[N];
			for (ll k = 0; k < N; k++)
			{
				if (i == 0)
				{
					good[i][j][k] = false;
					continue;
				}
				good[i][j][k] = good[i - 1][j][k];
				if (j >= arr[i - 1]) good[i][j][k] |= good[i - 1][j - arr[i - 1]][k];
				if (k >= arr[i - 1]) good[i][j][k] |= good[i - 1][j][k - arr[i - 1]];
			}
		}
		if (i == 0) good[i][0][0] = true;
	}
	auto ideal = new ll[N];
	for (ll i = 0; i < N; i++)
	{
		ideal[i] = -1;
		for (ll j = 0; j < N && good[n][i][j]; j++)
		{
			ideal[i]++;
		}
	}

	for (ll t = 0; t < q; t++)
	{
		cin >> k >> a >> b;
		cout << (ideal[b] >= a ? "YES" : "NO") << endl;
	}
	return 0;
}
