#pragma GCC optimize("O3")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#ifdef LOCAL
#define FAST_IO ;
#else
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define endl "\n"
#define mp(a, b) make_pair(a, b)
#define eb emplace_back
#define sz(v) (int)(v.size())


int M;
int k, n, p;

int findMe(const vec<int>& a) {
    map<int, int> is;
    for (auto& it : a)
        is[it] = true;
    assert(is[0]);
    for (int i = 1; i <= (1 << k); ++i)
        if (!is[i])
            return i;
}

int add(int x, int y) {
    return (x + y) % M;
}

void solve() {
    cin >> k >> n >> p;

    vec<int> nums;
    for (int i = 0; i < (1 << k); ++i)
        nums.eb(i);

    int ans = 0;
    for (int mask = 1; mask < (1 << sz(nums)); ++mask) {
        if (!(mask & 1)) continue;
        if (__builtin_popcount(mask) != n)
            continue;

        vec<int> was;
        for (int i = 0; i < sz(nums); ++i)
            if ((mask >> i) & 1)
                was.eb(nums[i]);

        int need = -1, last = -1, cnt = 0;
        for (int i = 0; i < 10000; ++i) {
            vec<int> a = was;
            int me = findMe(a);
            if (me == last) ++cnt;
            else cnt = 1, last = me;

            if (cnt >= 1000) {
                need = me;
                break;
            }

            for (auto& it : a)
                it = it ^ (me - 1);
            sort(all(a));
            swap(was, a);
        }

        ans = add(ans, need == p);
    }


    cout << ans << endl;
}


signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    cin >> M;
    int t; cin >> t;

    while (t--)
        solve();

}