#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#ifdef LOCAL
#define FAST_IO ;
#else
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif

#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define eb emplace_back
#define sz(v) (int)(v.size())
#define mp(a, b) make_pair(a, b)



const int N = 2e5 + 3, LOG = 256;



int n, k, q;
int le[N], ri[N];
bool isRiSon[N];


int pre[N][2];
int dp[N][2];


int turns[N];
int maxMoves[N];
int leavesCnt[N];
bool isLeaf[N];


void input() {
    cin >> n >> k >> q;
    for (int i = 0; i < n; ++i) {
        int t; cin >> t;
        le[i] = ri[i] = -1;
        if (t == 2) {
            cin >> le[i] >> ri[i];
            --le[i], --ri[i];
        }
    }
}




void findSons(int v, bool isRi) {
    isRiSon[v] = isRi;
    maxMoves[v] = k - turns[v];

    //cout << "v : " << v << "     " << isRiSon[v] << " turns : " << turns[v] << endl;

    if (le[v] == -1) {
        isLeaf[v] = true;
        leavesCnt[v] = 1;
        return;
    }

    turns[le[v]] = turns[ri[v]] = turns[v];
    turns[le[v]] += isRi && v;
    findSons(le[v], false);
    turns[ri[v]] += !isRi && v;
    findSons(ri[v], true);

    leavesCnt[v] = leavesCnt[le[v]] + leavesCnt[ri[v]];
}


// 0 = left, 1 = right

void countDp(int v) {
    dp[v][0] = dp[v][1] = 0;

    if (le[v] == -1) return;

    countDp(le[v]);
    countDp(ri[v]);

    int mov = maxMoves[v];
    if (mov < 0)
        return;

    bool f = isRiSon[v];
    dp[v][0] = dp[le[v]][0];
    if (mov - (f && v) >= 0 && isLeaf[le[v]])
        dp[v][0] += 1;
    if (mov - (f && v) && !isLeaf[le[v]])
        dp[v][0] += dp[le[v]][1];

    dp[v][1] = dp[ri[v]][1];
    if (mov - (!f && v) >= 0 && isLeaf[ri[v]])
        dp[v][1] += 1;
    if (mov - (!f && v) && !isLeaf[ri[v]])
        dp[v][1] += dp[ri[v]][0];

//    cout << "mov : " << mov << endl;
//    cout << "v : " << v << " le : " << dp[v][0] << " ri : " << dp[v][1] << endl;
//    //cout << "v : " << v << " le : " << pre[v][0] << " ri : " << pre[v][1] << endl;
//    cout << endl << endl;
}


void solve() {
    while (q--) {
        int v; cin >> v;
        --v;
        int moves = k - turns[v];
        //cout << "v : " << v << " moves : " << moves << endl;

        if (isLeaf[v] && moves >= 0) {
            cout << 1 << endl;
            continue;
        }

        if (k == n) {
            cout << leavesCnt[v] << endl;
            continue;
        }

        cout << dp[v][0] + dp[v][1] << endl;
    }
}



signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    input();
    findSons(0, false);
    countDp(0);
    solve();

}