#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;

const int N = 200005;

int l[N], r[N], flips[N], at[N], L[N], R[N], t[N];
vector<int> a;

int n, k, q, m;

void modify(int i) {
  for (; i < m; i |= (i + 1)) {
    t[i] += 1;
  }
}

int get(int i) {
  int res = 0;
  for (; i >= 0; i = (i & (i + 1)) - 1) {
    res += t[i];
  }
  return res;
}

void dfs1(int v, int cur, int type) {
  flips[v] = cur;
  if (l[v] != -1) {
    if (type == 2) {
      dfs1(l[v], cur + 1, 1);
    } else {
      dfs1(l[v], cur, 1);
    }
  }
  if (r[v] != -1) {
    if (type == 1) {
      dfs1(r[v], cur + 1, 2);
    } else {
      dfs1(r[v], cur, 2);
    }
  }
}

void dfs2(int v) {
  if (l[v] != -1) {
    dfs2(l[v]);
    dfs2(r[v]);
  } else {
    a.push_back(v);
  }
}

void dfs3(int v) {
  if (l[v] == -1) {
    L[v] = R[v] = v;
    return;
  }
  dfs3(l[v]);
  dfs3(r[v]);
  L[v] = L[l[v]];
  R[v] = R[r[v]];
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  memset(l, -1, sizeof(l));
  memset(r, -1, sizeof(r));
  cin >> n >> k >> q;
  for (int i = 0; i < n; ++i) {
    int cnt;
    cin >> cnt;
    if (cnt == 2) {
      cin >> l[i] >> r[i];
      --l[i], --r[i];
    }
  }
  dfs1(0, 0, 0);
  dfs2(0);
  dfs3(0);
  m = size(a);
  for (int i = 0; i < m; ++i) {
    if (flips[a[i]] <= k) {
      modify(i);
    }
    at[a[i]] = i;
  }
  for (int i = 0; i < q; ++i) {
    int v;
    cin >> v;
    --v;
    int left = at[L[v]], right = at[R[v]];
    cout << get(right) - get(left - 1) << '\n';
  }
  return 0;
}