#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;

const int inf = int(1e9);

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, q;
  cin >> n >> q;
  vector<ll> w(n);
  for (int i = 0; i < n; ++i) {
    cin >> w[i];
  }
  vector<vector<int>> dp(301, vector<int>(301, inf));
  dp[0][0] = -100;
  for (int h = 0; h < n; ++h) {
    ll x = w[h];
    for (int i = 300; i >= 0; --i) {
      for (int j = 300; j >= 0; --j) {
        if (i - x >= 0 && dp[i - x][j] < h) dp[i][j] = h;
        if (j - x >= 0 && dp[i][j - x] < h) dp[i][j] = h;
      }
    }
  }
  for (int i = 0; i <= 300; ++i) {
    for (int j = 0; j <= 300; ++j) {
      if (dp[i][j] == inf) dp[i][j] = 0;
      else dp[i][j] = 1;
    }
    for (int j = 1; j <= 300; ++j) {
      dp[i][j] += dp[i][j - 1];
    }
  }
  for (int i = 1; i <= 300; ++i) {
    for (int j = 0; j <= 300; ++j) {
      dp[i][j] += dp[i - 1][j];
    }
  }
  int foo;
  cin >> foo;
  while (q--) {
    ll k;
    int a, b;
    cin >> k >> a >> b;
    cout << (dp[a][b] == (a + 1) * (b + 1) ? "Yes" : "No") << '\n';
  }
  return 0;
}