#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pikachu push_back
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pll pair<ll, ll>
#define pii pair<int, int>
#define st first
#define nd second

void debug_out(){
    cerr << endl;
}

template<typename H, typename... T>
void debug_out(H head, T... tail){
    cerr << " " << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

void run();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
}

pll clc(ll n, vector<ll> a) {
    sort(all(a));
    ll ans = a.back() - a.front() + 1;
    ll k = 0;
    for (ll i = 0; i + 1 < sz(a); ++i) {
        if (ans > n - (a[i + 1] - a[i] - 1)) {
            ans = n - (a[i + 1] - a[i] - 1);
            k = a[i] + 1;
        }
    }
    //for(auto e: a) debug(e);
    //debug(n, ans + 1, k);
    return {ans, k};
}

void run() {
    ll h, w, k;
    cin >> h >> w >> k;
    vector<ll> r(k), c(k);
    for (ll i = 0; i < k; ++i) {
        cin >> r[i] >> c[i];
        --r[i], --c[i];
    }
    auto x = clc(h, r);
    for(auto& e: r) e = h - e - 1;
    auto x2 = clc(h, r);
    if (x2 < x) x = x2;
    auto y = clc(w, c);
    for(auto& e: c) e = w - e - 1;
    auto y2 = clc(w, c);
    if (y2 < y) y = y2;
    cout << x.st * y.st << ' ' << x.nd + y.nd;
}
