#include <bits/stdc++.h>
using namespace std;
struct Meeting {
    int l, r, id;
    bool need;
    Meeting() : l(-1), r(-1), id(-1), need(false) {}
    Meeting(int l, int r, int id) : l(l), r(r), id(id), need(true) {}
};
struct Record {
    int val, id, pr;
    Record() : val(-1), id(-1), pr(-1) {}
    Record(int val, int id, int pr) : val(val), id(id), pr(pr) {}
};
bool cmp(Meeting r1, Meeting  r2) {
    if (r1.r == r2.r) return r1.l > r2.l;
    return r1.r < r2.r;
}
bool cmp_3(Meeting r1, Meeting  r2) {
    return r1.id < r2.id;
}
vector <Meeting> v;
bool cmp_2(int a, int b) {
    return v[a].r < v[b].r;
}
vector <vector <int>> tree, layers;
vector <int> pr, layer;
void dfs(int x) {
    if (tree[x].empty()) {
        layer[x] = 0;
        layers[0].push_back(x);
        return;
    }
    for (auto e: tree[x]) {
        dfs(e);
        layer[x] = max(layer[x], layer[e] + 1);
    }
    layers[layer[x]].push_back(x);
}
void solution() {
    int n;
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].l >> v[i].r;
        v[i].id = i;
        v[i].need = true;
    }
    sort(v.begin(), v.end(), cmp);
    pr.resize(n);
    vector <Meeting> q_pr;
    vector <int> roots;
    for (int i = n - 1; i >= 0; i--) {
        if (q_pr.empty()) {
            pr[v[i].id] = -1;
            roots.push_back(v[i].id);
        }
        else {
            while (!q_pr.empty() && v[i].r < q_pr[q_pr.size() - 1].l) q_pr.pop_back();
            if (q_pr.empty()) {
                pr[v[i].id] = -1;
                roots.push_back(v[i].id);
            }
            else {
                pr[v[i].id] = q_pr[q_pr.size() - 1].id;
            }
        }
        q_pr.push_back(v[i]);
    }
    tree.resize(n);
    for (int i = 0; i < n; i++) {
        if (pr[i] != -1) tree[pr[i]].push_back(i);
    }
    layer.resize(n, 0);
    layers.resize(n);
    for (auto e: roots) {
        dfs(e);
    }
    sort(v.begin(), v.end(), cmp_3);
    for (int i = 0; i < n; i++) {
        sort(layers[i].begin(),layers[i].end(), cmp_2);
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < layers[i].size() / 2; j++) {
            v[layers[i][j]].need = false;
            cnt++;
        }
    }
    for (int i = n - 1; i >= 0 && cnt < n / 2; i--) {
        for (int j = layers[i].size() / 2; j < layers[i].size() && cnt < n / 2; j++) {
            v[layers[i][j]].need = false;
            cnt++;
        }
    }
    for (auto e: v) {
        if (e.need) {
            cout << e.id + 1 << " ";
        }
    }
    cout << "\n";
    v.clear();
    tree.clear();
    layers.clear();
    layer.clear();
    pr.clear();
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (; t > 0; t--) {
        solution();
    }
    return 0;
}