#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<stack>
#include<deque>
#include<queue>
#include<cmath>
#include<string>
#include<bitset>
#include<random>
#include<ctime>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

void solve() {
    int n;
    cin >> n;
    int a[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int dp[n + 2][n + 2];
    for (int i = 0; i <= n + 1; i++) {
        for (int j = 0; j < n + 2; j++) {
            dp[i][j] = -1e9;
        }
    }
    int max1[n + 2], max2[n + 2];
    for (int i = 0; i < n + 2; i++) {
        max1[i] = max2[i] = 0;
    }
    dp[0][n + 1] = 0;
    int ans = 0;
    for (int k = 0; k < n; k++) {
        int val = a[k];
        int max3 = -1e9;

        for (int i = 0; i < n + 2; i++) {
            if (i == val) continue;
            max3 = -1e9;
            for (int j = val + 1; j < n + 2; j++) {
                max3 = max(max3, dp[i][j]);
            }
            ans = max(ans, max3 + 1);
            dp[i][val] = max3 + 1;
        }
        for (int j = 0; j < n + 2; j++) {
            if (j == val) continue;
            max3 = -1e9;
            for (int i = 0; i < val; i++) {
                max3 = max(max3, dp[i][j]);
            }

            ans = max(ans, max3 + 1);
            dp[val][j] = max3 + 1;
        }
        for (int i = 0; i < val; i++) {
            for (int j = val + 1; j < n + 2; j++) {
                dp[i][j] = -1e9;
            }
        }
    }
    cout << ans << endl;

}

void solve1 () {
    int n;
    cin >> n;
    int a[n];
    vector<int> dp(n + 2, 1e9);
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        int l = 0, r = n + 1;
        while (l + 1 < r) {
            int d = (l + r) / 2;
            if (dp[d] < a[i]) {
                l = d;
            } else {
                r = d;
            }
        }
        dp[l + 1] = min(dp[l + 1], a[i]);
    }
    int ans = 0;
    for (int i = 0; i < n + 2; i++) {
        if (dp[i] <= n) {
            ans++;
        } else {
            break;
        }
    }
    cout << ans + 1 << endl;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tt;
    cin >> tt;

    while (tt--)
        solve1();
    return 0;
}