#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
using namespace std;
#define int long long
const int inf = 1e18;

void solve1() {
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int n, k;
        cin >> n >> k;
        vector<int> arr(k);
        for (int& x : arr) cin >> x;
        if (1) {
            vector<bool> used(n + 1, false);
            for (int i: arr) used[i] = 1;
            vector<int> res;
            int pt = 1;
            sort(arr.begin(), arr.end());
            for (int i: arr) {
                pt = max(pt, i);
                while (used[pt] && pt <= n) ++pt;
                if (pt <= n) {
                    used[pt] = 1;
                    res.push_back(pt);
                }
            }
            if (res.size() == arr.size()) {
                for (int i: res) {
                    cout << i << ' ';
                }
                cout << endl;
            } else {
                vector<bool> used(n + 1, false);
                for (int i: arr) used[i] = 1;
                vector<int> res;
                int pt = 1;
                sort(arr.rbegin(), arr.rend());
                for (int i: arr) {
                    pt = min(pt, i);
                    while (used[pt] && pt > 0) --pt;
                    if (pt > 0) {
                        used[pt] = 1;
                        res.push_back(pt);
                    }
                }
                if (res.size() == arr.size()) {
                    for (int i: res) {
                        cout << i << ' ';
                    }
                    cout << endl;
                } else {
                    assert(0);
                }
            }
        }
    }
}

void solve2() {
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int n, k;
        cin >> n >> k;
        vector<int> arr(k);
        for (int& x : arr) cin >> x;
        if (1) {
            vector<bool> used(n + 1, false);
            for (int i: arr) used[i] = 1;
            vector<int> res;
            int pt = n;
            sort(arr.rbegin(), arr.rend());
            for (int i: arr) {
                pt = min(pt, i);
                while (used[pt] && pt > 0) --pt;
                if (pt > 0) {
                    used[pt] = 1;
                    res.push_back(pt);
                }
            }
            if (res.size() == arr.size()) {
                for (int i: res) {
                    cout << i << ' ';
                }
                cout << endl;
            } else {
                vector<bool> used(n + 1, false);
                for (int i: arr) used[i] = 1;
                vector<int> res;
                int pt = 1;
                sort(arr.begin(), arr.end());
                for (int i: arr) {
                    pt = max(pt, i);
                    while (used[pt] && pt <= n) ++pt;
                    if (pt <= n) {
                        used[pt] = 1;
                        res.push_back(pt);
                    }
                }
                if (res.size() == arr.size()) {
                    for (int i: res) {
                        cout << i << ' ';
                    }
                    cout << endl;
                } else {
                    assert(0);
                }
            }
        }
    }
}

int32_t main() {
   int t;
   cin >> t;
   if (t == 1) {
       solve1();
   } else {
       solve2();
   }
}
