#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(v) v.begin(), v.end()
#define pii pair<int, int>

void solve() {
    int type, m;
    cin >> type >> m;
    if (type == 1) {
        for (int messageNum = 0; messageNum < m; ++messageNum) {
            int n, k;
            cin >> n >> k;
            vector<int> message(k);
            vector<pii> sortedMessage(k);
            for (int i = 0; i < k; ++i) {
                cin >> sortedMessage[i].first;
                sortedMessage[i].second = i;
            }
            sort(all(sortedMessage));
            vector<int> toConvert, lastUsed(k);
            for (int i = 0; i < k; ++i) {
                toConvert.emplace_back(i);
                int spaceToConvert, numToConvert = sortedMessage[i].first % n + 1;
                if (i < k - 1) spaceToConvert = sortedMessage[i + 1].first - sortedMessage[i].first - 1;
                else spaceToConvert = n - (sortedMessage[i].first - sortedMessage[0].first) - 1;
                while (!toConvert.empty() && spaceToConvert > 0) {
                    message[sortedMessage[toConvert[toConvert.size() - 1]].second] = numToConvert;
                    toConvert.pop_back(), --spaceToConvert, numToConvert = numToConvert % n + 1;
                }
                lastUsed[i] = (numToConvert + n - 2) % n + 1;
            }
            for (int i = 0; !toConvert.empty(); ++i) {
                if (i == k - 1) {
                    cout << "Error: Can't find space" << endl;
                    return;
                }
                int spaceToConvert, numToConvert = lastUsed[i] % n + 1;
                spaceToConvert = sortedMessage[i + 1].first - lastUsed[i] - 1;
                while (!toConvert.empty() && spaceToConvert > 0) {
                    message[sortedMessage[toConvert[toConvert.size() - 1]].second] = numToConvert;
                    toConvert.pop_back(), --spaceToConvert, numToConvert = numToConvert % n + 1;
                }
            }
            for (int i = 0; i < k; ++i) {
                cout << message[i] << ' ';
            }
            cout << endl;
        }
    } else {
        for (int messagesNum = 0; messagesNum < m; ++messagesNum) {
            int n, k;
            cin >> n >> k;
            vector<int> message(k);
            vector<pii> sortedMessage(k);
            for (int i = 0; i < k; ++i) {
                cin >> sortedMessage[i].first;
                sortedMessage[i].second = i;
            }
//            sort(all(sortedMessage), greater<>());
            set<int> cannotUse;
            for (int i = 0; i < k; ++i) {
                cannotUse.insert(sortedMessage[i].first);
            }
            for (int i = k - 1; i >= 0; --i) {
                int toUse = (sortedMessage[i].first + n - 2) % n + 1;
                while (cannotUse.count(toUse)) {
                    toUse = (toUse + n - 2) % n + 1;
                }
                message[sortedMessage[i].second] = toUse;
                cannotUse.insert(toUse);
            }
            for (int i = 0; i < k; ++i) {
                cout << message[i] << ' ';
            }
            cout << endl;
        }
    }
}

signed main() {
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

/*
1 10 3
1 5
1 7
1 2

 */