#include <bits/stdc++.h>
using namespace std;

string inp(const vector<int>& w,int n){
    string s(n,'0');
    for(const auto& x:w)
        s[x] = '1';
    return s;
}

void outp(const string& s,int n){
    for(int i=0;i<n;++i)
        if(s[i] == '1')
            cout << i+1 << " ";
    cout << "\n";
}

string left(string s,int n){
    int j = 0;
    for(int i=n-1;i>0;--i){
        if(s[i-1] == '0' && s[i] == '1'){
            swap(s[i-1],s[i]);
            j = i+1;
            break;
        }
    }
    if(j < n)
        for(int c=0;2*c<n-j;++c)
            swap(s[j+c],s[n-c-1]);
    return s;
}

string right(string s,int n){
    int j = 0;
    for(int i=n-1;i>0;--i){
        if(s[i-1] == '1' && s[i] == '0'){
            swap(s[i-1],s[i]);
            j = i+1;
            break;
        }
    }
    if(j < n)
        for(int c=0;2*c<n-j;++c)
            swap(s[j+c],s[n-c-1]);
    return s;
}

bool go(const string& a,const string& b,int n){
    for(int i=0;i<n;++i)
        if(a[i] == '1' && b[i] == '1')
            return false;
    return true;
}

int main(){
    int f;
    cin >> f;
    int t;
    cin >> t;
    while(t--){
        int n,q;
        cin >> n >> q;
        vector<int> w(q);
        for(int k=0;k<q;++k){
            cin >> w[k];
            --w[k];
        }
        if(2*q == n){
            string s = inp(w,n);
            for(int i=0;i<n;++i)
                s[i] = (s[i] == '0' ? '1' : '0');
            outp(s,n);
            continue;
        }
        if(q == 1 || q == 2){
            string s = inp(w,n);
            vector<int> p;
                for(int k=0;k<n;++k)
                    if(s[k] == '1')
                        p.push_back(k);
            if(f == 1){
                if(q == 2 && ((p[0] == 0 && p[1] == n-1) || p[0]+1 == p[1]) ){
                    swap(s[p[0]],s[(p[0]+2)%n]);
                    swap(s[p[1]],s[(p[1]+2)%n]);
                }
                else{
                    swap(s[p[0]],s[(p[0]+1)%n]);
                    if(q == 2)
                        swap(s[p[1]],s[(p[1]+1)%n]);
                }
                outp(s,n);
            }
            else{
                if(q == 2 && ((p[0] == 0 && p[1] == n-1) || p[0]+1 == p[1]) ){
                    swap(s[p[0]],s[(p[0]-2+n)%n]);
                    swap(s[p[1]],s[(p[1]-2+n)%n]);
                }
                else{
                    swap(s[p[0]],s[(p[0]-1+n)%n]);
                    if(q == 2)
                        swap(s[p[1]],s[(p[1]-1+n)%n]);
                }
                outp(s,n);
            }
            continue;
        }
        vector<int> p;
        for(const auto& v:w)
            p.push_back(f == 1 ? v+1 : v-1);
        sort(p.begin(),p.end());
        for(const auto& e:p)
            cout << e+1 << " ";
        cout << "\n";
    }
    return 0;
}