#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
using namespace std;
void cypher() {
    int n, k;
    cin >> n >> k;
    vector<int> nums(k);
    vector<bool> isnum(n + 1);
    for (int i = 0; i < k; i++) {
        cin >> nums[i];
        isnum[nums[i]] = true;
    }
    int curnum = 0;
    int need = 0;
    vector<int> ans;
    for (int i = 0; i <= 2 * n - 1; i++) {
        if (curnum < k && nums[curnum] == i + 1) {
            need++;
            curnum++;
        } else if (need > 0 && !isnum[i % n + 1]) {
            ans.push_back(i % n + 1);
            need--;
        }
    }
    sort(ans.begin(), ans.end());
    for (auto &i : ans) {
        cout << i << " ";
    }
    cout << endl;
}
void decypher() {
    int n, k;
    cin >> n >> k;
    vector<bool> nums(n + 1);
    vector<bool> was(n + 1);
    for (int i = 0; i < k; i++) {
        int now;
        cin >> now;
        nums[now] = true;
    }
    vector<int> ans;
    int credit = 0;
    for (int i = 2 * n - 1; i >= 0; i--) {
        if (credit > 0 && !nums[i % n + 1]) {
            ans.push_back(i % n + 1);
            credit--;
        }
        if (nums[i % n + 1] && !was[i % n + 1]) {
            credit++;
            was[i % n + 1] = true;
        }
    }
    sort(ans.begin(), ans.end());
    for (auto &i : ans) {
        cout << i << " ";
    }
    cout << endl;
}
int main() {
    int t;
    cin >> t;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        if (t == 1) {
            cypher();
        } else {
            decypher();
        }
    }
}
