#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <bitset>
using namespace std;
typedef long long ll;
vector <int> tree;
int n;
int get(int ql, int qr, int v = 0, int l = 0, int r = n) {
	if (r <= ql || qr <= l) return -1;
	if (l >= ql && r <= qr) return tree[v];
	return max(get(ql, qr, v * 2 + 1, l, (l + r) / 2), get(ql, qr, v * 2 + 2, (l + r) / 2, r));
}
void upd(int ind, int x, int v = 0, int l = 0, int r = n) {
	if (ind < l || ind >= r) return;
	if (l == r - 1) {
		tree[v] = x;
		return;
	}
	upd(ind, x, v * 2 + 1, l, (l + r) / 2);
	upd(ind, x, v * 2 + 2, (l + r) / 2, r);
	tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int t; cin >> t;
	while (t--) {
		cin >> n;
		vector <int> p(n);
		for (int i = 0; i < n; i++) cin >> p[i];
		if (n <= 16) {
			int ans = -1;
			for (int i = 0; i < (1 << n); i++) {
				vector <int> a, b;
				for (int j = 0; j < n; j++) {
					if ((i & (1 << j))) a.push_back(p[j]);
					else b.push_back(p[j]);
				}
				int x = -1, kol = 0;
				for (auto j : a) {
					if (j > x) kol++;
					x = max(x, j);
				}
				x = n + 1;
				for (auto j : b) {
					if (j < x) kol++;
					x = min(x, j);
				}
				ans = max(ans, kol);
			}
			cout << ans << "\n";
			continue;
		}
		tree.clear();
		tree.resize(4 * n);
		vector <int> dp(n);
		dp[0] = 1;
		upd(p[0] - 1, 1);
		for (int i = 1; i < n; i++) {
			dp[i] = get(0, p[i] + 1) + 1;
			upd(p[i] - 1, dp[i]);
		}
		cout << min(n, 1 + *max_element(dp.begin(), dp.end())) << "\n";
	}
	return 0;
}