#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <set>
#include <assert.h>
#include <bitset>
typedef long long ll;
using namespace std;
vector <ll> l;
vector <vector <ll>> g;
ll sum0 = 0, sum1 = 0, kol0, kol1;
vector <ll> g0, g1;
void dfs(ll v, ll c = 0, ll pr = -1) {
	if (c == 0) sum0 += l[v], g0.push_back(v), kol0++;
	else sum1 += l[v], g1.push_back(v), kol1++;
	for (auto i : g[v]) {
		if (i == pr) continue;
		dfs(i, 1 - c, v);
	}
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll t; cin >> t;
	while (t--) {
		l.clear(), g.clear(), g0.clear(), g1.clear();
		sum0 = sum1 = kol0 = kol1 = 0;
		ll n, q; cin >> n >> q;
		ll x, y, m; cin >> x >> y >> m;
		l.resize(n), g.resize(n);
		for (ll i = 0; i < n - 1; i++) {
			ll a, b; cin >> a >> b; a--, b--;
			g[a].push_back(b), g[b].push_back(a);
		}
		dfs(0);
		for (ll i = 0; i < n; i++) cin >> l[i] >> l[i];
		ll ind;
		if (kol0 > kol1) ind = 0;
		else if (kol1 > kol0) ind = 1;
		else {
			if (sum0 > sum1) ind = 0;
			else ind = 1;
		}
		ll k = 0;
		if (ind == 0) {
			for (ll i = 0; i < g0.size();i++) {
				k = (k ^ ((x * (i + 1) + y * l[g0[i]] * l[g0[i]]) % m));
			}
		}
		vector <int> ans;
		while (q--) {
			ll c; cin >> c;
			if (ind == 0 && c == sum0) cout << k << ' ', ans.push_back(k);
			else if (ind == 1 && c == sum1) cout << k << ' ', ans.push_back(k);
			else cout << "-1 ", ans.push_back(-1);
		}
		cout << endl;
		ll nmb;
		while (cin >> nmb && nmb) {
			nmb--;
			if (ans[nmb] == -1) { cout << "-1" << endl; continue; }
			if (ind == 0) for (auto i : g0) cout << l[i] << ' ';
			else for (auto i : g1) cout << l[i] << ' ';
			cout << endl;
		}
	}
	return 0;
}