#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC targe("avx,avx2,sse,sse2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll M = 6;

bool comb(const vector<vector<ll>> &g, vector<ll> &w, vector<ll> &f, vector<ll> &f1, ll m, ll v) {
    if (2 * __builtin_popcountll(v) > m) return comb(g, w, f, f1, m, v + 1);
    if (v == ll(g.size())) return 1;
    for (ll u: g[v]) {
        if (w[u]) continue;
        w[u] = 1;
        f[v] = u;
        f1[u] = v;
        if (comb(g, w, f, f1, m, v + 1)) return 1;
        w[u] = 0;
    }
    return 0;
}

mt19937_64 rng(3947823);

void match(ll m, vector<ll> &f, vector<ll> &f1) {
    f.assign(1 << m, 0);
    f1.assign(1 << m, 0);
    vector<vector<ll>> g(1 << m);
    for (ll t1 = 0; t1 < (1 << m); t1++) {
        for (ll t2 = 0; t2 < (1 << m); t2++) {
            if (t1 & t2) continue;
            if (__builtin_popcountll(t1) != __builtin_popcountll(t2)) continue;
            g[t1].push_back(t2);
        }
    }
    for (ll t1 = 0; t1 < (1 << m); t1++) shuffle(g[t1].begin(), g[t1].end(), rng);
    vector<ll> w(1 << m);
    if (!comb(g, w, f, f1, m, 0)) throw runtime_error("amogus");
}

vector<ll> f[M + 1], f1[M + 1];

int main() {
#ifndef AVEVAD
    cin.tie(0);
ios_base::sync_with_stdio(0);
#endif
    for (ll m = 2; m <= M; m++) match(m, f[m], f1[m]);
    ll tp;
    cin >> tp;
    ll T;
    cin >> T;
    while (T--) {
        ll n, m;
        cin >> m >> n;
        vector<ll> a(n);
        for (ll &e: a) cin >> e, e--;
        vector<ll> b;
        ll x = 0;
        for (ll i: a) x |= 1ll << i;
        ll y = tp == 1 ? f[m][x] : f1[m][x];
        for (ll i = 0; i < m; i++) if (y >> i & 1) b.push_back(i);
        for (ll e: b) cout << e + 1 << ' ';
        cout << endl;
    }
}