#include "bits/stdc++.h"


using namespace std;
using ll = long long;

#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)


void encode() {
	int MAX, n;
	cin >> MAX >> n;
	vector<bool> used(MAX);
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		used[x - 1] = true;
	}
	int cnt = 0;
	vector<bool> filled(used.size());
	for (int i = 0; i < used.size(); ++i) {
		if (filled[i]) continue;
		if (used[i]) {
			++cnt;
			filled[i] = true;
		}
		else {
			if (cnt) {
				--cnt;
				filled[i] = true;
				cout << i + 1 << ' ';
			}
		}
	}
	for (int i = 0; i < used.size(); ++i) {
		if (filled[i]) continue;
		if (used[i]) {
			++cnt;
			filled[i] = true;
		}
		else {
			if (cnt) {
				--cnt;
				cout << i + 1 << ' ';
			}
		}
	}
}


void decode() {
	int MAX, n;
	cin >> MAX >> n;
	vector<bool> used(MAX);
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		used[x - 1] = true;
	}
	int cnt = 0;
	vector<bool> filled(used.size());
	for (int i = used.size() - 1; i >= 0; --i) {
		if (filled[i]) continue;
		if (used[i]) {
			++cnt;
			filled[i] = true;
		}
		else {
			if (cnt) {
				--cnt;
				filled[i] = true;
				cout << i + 1 << ' ';
			}
		}
	}
	for (int i = used.size() - 1; i >= 0; --i) {
		if (filled[i]) continue;
		if (used[i]) {
			++cnt;
			filled[i] = true;
		}
		else {
			if (cnt) {
				--cnt;
				cout << i + 1 << ' ';
			}
		}
	}
}



int main() {
	FAST_IO;
	int type;
	cin >> type;
	if (type == 1) {
		int t;
		for (cin >> t; t; --t) { encode(); cout << endl; }
	} else {
		int t;
		for (cin >> t; t; --t) { decode(); cout << endl; }
	}
}