#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
using namespace std;
#define int long long

vector<int> lft;
vector<int> rght;
vector<int> h;
vector<int> sum;
void DFS(int v, int tp, int K) {
	if (lft[v] == -1) {
		sum[v] = 1;
		return;
	}
	if (tp == 1) {
		h[lft[v]] = h[v];
		DFS(lft[v], 1, K);
		if (h[v] + 1 <= K) {
			h[rght[v]] = h[v] + 1;
			DFS(rght[v], 2, K);
		}
		sum[v] = sum[lft[v]] + sum[rght[v]];
		return;
	}
	if(tp == 2) {
		h[rght[v]] = h[v];
		DFS(rght[v], 2, K);
		if (h[v] + 1 <= K) {
			h[lft[v]] = h[v] + 1;
			DFS(lft[v], 1, K);
		}
		sum[v] = sum[lft[v]] + sum[rght[v]];
		return;
	}
	h[rght[v]] = h[v];
	DFS(rght[v], 2, K);
	h[lft[v]] = h[v];
	DFS(lft[v], 1, K);
	sum[v] = sum[lft[v]] + sum[rght[v]];
}
void solve() {
	int N = 0, K = 0, Q = 0; cin >> N >> K >> Q;
	lft.assign(N, -1);
	rght.assign(N, -1);
	h.assign(N, 0);
	sum.assign(N, 0);
	for (int i = 0; i < N; ++i) {
		int t1 = 0; cin >> t1;
		if (t1 == 0) continue;
		int l_gr = 0, r_gr = 0;
		cin >> l_gr >> r_gr;
		lft[i] = l_gr - 1;
		rght[i] = r_gr - 1;
	}
	DFS(0, 0, K);
	while (Q--) {
		int num = 0; cin >> num; num--;
		cout << sum[num] << "\n";
	}
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	solve();
	return 0;
}