#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 5001;
const ll infll = 1000000000000000000 + 1;
ll dp[N], ndp[N];
template<typename T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
void solve_case() {
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    sort(w.begin(), w.end());
    int z;
    cin >> z;
    vector<int> ord(q);
    iota(ord.begin(), ord.end(), 0);
    vector<bool> ans(q);
    vector<ll> K(q), A(q), B(q);
    for (int i = 0; i < q; i++) {
        cin >> K[i] >> A[i] >> B[i];
    }
    sort(ord.begin(), ord.end(), [&](int left, int right){
        if (K[left] == K[right]) return left < right;
        return K[left] < K[right];
    });
    int ptr = 0;
    fill(dp, dp + N, -infll);
    fill(ndp, ndp + N, -infll);
    dp[0] = 0;
    for (ll xx : w) {
        while (xx > K[ptr]) {
            if (dp[A[ord[ptr]]] >= B[ord[ptr]]) {
                ans[ord[ptr]] = true;
            }
            ptr++;
        }
        int x = min(xx, (ll)N);
        ndp[0] = 0;
        for (int a = x - 1; a < N; a++) {
            chmax(ndp[min(N - 1, a + x)], dp[a]);
        }
        for (int a = 0; a < N; a++) {
            if (dp[a] >= x - 1) {
                chmax(ndp[a], dp[a] + x);
            }
        }
        for (int a = 0; a < N; a++) {
            chmax(dp[a], ndp[a]);
            ndp[a] = -infll;
        }
        for (int i = N - 2; i >= 0; i--) {
            chmax(dp[i], dp[i + 1]);
        }
        cerr << "Add " << xx << "\n";
        for (int i = 0; i < N; i++) {
            if (dp[i] >= 0) {
                cerr << i << " " << dp[i] << "\n";
            }
        }
        cerr << "-------\n";
    }
    while (ptr < q) {
        if (dp[A[ord[ptr]]] >= B[ord[ptr]]) {
            ans[ord[ptr]] = true;
        }
        ptr++;
    }
    for (int i = 0; i < q; i++) {
        if (ans[i]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }

}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
}