#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <deque>

using namespace std;
typedef long long ll;
#define endl '\n'

const int N = 200010;

int n;

inline int stup(vector <int> A)
{
	n = A.size();

	int an = 0;

	for (int musk = 0; musk < (1 << n); ++musk)
	{
		vector <int> x, y;
		for (int j = 0; j < n; ++j)
		{
			if ((musk >> j) & 1) x.push_back(A[j]);
			else y.push_back(A[j]);
		}
		int ans = 0;
		int mx = 0;
		for (auto i : x)
		{
			ans += i > mx;
			mx = max(mx, i);
		}
		int mn = n + 1;
		for (auto i : y)
		{
			ans += i < mn;
			mn = min(mn, i);
		}

		an = max(an, ans);
	}

	return an;
}

const int inf = 1e9;

int dp[210][210];
int dpn[210][210];

inline int N3(vector <int> A)
{
	n = A.size();

	for (int i = 0; i <= n + 1; ++i)
	{
		for (int j = 0; j <= n + 1; ++j)
		{
			dp[i][j] = -inf;
		}
	}
	dp[0][n + 1] = 0;
	for (int i = 0; i <= n + 1; ++i)
	{
		for (int j = n + 1; j >= 0; --j)
		{
			if (i) dp[i][j] = max(dp[i][j], dp[i - 1][j]);
			if (j <= n) dp[i][j] = max(dp[i][j], dp[i][j + 1]);
		}
	}

	for (auto v : A)
	{
		for (int i = 0; i <= n + 1; ++i)
		{
			for (int j = 0; j <= n + 1; ++j)
			{
				dpn[i][j] = dp[i][j];

				if (i == v && j == v) continue;
				if (i == v)
				{
					dpn[i][j] = max(dpn[i][j], dp[i][j] + 1);
				}
				if (j == v)
				{
					dpn[i][j] = max(dpn[i][j], dp[i][j] + 1);
				}

				if (i < v && j > v) dpn[i][j] = -inf;
			}
		}
		for (int i = 0; i <= n + 1; ++i)
		{
			for (int j = 0; j <= n + 1; ++j)
			{
				dp[i][j] = dpn[i][j];
			}
		}
		for (int i = 0; i <= n + 1; ++i)
		{
			for (int j = n + 1; j >= 0; --j)
			{
				if (i) dp[i][j] = max(dp[i][j], dp[i - 1][j]);
				if (j <= n) dp[i][j] = max(dp[i][j], dp[i][j + 1]);
			}
		}
	}

	int ans = 0;
	for (int i = 0; i <= n + 1; ++i)
	{
		for (int j = 0; j <= n + 1; ++j)
		{
			ans = max(ans, dp[i][j]);
		}
	}

	return ans;
}

void check(int n)
{
	vector <int> a(n);

	for (int i = 0; i < n; ++i) a[i] = i + 1;
	do
	{
		auto g1 = stup(a);
		auto g2 = N3(a);

		if (g1 != g2)
		{
			auto u = stup(a);
			auto v = N3(a);
			cout << "";
		}
	} while (next_permutation(a.begin(), a.end()));
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	//for (int i = 2; i < 100; ++i) check(i);
	
	int t;
	cin >> t;
	while (t--)
	{
		int n;
		cin >> n;
		vector <int> A(n);
		for (auto& i : A) cin >> i;
		auto got = N3(A);
		cout << got << endl;
	}

	return 0;
}