#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;
typedef long long ll;
#define endl '\n'

const int N = 100010;

int n;

struct seg
{
	int l, r, i;

	seg() {}
};

seg a[N];
vector <int> cro[N];

inline void solve()
{
	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i].l >> a[i].r;
		a[i].i = i;
	}

	sort(a + 1, a + 1 + n, [&](const seg& a, const seg& b) { return a.r < b.r; });

	vector <int> maxi;
	vector <int> oth;

	int lst = 0;
	for (int i = 1; i <= n; ++i)
	{
		if (a[i].l > lst)
		{
			lst = a[i].r;
			maxi.push_back(i);
		}
		else
		{
			oth.push_back(i);
		}
	}

	for (int i = 1; i <= n; ++i) cro[i].clear();

	for (auto i : oth)
	{/*
		int l = 0, r = maxi.size();
		while (l + 1 < r)
		{
			int mid = (l + r) >> 1;

			if (a[maxi[mid]].l > a[i].r) r = mid;
			else l = mid;
		}

		assert(!(a[i].r < a[maxi[l]].l) && !(a[maxi[l]].r < a[i].l));
		cro[maxi[l]].push_back(i);*/
		for (auto j : maxi)
		{
			if (!(a[i].r < a[j].l) && !(a[j].r < a[i].l))
			{
				cro[j].push_back(i);
				break;
			}
		}
	}

	vector <pair <int, int>> all;
	for (auto i : maxi)
	{
		all.push_back({ (int)cro[i].size(), i });
	}

	sort(all.rbegin(), all.rend());

	vector <int> ans;
	vector <int> ans2;
	for (int _ = 0; _ < all.size() / 2; ++_)
	{
		auto i = all[_];
		ans.push_back(i.second);
		for (auto j : cro[i.second]) ans2.push_back(j);
	}

	ans2.resize((n - all.size()) / 2);

	vector <int> fin;
	for (auto i : ans) fin.push_back(a[i].i);
	for (auto j : ans2) fin.push_back(a[j].i);

	for (auto i : fin) cout << i << ' ';
	cout << endl;

	return;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}