#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;
typedef long long ll;
//#define endl '\n'
#define int long long

const int N = 200010;

int n, q;
int x, y, m;

vector <int> g[N];
int l[N];
int r[N];

int v[N];
int k[N];

int mx[N][2];
int a[N];
vector <int> saved[N];

void dfs(int u, int p)
{
	mx[u][1] = a[u];
	mx[u][0] = 0;
	for (auto v : g[u]) if ( v != p)
	{
		dfs(v, u);
		mx[u][0] += max(mx[v][0], mx[v][1]);
		mx[u][1] += mx[v][0];	
	}
}

int gt()
{
	dfs(1, 1);
	return max(mx[1][0], mx[1][1]);
}

int plan()
{
	int ans = 0;
	for (int i = 1; i <= n; ++i)
	{
		ans ^= ((x * i + y * a[i] % m * a[i] % m) % m);
	}
	return ans;
}

inline void solve()
{
	cin >> n >> q;
	cin >> x >> y >> m;

	for (int i = 1; i <= n; ++i) g[i].clear();

	for (int i = 1; i <= n - 1; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	int maxi = 0;

	for (int i = 1; i <= n; ++i)
	{
		cin >> l[i] >> r[i];
		maxi += r[i] - l[i];
	}

	for (int i = 1; i <= n; ++i) a[i] = l[i];

	int le = gt();
	for (int i = 1; i <= n; ++i) a[i] = r[i];
	int ri = gt();

	for (int i = 1; i <= q; ++i)
	{
		cin >> v[i];

	}
	for (int i = 1; i <= q; ++i)
	{
		if (v[i] < le || v[i] > ri)
		{
			cout << -1 << ' ';
		}
		else
		{
			int lef = -1, rig = maxi + 1;
			while (true)
			{
				int mid = (lef + rig) >> 1;
				int cop = mid;
				for (int i = 1; i <= n; ++i)
				{
					int ad = min(r[i] - l[i], cop);
					cop -= ad;
					a[i] = l[i] + ad;
				}

				auto got = gt();
				if (got == v[i])
				{
					auto gt = plan();
					cout << gt << ' ';

					saved[i].clear();
					for (int j = 1; j <= n; ++j) saved[i].push_back(a[j]);
					break;
				}
				if (got < v[i]) lef = mid;
				else rig = mid;
			}
		}
	}
	cout << endl;
	while (true)
	{
		int i;
		cin >> i;

		if (x == i) return;
		if (v[i] < le || v[i] > ri)
		{
			cout << -1 << endl;
		}
		else
		{
			for (auto j : saved[i]) cout << j << ' ';
			cout << endl;
		}
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}
	cout << endl;

	return 0;
}