#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct Query {
    int k, a, b, id;
};

void solve() {
    int n, q;
    cin >> n >> q;

    vector <int> w(n);
    for (int& i : w)
        cin >> i;

    sort(all(w));

    int z;
    cin >> z;

    vector <Query> query;
    for (int i = 0; i < q; i++) {
        int k, a, b;
        cin >> k >> a >> b;
        query.push_back({k, a, b, i});
    }

    sort(all(query), [&](Query i, Query j) {
        return i.k < j.k;
    });

    set <pair <int, int>> st;
    st.insert({0, 0});

    int cur = 0;
    int ind = 0;

    const int MAX = 100050;

    bitset <MAX> bt;
    bt[0] = 1;

    for (int j = 0; j < n; j++) {
        for (int i = MAX - w[j] - 1; i >= 0; i--) {
            if (bt[i]) {
                bt[w[j] + i] = 1;
            }
        }
    }

    int maxok = MAX;
    for (int i = 1; i < MAX; i++) {
        if (!bt[i]) {
            maxok = i - 1;
            break;
        }
    }

    vector <int> ans(q);
    for (int i = 0; i < q; i++) {
        ans[query[i].id] = (maxok >= query[i].a);
    }

    for (auto& i : ans) {
        cout << (i ? "Yes" : "No") << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
