#include <bits/stdc++.h>

#pragma GCC optimie("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")

using namespace std;

typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define endl '\n'

mt19937_64 rng(228666);
uniform_int_distribution <int> uid(0, 1);
int rnd() {
    return uid(rng);
}

int dp[210][210][210];
int dp1[210][210], dp2[210][210];

void solve() {
    int n;
    cin >> n;
    vector <int> p(n);
    for (auto& i : p)
        cin >> i;
    for (int i = 0; i <= n; i++)
        for (int j = 0; j <= n; j++)
            dp[0][i][j] = -1e9;
    dp[0][0][n + 1] = 0;
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        for (int mx = 1; mx <= n; mx++)
            for (int mn = 1; mn <= n; mn++) {
                // dp[i][mx][mn] = max(dp[i - 1][<mx][all mn] +1, dp[i - 1][all mx][>mn] + 1);
                dp[i][mx][mn] = max(dp[i - 1][mn][mx], max(dp1[i - 1][mx] + 1, dp2[i - 1][mn] + 1));
                dp1[i][mx - 1] = dp[i][mx][mn];
                dp2[i][mn + 1] = dp[i][mx][mn];
                ans = max(ans, dp[i][mx][mn]);
            }
        for (int j = 1; j <= n; j++)
            dp1[i][j] = max(dp1[i][j], dp1[i][j - 1]);
        for (int j = n; j >= 0; j--)
            dp2[i][j] = max(dp2[i][j], dp2[i][j + 1]);
    }
    cout << ans << endl;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();

    cerr << "Ulyanovsk is the best" << endl;
}
