#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

void encode()
{
	int n, k;
	cin >> n >> k;
	set <int> mp;
	for (int i = 0; i < k; i++)
	{
		int x;
		cin >> x;
		mp.insert(x);
	}

	for (int i = 1; i <= n; i++)
	{
		if (!mp.count(i))
		{
			cout << i << ' ';
		}
	}
	cout << endl;
}
void decode()
{
	int n, k;
	cin >> n >> k;
	set <int> mp;
	for (int i = 0; i < k; i++)
	{
		int x;
		cin >> x;
		mp.insert(x);
	}

	for (int i = 1; i <= n; i++)
	{
		if (!mp.count(i))
		{
			cout << i << ' ';
		}
	}
	cout << endl;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int z, t;
	cin >> z >> t;
	if (z == 1)
	{
		while (t--)
		{
			encode();
		}
	}
	else
	{
		while (t--)
		{
			decode();
		}
	}
}