#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

int record(vector<int> a) {
    int n = sz(a);
    vector<int> dp(n, 1);
    int ans = 1;
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if(a[j] < a[i]){
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
        ans = max(ans, dp[i]);
    }
    return ans;
}
int anti(vector<int> a) {
    if(a.empty())return 0;
    int n = sz(a);
    vector<int> dp(n, 1);
    int ans = 1;
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if(a[j] > a[i]){
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
        ans = max(ans, dp[i]);
    }
    return ans;
}
void solve() {
    int n, N;
    cin >> n, N = 1 << n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int ans = 1;
    for (int mask = 0; mask < N; ++mask) {
        vector<int>a1, a2;
        for (int i = 0, x= 1; i < n; ++i, x*=2) {
            if((mask >> i) & 1)a1.push_back(a[i]);
            else a2.push_back(a[i]);
        }
        ans = max(ans, record(a1) + anti(a2));
    }
    cout<<ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}