#include <bits/stdc++.h>
using namespace std;

int run;

void solve() {
    int n, k;
    cin >> n >> k;
    int n0 = n;
    int input_mask = 0;
    for (int i = 0; i < k; i++) {
        int x;
        cin >> x;
        x--;
        input_mask |= (1 << x);
    }
    vector<int> masks;
    for (int mask = 0; mask < (1 << n); mask++) {
        if (__builtin_popcount(mask) == k) {
            masks.push_back(mask);
        }
    }
    n = (int)masks.size();
    vector<vector<int>> g(n);
    for (int u = 0; u < n; u++) {
        for (int v = 0; v < n; v++) {
            if ((masks[u] & masks[v]) == 0) {
                g[u].push_back(v);
            }
        }
    }
    mt19937 rng(42228);
    vector<pair<int, int>> matching;
    vector<bool> in_matching(n, false);
    while (count(in_matching.begin(), in_matching.end(), false) != 0) {
        in_matching.assign(n, false);
        matching = vector<pair<int, int>>();
        for (int u = 0; u < n; u++) {
            shuffle(g[u].begin(), g[u].end(), rng);
        }
        for (int u = 0; u < n; u++) {
            if (!in_matching[u]) {
                for (int v : g[u]) {
                    if (!in_matching[v]) {
                        matching.emplace_back(u, v);
                        in_matching[u] = in_matching[v] = true;
                        break;
                    }
                }
            }
        }
    }
    int ans = -1;
    for (auto [x, y] : matching) {
        if (masks[x] == input_mask) {
            ans = masks[y];
        } else if (masks[y] == input_mask) {
            ans = masks[x];
        }
    }
    for (int i = 0; i < n0; i++) {
        if ((ans >> i) & 1) {
            k--;
            cout << i + 1 << " \n"[k == 0];
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> run;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}