#include <bits/stdc++.h>

// #pragma GCC optimize("-Ofast")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) ((x).begin()), ((x).end())
#define sz(x) (ll)((x).size())

ll INF = (ll)1e9 + 7;
ll MOD = (ll)1e9 + 7;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct Event {
    ll l, r, id;
    Event() {}
};

ll m;

vector<ll> ans;
vector<Event> res;
vector<Event> ev;

ll cm = 0;
bool flag;
ll n;

void gen(ll i, ll j) {
    if (flag) {
        return;
    }
    if (sz(ans) == n / 2) {
        if (cm == m / 2) {
            flag = true;
            for (ll i : ans) {
                cout << i + 1 << ' ';
            }
            cout << '\n';
        }
        return;
    }
    for (ll tt = j; tt < n; ++tt) {
        bool p = 0;
        if (cm == 0 || ev[tt].l > res.back().r) {
            if (cm == m / 2) {
                continue;
            }
            ++cm;
            p = 1;
        }

        ans.push_back(ev[tt].id);

        res.push_back(ev[tt]);
        gen(i + 1, tt + 1);

        ans.pop_back();
        res.pop_back();

        if (p) {
            --cm;
        }

        if (flag) {
            return;
        }
    }
}

void solve() {

    cin >> n;
    ev.clear();
    ev.resize(n);
    flag = false;
    cm = 0;
    ans.clear();
    res.clear();

    for (ll i = 0; i < n; ++i) {
        cin >> ev[i].l >> ev[i].r;
        ev[i].id = i;
    }

    sort(all(ev), [&](Event a, Event b) -> bool {
        if (a.r < b.r) return true;
        if (a.r > b.r) return false;
        return a.l > b.l;
    });



    vector<Event> b;
    b.push_back(ev[0]);
    for (ll i = 1; i < n; ++i) {
        if (ev[i].l > b.back().r) {
            b.push_back(ev[i]);
        }
    }
    m = sz(b);


    gen(0, 0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
#endif

    ll tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}