#include<bits/stdc++.h>
#define ll long long

using namespace std;

ll n;
vector<ll> ans;
vector<pair<ll, ll>> a;

bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
    if (b.second > a.second || (b.second == a.second && b.first > a.first)) {
        return true;
    }
    return false;
}

ll precalc (ll l, ll r) {
    vector<pair<ll, ll>> c;
    for (ll i = l; i < r; i++) {
        c.push_back(a[i]);
    }
    sort(c.begin(), c.end(), cmp);
    ll summ = 0,  MAXIM = -1e9;
    for (ll i = 0; i < c.size(); i++) {
        if (c[i].first > MAXIM) {
            MAXIM = c[i].second;
            summ++;
        }
    }
    return summ;
}

void input() {
    cin >> n;
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
}

void solve() {
    ans = {};
    vector<ll> pos = {};
    vector<pair<pair<ll, ll>, ll>> X;
    for (ll i = 0; i < n; i++) {
        X.push_back({a[i], i});
    }
    sort(X.begin(), X.end());
    for (ll i = 0; i < n; i++) {
        pos.push_back(X[i].second);
    }
    sort(a.begin(), a.end());
    ll m = precalc(0, n);
    if (precalc(0, n / 2) == m / 2) {
        for (ll i = 0; i < n / 2; i++) {
            ans.push_back(pos[i]);
        }
        return;
    }
    if (precalc(n / 2, n) == m / 2) {
        for (ll i = n / 2; i < n; i++) {
            ans.push_back(pos[i]);
        }
        return;
    }
    ll l, r;
    if (precalc(0, n / 2) < m / 2) {
        l = 0;
        r = n / 2;
    } else {
        l = n / 2;
        r = 0;
    }
    while (abs(r - l) > 1) {
        //cout << "! " << l << " " << r << "\n";
        ll f = (r + l) / 2;
        ll R = precalc(f, f + n / 2);
        if (R > m / 2) {
            r = f;
        } else if (R == m / 2) {
            for (ll i = f; i < f + n / 2; i++) {
                ans.push_back(pos[i]);
            }
            return;
        } else {
            l = f;
        }
        //cout << l << " " << r << "\n";
    }
}

void output() {
    for (ll i = 0; i < ans.size(); i++) {
        cout << ans[i] + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll t;
    cin >> t;
    for (ll i = 0; i < t; i++) {
        input();
        solve();
        output();
    }
    return 0;
}
