#include <bits/stdc++.h>

using namespace std;

#define ssize(a) static_cast<ptrdiff_t>(size(a))
#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}

void solve();



int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  i32 t;
  cin >> t;
  while (t--) solve();
  return 0;
}

void solve() {
  i32 n, q;
  cin >> n >> q;
  i64 x, y, m;
  cin >> x >> y >> m;
  vector<vector<i32>> g(n);
  for (int i = 0; i < n - 1; ++i) {
    i32 u, v;
    cin >> u >> v;
    u--,v--;
    g[u].push_back(v);
    g[v].push_back(u);
  }
  vector<pair<i32, i32>> limits(n);
  for (auto& e : limits) cin >> e.first >> e.second;
  vector<i64> query(q);
  for (auto& e : query) cin >> e;

  struct Data {
    i64 r_sum_in, l_sum_in, r_sum_ex, l_sum_ex;
  };
  auto Dfs = [&](i32 u, i32 p, auto&& Dfs) -> Data {
    vector<Data> c;
    for (i32 v : g[u]) {
      if (v == p) continue;
      c.push_back(Dfs(v, u, Dfs));
    }
    Data res{};
    res.r_sum_in = limits[u].second;
    res.l_sum_in = limits[u].first;
    for (const auto& e : c) {
      res.r_sum_in += e.r_sum_ex;
      res.l_sum_in += e.l_sum_ex;
      res.r_sum_ex += e.r_sum_in;
      res.l_sum_ex += e.l_sum_in;
    }
    chmax(res.r_sum_in, res.r_sum_ex);
    chmax(res.l_sum_in, res.l_sum_ex);
    return res;
  };
  Data d = Dfs(0, 0, Dfs);
  i64 max_sum = d.r_sum_in, min_sum = d.l_sum_in;
  vector<i64> ans(q);
  for (int i = 0; i < q; ++i) {
    ans[i] = clamp(query[i], min_sum, max_sum) == query[i] ? 1 : -1;
  }
  for (i64 e : ans) cout << e << " ";
  cout << endl;
  i32 t;
  cin >> t;
  if (t != 0) abort();
}
