#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18 + 7;
const int N = 5001, Q = 3e5;

int w[N], dp[N], pref[N];
array<int, 4> req[Q];
bitset<Q> ans;

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n, q, z;
    cin >> n >> q;
    for (int i = 0; i < n; i++) cin >> w[i];
    sort(w, w + n);
    cin >> z;
    for (int i = 0; i < q; i++) {
        for (int j = 0; j < 3; j++) cin >> req[i][j];
        req[i][3] = i;
    }
    sort(req, req + q);
    for (auto & i : dp) i = -INF;
    dp[0] = 0;
    int ind = 0;
    for (int i = 0; i < n; i++) {
        pref[0] = dp[0];
        for (int j = 1; j < N; j++)
            pref[j] = min(pref[j - 1], dp[j]);
        while (ind < q && req[ind][0] < w[i]) {
            ans[req[ind][3]] = (req[ind][1] <= pref[req[ind][2]]);
            ind++;
        }
        for (int j = N - 1; j >= max(0ll, N - w[i]); j--) {
            if (dp[j] + 1 >= w[i]) dp[j] += w[i];
        }
        for (int j = N - w[i] - 1; j > -1; j--) {
            dp[j + w[i]] = max(dp[j + w[i]], dp[j]);
            if (dp[j] + 1 >= w[i]) dp[j] += w[i];
        }
    }
    pref[0] = dp[0];
    for (int j = 1; j < N; j++)
        pref[j] = min(pref[j - 1], dp[j]);
    while (ind < q) {
        ans[req[ind][3]] = (req[ind][1] <= pref[req[ind][2]]);
        ind++;
    }
    for (int i = 0; i < q; i++) {
        if (ans[i]) cout << "Yes\n";
        else cout << "No\n";
    }
}