#include <bits/stdc++.h>

#include <random>

using namespace std;
typedef long long ll;

vector<vector<vector<ll>>> all(8);
void enc() {
    ll n, k;
    cin >> n >> k;
    vector<ll> arr(k);
    for (auto &x : arr) {
        cin >> x;
    }

    ll i = std::find(all[n].begin(), all[n].end(), arr) - all[i].begin();
    i = (i + 1) % (ll) all[n].size();
    for (auto x : all[n][i]) {
        cout << x << " ";
    }
    cout << "\n";
}

ll to = -1;
vector<ll> now;

void gen(ll next = 1) {
    if (!now.empty()) {
        all[to].push_back(now);
    }
    if (now.size() > to / 2) {
        return;
    }

    for (ll j = next; j <= to; ++j) {
        now.push_back(j);
        gen(j + 1);
        now.pop_back();
    }
}

void dcr() {
    ll n, k;
    cin >> n >> k;
    vector<ll> arr(k);
    for (auto &x : arr) {
        cin >> x;
    }

    ll i = std::find(all[n].begin(), all[n].end(), arr) - all[i].begin();
    i = (i - 1 + (ll) all[n].size()) % (ll) all[n].size();
    for (auto x : all[n][i]) {
        cout << x << " ";
    }
    cout << "\n";
}

bool bad(vector<ll>& a, vector<ll>& b) {
    set<ll> s;
    for (auto x : a) {
        s.insert(x);
    }
    for (auto x : b) {
        if (s.find(x) != s.end()) {
            return true;
        }
    }
    return false;
}

mt19937 rnd(500);
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    for (ll i = 2; i <= 7; ++i) {
        to = i;

        while (true) {
            bool ok = true;
            for (ll j = 0; j < all[i].size(); ++j) {
                ll k = (j + 1) % (ll) all[i].size();
                if (bad(all[i][j], all[i][k])) {
                    ok = false;
                    shuffle(all[i].begin(), all[i].end(), rnd);
                }
            }
            if (ok) {
                break;
            }
        }
    }

    ll act;
    cin >> act;

    ll t;
    cin >> t;

    while (t--) {
        if (act == 1) {
            enc();
        } else {
            dcr();
        }
    }

    return 0;
}