#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

void solve() {
    ll n;
    cin >> n;
    vector<ll> arr(n + 1);
    vector<ll> all;
    for (ll i = 1; i <= n; ++i) {
        cin >> arr[i];
        all.push_back(arr[i]);
    }
    all.push_back(n + 2);

    std::sort(all.begin(), all.end());
    all.erase(std::unique(all.begin(), all.end()), all.end());

    for (auto &x : arr) {
        x = lower_bound(all.begin(), all.end(), x) - all.begin();
    }

    vector<vector<vector<ll>>> dp(n + 5, vector<vector<ll>>(n + 5, vector<ll>(n + 5, 0)));

    for (ll i = 1; i <= n; ++i) {
        for (ll prev = 0; prev <= n + 1; ++prev) {
            for (ll prev2 = 0; prev2 <= n + 1; ++prev2) {
                dp[i][max(prev, arr[i])][prev2] = max(dp[i][max(prev, arr[i])][prev2], dp[i - 1][prev][prev2] + ll(arr[i] > prev));
                dp[i][prev][min(arr[i], prev2)] = max(dp[i][prev][min(arr[i], prev2)], dp[i - 1][prev][prev2] + ll(arr[i] < prev2));
            }
        }
    }

    ll mx = 0;
    for (auto &x : dp[n]) {
        for (auto y : x) {
            mx = max(mx, y);
        }
    }

    cout << mx << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}