#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, q;
    cin >> n >> q;
    vector<ll> arr;
    arr.resize(n + 1);
    for (ll i = 1; i <= n; ++i) {
        cin >> arr[i];
    }

    std::sort(arr.begin(), arr.end());

    vector<vector<bitset<1501>>> can_take(n + 1, vector<bitset<1501>>(1501));
    can_take[0][0].set(0);

    for (ll i = 1; i <= n; ++i) {
        can_take[i] = can_take[i - 1];
        for (ll f = 0; f <= 1500; ++f) {
            if (f + arr[i] <= 1500) {
                can_take[i][f + arr[i]] |= can_take[i - 1][f];
            }
            can_take[i][f] |= (can_take[i - 1][f] << arr[i]);
        }
    }

    vector<vector<ll>> maxx(n + 1, vector<ll>(1501));

    for (ll mx_i = 0; mx_i <= n; ++mx_i) {
        ll mx_j = 1500;
        for (ll f = 0; f <= 1500; ++f) {
            for (ll j = 0; j <= mx_j; ++j) {
                if (!can_take[mx_i][f][j]) {
                    mx_j = j - 1;
                    break;
                }
            }

            maxx[mx_i][f] = mx_j;
        }
    }

    ll z;
    cin >> z;

    while (q--) {
        ll k, a, b;
        cin >> k >> a >> b;

        ll mx_i = 0;
        for (ll i = 0; i <= n; ++i) {
            if (arr[i] <= k) {
                mx_i = i;
            } else {
                break;
            }
        }

        if (maxx[mx_i][a] >= b) {
            cout << "Yes" << "\n";
        } else {
            cout << "No" << "\n";
        }
    }
    return 0;
}