#include "bits/stdc++.h"
#define f first
#define s second
#define all(a) a.begin(), a.end()
#define allr(a) a.rbegin(), a.rend()
#define len(a) (int)a.size()

using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18 + 100;
const int MAXI = 1e9 + 1e7;
const ll MOD = 1e9 + 7;

const ll MAXN = 2e5 + 100;
vector<ll> g[MAXN];
ll max_sum[MAXN][2], l[MAXN], r[MAXN];

void dfs(ll u, ll p = -1) {
    max_sum[u][0] = l[u];
    for (ll v : g[u]) {
        if (v != p) {
            dfs(v, u);
            max_sum[u][0] += max_sum[v][1];
            max_sum[u][1] += max(max_sum[v][1], max_sum[v][0]);
        }
    }
}

void init(ll n) {
    for (ll i = 0; i < n; i++) {
        g[i].clear();
        max_sum[i][0] = max_sum[i][1] = 0;
    }
}

int main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ll t;
    cin >> t;
    while (t--) {
        ll n, q;
        cin >> n >> q;
        ll x, y, m;
        cin >> x >> y >> m;
        init(n);
        for (ll i = 0; i < n - 1; i++) {
            ll u, v;
            cin >> u >> v;
            g[u - 1].push_back(v - 1);
            g[v - 1].push_back(u - 1);
        }
        ll k = 0;
        for (ll i = 0; i < n; i++) {
            cin >> l[i] >> r[i];
            k ^= (x * (i + 1) % m + y * l[i] % m * l[i] % m) % m;
        }
        dfs(0);
        ll eff = max(max_sum[0][0], max_sum[0][1]);
        vector<bool> pos(q);
        for (ll i = 0; i < q; i++) {
            ll v;
            cin >> v;
            pos[i] = eff == v;
            if (pos[i])
                cout << k << " ";
            else
                cout << -1 << " ";
        }
        cout << endl;
        while (true) {
            ll i;
            cin >> i;
            if (!i)
                break;
            if (pos[i - 1]) {
                for (ll j = 0; j < n; j++)
                    cout << l[j] << " ";
            } else
                cout << -1;
            cout << endl;
        }
    }
}


