#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int k;
vector<pii> g;
vi x;

void dfs(int u = 0, int r = 0, int d = 0) {
    if (g[u].first == -1) {
        if (r <= k)
            x[u] = 1;
    }
    else {
        if (d == 0) {
            dfs(g[u].first, r, 1);
            dfs(g[u].second, r, 2);
        }
        else if (d == 1) {
            dfs(g[u].first, r, 1);
            dfs(g[u].second, r + 1, 2);
        }
        else {
            dfs(g[u].first, r + 1, 1);
            dfs(g[u].second, r, 2);
        }
        x[u] = x[g[u].first] + x[g[u].second];
    }
}

int main() {
    fast;
    int n, q;
    cin >> n >> k >> q;
    g.resize(n);
    x.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 0)
            g[i] = {-1, -1};
        else {
            cin >> g[i].first >> g[i].second;
            --g[i].first;
            --g[i].second;
        }
    }
    dfs();
    while (q--) {
        int u;
        cin >> u;
        cout << x[u - 1] << '\n';
    }
}
