#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
#define ff first
#define ss second
using ll = long long;
const int MOD = 1ll << 60;

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}

int h, w;

int calclr(vector<int> &a) {
    int mi2 = 2 * MOD, ma2 = 2 * -MOD;
    for (auto i: a) {
        int y = ((i % w) + w) % w;
        mi2 = min(mi2, y);
        ma2 = max(ma2, y);
    }
    return (ma2 - mi2 + 1);
}

int calcud(vector<int> &a) {
    int mi2 = 2 * MOD, ma2 = 2 * -MOD;
    for (auto i: a) {
        int y = ((i % h) + h) % h + 1;
        mi2 = min(mi2, y);
        ma2 = max(ma2, y);
    }
    return (ma2 - mi2 + 1);
}

void solve() {
    int k;
    cin >> h >> w >> k;
    vector<pair<int, int>> v(k);
    for (auto &i: v) {
        cin >> i.first >> i.ss;
        i.ff--, i.ss--;
    }
    vector<int> lr, ud;
    for (auto i: v) {
        lr.pb(i.ss);
        ud.pb(i.ff);
    }
    int res1 = MOD, res2 = MOD, mi = 0, mi2 = 0;
    res1 = calclr(lr);
    res2 = calcud(ud);
    for (auto i: lr) {
        vector<int> lr2 = lr;
        for (auto &j: lr2) {
            j += w - i;
        }
        int give = calclr(lr2);
        if (relaxmi(res1, give)) {
            mi = w - i;
        } else if (res1 == give) {
            relaxmi(mi, w - i);
        }
    }

    for (auto i: lr) {
        vector<int> lr2 = lr;
        for (auto &j: lr2) {
            j -= i + 1;
        }
        int give = calclr(lr2);
        if (relaxmi(res1, give)) {
            mi = i + 1;
        } else if (res1 == give) {
            relaxmi(mi, i + 1);
        }
    }

    for (auto i: ud) {
        vector<int> ud2 = ud;
        for (auto &j: ud2) {
            j += h - i;
        }
        int give = calcud(ud2);
        if (relaxmi(res2, give)) {
            mi2 = h - i;
        } else if (res2 == give) {
            relaxmi(mi2, h - i);
        }
    }
    for (auto i: ud) {
        vector<int> ud2 = ud;
        for (auto &j: ud2) {
            j -= i + 1;
        }
        int give = calcud(ud2);
        if (relaxmi(res2, give)) {
            mi2 = i + 1;
        } else if (res2 == give) {
            relaxmi(mi2, i + 1);
        }
    }

    cout << 1ll * res1 * res2 << ' ' << mi + mi2;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) solve();
}