#include <bits/stdc++.h>
#include <bits/extc++.h>

#define int long long
using namespace std;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define ff first
#define ss second
#define pb push_back
#define all(v) v.begin(), v.end()
#define err(x) cerr << "[ " << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[ " << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << '\n';}


const int N = 3e5 + 5, M = 1501;

int w[N];
bool RES[N];

struct ask {
    int a, b, id;
};

vector<ask> t[N];

bool dp[M][M];
bool dp2[M][M];


void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) cin >> w[i];
    int z;
    cin >> z;
    sort(w, w + n);
    for (int i = 0; i < q; i++) {
        int j, c, d;
        cin >> j >> c >> d;
        int k = j, a = c, b = d;
        int ps = upper_bound(w, w + n, k) - w - 1;
        if (ps >= 0)
            t[ps].pb({a, b, i});
        else {
            if (a == 0 && b == 0) RES[i] = true;
        }
    }
    dp[0][0] = true;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < M; j++)
            for (int k = 0; k < M; k++)
                dp2[j][k] = false;
        for (int j = 0; j < M; j++)
            for (int k = 0; k < M; k++) {
                if (j >= w[i])
                    dp2[j][k] = dp2[j][k] || dp[j - w[i]][k];
                if (k >= w[i])
                    dp2[j][k] = dp2[j][k] || dp[j][k - w[i]];
            }
        for (int j = 0; j < M; j++)
            for (int k = 0; k < M; k++) {
                dp[j][k] = dp[j][k] || dp2[j][k];
                dp2[j][k] = false;
            }
        dp2[0][0] = true;
        for (int j = 0; j < M; j++)
            for (int k = 0; k < M; k++) {
                bool now = dp[j][k];
                if (j > 0) now = now && dp2[j - 1][k];
                if (k > 0) now = now && dp2[j][k - 1];
                dp2[j][k] = now;
            }
        for (auto [a, b, id]: t[i]) {
            if (a >= M || b >= M) RES[id] = false;
            else {
                RES[id] = dp2[a][b];
            }
        }
    }
    for (int i = 0; i < q; i++) {
        if (RES[i]) cout << "Yes\n";
        else cout << "No\n";
    }
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}