#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int INF = 2e9;
const ll LL_INF = 2e18;
const ld EPS = 1e-7;

void solve() {
    ll h, w, k;
    cin >> h >> w >> k;

    if (k == 1) {
        cout << "1 0";
        return;
    }

    vector < ll > x(k), y(k);
    for (int i = 0; i < k; ++i)
        cin >> x[i] >> y[i];

    deque < ll > lr, ud;
    for (int i = 0; i < k; ++i) {
        lr.push_back(y[i]);
        ud.push_back(x[i]);
    }

    sort(lr.begin(), lr.end());
    sort(ud.begin(), ud.end());
    lr.resize(unique(lr.begin(), lr.end()) - lr.begin());
    ud.resize(unique(ud.begin(), ud.end()) - ud.begin());
    deque < ll > lr1 = lr, ud1 = ud;

    // сначала пробуем влево, потом вправо, выбираем выгодный

    ll cnt1 = 0;
    while (lr.size() > 1) {
        ll l1 = lr.front(), l2 = lr.at(1);
        ll r1 = lr.back(), r2 = lr.at(lr.size() - 2);

        if (max({w - (r1 - l1), w - (l2 - l1), w - (r2 - l1)}) < r1 - l1) {
            cnt1 += (((l1 - cnt1) % w + w) % w + 1);
            lr.push_back(lr.front());
            lr.pop_front();
        }
        else
            break;
    }
    ll s = (lr.back() - lr.front() + 1);

    lr = lr1;
    ll cnt2 = 0;
    while (lr.size() > 1) {
        ll l1 = lr.front(), l2 = lr.at(1);
        ll r1 = lr.back(), r2 = lr.at(lr.size() - 2);

        if (max({w - (r1 - l1), w - (r1 - r2), w - (r1 - l2)}) < r1 - l1) {
            cnt2 += (((w - (r1 + cnt2)) % w) + w) % w + 1;
            lr.push_front(lr.back());
            lr.pop_back();
        }
        else
            break;
    }

    ll cnt = min(cnt1, cnt2);
    assert(s == (lr.back() - lr.front() + 1));

    cout << s << ' ' << cnt << "\n";
}

int main() {
//    freopen("../input.txt", "r", stdin);
    ios::sync_with_stdio(false), cin.tie(nullptr);
//    cout.tie(nullptr);

    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
}

