#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <functional>
#include <cassert>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(1337);

#define int long long

void solve() {
	int n, q; cin >> n >> q;
	vector <int> w(n);
	for (auto& x : w) cin >> x;
	sort(all(w));

	int z; cin >> z;
	while (q--) {
		int k, a, b; cin >> k >> a >> b;
		if ((a + 1) > 2000 || (b + 1) > 2000 || (a + 1) * (b + 1) > 2000) cout << "No\n";
		else {
			vector <vector <bool>> used(a + 1, vector <bool>(b + 1, false));
			for (int mask = 0; mask < (1ll << n); ++mask) {
				int mask1 = mask;
				do {
					int sm1 = 0, sm2 = 0;
					for (int i = 0; i < n; ++i) {
						if (w[i] <= k) {
							if (mask1 >> i & 1) {
								sm2 += w[i];
							}
							else if (mask >> i & 1) {
								sm1 += w[i];
							}
						}
					}
					if (sm1 <= a && sm2 <= b) used[sm1][sm2] = true;

					mask1 = mask & (mask1 - 1);
				} while (mask1 != mask);
			}
			
			if (*min_element(all(*min_element(all(used)))) == true) cout << "Yes\n";
			else cout << "No\n";
		}
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}