#include <bits/stdc++.h>
#define ff first
#define ss second
#define endl '\n'
#define all(x) x.begin(), x.end()

typedef long long ll;
using namespace std;

bool yes = 0;

struct seg {
    int l, r, id;

    seg() {
        l = 0;
        r = 0;
        id = 0;
    }
};

bool cmp(seg a, seg b) {
    if (a.r != b.r) return a.r < b.r;

    return a.l < b.l;
}


int solve2(int n, vector<seg>& e, vector<pair<int, int>>& w) {
    int ans = 0, r = 0;
    for (int i = 0; i < n; i++) {
        if (e[i].l > r) {
            ans++;
            r = e[i].r;
        }
    }
    return ans;
}

void rec(int n, int m, vector<seg>& e, vector<pair<int, int>>& w, vector<int>& a, int i, int r, int ans) {
    if (!a.empty() && e[a.back()].l > r) {
        r = e[a.back()].r;
        ans++;
    }

    if (a.size() == n / 2) {
        if (ans == m / 2) {
            yes = 1;
            for (auto x : a) cout << x + 1 << " ";
            cout << endl;
            return;
        }
    }

    if (n - i - 1 > n / 2 - a.size()) {
        rec(n, m, e, w, a, i + 1, r, ans);
    }
    if (yes) return;


    if (a.size() < n / 2) {
        a.push_back(i);
        rec(n, m, e, w, a, i + 1, r, ans);
        if (yes) return;
        a.pop_back();
    }
}

void solve() {
    yes = 0;
    int n;
    cin >> n;

    vector<seg> e(n);
    vector<pair<int, int>> w(n);
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;

        seg u;
        u.l = a;
        u.r = b;
        u.id = i;

        e[i] = u;

        w[i] = {b, a};
    }
    sort(all(e), cmp);
    sort(all(w));

    int m = solve2(n, e, w);
    vector<int> a;
    rec(n, m, e, w, a, 0, 0, 0);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
