#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;

#pragma GCC target("avx")

void solve();

vector<vector<short int>> dp[2];

const short int MX = 2000;

int32_t main() {
    for (short int i = 0; i < 2; ++i) {
        dp[i].resize(MX + 2, vector<short int>(MX + 1, -1));
    }
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int q = 1;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        solve();
    }
}

short int max(short int x, short int y) {
    return x > y ? x : y;
}

void solve() {
    short int n;
    cin >> n;
    vector<short int> a(n);
    for (auto &i: a) {
        cin >> i;
    }
    a.insert(a.begin(), -1); //dp[pref][lst_down][lst_up]
    for (short int was_down = 0; was_down <= n + 1; ++was_down) {
        for (short int was_up = 0; was_up <= n; ++was_up) {
            dp[0][was_down][was_up] = dp[1][was_down][was_up] = -1;
        }
    }
    dp[0][n + 1][0] = 0;
    short int mx = 0;
    vector<pair<short int, short int>> hv;
    hv.emplace_back(n + 1, 0);
    for (short int i = 1; i <= n; ++i) {
        for (auto &[was_down, was_up]: hv) {
            dp[1][was_down][was_up] = -1;
        }
        vector<pair<short int, short int>> nw;
        for (auto &[was_down, was_up]: hv) {
            dp[1][min(was_down, a[i])][was_up] = dp[0][was_down][was_up];
            dp[1][was_down][max(was_up, a[i])] = dp[0][was_down][was_up];
//            nw.emplace_back(was_down, max(was_up, a[i]));
//            nw.emplace_back(min(was_down, a[i]), was_up);
        }
        for (auto &[was_down, was_up]: hv) {
            if (was_down > a[i]) {
                dp[1][a[i]][was_up] = max(dp[1][a[i]][was_up], dp[0][was_down][was_up] + 1);
                mx = max(mx, dp[1][a[i]][was_up]);
                nw.emplace_back(a[i], was_up);
            }
            if (was_up < a[i]) {
                dp[1][was_down][a[i]] = max(dp[1][was_down][a[i]], dp[0][was_down][was_up] + 1);
                mx = max(mx, dp[1][was_down][a[i]]);
                nw.emplace_back(was_down, a[i]);
            }
        }
        sort(all(nw)), nw.resize(unique(all(nw)) - nw.begin());
        swap(hv, nw);
        swap(dp[0], dp[1]);
    }
    cout << mx << "\n";
}