#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
//#define endl '\n'

using namespace std;

mt19937_64 gen(time(nullptr));
int n, k;
vector<bool> coded;
vector<bool> locked;
int buff = 0;

void encode(vector<int> &a) {
    vector<int> ans;

    coded.assign(n, true);
    locked.assign(n, false);
    for (auto u: a){
        coded[u - 1] = false;
        locked[u - 1] = true;
    }

    for (int i = 0; i < n; ++i) {
        if(!coded[i])
            ++buff;
        coded[i] = true;
        if(buff > 0 and !locked[i]){
            ans.emplace_back(i + 1);
            locked[i] = true;
            --buff;
        }
    }
    if(buff != 0){
        for (int i = 0; i < n; ++i) {
            if(!coded[i])
                ++buff;
            coded[i] = true;
            if(buff > 0 and !locked[i]){
                ans.emplace_back(i + 1);
                locked[i] = true;
                --buff;
            }
        }
    }
    sort(all(ans));
    for (auto u : ans) {
        cout << u << ' ';
    }
    cout << endl;
}

void decode(vector<int> &a){
    vector<int> ans;

    coded.assign(n, true);
    locked.assign(n, false);
    for (auto u: a){
        coded[u - 1] = false;
        locked[u - 1] = true;
    }

    for (int i = n - 1; i >= 0; --i) {
        if(!coded[i])
            ++buff;
        coded[i] = true;
        if(buff > 0 and !locked[i]){
            ans.emplace_back(i + 1);
            locked[i] = true;
            --buff;
        }
    }
    if(buff != 0){
        for (int i = n - 1; i >= 0; --i) {
            if(!coded[i])
                ++buff;
            coded[i] = true;
            if(buff > 0 and !locked[i]){
                ans.emplace_back(i + 1);
                locked[i] = true;
                --buff;
            }
        }
    }
    sort(all(ans));
    for (auto u : ans) {
        cout << u << ' ';
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int a;
    cin >> a;
    int t;
    cin >> t;
    while(t--) {
        cin >> n >> k;
        vector<int> u(k);
        for (int i = 0; i < k; ++i) {
            cin >> u[i];
        }
        if (a == 1) {
            encode(u);
        }else{
            decode(u);
        }
    }

    return 0;
}
