#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

#define int long long
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define fastIo(a) ios_base::sync_with_stdio(a) ; cin.tie(a); cout.tie(a);

const int INF = 1e9;
const ll INFll = 1e18;

int mod;

int mex(vector<int> a) {
    int n = a.size();
    vector<bool> used(n + 1);
    for (auto &i : a) {
        if (i <= n) used[i] = true;
    }
    for (int i = 0; i <= n; i++) {
        if (!used[i]) return i;
    }
}

vector<int> ultra(vector<int> v) {
    int m = mex(v);
    for (auto &i : v) i ^= (m - 1);
    return v;
}

ll get_hash(vector<int> v) {
    int md = (int)1e9 + 9;
    ll h = 0, p = (int)13427;
    for (auto &i : v)
        h = (h * p + i) % md;
    return h;
}

void solve() {
    int k, n, p;
    cin >> k >> n >> p;
    int mx = (1ll << k);
    int cnt = 0;
    for (int mask = 0; mask < (1ll << mx); mask++) {
        if (!(mask & 1)) continue;
        gp_hash_table<ll, bool> used;
        vector<int> v;
        for (int i = 0; i < mx; i++) {
            if (mask >> i & 1) v.emplace_back(i);
        }

        if (v.size() != n) continue;

        ll h = get_hash(v);
        while (!used[h]) {
            used[h] = true;
            v = ultra(v);
            h = get_hash(v);
        }

        auto check = [&](vector<int> v) {
            ll h = get_hash(v);
            int m = mex(v);
            gp_hash_table<ll, bool> used;
            while (!used[h]) {
                used[h] = true;
                v = ultra(v);
                if (mex(v) != m || m != p) return false;
            }
            return true;
        };

        cnt += check(v);
    }
    cout << cnt << '\n';
}

signed main() {
    fastIo(0);
    int t = 1;
    cin >> mod >> t;
    while (t--) {
        solve();
    }
}