#include <bits/stdc++.h>

using namespace std;

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

int mex(vector<int>& v) {
    int n = (int)v.size();
    vector<char> used(n);
    for (int x : v) {
        if (x < n) {
            used[x] = true;
        }
    }
    int ind = 0;
    while ((ind < n) && (used[ind])) {
        ++ind;
    }
    return ind;
}

void solve() {
    int k, n, p;
    cin >> k >> n >> p;
    int ans = 0;
    for (int mask = 0; mask < (1 << (1 << k)); ++mask) {
        if ((__builtin_popcount(mask) == n) && (mask & 1)) {
            vector<int> v;
            for (int i = 0; i < (1 << k); ++i) {
                if ((mask >> i) & 1) {
                    v.push_back(i);
                }
            }

//            for (int x : v) {
//                cerr << x << ' ';
//            }
//            cerr << '\n';

            int old_m = -1;
            int m = mex(v);
            while (old_m != m) {
                assert(m > old_m);
                old_m = m;
                for (int& x : v) {
                    x ^= m - 1;
                }
                m = mex(v);
            }
            if (m == p) {
                ++ans;
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int m;
    cin >> m;
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}