#include <iostream>
#include <vector>
#include <cassert>
 
using namespace std;
 
void encode() {
    int n, k; cin >> n >> k;
    assert(k == 2);
    int a, b; cin >> a >> b; a--; b--;
    if (b < a) {
        swap(a, b);
    }
    if (a == 0 && b == n - 1) {
        cout << 2 << ' ' << 3 << endl;
    } else if (b == a + 1) {
        cout << ((a + 2) % n) + 1 << ' ' << ((a + 3) % n) + 1 << endl;
    } else {
        cout << (a + 1) % n + 1 << ' ' << (b + 1) % n + 1 << endl;
    }
}
 
void decode() {
    int n, k; cin >> n >> k;
    assert(k == 2);
    int a, b; cin >> a >> b; a--; b--;
    if (b < a) {
        swap(a, b);
    }
    if (a == 0 && b == n - 1) {
        cout << n - 2 << ' ' << n - 1 << endl;
    } else if (b == a + 1) {
        cout << ((a - 2 + n) % n) + 1 << ' ' << ((a - 1 + n) % n) + 1 << endl;
    } else {
        cout << ((a - 1 + n) % n) + 1 << ' ' << ((b - 1 + n) % n) + 1 << endl;
    }
}
 
int main() {
    int t, m; cin >> t >> m;
    while (m--) {
        if (t == 1) {
            encode();
        } else if (t == 2) {
            decode();
        }
    }
}
