#include <iostream>
#include <cassert>
#include <string>
#include <sstream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <iomanip>

using namespace std;

#define wall(X) X.begin(),X.end()
#define ins insert
#define era erase
#define int long long
#define foriab(i,a,b) for(int i=(a);i<(b);++i)
#define fori(i,n) foriab(i,0,n)
#define foris(i,n) fori(i,n.sz())
#define fori1(i,n) foriab(i,1,n)
#define x first
#define y second
#define sz size
#define pb push_back
#define pp pop_back
#define VI vector<int>
#define VVI vector<VI>
#define VS vector<string>
#define byte unsigned char
#define ret return
#define endl '\n'
#define endlf endl<<flush
#define cont continue
#define VB vector<byte>
#define PII pair<int,int>
#define VPII vector<PII>
#define sstream stringstream
#define ANS(X) {cout<<(X)<<endl;ret;}
#define SI set<int>
#define SPII set<PII>
#define MII map<int,int>

template<class A,class B> ostream& operator<<(ostream& o,const pair<A,B>& v){
	ret o<<v.x<<' '<<v.y<<endl;
}
template<class A,class B> istream& operator>>(istream& i,pair<A,B>& v){
	ret i>>v.x>>v.y;
}
template<class T> ostream& operator<<(ostream& o,const vector<T>& v){
	for(const auto& x:v){
		o<<x<<' ';
	}
	ret o<<endl;
}
template<class T> istream& operator>>(istream& i,vector<T>& v){
	for(auto& x:v){
		i>>x;
	}
	ret i;
}
template<class A,class B> bool rmax(A& a,const B& b){
	A tmp=b;
	if(a<tmp){
		a=move(tmp);
		ret 1;
	}
	ret 0;
}
template<class A,class B> bool rmin(A& a,const B& b){
	A tmp=b;
	if(tmp<a){
		a=move(tmp);
		ret 1;
	}
	ret 0;
}

int M;
VI cycnum;
int get(int m,VI& g,VI&num){
	if(cycnum[m]!=-2){
		ret cycnum[m];
	}
	VI path;
	MII where;
	VI nums;
	path.pb(m);
	where[m]=0;
	nums.pb(num[m]);
	int last=g[m];
	while(1){
		if(cycnum[last]!=-2){
			for(auto p:path){
				cycnum[p]=cycnum[last];
			}
		}
		if(where.count(last)){
			int w=where[last];
			foriab(i,w,nums.sz()){
				if(nums[i]!=nums.back()){
					for(auto p:path){
						cycnum[p]=-1;
					}
					goto end;
				}
			}
			for(auto p:path){
				cycnum[p]=nums.back();
			}
			goto end;
		}else{
			where[last]=path.sz();
			path.pb(last);
			nums.pb(num[last]);
			last=g[last];
		}
	}
	end:;
	ret cycnum[m];
}
void solve(){
	cycnum.clear();
	int k,n;
	int p;
	cin>>k>>n>>p;
	int N=1LL<<k;
	N=1LL<<N;
	cycnum.resize(N,-2);
	VI g(N);
	VI num(N);
	VI sts;
	fori(i,N){
		if(__builtin_popcountll(i)==n&&i%2){
			sts.pb(i);
		}
	}
	for(auto m:sts){
		VI ones;
		ones.reserve(n);
		int x=0;
		int m2=m;
		while(m2){
			if(m2%2){
				ones.pb(x);
			}
			++x;
			m2/=2;
		}
		//assert(ones.sz()==n);
		int f0=__builtin_ctzll(m+1);
		num[m]=f0;
		for(auto x:ones){
			m2|=(1LL<<(x^(f0-1LL)));
		}
		g[m]=m2;
	}
	int _=0;
	for(auto m:sts){
		_+=(get(m,g,num)==p);
		if(_>=M){
			_-=M;
		}
	}
	/*
	for(auto x:sts){
		VB used(N);
		int y=x;
		int _last=_;
		while(1){
			used[y]=1;
			if(g[y]==y){
				_+=(num[y]==p);
				break;
			}
			y=g[y];
			if(used[y]){
				break;
			}
		}
		int d1=_-_last;
		if(d1!=(get(x,g,num)==p)){
			cycnum.clear();
			cycnum.resize(N,-2);
			cout<<"BEDA"<<get(x,g,num)<<endl;
		}
	}
	*/
	ANS(_%M);
}
signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t=1;
	cin>>M;
	cin>>t;
	while(t--){
		solve();
	}
	ret 0;
}
