#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <random>


#define int long long


using namespace std;

set <pair<int, set <int>>> al6;

set <pair<int, set <int>>> al7;

void gen6 (set <int> &nw, int uk) {
    if (nw.size() == 3) {
        al6.insert({1, nw});
        return;
    }
    for (int i = uk; i <= 6; i++) {
        nw.insert(i);
        gen6(nw, i + 1);
        nw.erase(i);
    }
}


void gen7 (set <int> &nw, int uk) {
    if (nw.size() == 3) {
        al7.insert({4, nw});
        return;
    }
    for (int i = uk; i <= 7; i++) {
        nw.insert(i);
        gen7(nw, i + 1);
        nw.erase(i);
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int f;
    cin >> f;
    set <int> rd;
    gen6(rd, 1);
    rd.clear();
    gen7(rd, 1);
    map<set <int>, set <int>> f6;
    map<set <int>, set <int>> f7;
    set <pair<int, set <int>>> c7 = al7;
    while (al6.size() != 0) {
        pair<int, set<int>> bb = *al6.begin();
        set <int> b = bb.second;
        pair<int, set <int>> nd;
        for (auto nw : al6) {
            int ch = 1;
            for (auto el : nw.second) {
                if (b.find(el) != b.end()) {
                    ch = 0;
                    break;
                }
            }
            if (ch) {
                nd = nw;
                break;
            }
        }
        f6[b] = nd.second;
        f6[nd.second] = b;
        al6.erase(bb);
        al6.erase(nd);
        set <pair<int, set <int>>> nal6;
        for (auto nw : al6) {
            set <int> rn = nw.second;
            int ans = 0;
            for (auto els : al6) {
                int ch = 1;
                for (auto p : els.second) {
                    if (rn.find(p) != rn.end()) {
                        ch = 0;
                        break;
                    }
                }
                ans += ch;
            }
            nal6.insert({ans, rn});
        }
        al6 = nal6;
    }
    while (al7.size() != 0) {
        pair<int, set<int>> bb = *al7.begin();
        set <int> b = bb.second;
        pair<int, set <int>> nd;
        for (auto nw : c7) {
            int ch = 1;
            for (auto el : nw.second) {
                if (b.find(el) != b.end()) {
                    ch = 0;
                    break;
                }
            }
            if (ch) {
                nd = nw;
                break;
            }
        }
        f7[b] = nd.second;
        f7[nd.second] = b;
        al7.erase(bb);
        c7.erase(nd);
        set <pair<int, set <int>>> nal7;
        for (auto nw : al7) {
            set <int> rn = nw.second;
            int ans = 0;
            for (auto els : c7) {
                int ch = 1;
                for (auto p : els.second) {
                    if (rn.find(p) != rn.end()) {
                        ch = 0;
                        break;
                    }
                }
                ans += ch;
            }
            nal7.insert({ans, rn});
        }
        al7 = nal7;
        set <pair<int, set <int>>> nc7;
        for (auto nw : c7) {
            set <int> rn = nw.second;
            int ans = 0;
            for (auto els : al7) {
                int ch = 1;
                for (auto p : els.second) {
                    if (rn.find(p) != rn.end()) {
                        ch = 0;
                        break;
                    }
                }
                ans += ch;
            }
            nc7.insert({ans, rn});
        }
        c7 = nc7;
    }
    if (f == 1) {
        int t;
        cin >> t;
        while (t--) {
            int n, k;
            cin >> n >> k;
            vector<int> num;
            set <int> th;
            set <int> hh;
            hh.insert(2);
            hh.insert(5);
            hh.insert(7);
            for (int i = 0; i < k; i++) {
                int nw;
                cin >> nw;
                num.push_back(nw);
                th.insert(nw);
            }
            if (th == hh) {
                exit(1);
            }
            int sdv = 0;
            if (k < 3) {
                if (k == 2) {
                    if (num[k - 1] - num[0] == 1 or num[k - 1] - num[0] == n - 1) {
                        sdv = 2;
                    } else {
                        sdv = 1;
                    }
                } else if (k == 1) {
                    sdv = 1;
                }
                for (int i = 0; i < k; i++) {
                    num[i] = (num[i] - 1 + sdv) % n + 1;
                }
                sort(num.begin(), num.end());
                for (auto el: num) {
                    cout << el << " ";
                }
                cout << endl;
            }
            else {
                if (n == 6) {
                    for (auto nw : f6[th]) {
                        cout << nw << " ";
                    }
                    cout << endl;
                }
                else {
                    for (auto nw : f7[th]) {
                        cout << nw << " ";
                    }
                    cout << endl;
                }
            }
        }
    }
    else {
        int t;
        cin >> t;
        while (t--) {
            int n, k;
            cin >> n >> k;
            vector<int> num;
            set <int> th;
            for (int i = 0; i < k; i++) {
                int nw;
                cin >> nw;
                num.push_back(nw);
                th.insert(nw);
            }
            int sdv = 0;
            if (k < 3) {
                if (k == 2) {
                    if (num[k - 1] - num[0] == 1 or num[k - 1] - num[0] == n - 1) {
                        sdv = 2;
                    } else {
                        sdv = 1;
                    }
                } else if (k == 1) {
                    sdv = 1;
                }
                for (int i = 0; i < k; i++) {
                    num[i] = (num[i] - 1 - sdv + n) % n + 1;
                }
                sort(num.begin(), num.end());
                for (auto el: num) {
                    cout << el << " ";
                }
                cout << endl;
            }
            else {
                if (n == 6) {
                    for (auto nw : f6[th]) {
                        cout << nw << " ";
                    }
                    cout << endl;
                }
                else {
                    for (auto nw : f7[th]) {
                        cout << nw << " ";
                    }
                    cout << endl;
                }
            }
        }
    }
}