#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>


#define int long long


using namespace std;


const int mn = 2e5;
int mi[mn];
int sz[mn];
int k;

void dfs (int v, vector <vector <int>> &gr, int lst, int pov) {
    if (gr[v].size() != 0) {
        if (lst == 0) {
            mi[gr[v][0]] = pov;
            mi[gr[v][1]] = pov + 1;
            dfs(gr[v][0], gr, lst, pov);
            dfs(gr[v][1], gr, 1, pov + 1);
            sz[v] += sz[gr[v][0]];
            sz[v] += sz[gr[v][1]];
        }
        else {
            mi[gr[v][0]] = pov + 1;
            mi[gr[v][1]] = pov;
            dfs(gr[v][0], gr, 0, pov + 1);
            dfs(gr[v][1], gr, 1, pov);
            sz[v] += sz[gr[v][0]];
            sz[v] += sz[gr[v][1]];
        }
    }
    else {
        if (mi[v] <= k) {
            sz[v]++;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, q;
    cin >> n >> k >> q;
    vector <vector <int>> gr(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t != 0) {
            int l, r;
            cin >> l >> r;
            l--;
            r--;
            gr[i] = {l, r};
        }
    }
    mi[0] = 0;
    mi[gr[0][0]] = 0;
    mi[gr[0][1]] = 0;
    dfs(gr[0][0], gr, 0, 0);
    dfs(gr[0][1], gr, 1, 0);
    sz[0] = sz[gr[0][0]] + sz[gr[0][1]];
    for (int tt = 0; tt < q; tt++) {
        int u;
        cin >> u;
        u--;
        cout << sz[u] << "\n";
    }
}
