#include <bits/stdc++.h>
#define int long long
#define ll long long
#define x first
#define y second
#define pii pair <int, int>
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
using namespace std;

vector <vector <int> > v, dp;
vector <int> used, cost;


void dfs(int h) {
    used[h] = 1;
    dp[h][1] = cost[h];
    for (auto c : v[h]) {
        if (!used[c]) {
            dfs(c);
            dp[h][0] += max(dp[c][0], dp[c][1]);
            dp[h][1] += dp[c][0];
        }
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    v.resize(n); dp.resize(n, vector <int> (2)); cost.resize(n); used.resize(n);
    int x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b; a--; b--;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    for (int i = 0; i < n; i++) {
        cin >> cost[i] >> cost[i];
    }
    dfs(0);
    vector <int> ans(q);
    int c = 0;
    int k = 0;
    for (int i = 0; i < n; i++) {
        k ^= (x * (i + 1) + y * cost[i] * cost[i]) % m;
    }
//    cout << max(dp[0][0], dp[0][1]) << endl;
    while (q--) {
        int xx;
        cin >> xx;
        if (max(dp[0][0], dp[0][1]) == xx) {
            cout << k << endl;
            ans[c] = k;
        } else {
            cout << -1 << endl;
            ans[c] = -1;
        }
        c++;
    }
    int pos;
    while (true) {
        cin >> pos;
        if (!pos) break;
        pos--;
        if (ans[pos] == -1) {
            cout << -1 << endl;
        } else {
            for (int i = 0; i < n; i++) {
                cout << cost[i] << " ";
            }
            cout << endl;
        }
    }


    v.clear(); dp.clear(); cost.clear(); used.clear();
}

signed main() {
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }

}