#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

struct event {
    int i, l, r;
};

int count_ans(vector<event>& e) {
    int n = e.size();
    vector<int> dp(n);
    dp[0] = 1;
    int ans = 1;
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < i; j++) {
            if (e[j].r < e[i].l) {
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
        ans = max(ans, dp[i]);
    }

    return ans;
}

int n, m;
vector<event> ev;
vector<event> cur;
bool f;
void rec(int i = 1) {
    if (f) return;
    if (i == n + 1) {
        if (count_ans(cur) == m / 2) {
            for (int i = 0; i < n / 2; i++) cout << cur[i].i + 1 << ' '; cout << '\n';
            f = true;
            return;
        }
    }

    if (cur.size() + (n - i) >= n / 2) {
        rec(i + 1);
    }

    if (cur.size() < n / 2) {
        cur.push_back(ev[i - 1]);
        rec(i + 1);
        cur.pop_back();
    }
}

void solve() {
    f = false;
    cur.clear();

    cin >> n;
    ev.resize(n);
    for (int i = 0; i < n; i++) cin >> ev[i].l >> ev[i].r, ev[i].i = i;
    sort(all(ev), [&](event a, event b) {return a.r < b.r;});
    m = count_ans(ev);
    rec();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    for (int testCase = 0; testCase < t; testCase++) {
        solve();
    }

    return 0;
}