#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

typedef long long ll;
#define ve vector
#define reader(tp) [](){ tp x; cin >> x; return x; }
#define all(x) x.begin(), x.end()

void solve();

int main() {
    ll t;
    cin >> t;
    while(t--)
    {
        solve();
    }
}

void solve()
{
    ll n;
    cin >> n;
    ve<ll> a(n);
    generate(all(a), reader(ll));
    ve<pair<ll, ll>> dp(n + 1, {1e15, 1e9});
    dp[0] = {0, -1};
    ll mx = 0;
    for (ll i = 0; i < n; ++i) {
        ll x = lower_bound(all(dp), pair<ll, ll>{a[i], -1}) - dp.begin();
        dp[x] = {a[i], i};
        mx = max(mx, x);
    }
    cout << mx + 2 << endl;
}