#include <iostream>
#include <ostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
#define int long long
void speed(){
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
vector<int> v;
int mx_ans = 0;

void main0(){
    v.clear(); mx_ans = 0;
    int n; cin >> n;
    v.resize(n); for (int i = 1; i <= n; i++) cin >> v[i - 1];
    vector<vector<vector<int>>> dp(n, vector<vector<int>> (n+1, vector<int>(n+1)));
    dp[0][v[0]][v[0]] = 1;
    vector<int> q_(n), mqs(n), r_(n), mrs(n); q_[0] = r_[0] = 1;


    int mq = 0, mr = 0; for (int i = 1; i < n; i++) {
        q_[i] = q_[mq]; r_[i] = r_[mr];
        if (v[i] > v[mr]) { mr = i;r_[i]++; }
        if (v[i] < v[mq]) {mq = i;q_[i]++;}
        mrs[i] = mr; mqs[i] = mq;
    }

    //for (int i : q_) cout << i << ' '; cout << '\n';
    //for (int i : r_) cout << i << ' '; cout << '\n';

    for (int i = 1; i < n; i++){
        dp[i][v[mqs[i - 1]]][v[i]] = 1 + q_[i - 1];
        dp[i][v[i]][v[mrs[i - 1]]] = 1 + r_[i - 1];
        for (int l_q = 1; l_q <= n; l_q++){ // q - min
            for (int l_r = 1; l_r <= n; l_r++){ // r - max
                //min(q) = l_q, max(r) = l_r
                dp[i][l_q][l_r] = max(dp[i][l_q][l_r], dp[i - 1][l_q][l_r]);
                if (v[i] > l_r) dp[i][l_q][v[i]] = max(dp[i][l_q][v[i]], 1 + dp[i-1][l_q][l_r]);
                if (v[i] < l_q) dp[i][v[i]][l_r] = max(dp[i][v[i]][l_r], 1 + dp[i-1][l_q][l_r]);
            }
        }
    }
    mx_ans = 0;
    for (int i = 0; i <= n; i++){
        for (int j = 0; j <= n; j++)
            //cout << dp[n-1][i][j] << ' '; cout << '\n';
            mx_ans = max(mx_ans, dp[n-1][i][j]);
    }
    cout << mx_ans;
}

signed main() {
    speed();
    int t = 1; cin >> t;
    while (t--){
        main0();
        cout << '\n';
    }
}