#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Node {
    int x, num, type;
};

bool cmp(Node a, Node b) {
    if (a.x == b.x)
        return a.type < b.type;
    return a.x < b.x;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector <int> l(n), r(n), ans;
        vector <Node> a;
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
            a.push_back(Node{l[i], i, 1});
            a.push_back(Node{r[i], i, -1});
        }
        sort(a.begin(), a.end(), cmp);
        int last = -1;
        for (auto [x, num, type] : a) {
            if (type == -1 && l[num] == last) {
                ans.push_back(num);
            } else if (type == 1) {
                last = x;
            }
        }
        vector <bool> used(n, false);
        int cnt = 0;
        for (int i = 0; i < ans.size(); ++i) {
            if (i < ans.size() / 2) {
                cout << ans[i] + 1 << " ";
                ++cnt;
            }
            used[ans[i]] = true;
        }
        for (int i = 0; i < n; ++i) {
            if (cnt == n / 2)
                break;
            if (!used[i]) {
                cout << i + 1 << " ";
                used[i] = true;
                ++cnt;
            }
        }
        cout << '\n';
    }
    return 0;
}
