#include<bits/stdc++.h>

#define int long long
#define vec vector
#define f first
#define s second
#define pii pair<int, int>
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define pb push_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x).size()

using namespace std;

const int N = 310;
int dp[N][N + 1][N + 1];
int pref[N][N + 2][N + 2];

void solve()
{
    int n, q;
    cin >> n >> q;

    vec<int> w (n);
    for(auto &i : w)
        cin >> i;
    sort(all(w));
    int z;
    cin >> z; /// ZOV
    assert(z == 0);

    dp[0][0][0] = 1;

    FOR(i, n)
    {
        FOR(x, N + 1)
        {
            FOR(y, N + 1)
            {
                int nx = min(N, x + w[i]);
                int ny = min(N, y + w[i]);
                dp[i + 1][x][y] = max(dp[i + 1][x][y], dp[i][x][y]);
                dp[i + 1][nx][y] = max(dp[i + 1][nx][y], dp[i][x][y]);
                dp[i + 1][x][ny] = max(dp[i + 1][x][ny], dp[i][x][y]);
            }
        }
    }

    FOR(i, n + 1)
    {
        FOR(x, N + 1)
        {
            FOR(y, N + 1)
            {
                pref[i][x + 1][y + 1] = pref[i][x][y + 1] + pref[i][x + 1][y] - pref[i][x][y] + dp[i][x][y];
            }
        }
    }
//
//    FOR(i, 10)
//        FOR(j, 10)
//            cout << dp[n][i][j] << " \n"[j == 9];
//
//    FOR(i, 10)
//        FOR(j, 10)
//            cout << pref[n][i][j] << " \n"[j == 9];

    auto get = [&](int pos, int a, int b)
    {
        int cnt = pref[pos][a + 1][b + 1];
        if(cnt == (a + 1) * (b + 1))
            return 1;
        return 0;
    };

    while(q--)
    {
        int k, a, b;
        cin >> k >> a >> b;
        int pos = n;
        FOR(i, n)
            if(w[i] > k)
            {
                pos = i;
                break;
            }

        if(get(pos, a, b))
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }
}

/**

5 3
1 2 3 4 5
0
1000 2 3
1000 1 2
1000 0 1

*/


signed main()
{
    int t = 1;
    //cin >> t;
    while(t--)
    {
        solve();
    }
}
