#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define sz(x) (int)(x.size())
#define int long long
const int MX = 3e5 + 10;
const int INF = 2e9;
const int MOD = 1e9 + 7;

int n, h, w;
pair<int, int> p[MX];

int f(int x, int y, int o1, int o2) {
    return min(h - 1 - x, x + 1) * o1 + min(w - 1 - y, y + 1) * o2;
}

void solve() {
    cin >> h >> w;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> p[i].fi >> p[i].se;
        p[i].fi--, p[i].se--;
    }
    multiset<int> x, y;
    for (int i = 0; i < n; i++) {
        x.insert(p[i].fi);
        y.insert(p[i].se);
    }
    int res = h * w;
    int min_dist = 0;
    for (int i = 0; i < n; i++) {
        int X = p[i].fi, Y = p[i].se;
        auto it1 = x.upper_bound(X);
        auto it2 = y.upper_bound(Y);
        int ok1 = 0, ok2 = 0;
        int H = -1, W = -1;
        if (it1 != x.end()) {
            ok1 = 1;
            H = h - (*it1 - X - 1);
        } else {
            it1 = x.begin();
            H = (X - *it1 + 1);
        }
        if (it2 != y.end()) {
            ok2 = 1;
            W = w - (*it2 - Y - 1);
        } else {
            it2 = y.begin();
            W = (Y - *it2 + 1);
        }
        int d = f(X, Y, ok1, ok2);

        //cout << f(X, Y, ok1, ok2) << " " << H << " " << W << '\n';
        if (H * W < res) {
            res = H * W;
            min_dist = d;
        } else if (H * W == res) {
            min_dist = min(min_dist, d);
        }
    }
    cout << res << " " << min_dist << '\n';
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie(0);
#endif

    int T = 1;
    // cin >> T;
    while (T--) solve();
    return 0;
}