#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using ll = long long;
using pl = pair<ll, ll>;
using vi = vector<int>;

const int maxN = 2e5, maxQ = 2e5;

int test, n, q, s, f, l[maxN], r[maxN], i;
ll x, y, mod, u[maxQ];
pl dp[maxN][2];
vi gr[maxN];

ll add(ll a, ll b) {
    return a + b < mod ? a + b : a + b - mod;
}

ll mul(ll a, ll b) {
    return a * b % mod;
}

void dfs(int u, int p) {
    dp[u][0] = make_pair(0, 0);
    dp[u][1] = make_pair(l[u], r[u]);
    for (int v : gr[u]) {
        if (v == p)
            continue;
        dfs(v, u);
        dp[u][0].first += dp[v][1].first;
        dp[u][0].second += dp[v][1].second;
        dp[u][1].first += dp[v][0].first;
        dp[u][1].second += dp[v][0].second;
    }
    dp[u][1].first = max(dp[u][1].first, dp[u][0].first);
    dp[u][1].second = max(dp[u][1].second, dp[u][0].second);
}

void solve() {
    for (int i = 0; i < n; i++)
        gr[i].clear();
    cin >> n >> q >> x >> y >> mod;
    for (int i = 1; i < n; i++) {
        cin >> s >> f;
        s--, f--;
        gr[s].push_back(f);
        gr[f].push_back(s);
    }
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];
    dfs(0, -1);
    for (int i = 0; i < q; i++)
        cin >> u[i];
    for (int i = 0; i < q; i++) {
        if (dp[0][1].first <= u[i] && u[i] <= dp[0][1].second)
            cout << "0 ";
        else
            cout << "-1 ";
    }
    cout << endl;
    cin >> i;
    while (i != 0)
        cin >> i;
}

int main() {
    cin >> test;
    while (test--)
        solve();
    return 0;
}
