#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;
#define int long long
int n, m, k;

const int N = 3e5 + 7;

bool used[N], answ[N];

void solve1() {
	cin >> n >> k;
	vector<int> p;
	for (int i = 0; i < k; i++) {
		int x;
		cin >> x;
		p.push_back((x % n) + 1);
	}
	sort(p.begin(), p.end());
	for (auto u : p) {
		cout << u << " ";
	}
	cout << "\n";
	cout.flush();
}

void solve2() {
	cin >> n >> k;
	vector<int> p;
	p.clear();
	for (int i = 0; i < k; i++) {
		int x;
		cin >> x;
		used[x] = 1;
		if (x == 1) {
			p.push_back(n);
		}
		else
			p.push_back(x - 1);
	}
	sort(p.begin(), p.end());
	for (auto u : p) {
		cout << u << " ";
	}
	cout << "\n";
	cout.flush();
}


signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	if (t == 1) {
		cin >> t;
		while (t--) {
			solve1();
		}
	}
	else {
		cin >> t;
		while (t--) {
			solve2();
		}
	}
}