#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

const int N = 5e5 + 7;

struct Event {
	int l, r, ind;
};

vector<Event> events;

vector<int> sorted;

int dp[N], n;

vector<int> opt[N];
vector<Event> st[N];

map<int,int> pos;

bool del[N];

void solve() {
	cin >> n;
	sorted.clear();
	pos.clear();
	events.clear();
	for (int i = 0; i <= n * 4 + 5; i++) {
		opt[i].clear();
		st[i].clear();
		dp[i] = 0;
		del[i] = 0;
	}
	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> l >> r;
		sorted.push_back(l);
		sorted.push_back(l-1);
		sorted.push_back(r);
		events.push_back({ l,r,i });
	}
	sorted.push_back(0);
	sort(sorted.begin(), sorted.end());
	sorted.resize(unique(sorted.begin(), sorted.end()) - sorted.begin());
	for (int i = 0; i < sorted.size(); i++) {
		pos[sorted[i]] = i;
	}
	for (auto u : events) {
		st[pos[u.l]].push_back(u);
	}
	for (int i = 0; i < sorted.size() - 1; i++) {
		dp[i + 1] = max(dp[i + 1], dp[i]);
		for (auto u : st[i + 1]) {
			int j = pos[u.r];
			dp[j] = max(dp[j], dp[i] + 1);
		}
	}
	int m = dp[sorted.size() - 1];
	if (m % 2 != 0) {
		int h = 0;
		cout << 1 / h;
	}
	for (int i = 0; i < sorted.size(); i++) {
		for (auto u : st[i + 1]) {
			int j = pos[u.r];
			opt[dp[i] + 1].push_back(u.ind);
		}
	}
	int cnt = 0;
	for (int i = 1; i <= m / 2; i++) {
		cnt += opt[i].size();
	}
	if (cnt <= n / 2) {
		cnt = 0;
		for (int i = 1; i <= m / 2; i++) {
			for (auto u : opt[i]) {
				del[u] = 1;
				cnt++;
			}
		}
		int j = m / 2 + 1;
		while (cnt < n/2) {
			if (opt[j].size() > 1) {
				del[opt[j][opt[j].size() - 1]] = 1;
				cnt++;
				opt[j].pop_back();
			}
			else {
				j++;
			}
		}
	}
	else {
		cnt = 0;
		for (int i = m/2+1; i <= m; i++) {
			for (auto u : opt[i]) {
				del[u] = 1;
				cnt++;
			}
		}
		int j = 1;
		while (cnt < n / 2) {
			if (opt[j].size() > 1) {
				del[opt[j][opt[j].size() - 1]] = 1;
				cnt++;
				opt[j].pop_back();
			}
			else {
				j++;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (!del[i]) {
			cout << i + 1 << " ";
		}
	}
	cout << "\n";
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
