#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <iostream>
typedef long long ll;
typedef long double ld;
using namespace std;
int ok = 0;
void solve() {
	ll n;
	cin >> n;
	vector<ll> p(n);
	for (int i = 0; i < n; ++i) cin >> p[i];
	if (n <= 16 && ok) {
		ll mx = 0;
		for (ll mask = 0; mask < (1LL << n); ++mask) {
			ll last = -1;
			ll last2 = n + 1;
			ll ans = 0;
			for (int i = 0; i < n; ++i) {
				if (mask & (1LL << i)) {
					if (last < p[i]) {
						++ans;
						last = p[i];
					}
				}
				else {
					if (last2 > p[i]) {
						++ans;
						last2 = p[i];
					}
				}
			}
			mx = max(mx, ans);
		}
		cout << mx << '\n';
	}
	else {
		ll inf = 1e15;
		vector<vector<ll>> dp(n + 1, vector<ll>(2, 0));
		for (int i = 0; i < n; ++i) {
			dp[p[i]][0] = max(dp[p[i]][0], 1LL);
			dp[p[i]][1] = max(dp[p[i]][1], 1LL);
			for (int j = 1; j <= n; ++j) {
				if (!dp[j][0] || j == p[i]) continue;
				if (j > p[i]) {
					dp[p[i]][0] = max(dp[p[i]][0], dp[j][0] + 1);
				}else{
					dp[p[i]][1] = max(dp[p[i]][1], dp[j][1] + 1);
				}
			}
		}
		cout << max(dp[p[n - 1]][0], dp[p[n - 1]][1]) << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	ll tc;
	cin >> tc;
	if (tc <= 120) ok = 1;
	while (tc--) {
		solve();
	}
}