#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <iostream>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;



int main() {
	ios::sync_with_stdio(0); cout.tie(0); cin.tie(0);
	ll n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i) cin >> w[i];
	map<pair<ll, ll>, ll> h;
	if (n <= 10 && q <= 10) {
		set<ll> s;
		for (ll mask = 0; mask < (1LL << n); ++mask) {
			for (ll mask2 = 0; mask2 < (1LL << n); ++mask2) {
				if (mask & mask2) continue;
				ll count = 0;
				ll count2 = 0;
				ll mx = 0;
				for (int i = 0; i < n; ++i) {
					if (mask & (1LL << i)) {
						count += w[i];
						mx = max(mx, w[i]);
					}
					if (mask2 & (1LL << i)) {
						count2 += w[i];
						mx = max(mx, w[i]);
					}
				}
				s.insert(count);
				s.insert(count2);
				if (h[{count, count2}]) {
					h[{count, count2}] = min(h[{count, count2}], mx);
				}
				else {
					h[{count, count2}] = mx;
				}
			}
		}
		ll z; cin >> z;
		for (int i = 0; i < q; ++i) {
			ll k, a, b;
			cin >> k >> a >> b;
			if (a > (ll)s.size() || b > (ll)s.size()) {
				cout << "No\n";
			}
			else {
				int ok = 1;
				for (int j = 0; j <= a; ++j) {
					for (int c = 0; c <= b; ++c) {
						if (!j && !c) continue;
						if ((!h[{j, c}] || h[{j, c}] > k) && (!h[{c, j}] || h[{c, j}] > k)) {
							cout << "No\n";
								ok = 0;
								break;
						}
					}
					if (!ok) break;
				}
				if (ok) cout << "Yes\n";
			}
		}
	}
};
