#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9;

inline void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;
    vector<int> s(n, -1);
    stack<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.top()] > a[i]) {
            s[st.top()] = i;
            st.pop();
        }
        st.push(i);
    }
    int ci = count_if(s.begin(), s.end(), [](int a){return a != -1;});
    int ans = n - ci;
    if (ci != 0)
        ans++;
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    cin >> tests;
    for (int t = 1; t <= tests; ++t)
        solve();
    return 0;
}
