#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl;
#else
#define nl endl;
//#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define _ <<" "<<

#define int ll

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void encode() {
    int n, k;
    cin >> n >> k;
    vector<int> s(k);
    forn(i, k) cin >> s[i];
    if (k == 1) {
        int x = s[0];
        cout << x % n + 1 << nl;
        return;
    }
    if (2 * k == n) {
        set<int> st;
        forn(i, n) st.emplace(i);
        forn(i, k) st.extract(s[i] - 1);
        for (int i: st) cout << i + 1 << " ";
        cout << nl;
        return;
    }
    if (s[k - 1] - s[0] <= n / 2.0 - 1) {
        int d = s[k - 1] - s[0];
        vector<int> res;
        forn(i, k) res.emplace_back((s[i] + d + 1) % n);
        sort(all(res));
        forn(i, k) cout << res[i] + 1 << " ";
        cout << nl;
        return;
    }
    bool ok = true;
    forn(i, k - 1) if (s[i + 1] - s[i] == 1) ok = false;
    if (ok) {
        forn(i, k) cout << (((s[i] - 1) ^ 1) + 1) << " ";
        cout << nl;
        return;
    }
    vector<int> res;
    forn(i, k) res.emplace_back(n - s[i] + 1);
    sort(all(res));
    forn(i, k) cout << res[i] << " ";
    cout << nl;
}

void decode() {
    int n, k;
    cin >> n >> k;
    vector<int> s(k);
    forn(i, k) cin >> s[i];
    if (k == 1) {
        int x = s[0];
        cout << (x - 2 + n) % n + 1 << nl;
        return;
    }
    if (2 * k == n) {
        set<int> st;
        forn(i, n) st.emplace(i);
        forn(i, k) st.extract(s[i] - 1);
        for (int i: st) cout << i + 1 << " ";
        cout << nl;
        return;
    }
    if (s[k - 1] - s[0] <= n / 2.0 - 1) {
        int d = s[k - 1] - s[0];
        vector<int> res;
        forn(i, k) res.emplace_back((s[i] - 1 - d - 1 + 2 * n) % n);
        sort(all(res));
        forn(i, k) cout << res[i] + 1 << " ";
        cout << nl;
        return;
    }
    bool ok = true;
    forn(i, k - 1) if (s[i + 1] - s[i] == 1) ok = false;
    if (ok) {
        forn(i, k) cout << (((s[i] - 1) ^ 1) + 1) << " ";
        cout << nl;
        return;
    }
    vector<int> res;
    forn(i, k) res.emplace_back(n - s[i] + 1);
    sort(all(res));
    forn(i, k) cout << res[i] << " ";
    cout << nl;
}

signed main() {
    int t;
    cin >> t;

    int tt = 1;
    cin >> tt;
    while (tt--) t - 1 ? decode() : encode();
}