#include <bits/stdc++.h>

using namespace std;

#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#else
#define dbg(x) 
#endif

using ll = long long;
using ld = long double;

template <class A>
bool umin(A& x, const A& y) {
    if (x <= y) return false;
    x = y;
    return true;
}

template <class A>
bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}

// #define int ll
#define sz(x) int((x).size())

void solve() {
    int n;
    cin >> n;

    vector<int> p(n);
    for (int& x : p) {
        cin >> x;
    }

    vector dp(n + 2, vector<int>(n + 2, -1));
    vector ndp(n + 2, vector<int>(n + 2, -1));

    dp[0][n + 1] = 0;
    
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= n + 1; ++j) {
            for (int k = 0; k <= n + 1; ++k) {
                if (dp[j][k] == -1) continue;
                umax(ndp[max(j, p[i])][k], dp[j][k] + (p[i] > j));
                umax(ndp[j][min(k, p[i])], dp[j][k] + (p[i] < k));
            }
        }
        swap(dp, ndp);
        ndp.assign(n + 2, vector<int>(n + 2, -1));
    }

    int ans = 0;
    for (int i = 0; i <= n + 1; ++i) {
        for (int j = 0; j <= n + 1; ++j) {
            umax(ans, dp[i][j]);
        }
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    cin >> T;

    for (int t = 1; t <= T; ++t) {
        solve();    
    }
}