#include <bits/stdc++.h>

#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#define showTest(x) cout << "_____TEST #" << x << "_____\n";
#else
#define dbg(x)
#define showTest(x)
#endif

using namespace std;

using ll = long long;
using ld = long double;

template <class A> 
inline bool umin(A& x, const A&y) {
    if (x <= y) return false;
    x = y;
    return true;
}

template <class A>
inline bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}

// #define int ll
#define sz(x) int((x).size())

int calc(vector<pair<int, int>> e) {
    int n = sz(e);
    
    vector<pair<int, int>> ev;
    for (int i = 0; i < n; ++i) {
        ev.emplace_back(e[i].first, -i);
        ev.emplace_back(e[i].second, i);
    }

    sort(ev.begin(), ev.end());

    vector<int> dp(n);
    int best = 0;

    for (auto [x, ind] : ev) {
        if (ind > 0) {
            ++dp[ind];
            umax(best, dp[ind]);
        } else {
            dp[-ind] = best;
        }
    }

    return best;
}

void solve() {
    int n;
    cin >> n;

    vector<pair<int, int>> e(n);
    for (auto& [l, r] : e) {
        cin >> l >> r;
    }

    int kok = calc(e);

    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> ind;
        vector<pair<int, int>> et;
        for (int i = 0; i < n; ++i) {
            if (mask >> i & 1) {
                ind.push_back(i);
                et.push_back(e[i]);
            }
        }
        if (calc(et) * 2 == kok && sz(ind) * 2 == n) {
            for (int x : ind) cout << x + 1 << ' ';
            cout << '\n';
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    cin >> T;

    for (int t = 1; t <= T; ++t) {
        showTest(t);
        solve();
    }
}