#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <climits>
#include <deque>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <iomanip>
#include <stdio.h>

using namespace std;

#define int long long
#define endl '\n'

struct Seg
{
	int l, r, num;
	bool operator<(Seg s) const
	{
		return l < s.l || (l == s.l && r > s.r);
	}
};

/*vector<pair<int, int>> tree;

void update(int v, int l, int r, int pos, pair<int, int> p)
{
	if (r <= pos || l > pos) return;
	else if (r - l == 1)
	{
		tree[v] = p;
	}
	else
	{
		int m = (r + l) / 2;
		update(v * 2, l, m, pos, p);
		update(v * 2 + 1, m, r, pos, p);

		pair<int, int> ll = tree[v * 2];
		pair<int, int> rr = tree[v * 2 + 1];
		if (ll
	}
}*/

void task()
{
	int n;
	cin >> n;
	vector<Seg> v(n);

	for (int i = 0; i < n; i++)
	{
		cin >> v[i].l >> v[i].r;
		v[i].num = i;
	}

	sort(v.begin(), v.end());

	vector<int> dp(n, 0);
	vector<int> prev(n, -1);
	vector<int> pref(n, LONG_MAX);
	vector<pair<int, int>> d;
	for (int i = 0; i < n; i++)
	{
		if (d.size() == 0 || d[0].first >= v[i].l)
		{
			dp[i] = 1;
			prev[i] = -1;
		}
		else
		{
			int l = 0;
			int r = d.size();
			while (r - l > 1)
			{
				int m = (r + l) / 2;
				if (d[m].first < v[i].l) l = m;
				else r = m;
			}
			dp[i] = dp[d[l].second] + 1;
			prev[i] = d[l].second;
		}

		while (d.size() > 0 && d[d.size() - 1].first >= v[i].r) d.pop_back();
		d.push_back({ v[i].r,i });

		/*int maxx = 0;
		int p = -1;
		for (int j = i - 1; j >= 0; j--)
		{
			if (v[j].r < v[i].l)
			{
				maxx = dp[j];
				p = j;
				break;
			}
		}

		dp[i] = maxx + 1;
		prev[i] = p;*/
	}

	int num = 0;
	for (int i = 1; i < n; i++)
	{
		if (dp[i] > dp[num]) num = i;
	}

	vector<int> b;
	while (num != -1)
	{
		b.push_back(num);
		num = prev[num];
	}
	reverse(b.begin(), b.end());

	vector<int> ans;
	set<int> s;

	for (int i = n - 1; i >= 0; i--)
	{
		if (dp[i] == b.size() / 2)
		{
			if (i + 1 <= n / 2)
			{
				int num = n - 1;
				for (int j = 0; j < b.size() / 2; j++)
				{
					ans.push_back(v[num].num + 1);
					s.insert(v[num].num + 1);
					num = prev[num];
				}
				for (int j = i + 1; j < n; j++)
				{
					if (ans.size() < n / 2 && s.find(v[j].num + 1) == s.end())
					{
						ans.push_back(v[j].num + 1);
					}
				}

				for (int j = 0; j < ans.size(); j++)
				{
					cout << ans[j] << ' ';
				}
				cout << endl;
				return;
			}
			else
			{
				int num = i;
				for (int j = 0; j < b.size() / 2; j++)
				{
					ans.push_back(v[num].num + 1);
					s.insert(num);
					num = prev[num];
				}
				for (int j = 0; j < i + 1; j++)
				{
					if (ans.size() < n / 2 && s.find(j) == s.end())
					{
						ans.push_back(v[j].num + 1);
					}
				}

				for (int j = 0; j < ans.size(); j++)
				{
					cout << ans[j] << ' ';
				}
				cout << endl;
				return;
			}
		}
	}

	/*vector<int> in(n, 0);
	for (int i = 0; i < b.size(); i++)
	{
		in[b[i]] = 1;
	}

	vector<int> ans;
	int cnt1 = b.size() / 2;
	int cnt0 = (n - b.size()) / 2;

	for (int i = n - 1; i >= 0; i--)
	{
		if (in[i])
		{
			if (cnt1 > 0)
			{
				cnt1--;
			}
			else
			{
				ans.push_back(v[i].num + 1);
			}
		}
		else
		{
			if (cnt0 > 0)
			{
				cnt0--;
			}
			else
			{
				ans.push_back(v[i].num + 1);
			}
		}
	}

	sort(ans.begin(), ans.end());

	for (int i = 0; i < ans.size(); i++)
	{
		cout << ans[i] << ' ';
	}
	cout << endl;*/
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	bool multitest = 1;
	int t = 1;
	if (multitest) cin >> t;
	while (t--) task();

	return 0;
}
