#include <bits/stdc++.h>

#define vc vector
#define pii pair <int, int>
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define fi first
#define se second

using namespace std;

const int N = 501;

mt19937 rnd(chrono::high_resolution_clock().now().time_since_epoch().count());

void solve () {
    int n;
    cin >> n;
    vc <pii> a(n);
    vc <int> p(n);
    iota(all(p), 0);
    vc <int> c;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].fi >> a[i].se;
        c.pb(a[i].fi);
        c.pb(a[i].se);
    }
    sort(all(c));
    c.resize(unique(all(c)) - c.begin());
    for (int i = 0; i < n; ++i) {
        a[i].fi = lower_bound(all(c), a[i].fi) - c.begin();
        a[i].se = lower_bound(all(c), a[i].se) - c.begin();
    }
    auto cmp = [&](int i, int j){
        if (a[i].se == a[j].se)
            return a[i].fi > a[j].fi;
        return a[i].se < a[j].se;
    };
    sort(all(p), cmp);
    int was = -1;
    vc <int> mx;
    vc <int> not_mx;
    for (int i : p) {
        if (a[i].fi > was) {
            mx.pb(i);
            was = a[i].se;
        } else {
            not_mx.pb(i);
        }
    }
    auto check = [&](vc <int> &in){
        int cnt = 0;
        vc <int> pr(sz(c) + 1);
        vc <int> q(sz(c) + 1);
        for (int j : in) {
            auto [l, r] = a[j];
            pr[l]++;
            pr[r + 1]--;
            ++cnt;
        }
        for (int i = 1; i <= sz(c); ++i) {
            pr[i] += pr[i - 1];
        }
        for (int i = 0; i < sz(c); ++i)
            q[i + 1] = q[i] + pr[i];
        vc <int> in2;
        for (int i : not_mx) {
            if (cnt == n / 2)
                break;
            auto [l, r] = a[i];
            if (q[r + 1] - q[l] > 0) {
                in2.pb(i);
                ++cnt;
            }
        }
        vc <int> tmp;
        merge(all(in), all(in2), back_inserter(tmp), cmp);
        if (cnt == n / 2) {
            int was = -1;
            sort(all(tmp), cmp);
            int real = 0;
            for (int i : tmp) {
                if (a[i].fi > was) {
                    ++real;
                    was = a[i].se;
                }
            }
            if (real * 2 == sz(mx)) {
                for (int i: tmp) {
                    cout << i + 1 << ' ';
                }
                cout << '\n';
                return true;
            }
        }
        return false;
    };
    vc <int> in;
    for (int i = 1; i < sz(mx); i += 2) {
        in.pb(mx[i]);
    }
    if (check(in))
        return;
    in.clear();
    for (int i = 0; i < sz(mx); i += 2) {
        in.pb(mx[i]);
    }
    if (check(in))
        return;
    in.clear();
    for (int i = 0; i < sz(mx); i += 2) {
        if ((i / 2) % 2 == 0) {
            in.pb(mx[i]);
        } else {
            in.pb(mx[i + 1]);
        }
    }
    if (check(in))
        return;
    in.clear();
    for (int i = 0; i < sz(mx); i += 2) {
        if ((i / 2) % 2 == 0) {
            in.pb(mx[i + 1]);
        } else {
            in.pb(mx[i]);
        }
    }
    if (check(in))
        return;
    int it = 0;
    while (clock() * 1.0 / CLOCKS_PER_SEC <= 0.99) {
        in.clear();
        shuffle(all(mx), rnd);
        ++it;
        for (int i = 0; i < sz(mx) / 2; ++i)
            in.pb(mx[i]);
        if (check(in))
            return;
    }
    exit(1);
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
