#include <bits/stdc++.h>

#define vc vector
#define pii pair <int, int>
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define int long long

using namespace std;

const int N = 2e5 + 1;

template <class T>
bool chmax (T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

void solve () {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    vc <vc <int>> g(n);
    vc <int> l(n), r(n);
    vc <vc <int>> dp(n, vc <int> (2));
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v; --u; --v;
        g[u].pb(v);
        g[v].pb(u);
    }
    int score = 0;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        score ^= ((i + 1) * x % m + l[i] * l[i] % m * y % m) % m;
    }
    function <void(int, int)> dfs = [&](int u, int p) {
        dp[u][1] = l[u];
        for (int v : g[u]) {
            if (v != p) {
                dfs(v, u);
                dp[u][0] += max(dp[v][0], dp[v][1]);
                dp[u][1] += dp[v][0];
            }
        }
    };
    dfs(0, -1);
    int mx = max(dp[0][0], dp[0][1]);
    vc <bool> ok(q);
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        if (v == mx) {
            cout << score << endl;
            ok[i] = true;
        } else {
            cout << -1 << endl;
            ok[i] = false;
        }
    }
    while (1) {
        int i;
        cin >> i; --i;
        if (i == -1)
            break;
        if (ok[i]) {
            for (int j = 0; j < n; ++j) {
                cout << l[j] << ' ';
            }
        } else {
            cout << "-1";
        }
        cout << endl;
    }
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
