#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
#define all(x) x.begin(), x.end()
using namespace std;

void solve() {
    int n, m; cin >> n >> m;
}

void encode() {
    int n, k; cin >> n >> k;
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    for (int e : a) {
        cout << (e % n) + 1 << endl;
    }
}

void decode() {
    int n, k; cin >> n >> k;
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    for (int e : a) {
        cout << (e - 2 + n) % n + 1 << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(20);
    cout.setf(ios_base::fixed);
    int a; cin >> a;
    int m; cin >> m;
    while (m--) {
       if (a == 1) {
           encode();
       } else {
           decode();
       }
    }
}
