#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
#define all(x) x.begin(), x.end()
using namespace std;

int mex(vector<int> &a) {
    sort(all(a));
    int cur = 1;
    for (int e : a) {
        if (e == cur) {
            cur++;
        }
    }
    return cur;
}

void xex(vector<int> &a) {
    int sas = mex(a);
    for (int &e : a) {
        e ^= sas;
    }
}

int M;
void solve() {
    int k, n, p; cin >> k >> n >> p;
    int ans = 0;
    for (int mask = 0; mask < (1 << (1 << k)); ++mask) {
        vector<int> s = {0};
        for (int i = 1; i <= (1 << k); ++i) {
            if (mask & (1 << (i - 1))) {
                s.push_back(i);
            }
        }
        if (s.size() != n) continue;
        bool good = false;
        int prev = -1;
        for (int i = 0; i < 1000; ++i) {
            int sas = mex(s);
            if (sas != p) {
                prev = i;
            }
            if (i - prev > 100) {
                good = true;
                break;
            }
            xex(s);
        }
        ans += good;
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(20);
    cout.setf(ios_base::fixed);
    cin >> M;
    int t; cin >> t;
    while (t--) {
        solve();
    }
}