#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll M = 1e9 + 7;
const ll INF = 1e18 + 21;
const double PI = acos(-1);

void solve() {
	ll n, k;
	cin >> k >> n;
	vector<ll> a(n);
	for (auto& e : a) {
		cin >> e;
	}
	set<ll> q;
	q.insert(a[0]);
	q.insert(a[1]);
	for (int j = 0; j < 2; ++j) {
		for (int i = 1; i <= 10; ++i) {
			ll nxt = a[j] + i;
			if (nxt > k) nxt -= k;
			if (q.find(nxt) == q.end()) {
				cout << nxt << ' ';
				q.insert(nxt);
				break;
			}
		}
	}
	cout << endl;
}

void solve2() {
	ll n, k;
	cin >> k >> n;
	vector<ll> a(n);
	for (auto& e : a) {
		cin >> e;
	}
	set<ll> q;
	q.insert(a[0]);
	q.insert(a[1]);
	for (int j = 1; j > -1; --j) {
		for (int i = a[j] + k; i > 0; --i) {
			ll nxt = i;
			if (nxt > k) nxt -= k;
			if (q.find(nxt) == q.end()) {
				cout << nxt << ' ';
				q.insert(nxt);
				break;
			}
		}
	}
	cout << endl;
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int tp;
	cin >> tp;
	int t = 1;
	cin >> t;
	while (t--) {
		if (tp == 1) {
			solve();
		}
		else {
			solve2();
		}
	}
}