#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-9;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        vector<ll> p(n);
        for (ll i = 0; i < n; i++) cin >> p[i];

        ll dp[n+1][n+2][n+2];
        for (auto &t1 : dp)
            for (auto &t2 : t1)
                for (auto &t3 : t2)
                    t3 = -INF;

        dp[0][0][n+1] = 0;

        for (ll i = 0; i < n; i++) {
            for (ll a = 0; a <= n + 1; a++) {
                for (ll b = 0; b <= n + 1; b++) {
                    ll nw = dp[i][a][b];
                    ll num = p[i];
                    dp[i+1][max(num, a)][b] = max(dp[i+1][max(num, a)][b], nw + (num > a));
                    dp[i+1][a][min(b, num)] = max(dp[i+1][a][min(b, num)], nw + (num < b));
                }
            }
        }

        ll mx = -INF;
        for (ll i = 1; i <= n; i++)
            for (ll j = 1; j < n; j++)
                mx = max(mx, dp[n][i][j]);

        cout << mx << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
