#include <iostream>
#include <vector>

using namespace std;

vector <vector <int>> g;
vector <int> ans;

void dfs(int v, int k, int p) {
	if (k < 0) {
		ans[v] = 0;
		return;
	}
	if (g[v].size() == 0) {
		ans[v] = 1;
		return;
	}
	dfs(g[v][0], k - (p != 1), 1);
	dfs(g[v][1], k - (p != 2), 2);
	ans[v] = ans[g[v][0]] + ans[g[v][1]];
}

int main() {
	int n, k, q;
	cin >> n >> k >> q;
	g.resize(n);
	ans.resize(n, 0);
	for (int i = 0; i < n; i++) {
		int t, f, s;
		cin >> f;
		if (f) {
			cin >> f >> s;
			--f; --s;
			g[i].push_back(f);
			g[i].push_back(s);
		}
	}
	dfs(g[0][0], k, 1);
	dfs(g[0][1], k, 2);
	ans[0] = ans[g[0][1]] + ans[g[0][0]];
	while (q--) {
		int f;
		cin >> f;
		--f;
		cout << ans[f] << "\n";
	}
}