#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>

using namespace std;

#define mp make_pair
#define int long long
const int maxa = 1e5 + 1;
const int maxb = 1;

signed main() {
	int n, q;
	cin >> n >> q;
	vector <int> a(n);
	for (auto& i : a) cin >> i;
	sort(a.begin(), a.end());
	vector <pair <pair <int, int>, pair <int, int>>> qs;
	int p = 0;
	vector <int> anses(q, 0);
	int tr; cin >> tr;
	while (q--) {
		int k, i, j;
		cin >> k >> i >> j;
		qs.push_back(mp(mp(k, p), mp(i, j)));
		p++;
	}
	sort(qs.begin(), qs.end());
	vector <vector <int>> dp(maxa, vector <int>(maxb, 0));
	vector <vector <int>> dpa(maxa, vector <int>(maxb, 0));
	dp[0][0] = 1;
	dpa[0][0] = 1;
	q = 0;
	for (int in = 0; in < n; in++) {
		while (q < qs.size() && a[in] > qs[q].first.first) {
			int l = 1;
			int a1 = qs[q].second.first;
			int a2 = qs[q].second.second;
			l = dpa[a1][a2];
			anses[qs[q].first.second] = l;
			q++;
		}
		auto dp2 = dp;
		for (int i = maxa - a[in] - 1; i >= 0; i--) {
			for (int j = maxb -1; j >= 0; j--) {
				dp2[i + a[in]][j] |= dp[i][j];
			}
		}
		for (int i = maxa -1; i >= 0; i--) {
			for (int j = maxb - a[in] - 1; j >= 0; j--) {
				dp2[i][j + a[in]] |= dp[i][j];
			}
		}
		dp = dp2;
		dpa[0][0] = 1;
		for (int i = 1; i < maxa; i++) {
			dpa[i][0] = dpa[i - 1][0] & dp[i][0];
		}
		for (int j = 1; j < maxb; j++) {
			dpa[0][j] = dpa[0][j - 1] & dp[0][j];
		}
		for (int i = 1; i < maxa; i++) {
			for (int j = 1; j < maxb; j++) {
				dpa[i][j] = dpa[i - 1][j] & dpa[i][j - 1] & dp[i][j];
			}
		}
	}
	while (q < qs.size()) {
		int l = 1;
		int a1 = qs[q].second.first;
		int a2 = qs[q].second.second;
		l = dpa[a1][a2];
		anses[qs[q].first.second] = l;
		q++;
	}
	for (auto& i : anses) {
		if (i) cout << "Yes\n";
		if (!i) cout << "No\n";
	}
}