#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>

using namespace std;

#define mp make_pair
#define int long long
const int maxa = 1501;
const int maxb = 1501;

struct bits {
	vector <long long> a;
	bits(int a)
		:a((a + 63)/64, 0)
	{}
	void g(int x) {
		a[x / 64] |= (1 << (x % 64));
	}
	int get(int x) {
		return (a[x / 64] >> (x % 64)) & 1;
	}
	void oq(int x, int b)  {
		if (b) a[x / 64] |= (1 << (x % 64));
	}
};

signed main() {
	int n, q;
	cin >> n >> q;
	vector <int> a(n);
	for (auto& i : a) cin >> i;
	sort(a.begin(), a.end());
	vector <pair <pair <int, int>, pair <int, int>>> qs;
	int p = 0;
	vector <int> anses(q, 0);
	int tr; cin >> tr;
	while (q--) {
		int k, i, j;
		cin >> k >> i >> j;
		qs.push_back(mp(mp(k, p), mp(i, j)));
		p++;
	}
	sort(qs.begin(), qs.end());
	vector <bits> dp(maxa);
	vector <bits> dpa(maxa);
	dp[0].g(0);
	dpa[0].g(0);
	q = 0;
	for (int in = 0; in < n; in++) {
		while (q < qs.size() && a[in] > qs[q].first.first) {
			int l = 1;
			int a1 = qs[q].second.first;
			int a2 = qs[q].second.second;
			l = dpa[a1].get(a2);
			anses[qs[q].first.second] = l;
			q++;
		}
		auto dp2 = dp;
		for (int i = maxa - a[in] - 1; i >= 0; i--) {
			for (int j = maxb -1; j >= 0; j--) {
				dp2[i + a[in]].oq(j, dp[i].get(j));
			}
		}
		for (int i = maxa -1; i >= 0; i--) {
			for (int j = maxb - a[in] - 1; j >= 0; j--) {
				dp2[i].oq(j + a[in], dp[i].get(j));
			}
		}
		dp = dp2;
		dpa[0].g(0);
		for (int i = 1; i < maxa; i++) {
			if ((dpa[i - 1].get(0) & dp[i].get(0))) {
				dpa[i].g(0);
			}
		}
		for (int j = 1; j < maxb; j++) {
			if ((dpa[0].get(j - 1) & dp[0].get(j))) {
				dpa[0].g(j);
			}
		}
		for (int i = 1; i < maxa; i++) {
			for (int j = 1; j < maxb; j++) {
				if ((dpa[i - 1].get(j) & dp[i].get(j)) && dpa[i].get(j - 1)) {
					dpa[i].g(j);
				}
			}
		}
	}
	while (q < qs.size()) {
		int l = 1;
		int a1 = qs[q].second.first;
		int a2 = qs[q].second.second;
		l = dpa[a1].get(a2);
		anses[qs[q].first.second] = l;
		q++;
	}
	for (auto& i : anses) {
		if (i) cout << "Yes\n";
		if (!i) cout << "No\n";
	}
}