#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
//#define int long long
const int maxn = 2e5 + 1;
int l0[maxn];
int l1[maxn];
int used[maxn];
vector <int> g[maxn];
int val[maxn];
void dfs(int v) {
	used[v] = 1;
	l0[v] = val[v];
	l1[v] = 0;
	for (auto& i : g[v]) {
		if (used[i]) continue;
		dfs(i);
		l0[v] += l1[i];
		l1[v] += max(l0[i], l1[i]);
	}
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		int n, q;
		cin >> n >> q;
		int x, y, m;
		cin >> x >> y >> m;
		{
			for (auto& i : used) i = 0;
			for (auto& i : val) i = 0;
			for (auto& i : l0) i = 0;
			for (auto& i : l1) i = 0;
			for (auto& i : g) i.clear();
		}
		for (int i = 0; i < n - 1; i++) {
			int f, s;
			cin >> f >> s;
			--s; --f;
			g[f].push_back(s);
			g[s].push_back(f);
		}
		for (int i = 0; i < n; i++) cin >> val[i] >> val[i];
		vector <int> qs(q);
		for (auto& i : qs) cin >> i;
		vector <int> qsssss = qs;
		dfs(0)
			;
		int ki = 0;
		for (int i = 1; i <= n; i++) {
			ki ^= (x * i + y * (long long)(val[i - 1] * val[i - 1])) % m;
		}
		int ans = max(l0[0], l1[0]);
		for (auto& i : qs) {
			if (i == ans) {
				cout << ki << " ";
			}
			else cout << "-1 ";
		}
		cout << "\n";
		int qt;
		cin >> qt;
		while (qt) {
			if (ans == qsssss[qt - 1]) {
				for (int i = 0; i < n; i++) {
					cout << val[i] << " ";
				}
				cout << "\n";
			}
			else {
				cout << "-1" << "\n";
			}
			int qt;
			cin >> qt;
		}
	}
}