#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;
vector<vector<ll>> g;
vector<ll> l, r, dp1, dp2;
void dfs(ll v, ll p) {
	dp1[v] = r[v];
	dp2[v] = 0;
	for (auto to : g[v]) {
		if (to == p) continue;
		dfs(to, v);
		dp1[v] += dp2[to];
		dp2[v] += max(dp1[to], dp2[to]);
	}
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	cin >> t;
	while (t--) {
		ll n, q, x, y, m;
		cin >> n >> q >> x >> y >> m;
		g.assign(n, {});
		for (ll i = 0; i < n - 1; ++i) {
			ll u, v;
			cin >> u >> v;
			g[--u].push_back(--v);
			g[v].push_back(u);
		}
		l.resize(n);
		r.resize(n);
		for (ll i = 0; i < n; ++i) cin >> l[i] >> r[i];
		dp1.assign(n, 0);
		dp2.assign(n, 0);
		dfs(0, -1);
		ll z1 = max(dp1[0], dp2[0]), z2 = 0;
		for (ll i = 0; i < n; ++i) z2 = (z2 ^ (((x * (i + 1)) % m + (((y * l[i]) % m) * l[i]) % m) % m));
		vector<ll> v(q);
		for (ll i = 0; i < q; ++i) cin >> v[i];
		for (ll i = 0; i < q; ++i) {
			if (v[i] == z1) cout << z2 << " ";
			else cout << "-1 ";
		}
		cout << endl;
		ll c;
		cin >> c;
		while (c) {
			--c;
			if (v[c] == z1) {
				for (ll i = 0; i < n; ++i) cout << l[i] << " ";
			} else cout << -1;
			cout << endl;
			cin >> c;
		}
	}
	cout << endl;
	return 0;
}