#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long
#define popcnt __builtin_popcount

const ll INF = 2e9, MOD = 1e9 + 7, N = 2e5 + 100, K = 20;

struct seg {
    int l, r, id;
};

bool cmp(seg a, seg b) {
    if (a.r == b.r)
        return a.l > b.l;
    return a.r < b.r;
}

bool cmp2(seg a, seg b) {
    if (a.l == b.l)
        return a.r < b.r;
    return a.l > b.l;
}

void solve() {
    int n;
    cin >> n;
    vector<seg> a(n);
    vector<int> p(n, -1), cnt(n), cnt2(n), used(n);
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        a[i] = {l, r, i};
    }
    sort(a.begin(), a.end(), cmp);
    vector<vector<int>> dp(2, vector<int> (n));
    dp[1][0] = 1;
    for (int i = 1; i < n; i++) {

        dp[0][i] = max(dp[0][i - 1], dp[1][i - 1]);
        int j = i - 1;
        while (j >= 0 && a[j].r >= a[i].l)
            j--;
        if (j < 0)
            dp[1][i] = 1;
        else
            dp[1][i] = max(dp[0][j], dp[1][j]) + 1;
    }
    int m = max(dp[0][n - 1], dp[1][n - 1]);
    vector<int> g[n];
    vector<int> buf;
    for (int i = 0; i < n - 1; i++) {
        buf.push_back(i);
        if (a[i].r < a[i + 1].l) continue;
        else {
            while (!buf.empty() && a[buf.back()].r >= a[i + 1].l) {
                int j = buf.back();
                buf.pop_back();
                p[j] = i + 1;
                cnt[i + 1]++;
                used[i + 1] = 1;
                g[i + 1].push_back(j);
            }
        }
    }
    int cur = 0, cur2 = n;
    set<tuple<int, int, int>> s;
    vector<int> del(n);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            if (p[i] != -1) {
                cur++;
                s.insert({-1, cnt[p[i]], p[i]});
            }
        }
    }
    while (cur != m / 2) {
        auto [need, cn, v] = *s.rbegin();
        s.erase({need, cn, v});
        need *= -1;
        while (cur != m / 2 && g[v].size() != 1) {
            cur--;
            int to = g[v].back();
            while (!g[to].empty()) {
                to = g[to][0];
            }
            while (to != v) {
                del[to] = 1;
                to = p[to];
            }
            cur2 -= need;
            g[v].pop_back();
            cn--;
        }
        if (cur == m / 2) break;
        used[v] = 1;
        int ch = 1;
        int last = v;
        while (v != -1 && g[v].size() == 1) {
            ch++;
            last = v;
            v = p[v];
        }
        if (v != -1) {
            cnt2[v]++;
            if (cnt2[v] == cnt[v] - 1)
                s.insert({-ch, g[v].size(), v});
        } else {
            ch--;
            s.insert({-ch, g[last].size(), last});
        }
    }
    vector<int> ans;
    cur2 = 0;
    for (int i = 0; i < n; i++) {
        if (used[i] && !del[i]) {
            cur2++;
            ans.push_back(a[i].id);
        }
    }
    int i = 0;
    while (cur2 != n / 2) {
        if (!used[i] && p[i] == -1) {
            ans.push_back(a[i].id);
            cur2++;
        }
        i++;
    }
    i = 0;
    while (cur2 != n / 2) {
        if (!used[i] && del[i]) {
            ans.push_back(a[i].id);
            cur2++;
        }
        i++;
    }
    sort(ans.begin(), ans.end());
    for (auto to : ans)
        cout << to << " ";
    cout << endl;



}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
