#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

#define int long long

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int h, w, k;
    cin >> h >> w >> k;

    vector<int> x, y;

    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> b >> a;

        x.push_back(a);
        y.push_back(b);
    }

    sort(x.begin(), x.end());
    sort(y.begin(), y.end());

    int maxix = x[0] + w - x.back();
    int maxiy = y[0] + h - y.back();

    x.push_back(x[0] + w);
    y.push_back(y[0] + h);

    int maxicntx = 0;
    int maxicnty = 0;

    for (int i = 0; i < k - 1; i++) {
        if (maxix < x[i + 1] - x[i]) {
            maxix = max(maxix, x[i + 1] - x[i]);
            maxicntx = min(x[i], w - x[i + 1] + 1);
        } else if (maxix == x[i + 1] - x[i]) {
            maxicntx = min(maxicntx, min(x[i], w - x[i + 1] + 1));
        }

        if (maxiy < y[i + 1] - y[i]) {
            maxiy = max(maxiy, y[i + 1] - y[i]);
            maxicnty = min(y[i], h - y[i + 1] + 1);
        } else if (maxiy == y[i + 1] - y[i]) {
            maxicnty = min(maxicnty, min(y[i], h - y[i + 1] + 1));
        }
    }

    cout << (h - maxiy + 1) * (w - maxix + 1) << " " << maxicntx + maxicnty << endl;

}