#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int>> a(k);
    vector<int> xs(k);
    vector<int> ys(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
        a[i].second--;
        xs[i] = a[i].second;
        ys[i] = a[i].first;
    }

    sort(xs.begin(), xs.end());
    sort(ys.begin(), ys.end());

    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
    ys.resize(unique(ys.begin(), ys.end()) - ys.begin());

    int miny = n;
    int minx = m;
    int xop = 0;
    int yop = 0;

    for (int i = 0; i < (int)xs.size(); i++) {
        int cend = i - 1;
        if (cend < 0) {
            cend += xs.size();
        }
        int clastcoord = xs[cend];
        if (clastcoord < xs[i]) {
            clastcoord += m;
        }
        // minx = min(minx, clastcoord - xs[i] + 1);
        int cop = max(0, min(m - xs[i], clastcoord - m + 1));

        if (clastcoord - xs[i] + 1 < minx) {
            minx = clastcoord - xs[i] + 1;
            xop = cop;
        } else if (clastcoord - xs[i] + 1 == minx) {
            xop = min(xop, cop);
        }
    }

    for (int i = 0; i < (int)ys.size(); i++) {
        int cend = i - 1;
        if (cend < 0) {
            cend += ys.size();
        }
        int clastcoord = ys[cend];
        if (clastcoord < ys[i]) {
            clastcoord += n;
        }
        // miny = min(miny, clastcoord - ys[i] + 1);
        int cop = max(0, min(n - ys[i], clastcoord - n + 1));

        if (clastcoord - ys[i] + 1 < miny) {
            miny = clastcoord - ys[i] + 1;
            yop = cop;
        } else if (clastcoord - ys[i] + 1 == miny) {
            yop = min(yop, cop);
        }
    }

    cout << minx * miny << " " << xop + yop << "\n";
    return 0;
}