#include <algorithm>
#include <cassert>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

int m;

int mex(const vector<int>& a) {
    vector<bool> used(a.back() + 2, false);
    for (auto el : a) {
        used[el] = true;
    }
    for (int i = 0; i <= (int)a.back() + 1; i++) {
        if (!used[i]) {
            return i;
        }
    }
    exit(-1);
}

int good(vector<int> st) {
    set<vector<int>> seen;
    vector<int> prev;
    int cnt = 0;
    while (seen.find(st) == seen.end()) {
        seen.insert(st);
        prev = st;
        int ck = mex(st);
        for (int i = 0; i < (int)st.size(); i++) {
            st[i] ^= ck;
        }
        sort(st.begin(), st.end());
        st.resize(unique(st.begin(), st.end()) - st.begin());
        if (seen.find(st) != seen.end()) {
            if (cnt < 2) {
                seen.clear();
                cnt++;
            }
        }
    }
    if (st == prev) {
        return mex(st);
    } else {
        return -1;
    }
}

void solve() {
    int k, n, p;
    cin >> k >> n >> p;

    int maxel = (1 << k);
    int res = 0;
    for (unsigned mask = 0; mask < (1u << maxel); mask++) {
        if (__builtin_popcount(mask) != n || !(mask & 1)) {
            continue;
        }
        vector<int> cset;
        for (int i = 0; i < maxel; i++) {
            if ((mask >> i) & 1) {
                cset.emplace_back(i);
            }
        }

        sort(cset.begin(), cset.end());

        int cres = good(cset);
        if (cres == p) {
            res++;
            if (res >= m) {
                res -= m;
            }
        }
    }

    res %= m;
    if (res < 0) {
        res += m;
    }

    cout << res << "\n";
}

int main() {
    cin >> m;
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}