#include <bits/stdc++.h>

using namespace std;
#define int long long
struct H {
    int l, r, i;
};

bool operator<(H a, H b) {
    return tie(a.l, a.r, a.i) < tie(b.l, b.r, b.i);
}

void solve() {
    int n;
    cin >> n;
    vector<H> a(n);
    vector<H> p;
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        a[i] = {l, r, i};
        p.push_back({l, -1, i});
        p.push_back({r, 1, i});
    }
    sort(a.begin(), a.end());
    sort(p.begin(), p.end());
    vector<bool> used(n);
    int bal = 0;
    for (auto i: p) {
        bal -= i.r;
        if (bal == 2) used[i.i] = 1;
    }
    int k = 0;
    for (int i = 0; i < n; i++) k += used[i];
    int k1 = 0;
    for (int i = 0; i < n; i++) {
        if (used[i] && k1 < k / 2) {
            cout << i + 1 << ' ';
            k1++;
        }
    }
    k1 = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i] && k1 < (n - k) / 2) {
            cout << i + 1 << ' ';
            k1++;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _;
    cin >> _;
    while (_--) {
        solve();
    };
    return 0;
}
