#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#define int int_fast64_t
#define nx << ' ' <<
#define cft int t; cin >> t; while(t--)
#define all(a) a.begin(), a.end()


using namespace std;

void dfs(vector<vector<int>>& g, vector<int>& used, vector<vector<int>>& dp, int u) {
	used[u] = 1;
	for (auto v : g[u]) {
		if (!used[v]) {
			dfs(g, used, dp, v);
			dp[u][1] += dp[v][0];
			dp[u][0] += max(dp[v][0], dp[v][1]);
		}
	}
}

void backdfs(vector<vector<int>>& g, vector<int>& used, vector<vector<int>>& dp, vector<int>& ans, int u) {
	used[u] = 1;
	for (auto v : g[u]) {
		if (!used[v]) {
			if (ans[u] == 0) {
				if (dp[v][0] > dp[v][1])
					ans[v] = 0;
				else
					ans[v] = 1;
			}
			else {
				ans[v] = 0;
			}
			backdfs(g, used, dp, ans, v);
		}
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector<vector<int>> dp(n + 1, { 0, 0 });
	vector<int> in(n + 1);
	vector<vector<int>> g(n + 1);
	vector<int> used(n + 1, 0);
	int x, y, m;
	cin >> x >> y >> m;
	for (int i = 1; i < n; ++i) {
		int s, f;
		cin >> s >> f;
		g[s].push_back(f);
		g[f].push_back(s);

	}
	for (int i = 1; i <= n; ++i) {
		int s, f;
		cin >> s >> f;
		dp[i][1] = s;
		in[i] = s;
	}
	dfs(g, used, dp, 1);
	used.assign(n + 1, 0);
	vector<int> ans(n + 1, 0);
	if (dp[1][0] > dp[1][1])
		ans[1] = 0;
	else
		ans[1] = 1;
	backdfs(g, used, dp, ans, 1);
	vector<int> que(q);
	for (int i = 0; i < q; ++i) {
		int u;
		cin >> u;
		que[i] = u;
		if (u == dp[1][ans[1]]) {
			int k = 0;
			for (int j = 1; j <= n; ++j) {
				k ^= ((x * j + y * in[i] * in[i]) % m);
			}
			cout << k << endl;
		}
		else {
			cout << -1 << endl;
		}
	}
	int l;
	cin >> l;
	while (l) {
		if (que[l - 1] == dp[1][ans[1]]) {
			for (int j = 1; j <= n; ++j) {
				cout << in[j] << ' ';
			}
			cout << endl;
		}
		else {
			cout << -1 << endl;
		}
		cin >> l;
	}
}

signed main() {
	cft
		solve();
}