#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define x first
#define y second

using namespace std;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;

void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

//--------------------------------------

const int MAXN = 2e5 + 10;

int k;

array<int, 2> gr[MAXN];
int sum[MAXN];

void dfs(int v, int cnt = 0, int lst = -1){
    if (gr[v][0] == 0){
        sum[v] = cnt <= k;
        return;
    }
    for (int i = 0; i < 2; i++){
        int u = gr[v][i];
        dfs(u, cnt + (lst != i && lst != -1), i);
        sum[v] += sum[u];
    }
}

void run(){
    int n, q;
    cin >> n >> k >> q;
    for (int i = 0; i < n; i++){
        int t;
        cin >> t;
        if (t > 0){
            cin >> gr[i][0] >> gr[i][1];
            gr[i][0]--, gr[i][1]--;
        }
    }
    dfs(0);
    while (q--){
        int u;
        cin >> u;
        u--;
        cout << sum[u] << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    run();
    return 0;
}
