#include <bits/stdc++.h>

using namespace std;
#define int long long
const int N = 5e3 + 7;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> vec;
    map<int, int> cnt;
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        cnt[a]++;
    }
    for (auto c : cnt) {
        while (c.second > 0) {
            c.second--;
            vec.push_back(c.first);
        }
    }
    int Z;
    cin >> Z;

    sort(vec.begin(), vec.end());
    vector<vector<int>> dp(vec.size() + 1, vector<int>(N, -1));
    dp[0][0] = 0;
    for (int i = 1; i <= vec.size(); ++i) {
        int el = vec[i - 1];
        bool fl = true;
        for (int j = 0; j < N; ++j) {
            dp[i][j] = dp[i - 1][j];
            if (dp[i - 1][j] >= el - 1) {
                dp[i][j] = dp[i - 1][j] + el;
            }
            if (j - el >= 0) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j - el]);
            }
            if (dp[i][j] < N) {
                fl = false;
            }
        }
        for (int j = 1; j < N; ++j) {
            dp[i - 1][j] = min(dp[i - 1][j], dp[i - 1][j - 1]);
        }
        if (fl) {
            int nn = vec.size();
            for (int j = 0; j < nn - i; ++j) {
                vec.pop_back();
            }
            break;
        }
    }
    for (int j = 1; j < N; ++j) {
        dp[vec.size()][j] = min(dp[vec.size()][j], dp[vec.size()][j - 1]);
    }
    for (int w = 0; w < q; ++w) {
        int k, a, b;
        cin >> k >> a >> b;
        int ind = upper_bound(vec.begin(), vec.end(), k) - vec.begin();
        if (dp[ind][a] >= b) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
// cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}