#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <numeric>
#include <cassert>
#include <bitset>

using namespace std;
using ll = unsigned long long;

constexpr int C = 100005;
bitset<C> dp; // dp[C];
constexpr int INF = 0x3f3f3f3f;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    dp[0] = 1;//[0] = true;
    cin.tie(0)->sync_with_stdio(0);
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (ll &now : w) {
        cin >> now;
//        if (now > 1024) now = 0;
    }
    std::sort(w.begin(), w.end());
    int z;
    cin >> z;
    for (int i = 0; i < n; ++i) {
        if (w[i] > C) continue;
        dp |= dp << w[i];
//        for (int f = C - 1; f >= 0; --f) {
//            if (f + w[i] < C) dp[f + w[i]] = dp[f + w[i]] | dp[f];
//            dp[f] = dp[f] | (dp[f] << w[i]);
////            for (int s = C - 1; s >= 0; --s) {
////                if (f >= w[i]) dp[f][s] = dp[f][s] || dp[f - w[i]][s];
////                if (s >= w[i]) dp[f][s] = dp[f][s] || dp[f][s - w[i]];
////            }
//        }
    }
    for (int i = 1; i < C; ++i) {
        if (!dp[i - 1]) dp[i] = false;
    }
//    int sv = 0;
    for (int qi = 0; qi < q; ++qi) {
        ll k, a, b;
        cin >> k >> a >> b;
//        k -= sv * z;
//        a -= sv * z;
//        b -= sv * z;
        bool ok = true;
//        for (int i = 0; i <= a && ok; ++i) {
//            for (int j = 0; j <= b; ++j) {
//                if (!dp[i][j]) {
//                    ok = false;
//                    break;
//                }
//            }
//        }
        if (dp[a]) {
            cout << "Yes\n";
//            sv += qi + 1;
        } else {
            cout << "No\n";
        }
    }
    return 0;
}