#include <iostream>
#include <random>
#include <array>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <bitset>

using namespace std;
using ll = long long;

int main() {
    ll n, q;
    cin >> n >> q;

    vector<ll> apples(n);
    for (int i = 0; i < n; ++i) {
        cin >> apples[i];
    }

    sort(apples.begin(), apples.end());
    bitset<(ll) 100002> bits;
    bits[0] = true;

    for (int i = 0; i < n; ++i) {
        bits |= bits << apples[i];
    }

    ll min_false = 1e12;
    for (int i = 0; i < bits.size(); ++i) {
        if (!bits[i]) {
            min_false = i;
            break;
        }
    }

    ll z;
    cin >> z;

    for (int i = 0; i < q; ++i) {
        ll k, a, b;
        cin >> k >> a >> b;

        cout << (a < min_false ? "Yes" : "No") << endl;
    }

    return 0;
}