//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

vector<ll> solve(ll n, vector<pair<ll, ll>> arr) {
	vector<pair<ll, ll>> sob;
	set<ll> live;
	for (ll i = 0; i < n; i++) {
		live.insert(i);
		sob.emplace_back(arr[i].second, i);
	}
	set<ll> ans;
	ll l = 0;
	sort(sob.begin(), sob.end());
	for (auto[x, i] : sob) {
		if (arr[i].first > l) {
			l = x;
			ans.insert(i);
			live.erase(i);
		}
	}
	ll ss = ans.size();
	while (ans.size() != ss / 2) {
		map<ll, vector<ll>> col;
		set<pair<ll, ll>> st, en;
		for (auto i : ans) {
			st.insert(make_pair(arr[i].first, i));
			en.insert(make_pair(arr[i].second, i));
		}
		for (auto i : live) {
			ll fi = en.lower_bound(make_pair(arr[i].first, 0))->second;
			auto it = st.upper_bound(make_pair(arr[i].second, n));
			it--;
			ll li = it->second;
			if (li == fi) {
				col[fi].push_back(i);
			}
		}
		ll ms = n, msi = 0;
		for (auto i : ans) {
			if (assign_min(ms, (ll)col[i].size())) {
				msi = i;
			}
		}
		ans.erase(msi);
		for (auto j : col[msi]) {
			live.erase(j);
		}
	}
	ll na = n / 2;
	vector<ll> a;
	for (auto i : ans) {
		a.push_back(i + 1);
		na--;
	}
	for (auto j : live) {
		if (na == 0) {
			break;
		}
		a.push_back(j + 1);
		na--;
	}
	return a;
}

vector<ll> stupid(ll n, vector<pair<ll, ll>> arr) {
	vector<pair<ll, ll>> sob;
	for (ll i = 0; i < n; i++) {
		sob.emplace_back(arr[i].second, i);
	}
	ll l = 0, ans = 0;
	sort(sob.begin(), sob.end());
	for (auto[x, i] : sob) {
		if (arr[i].first > l) {
			l = x;
			ans++;
		}
	}
	for (ll i = 0; i < (1 << n); i++) {
		vector<pair<ll, ll>> now;
		for (ll j = 0; j < n; j++) {
			if ((i >> j) & 1) {
				now.push_back(arr[j]);
			}
		}
		if (now.size() != n / 2) {
			continue;
		}
		vector<pair<ll, ll>> sob;
		for (ll i = 0; i < n / 2; i++) {
			sob.emplace_back(now[i].second, i);
		}
		ll l = 0, na = 0;
		sort(sob.begin(), sob.end());
		for (auto[x, i] : sob) {
			if (now[i].first > l) {
				l = x;
				na++;
			}
		}
		if (na == ans / 2) {
			vector<ll> a;
			for (ll j = 0; j < n; j++) {
				if ((i >> j) & 1) {
					a.push_back(j + 1);
				}
			}
			return a;
		}
	}
	vector<ll> a;
	return a;
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<pair<ll, ll>> arr(n);
		for (auto&[l, r] : arr) {
			cin >> l >> r;
		}
		for (auto i : stupid(n, arr)) {
			cout << i << ' ';
		}
		cout << '\n';
	}
}
