#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(a) cerr << a << endl;
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;

int ans1 = mxn, ans2 = mxn, cnt1 = mxn, cnt2 = mxn;

void upd1 (int ANS, int CNT) {
    if (ANS < ans1 || (ANS == ans1 && CNT < cnt1)) {
        ans1 = ANS;
        cnt1 = CNT;
    }
}

void upd2 (int ANS, int CNT) {
    if (ANS < ans2 || (ANS == ans2 && CNT < cnt2)) {
        ans2 = ANS;
        cnt2 = CNT;
    }
}

void solve() {
    int h, w, k; cin >> h >> w >> k;
    vector <pii> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second;
        --a[i].first; --a[i].second;
    }
    vector <int> b, c;
    for (int i = 0; i < k; ++i) {
        b.pb(a[i].first);
        c.pb(a[i].second);
    }
    sort(all(b)); sort(all(c));
    b.erase(unique(all(b)), b.end());
    c.erase(unique(all(c)), c.end());
    for (int i = 0; i < b.size(); ++i) {
        if (!i) {
            upd1(b.back() - b[i] + 1, 0);
        }
        else {
            upd1(h - (b[i] - b[i - 1] - 1), min(h - b[i], b[i - 1] + 1));
        }
    }
    for (int i = 0; i < c.size(); ++i) {
        if (!i) {
            upd2(c.back() - c[i] + 1, 0);
        }
        else {
            upd2(w - (c[i] - c[i - 1] - 1), min(w - c[i], c[i - 1] + 1));
        }
    }
    cout << ans1 * ans2 << ' ' << cnt1 + cnt2 << endl;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}