#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void group1_1(int n, int k) {
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }

    set<int> ans;
    for (int i = 0; i < k; ++i) {
        ans.insert((a[i] - 1 + (n + 1) / 2) % n + 1);
    }

    for (int x : ans) {
        cout << x << " ";
    }
    cout << endl;
}

void group1_2(int n, int k) {
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }

    set<int> ans;
    for (int i = 0; i < k; ++i) {
        ans.insert((a[i] - 1 - (n + 1) / 2 + n) % n + 1);
    }

    for (int x : ans) {
        cout << x << " ";
    }
    cout << endl;
}

void group3_1(int n, int k) {
    int ai;
    set<int> ans;
    for (int i = 1; i <= n; ++i) {
        ans.insert(i);
    }
    for (int i = 0; i < k; ++i) {
        cin >> ai;
        ans.erase(ai);
    }

    for (int x : ans) {
        cout << x << "\n";
    }
}

void group3_2(int n, int k) {
    int ai;
    set<int> ans;
    for (int i = 1; i <= n; ++i) {
        ans.insert(i);
    }
    for (int i = 0; i < k; ++i) {
        cin >> ai;
        ans.erase(ai);
    }

    for (int x : ans) {
        cout << x << "\n";
    }
}

void group2_1(int n, int k) {
    int a, b;
    cin >> a >> b;

    if (a + 1 == b || a == 1 && b == n) {
        int c = (a + 1) % n + 1, d = (b + 1) % n + 1;
        if (d < c) swap(c, d);

        cout << c << " " << d << endl;
    } else {
        int c = a % n + 1, d = b % n + 1;
        if (d < c) swap(c, d);

        cout << c << " " << d << endl;
    }
}

void group2_2(int n, int k) {
    int a, b;
    cin >> a >> b;

    if (a + 1 == b || a == 1 && b == n) {
        int c = (a - 3 + n) % n + 1, d = (b - 3 + n) % n + 1;
        if (d < c) swap(c, d);

        cout << c << " " << d << endl;
    } else {
        int c = (a - 2 + n) % n + 1, d = (b - 2 + n) % n + 1;
        if (d < c) swap(c, d);

        cout << c << " " << d << endl;
    }
}

void solve1() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        group1_1(n, k);
    } else if (2 * k == n) {
        group3_1(n, k);
    } else if (k == 2) {
        group2_1(n, k);
    }
}

void solve2() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        group1_2(n, k);
    } else if (2 * k == n) {
        group3_2(n, k);
    } else if (k == 2) {
        group2_2(n, k);
    }
}

int main() {
#ifndef NEKSTAS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int a, t = 1;
    cin >> a >> t;
    for (int i = 0; i < t; ++i) {
        if (a == 1) {
            solve1();
        } else {
            solve2();
        }
    }
}
