#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll m;

vector<ll> b_to_v(ll b) {
    vector<ll> v;
    for (ll i = 0; (1 << i) <= b; ++i) {
        if ((b >> i) & 1) {
            v.push_back(i);
        }
    }
    return v;
}

ll v_to_b(const vector<ll> &v) {
    ll b = 0;
    for (ll ai : v) {
        b += (1 << ai);
    }
    return b;
}

ll mex(ll a) {
    ll i = 0;
    while ((a >> i) & 1) ++i;
    return i;
}

ll next(ll a, ll z) {
    vector<ll> av = b_to_v(a);
    for (ll &ai : av) {
        ai ^= (z - 1);
    }
    return v_to_b(av);
}


void solve() {
    ll k, n, p, ans = 0;
    cin >> k >> n >> p;

    for (ll a = 1; a < (1ll << (1ll << k)); a += 2) {
        if (__builtin_popcount(a) != n) continue;

        unordered_map<ll, ll> w, nxt;
        ll c = a;
        while (!w.count(c)) {
            w[c] = mex(c);
            nxt[c] = next(c, w[c]);
            c = nxt[c];
        }

        bool ok = (w[c] == p);
        ll d = nxt[c];
        while (d != c) {
            ok &= (w[d] == p);
            d = nxt[d];
        }

        if (ok) {
            ans++;
        }
    }

    cout << ans % m << "\n";
}

int main() {
#ifndef NEKSTAS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll t = 1;
    cin >> m >> t;
    for (ll i = 0; i < t; ++i) {
        solve();
    }
}
