#include <bits/stdc++.h>
using namespace std;
#define pb push_back

int maxn = 2e5 + 1;

int len(vector<pair<int, int>> a) {
    set<pair<int, int>> cringe;
    int ans = 0, r = 0;
    for (auto [u, v]: a) cringe.insert({v, u});
    while (!cringe.empty()) {
        auto [rr, l] = *cringe.begin();
        if (l > r) {
            r = rr;
            ans++;
        }
        cringe.erase(cringe.begin());
    }
    return ans;
}

bool intersect(pair<int, int> b, pair<int, int> a) {
    return (a.first < b.first && b.second < a.second);
}

bool cmp(vector<int> &a, vector<int> &b) {
    return a.size() > b.size();
}

void solve() {
    int n, m;
    cin >> n;
    vector<tuple<int, int, int>> inp(n);
    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        inp[i] = {a, b, i};
    }
//    m = len(inp);
    vector<vector<int>> blocks(1);
    sort(inp.begin(), inp.end());
    for (int i = 0; i < n; ++i) {
        auto [a1, b1, c1] = inp[i];
        blocks.pb({c1});
        if (i + 1 != n) {
            auto [a2, b2, c2] = inp[i + 1];
            while (i + 1 < inp.size() && intersect({a2, b2}, {a1, b1})) {
                i++;
                swap(a1, a2);
                swap(b1, b2);
                swap(c1, c2);
                a2 = get<0>(inp[i + 1]);
                b2 = get<1>(inp[i + 1]);
                c2 = get<2>(inp[i + 1]);
                blocks.back().pb(c1);
            }
        }
    }
    sort(blocks.begin(), blocks.end(), cmp);
    m = blocks.size() / 2;
    vector<int> ans;
    for (auto it: blocks) {
        m--;
        if (ans.size() == n / 2) {
            break;
        }
        for (auto i: it) {
            if (ans.size() + m < n / 2) {
                ans.pb(i);
            } else break;
        }
    }
    for (auto it: ans) {
        cout << it + 1 << " ";
    }
    cout << '\n';
}
//
//1
//8
//1 9
//11 13
//16 23
//27 30
//28 29
//2 6
//3 5
//17 20


int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
