#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//#endif
    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;
        int x, y, m;
        cin >> x >> y >> m;
        vector<vector<int>> g(n);
        for (int i = 0; i < n - 1; ++i) {
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        vector<pair<int, int>> lr(n);
        for (auto &[l, r] : lr) {
            cin >> l >> r;
            assert(l == r);
        }
        vector<ll> vv(q);
        cin >> vv;
        vector<vector<int>> ans(101);
        for (int mask = 0; mask < (1 << n); ++mask) {
            for (int submask = mask;; submask = (submask - 1) & mask) {
                vector<array<ll, 2>> dp(n);
                vector<int> cur(n);
                for (int i = 0; i < n; ++i) {
                    if ((mask >> i) & 1) {
                        if ((submask >> i) & 1) {
                            cur[i] = lr[i].first + 2;
                        } else {
                            cur[i] = lr[i].first + 1;
                        }
                    } else {
                        cur[i] = lr[i].first;
                    }
                    cur[i] = min(cur[i], lr[i].second);
                }
                auto dfs = [&](auto dfs, int v, int p) -> void {
                    for (auto u : g[v]) {
                        if (u != p) {
                            dfs(dfs, u, v);
                            dp[v][0] += max(dp[u][0], dp[u][1]);
                            dp[v][1] += dp[u][0];
                        }
                    }
                    dp[v][1] += lr[v].first;
                };
                dfs(dfs, 0, -1);
                ans[max(dp[0][0], dp[0][1])] = cur;
                if (submask == 0) {
                    break;
                }
            }
        }
        auto mul = [&](ll a, ll b) {
            return (a * b) % m;
        };
//        cout << ww << endl;
        for (auto i : vv) {
            if (i <= 100 && !ans[i].empty()) {
                ll norm = 0;
                for (int j = 0; j < n; ++j) {
                    norm ^= (mul(x, j + 1) + mul(y, mul(ans[i][j], ans[i][j]))) % m;
                }
                cout << norm << " ";
            } else {
                cout << "-1 ";
            }
        }
        cout << endl;
        int cur;
        cin >> cur;
        while (cur != 0) {
            --cur;
            if (vv[cur] <= 100 && !ans[vv[cur]].empty()) {
                for (int i = 0; i < n; ++i) {
                    cout << ans[vv[cur]][i] << " ";
                }
                cout << endl;
            } else {
                cout << "-1" << endl;
            }
            cin >> cur;
        }
    }
}
