#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct query {
    int id;
    ll x;
};

void solve() {
    int n, q;
    cin >> n >> q;
    ll X, Y, M;
    cin >> X >> Y >> M;
    vector<vector<int>> a(n);
    for (int i = 0; i < n - 1; ++i) {
        int s, t;
        cin >> s >> t;
        --s, --t;
        a[s].push_back(t);
        a[t].push_back(s);
    }
    vector<ll> lb(n);
    vector<ll> rb(n);
    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        lb[i] = l;
        rb[i] = r;
    }
    vector<query> qs(q);
    for (int i = 0; i < q; ++i) {
        qs[i].id = i;
        cin >> qs[i].x;
    }
    vector<int> p(n);
    {
        vector<vector<int>> g(n);
        vector<bool> used(n);
        auto dfs = [&](int v, auto dfs) -> void {
            used[v] = true;
            for (int u: a[v]) {
                if (!used[u]) {
                    g[v].push_back(u);
                    p[u] = v;
                    dfs(u, dfs);
                }
            }
        };
        dfs(0, dfs);
        a = g;

    }

    ll ulb, urb;
    ll dlb = 0, drb = 0;
    ulb = lb[0];
    urb = rb[0];
    for (int i = 1; i < n; ++i) {
        dlb += lb[i];
        drb += rb[i];
    }
    vector<ll> s(n);
    auto cert = [&]() -> ll {
        ll k = 0;
        for (ll i = 0; i < (ll) n; ++i) {
            k = k ^ ((X * (i + 1) + Y * s[i] % M * s[i] % M) % M);
        }
        return k;
    };
    vector<ll> certans(q, -1);
    sort(qs.begin(), qs.end(), [&](const auto &x, const auto &y) {return x.x < y.x;});

    for (int i = 0; i < n; ++i) s[i] = lb[i];
    ll ccert = cert();
    int pt = 0;
    ll acc = 0;
    bool ctu = true;
    for (auto &qqq : qs) {
        ll x = qqq.x;
        bool ntu = (ulb <= x && x <= urb);
        if (x < dlb || x < ulb) {
            certans[qqq.id] = -1;
            continue;
        }
        if (ctu && !(ntu)) {
            for (int i = 0; i < n; ++i) s[i] = lb[i];
            ccert = cert();
            pt = 1;
            acc = dlb;
            ctu = false;
        }
        if ((!ctu) && ntu) {
            for (int i = 0; i < n; ++i) s[i] = rb[i];
            ccert = cert();
            pt = 0;
            acc = 0;
            ctu = true;
        }
        if (ctu && ntu) {
            pt = 0;
            ccert ^= ((X * (pt + 1) + Y * s[pt] % M * s[pt] % M) % M);
            s[pt] = x;
            ccert ^= ((X * (pt + 1) + Y * s[pt] % M * s[pt] % M) % M);
            certans[qqq.id] = ccert;
        } else if ((!ctu) && (!ntu)) {
            while (true) {
                while (pt < n && s[pt] == rb[pt]) ++pt;
                if (pt == n) break;
                ll df = min(rb[pt] - s[pt], x - acc);
                acc += df;
                ccert ^= ((X * (pt + 1) + Y * s[pt] % M * s[pt] % M) % M);
                s[pt] += df;
                ccert ^= ((X * (pt + 1) + Y * s[pt] % M * s[pt] % M) % M);
                if (acc == x) break;
            }
            if (pt == n) {
                certans[qqq.id] = -1;
            } else {
                certans[qqq.id] = ccert;
            }
        }
    }

    sort(qs.begin(), qs.end(), [&](const auto &x, const auto &y) {return x.id < y.id;});
    for (int i = 0; i < q; ++i) {
        cout << certans[i] << ' ';
    }
    cout << endl;
    while (true) {
        int ind;
        cin >> ind;
        if (ind == 0) break;
        --ind;
        if (certans[ind] == -1) {
            cout << -1 << endl;
            continue;
        }

        for (auto &x: s) x = 0;

        for (int i = 0; i < n; ++i) s[i] = lb[i];

        ll ccert = cert();
        int pt = 0;
        ll acc = 0;
        bool ctu = true;
        ll x = qs[ind].x;
        {

            bool ntu = (ulb <= x && x <= urb);
            if (ctu && !(ntu)) {
                for (int i = 0; i < n; ++i) s[i] = lb[i];
                ccert = cert();
                pt = 1;
                acc = dlb;
                ctu = false;
            }
            if ((!ctu) && ntu) {
                for (int i = 0; i < n; ++i) s[i] = rb[i];
                ccert = cert();
                pt = 0;
                acc = 0;
                ctu = true;
            }
            if (ctu && ntu) {
                pt = 0;
                ccert ^= ((X * (pt + 1) + Y * s[pt] % M * s[pt] % M) % M);
                s[pt] = x;
                ccert ^= ((X * (pt + 1) + Y * s[pt] % M * s[pt] % M) % M);
            } else if ((!ctu) && (!ntu)) {
                while (true) {
                    while (pt < n && s[pt] == rb[pt]) ++pt;
                    if (pt == n) break;
                    ll df = min(rb[pt] - s[pt], x - acc);
                    acc += df;
                    ccert ^= ((X * (pt + 1) + Y * s[pt] % M * s[pt] % M) % M);
                    s[pt] += df;
                    ccert ^= ((X * (pt + 1) + Y * s[pt] % M * s[pt] % M) % M);
                    if (acc == x) break;
                }
            }
            for (auto &y : s) cout << y << ' ';
            cout << endl;
        }

    }
    return;
}

int main() {
    int t;
    cin >> t;
    while (t--) solve();
}