#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;

int get_res(int mask, vector<int> p) {
	int max1 = -1, max2 = -1, min1 = 1e9, min2 = 1e9;
	int ans = 0;
	for (int i = 0; i < p.size(); ++i) {
		if ((mask >> i) & 1) {
			if (max1 < p[i]) {
				ans++;
				max1 = p[i];
			}
		}
		else {
			if (min2 > p[i]) {
				ans++;  
				min2 = p[i];
			}
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n;
		cin >> n;
		vector<int> p(n);
		for (int i = 0; i < n; ++i)
			cin >> p[i];
		int ans = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			ans = max(ans, get_res(mask, p));
		}
		cout << ans << "\n";
	}

	return 0;
}