#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
using namespace std;
typedef long long ll;

bool check(ll mask, ll n, ll k, ll p) {
	ll cnt = 0;
	ll all_cnt = ((ll)(1) << k);
	for (ll i = 0; i < all_cnt; ++i) {
		if ((mask >> i) & 1) cnt++;
	}
	if (cnt != n || !(mask & 1)) return false;
	vector<ll> a;
	for (ll i = 0; i < all_cnt; ++i) {
		if ((mask >> i) & 1)
			a.push_back(i);
	}
	ll prev_mex = -1;
	ll prev_cnt = 0;
	for (ll i = 0; ; ++i) {
		if (i > p + 31) return false;
		unordered_set<ll> used;
		sort(a.begin(), a.end());
		ll mex = all_cnt;
		for (int i = 1; i < n; ++i) {
			if (a[i] - a[i - 1] > 1) {
				mex = a[i - 1] + 1;
				break;
			}
		}
		if (mex == prev_mex) {
			prev_cnt++;
			if (prev_cnt >= 30) {
				return (mex == p);
			}
		}
		else {
			prev_mex = mex;
			prev_cnt = 1;
		}
		for (ll i = 0; i < n; ++i)
			a[i] = (a[i] ^ (mex - 1));
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	ll M; cin >> M;
	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		ll k, n, p;
		cin >> k >> n >> p;
		ll ans = 0;
		ll cnt = ((ll)(1) << k);
		for (ll mask = 0; mask < ((ll)(1) << cnt); ++mask) {
			if (check(mask, n, k, p))
				ans = (ans + 1) % M;
		}
		//cout << "    " << mask << "\n";
		cout << ans << "\n";
	}

	return 0;
}