#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i)
		cin >> w[i];
	vector<vector<vector<bool>>> dp(301, vector<vector<bool>>(301, vector<bool>(n + 1, false)));
	for (int i = 0; i <= n; ++i) {
		dp[0][0][i] = true;
	}
	for (int a = 0; a <= 300; ++a) {
		for (int b = 0; b <= 300; ++b) {
			for (int i = 1; i <= n; ++i) {
				dp[a][b][i] = (dp[a][b][i] | dp[a][b][i - 1]);
				if (a >= w[i - 1]) dp[a][b][i] = (dp[a][b][i] | dp[a - w[i - 1]][b][i - 1]);
				if (b >= w[i - 1]) dp[a][b][i] = (dp[a][b][i] | dp[a][b - w[i - 1]][i - 1]);
			}
		}
	}
	ll z; cin >> z; 
	ll v = 0;
	for (int _ = 0; _ < q; ++_) {
		ll k, a, b;
		cin >> k >> a >> b;
		bool flag = true;
		for (int i = 0; i <= a; ++i) {
			for (int j = 0; j <= b; ++j) {
				if (!dp[i][j][n]) {
					flag = false;
				}
			}
		}
		if (flag)
			cout << "Yes\n";
		else
			cout << "No\n";
	}

	return 0;
}