#include <iostream>
#include <deque>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

ll inf = 1e9;

#define mod(a, m) ((a%m)+m)%m

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll h, w, k, hs, vs;
	cin >> h >> w >> k;
	deque<ll> hor(k), ver(k);
	for (int i = 0; i < k; i++)
	{
		cin >> ver[i] >> hor[i];
		hor[i]--;
		ver[i]--;
	}
	sort(hor.begin(), hor.end());
	sort(ver.begin(), ver.end());
	hs = hor[0];
	vs = ver[0];
	ll mini = inf, cur = 0, min1 = inf, s = 1, cnt = 0;
	if (k == 1)
	{
		cout << "1 0" << endl;
		return 0;
	}
	if (hor[0] != hor[k - 1])
	{
		for (int i = 0; i < k + 2 && (hs != hor[0] || i == 0); i++)
		{
			ll x1 = (hor[0] + cur) % w, xk = (hor[k - 1] + cur) % w;
			if (abs(xk - x1) < min1)
			{
				min1 = abs(xk - x1);
				mini = min((ll)i, abs(k - i));
			}
			else if (abs(xk - x1) == min1 && min((ll)i, abs(k - i)) < mini)
			{
				mini = min((ll)i, abs(k - i));
			}
			cur += w - xk;
			hor.push_front(hor[k - 1]);
			hor.pop_back();
			while (hor[0] == hor[k - 1])
			{
				hor.push_front(hor[k - 1]);
				hor.pop_back();
			}
		}

		cnt += mini;
		s *= (min1 + 1);
		cur = 0;
		min1 = inf;
		mini = inf;
	}
	if (ver[k - 1] != ver[0])
	{
		for (int i = 0; i < k + 2 && (vs != ver[0] || i == 0); i++)
		{
			ll x1 = (ver[0] + cur) % h, xk = (ver[k - 1] + cur) % h;
			if (abs(xk - x1) < min1)
			{
				min1 = abs(xk - x1);
				mini = min((ll)i, abs(k - i));
			}
			else if (abs(xk - x1) == min1 && min((ll)i, abs(k - i)) < mini)
			{
				mini = min((ll)i, abs(k - i));
			}
			cur += h - xk;
			ver.push_front(ver[k - 1]);
			ver.pop_back();
			while (ver[0] == ver[k - 1])
			{
				ver.push_front(ver[k - 1]);
				ver.pop_back();
			}
		}
		s *= (min1 + 1);
		cnt += mini;
	}
	cout << s << " " << cnt;
}


