#pragma GCC optimize("O3")
#include<bits/stdc++.h>
using namespace std;

#define int long long
typedef long long ll; typedef long double ld;
typedef vector<int> vi; typedef pair<int, int> pii;

const int MAXN = 200000;

vi g[MAXN];
int l[MAXN], r[MAXN];
int dp[MAXN][2];
void dfs(int v, int p){
    dp[v][0] = 0;
    dp[v][1] = l[v];
    for(int i : g[v]){
        if(i == p)continue;
        dfs(i, v);
        dp[v][0] += max(dp[i][0], dp[i][1]);
        dp[v][1] += dp[i][0];
    }
}

void run_case(){
    int n, qq;cin >> n >> qq;
    for(int i = 0; i < n; i++)g[i].clear();
    int x, y, m;cin >> x >> y >> m;
    for(int i = 0; i <n-1; i++){
        int v1, v2;
        cin >> v1 >> v2;
        v1--;v2--;
        g[v1].push_back(v2);
        g[v2].push_back(v1);
    }
    int S = 0;
    for(int i = 1; i <= n; i++){
        int c = l[i-1];
        int v = (x*i)%m;
        v += (((c*c)%m) * y)%m;
        v %= m;
        S^=v; 
    }
    for(int i = 0; i < n; i++)cin >> l[i] >> r[i];
    dfs(0, -1);
    int ce = max(dp[0][0], dp[0][1]);
    vi ans(qq, -1);
    for(int i = 0; i < qq; i++){
        int c;cin >> c;
        if(c == ce){
            ans[i] = S;
        }
    }
    for(int i : ans)cout << i << ' ';
    cout << endl;
    int z;cin >> z;
    while(z != 0){
        int c = z-1;
        if(ans[c] == -1){
            cout << "-1" << endl;
        }else{
            for(int i = 0; i < n; i++)cout << l[i] << ' ';
            cout << endl;
        }
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    #ifdef PAFIMOV
    freopen("input", "r", stdin);
    // cin >> tt;
    #endif
    cin >> tt;
    while(tt--){
        run_case();
    }
}