#include "bits/stdc++.h"

using namespace std;
#define int long long

#define sz(a)(int)a.size()
#define all(a) a.begin(),a.end()
const int inf = 1e9;
struct info {
    int l, r, ind;
};
int L = 1;


int get(int x, int xl, int xr, int d, vector<int> &sg) {
    if (sg[x] < d)
        return -1;
    if (xl + 1 == xr)
        return x-L;
    int mid = (xl + xr) >> 1;
    if (sg[x * 2] >= d)
        return get(x * 2, xl, mid, d, sg);
    return get(x * 2 + 1, mid, xr, d, sg);
}

void solve() {
    int n;
    cin >> n;
    L = 1;
    while (L  < n)
        L *= 2;
    vector<int> sg(2 * L, -1);
    vector<info> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].l >> a[i].r;
        a[i].ind = i;
    }
    sort(all(a), [&](info u, info v) {
        if (u.r != v.r)
            return u.r < v.r;
        return u.l < v.l;
    });
    for (int i = 0; i < n; ++i)
        sg[i + L] = a[i].l;
    for (int i = L - 1; i > 0; --i)
        sg[i] = max(sg[i * 2], sg[i * 2 + 1]);

    vector<int> t;
    int prev = 0;
    while (true) {
        int found = get(1, 0, L, prev + 1,sg);
        if (found != -1) {
            t.push_back(found);
            prev = a[found].r;
        } else
            break;
    }
    vector<int> LEFT;
    vector<int> RIGHT;
    for (int i = 0; i < n; ++i) {
        if (a[i].l >= a[t[sz(t) / 2 - 1]].r)
            LEFT.push_back(i);
        else
            RIGHT.push_back(i);
    }
    if (sz(LEFT) > sz(RIGHT))
        swap(LEFT, RIGHT);
    vector<int> mark(n);
    for (auto x: t)
        mark[x] = 2;
    for (auto x: LEFT)
        mark[x] = 1;
    int cnt = sz(LEFT);
    for (int i = 0; i < n; ++i)
        if (!mark[i] && cnt + 1 <= n / 2) {
            mark[i] = 1;
            cnt++;
        }
    vector<int> ans;
    for (int i = 0; i < n; ++i)
        if (!mark[i] || mark[i] == 2)
            ans.push_back(a[i].ind);
    sort(all(ans));
    for (auto x: ans)
        cout << x + 1 << " ";
    cout << "\n";
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
