#include <bits/stdc++.h>

using namespace std;

void solvefirst() {
	int n, k;
	cin >> n >> k;
	vector<int> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
		--a[i];
	}
	vector<int> b;
	int cnt = 0;
	for (int i = 0; i < k; ++i) {
		++cnt;
		int p = a[i] + 1;
		while (cnt > 0 && p != a[(i + 1) % k]) {
			--cnt;
			b.push_back(p);
			++p;
			p %= n;
		}
	}
	sort(b.begin(), b.end());
	for (int i = 0; i < k; ++i) {
		cout << b[i] + 1 << " ";
	}
	cout << "\n";
}

void solvesecond() {
	int n, k;
	cin >> n >> k;
	vector<int> b(k);
	for (int i = 0; i < k; ++i) {
		cin >> b[i];
		--b[i];
	}
	set<int> bst;
	for (int i = 0; i < k; ++i) {
		bst.insert(b[i]);
	}
	int mn = k;
	for (int i = 0; i < k; ++i) {
		int prv = (b[i] - 1 + n) % n;
		if (!bst.count(prv)) {
			mn = min(mn, i);
		}
	}
	rotate(b.begin(), b.begin() + mn, b.end());
	set<int> used;
	for (int i = 0; i < k; ++i) {
		used.insert(b[i]);
	}
	vector<int> a;
	vector<int> st;
	for (int i = 0; i < k; ++i) {
		st.push_back((b[i] - 1 + n) % n);
		while (used.count(st.back())) {
			st.pop_back();
		}
		a.push_back(st.back());
		st.back() = (st.back() - 1 + n) % n;
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < k; ++i) {
		cout << a[i] + 1 << " ";
	}
	cout << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int a, m;
	cin >> a >> m;
	while (m--) {
		if (a == 1) {
			solvefirst();
		} else {
			solvesecond();
		}
	}
	return 0;
}