#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 2e5 + 7;

int n, q;
vector<int> g[N];
ll X, Y, M;
ll V[N];
ll l[N], r[N];
vector<int> kek;
ll dp[N][2];

void dfs(int v, int p = -1) {
	dp[v][0] = 0;
	dp[v][1] = r[v];
	for (int u : g[v]) {
		if (u != p) {
			dfs(u, v);
			dp[v][0] += dp[u][1];
			dp[v][1] += dp[u][0];
		}
	}
	dp[v][1] = max(dp[v][1], dp[v][0]);
}
	
void dfs1(int v, int f, int p = -1) {
	if (f == 0 || dp[v][0] == dp[v][1]) {
		for (int u : g[v]) {
			if (u != p) {
				dfs1(u, 1, v);
			}
		}
	} else {
		kek.push_back(v);
		for (int u : g[v]) {
			if (u != p) {
				dfs1(u, 0, v);
			}
		}
	}
}

void solve() {
	cin >> n >> q;
	cin >> X >> Y >> M;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < n - 1; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}
	for (int i = 0; i < q; ++i) {
		cin >> V[i];
	}
	// dfs(0);
	// kek.clear();
	// dfs1(0, 1);
	ll suml = 0, sumr = 0;
	for (int i = 1; i < n; ++i) {
		suml += l[i];
		sumr += r[i];
	}
	vector<ll> k(q, -1);
	vector<ll> a(n);
	for (int i = 0; i < n; ++i) {
		a[i] = l[i];
	}
	auto get = [&](int v) {
		return (X * (v + 1) % M + Y * a[v] % M * a[v] % M) % M;
	};
	ll cert = 0;
	for (int i = 0; i < n; ++i) {
		cert ^= get(i);
	}
	vector<pair<ll, int>> vs;
	for (int i = 0; i < q; ++i) {
		if (V[i] >= max(l[0], suml)) {
			if (V[i] <= sumr) {	
				vs.push_back({V[i], i});
			} else if (V[i] <= r[0]) {
				cert ^= get(0);
				a[0] = V[i];
				cert ^= get(0);
				k[i] = cert;
				cert ^= get(0);
				a[0] = l[0];
				cert ^= get(0);
			}
		}
	}
	sort(vs.begin(), vs.end());
	ll cursum = 0;
	for (int i = 1; i < n; ++i) {
		cursum += a[i];
	}
	int ptr = 1;
	for (auto p : vs) {
		while (cursum < p.first) {
			while (a[ptr] == r[ptr]) {
				++ptr;
			}
			int v = ptr;
			ll mn = min(r[v] - a[v], p.first - cursum);
			cert ^= get(v);
			a[v] += mn;
			cert ^= get(v);
			cursum += mn;
		}
		k[p.second] = cert;
	}
	for (int i = 0; i < q; ++i) {
		cout << k[i] << " ";
	}
	cout << endl;
	while (true) {
		int id;
		cin >> id;
		if (id == 0) {
			break;
		}
		--id;
		if (k[id] == -1) {
			cout << -1 << endl;
			continue;
		}
		for (int i = 0; i < n; ++i) {
			a[i] = l[i];
		}
		if (V[id] <= sumr) {
			cursum = 0;
			for (int i = 1; i < n; ++i) {
				cursum += a[i];
			}
			int ptr = 1;
			for (auto p : vs) {
				while (cursum < p.first) {
					while (a[ptr] == r[ptr]) {
						++ptr;
					}
					int v = ptr;
					ll mn = min(r[v] - a[v], p.first - cursum);
					a[v] += mn;
					cursum += mn;
				}
				if (p.second == id) {
					break;
				}
			}
		} else {
			a[0] = V[id];
		}
		for (int i = 0; i < n; ++i) {
			cout << a[i] << " ";
		}
		cout << endl;
	}
}	

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}