#include <bits/stdc++.h>
  
using namespace std;
 
void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        p[i]--;
    }
    vector<int> up(n + 1, n);
    up[0] = -1;
    vector<int> prv(n, -1);
    for (int i = 0; i < n; ++i) {
        int pos = lower_bound(up.begin(), up.end(), p[i]) - up.begin();
        up[pos] = p[i];
        if (pos != 0) {
            prv[p[i]] = up[pos - 1];
        }
    }
    int len = lower_bound(up.begin(), up.end(), n) - up.begin() - 1;
    vector<int> used(n);
    int nw = up[len];
    while (nw != -1) {
        used[nw] = 1;
        nw = prv[nw];
    }
    int ans = len;
    int mn = n;
    for (int i = 0; i < n; ++i) {
        if (!used[p[i]]) {
            if (mn > p[i]) {
                ans++;
                mn = p[i];
            }
        }
    }
    cout << ans << '\n';
}
  
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
