#include <bits/stdc++.h>
 
using namespace std;

int get_mex(vector<int> vals) {
    sort(vals.begin(), vals.end());
    for (int i = 1; i < (int)vals.size(); ++i) {
        if (vals[i] != vals[i - 1] + 1) {
            return vals[i - 1] + 1;
        }
    }
    return vals.back() + 1;
}

void dfs(int k, int mask, vector<int> &used) {
    if (used[mask] != -1) {
        return;
    }
    used[mask] = 0;
    vector<int> vals;
    for (int i = 0; i < k; ++i) {
        if (mask & (1 << i)) {
            vals.push_back(i);
        }
    }
    int mex = get_mex(vals);
    vector<int> vals_nw;
    int mask_nw = 0;
    for (auto vl : vals) {
        vals_nw.push_back(vl ^ (mex - 1));
        mask_nw |= (1 << (vl ^ (mex - 1)));
    }
    if (mex == get_mex(vals_nw))  {
        used[mask] = used[mask_nw] = mex;
        return;
    }
    dfs(k, mask_nw, used);
    used[mask] = used[mask_nw];
}

void solve(int mod) {
    int k, n, p;
    cin >> k >> n >> p;
    vector<int> used(1 << (1 << k), -1);
    int ans = 0;
    for (int mask = 0; mask < (1 << (1 << k)); ++mask) {
        int cnt = 0;
        for (int i = 0; i < (1 << k); ++i) {
            if (mask & (1 << i)) {
                cnt++;
            }
        }
        if (cnt == n && (mask & 1)) {
            dfs(1 << k, mask, used);
            if (used[mask] == p) {
                ans++;
            }
        }
    }
    cout << ans << '\n';
}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int mod;
    cin >> mod;
    int t = 1;
    cin >> t;
    while (t--) {
        solve(mod);
    }
    return 0;
}
