#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;

vector<vector<vector<int>>> gnd;

void gen(vector<vector<int>>& v, vector<vector<int>>& r, int i) {
	if (i == v.size()) {
		gnd.push_back(r);
	}
	else {
		if ((int)v.size() - i > (int)v.size() / 2 - r.size()) {
			gen(v, r, i + 1);
		}
		r.push_back(v[i]);
		gen(v, r, i + 1);
		r.pop_back();
	}
}

int f(vector<vector<int>>& v) {
	int res = 1;
	int l = 0, r = 1;
	while (r < v.size()) {
		if (v[r][1] >= v[l][0]) {
			l = r;
			++res;
		}
		++r;
	}
	return res;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<vector<int>> v;
		for (int i = 0; i < n; ++i) {
			int l, r;
			cin >> l >> r;
			v.push_back({r, l, i});
		}
		sort(v.begin(), v.end());
		vector<vector<int>> r;
		gen(v, r, 0);
		int m = f(v);
		for (int i = 0; i < gnd.size(); ++i) {
			if (f(gnd[i]) == m / 2) {
				for (int j = 0; j < n / 2; ++j) {
					cout << gnd[i][j][2] + 1 << ' ';
				}
				cout << '\n';
				break;
			}
		}
	}
	return 0;
}
