#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve(){
    int n, k, q;
    cin >> n >> k >> q;

    vector < pair <int, int> > a(n, {-1, -1});
    for(int i = 0; i < n; ++i){
        int t;
        cin >> t;

        if(t == 2){
            int x, y;
            cin >> x >> y;
            --x; --y;

            a[i] = {x, y};
        }
    }

    vector <int> dp(n);
    function <void(int, int, int)> dfs = [&](int v, int d, int f){
        if(a[v].first == -1){
            if(d <= k){
                dp[v] = 1;
            }
            return;
        }

        if(f == -1) {
            dfs(a[v].first, d, 0);
            dfs(a[v].second, d, 1);
        }else {
            if (f == 0) {
                dfs(a[v].first, d, 0);
                dfs(a[v].second, d + 1, 1);
            } else {
                dfs(a[v].first, d + 1, 0);
                dfs(a[v].second, d, 1);
            }
        }

        dp[v] = dp[a[v].first] + dp[a[v].second];
    };

    dfs(0, 0, -1);

    while(q--){
        int x;
        cin >> x;
        --x;

        cout << dp[x] << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    //cin >> tests;
    while(tests--){
        solve();
    }
}
