#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()

typedef pair<int, int> pi;

const int INF = 1e18;

int a;

int get(int x, int n) {
    while (x > n)
        x -= n;
    while (x <= 0)
        x += n;
    return x;
}

void encode(int n, int k, vector<int> &v) {
    vector<int> g;
    set<int> s(v.begin(), v.end());
    for(int i = 1; i <= n; i++) {
        if(!s.count(i))
            g.push_back(i);
    }

    for(auto el : g)
        cout << el << " ";
    cout << endl;
}

void decode(int n, int k, vector<int> &v) {
    vector<int> g;
    set<int> s(v.begin(), v.end());
    for(int i = 1; i <= n; i++) {
        if(!s.count(i))
            g.push_back(i);
    }

    for(auto el : g)
        cout << el << " ";
    cout << endl;
}

void solve() {
    if (a == 1) {
        int n, k;
        cin >> n >> k;
        vector<int> v(k);
        for (auto &el: v)
            cin >> el;
        encode(n, k, v);
    } else {
        int n, k;
        cin >> n >> k;
        vector<int> v(k);
        for (auto &el: v)
            cin >> el;
        decode(n, k, v);
    }
}

signed main() {
// ios_base::sync_with_stdio(false);
// cin.tie(nullptr);
// cout.tie(nullptr);

    cin >> a;

    int t;
    cin >> t;
// t = 1;

    while (t--)
        solve();
}