#include <iostream>
#include <vector>
#include <random>
#include <chrono>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;

ll INF = 2e18, L_INF = 2e9, mod = 1e9+7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define all(x) x.begin(), x.end()
#define forall(aaa, aaaa) for(auto& aaa: aaaa)

void print(vector < vector < ll >>& a) {
    forall(i, a) {
        forall(j, i) cout << max(j, -1ll) << '\t';
        cout << '\n';
    }
    cout << "-----------";
    cout << endl;
}

void solve() {
    ll n;
    cin >> n;
    vector < ll > a(n);
    forall(i, a) cin >> i;
    vector < vector < vector < ll >>> dp(n, vector < vector < ll >> (n + 1, vector < ll > (n + 1, -INF)));
//    dp[0][a[0]][a[0]] = 1;
    for (ll i = 1; i <= n; i++) dp[0][a[0]][i] = 1;
    for (ll i = 1; i <= n; i++) dp[0][i][a[0]] = 1;
    ll ans = 0;
//    print(dp[0]);
    for (ll i = 0; i < n - 1; i++) {
        for (ll mx = 1; mx <= n; mx++) {
            for (ll mn = 1; mn <= n; mn++)  {
                if (a[i + 1] > mx) dp[i + 1][a[i + 1]][mn] = max(dp[i + 1][a[i + 1]][mn], dp[i][mx][mn] + 1);
                else dp[i + 1][mx][mn] = max(dp[i + 1][mx][mn], dp[i][mx][mn]);

                if (a[i + 1] < mn) dp[i + 1][mx][a[i + 1]] = max(dp[i + 1][mx][a[i + 1]], dp[i][mx][mn] + 1);
                else dp[i + 1][mx][mn] = max(dp[i + 1][mx][mn], dp[i][mx][mn]);
            }
        }
//        print(dp[i + 1]);
    }

    for (ll i = 1; i <= n; i++) for (ll j = 1; j <= n; j++) ans = max(ans, dp[n - 1][i][j]);
    cout << ans << '\n';
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1, k;
//    cin >> k;
    cin >> T;
    while (T--) {
//        if (k == 1) solve1();
//        else solve2();
        solve();
    }
    return 0;
}
