#include <bits/stdc++.h>

using namespace std;

const int N = 15;

int n, q;
long long x, y, m;
int l[N], r[N], dp[N][2];
vector<int> g[N];
vector<long long> a;

void dfs(int v, int p) {
    dp[v][0] = dp[v][1] = 0;
    for (auto u: g[v]) {
        if (u != p) {
            dfs(u, v);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += dp[u][0];
        }
    }
    dp[v][1] += a[v];
}


pair<int, long long> find() {
    dfs(0, -1);
    long long res = (((x * 1) % m + ((y * a[0]) % m * a[0]) % m) % m) % m;
    for (int i = 1; i < n; i++)
        res = (res ^ (((x * (i + 1)) % m + ((y * a[i]) % m * a[i]) % m) % m));
    return {max(dp[0][0], dp[0][1]), res};
}

int mp[301], cnt = 0;
bool used[301];
vector<long long> ans[301];

void rec(int v){
    if(cnt == q)
        return;
    if(v >= n){
        int xx = find().first, yy = find().second;
        if(xx > 300)
            return;
        if(!used[xx])
            return;
        cnt++;
        mp[xx] = yy;
        ans[xx] = a;
        return;
    }
    for(int cur = l[v]; cur <= r[v]; cur++){
        a[v] = cur;
        rec(v + 1);
    }
}

void sol() {
    cnt = 0;
    cin >> n >> q;
    cin >> x >> y >> m;
    fill(mp, mp + 10 * n + 1, -1);
    fill(used, used + 10 * n + 1, false);
    a.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].emplace_back(v - 1);
        g[v - 1].emplace_back(u - 1);
    }
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];
    int qr[q];
    for (int i = 0; i < q; i++) {
        cin >> qr[i];
        used[qr[i]] = true;
    }
    rec(0);
    for (int i = 0; i < q; i++) {
        if(mp[qr[i]] != -1)
            cout << mp[qr[i]] << " ";
        else
            cout << "-1 ";
    }
    cout << endl;
    int i;
    while (true) {
        cin >> i;
        if (i == 0)
            break;
        if(mp[qr[i - 1]] != -1){
            a = ans[qr[i - 1]];
            for (int ii = 0; ii < n; ii++)
                cout << a[ii] << " ";
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
    for (i = 0; i < n; i++)
        g[i].clear(), dp[i][0] = dp[i][1] = 0;
    a.clear();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--)
        sol();
    return 0;
}