#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

const ll N = 100'005;

using bs = bitset<N>;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    ll sum = 0;
    bs ra, rb;
    ra[0] = 1;
    rb[0] = 1;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        ra |= (ra << w[i]);
        sum += w[i];
    }
    int z;
    cin >> z;

//    vector<int> prefa(N, 0);
//    prefa[0] = 1;
//    for (int i = 1; i < N; ++i) {
//        prefa[i] = prefa[i - 1] + (ra[i] == 1);
//        if (ra[i] == 1) {
//            rb[sum - i] = 1;
//        }
//    }
//
//    vector<int> prefb(N, 0);
//    prefb[0] = 1;
//    for (int i = 1; i < N; ++i) {
//        prefb[i] = prefb[i - 1] + (rb[i] == 1);
//    }
//
//    for (int qw = 0; qw < q; ++qw) {
//        ll k, a, b;
//        cin >> k >> a >> b;
//        bool ok = (prefa[a] == a + 1) && (prefb[b] == b + 1);
//        cout << (ok ? "Yes" : "No") << en;
//    }

    vector<vector<int>> dp(500, vector<int> (500, 0));
    vector<vector<int>> ndp(500, vector<int> (500, 0));
    dp[0][0] = 1;
    ndp[0][0] = 1;

    for (int i = 0; i < n; ++i) {
        ndp = dp;
        for (int a = 0; a < 400; ++a) {
            for (int b = 0; b < 400; ++b) {
                if (dp[a][b]) {
                    if (a + w[i] < 400) {
                        ndp[a + w[i]][b] = 1;
                    }
                    if (b + w[i] < 400) {
                        ndp[a][b + w[i]] = 1;
                    }
                }
            }
        }
        dp.swap(ndp);
    }

    for (int qw = 0; qw < q; ++qw) {
        ll k, a, b;
        cin >> k >> a >> b;
        int cnt = 0;
        for (int x = 0; x <= a; ++x) {
            for (int y = 0; y <= b; ++y) {
                cnt += dp[x][y];
            }
        }
        bool ok = (cnt == (a + 1) * (b + 1));
        cout << (ok ? "Yes" : "No") << en;
    }
}

int main() {
    int tests = 1;
#ifdef THEEVILBIRD
    freopen("input-c.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
