#include <iostream>
#include "vector"
#include "algorithm"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

struct seg {
    int l, r;
};

vector<seg> segs;

bool cmp(int i, int j) {
    if (segs[i].r == segs[j].r) {
        return segs[i].l > segs[j].l;
    }
    return segs[i].r < segs[j].r;
}

vector<vector<int>> pars;

bool cmp2(int i, int j) {
    return pars[i].size() > pars[j].size();
}

void solve() {
    segs.clear(); pars.clear();
    int n; cin >> n;
    segs.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> segs[i].l >> segs[i].r;
    }
    vector<int> order(n);
    for (int i = 0; i < n; ++i) {
        order[i] = i;
    }
    sort(all(order), cmp);
    int m = 0, last = -1;
    pars.resize(n);
    vector<int> now, took;
    for (auto i: order) {
        if (segs[i].l > last) {
            took.push_back(i);
            pars[i] = now;
            last = segs[i].r;
            m++;
        } else {
            now.push_back(i);
        }
    }
    sort(all(took), cmp2);
    vector<int> ans;
    for (int i = 0; i < m / 2; ++i) {
        ans.push_back(took[i]);
    }
    for (int i = 0; i < m / 2 and ans.size() < n / 2; ++i) {
        for (auto p: pars[took[i]]) {
            if (ans.size() == n / 2) break;
            ans.push_back(p);
        }
    }
    for (auto el: ans) {
        cout << el + 1 << " ";
    }
    cout << '\n';
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test; cin >> test;
    while (test--) {
        solve();
    }
}