//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define len(a) (ll) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 1e18;

ll C, n, m;
vector <ll> l, r, now;
vector <vector <pair <ll, ll>>> q;
vector <vector <ll>> g;

void solve() {
    cin >> n;
    l.clear(), r.clear(), now.clear();
    l.resize(n), r.resize(n);
    vector <ll> vals = {0};
    for (ll i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        vals.emplace_back(l[i]);
        vals.emplace_back(r[i]);
    }
    sort(all(vals));
    vals.resize(unique(all(vals)) - vals.begin());
    C = len(vals) + 1;
    q.resize(C);
    map <ll, pair <ll, ll>> index;
    for (ll i = 0; i < n; i++) {
        l[i] = lower_bound(all(vals), l[i]) - vals.begin();
        r[i] = lower_bound(all(vals), r[i]) - vals.begin();
        q[r[i]].emplace_back(l[i], i);
        index[i] = {l[i], r[i]};
    }
    vector <ll> dp(C), last(C, -1);
    for (ll i = 1; i < C; i++) {
        dp[i] = dp[i - 1];
        last[i] = last[i - 1];
        for (auto t : q[i]) {
            if (dp[i] <= dp[t.first - 1] + 1) {
                dp[i] = dp[t.first - 1] + 1;
                last[i] = t.second;
            }
        }
    }
    m = dp.back();
    ll u = C - 1;
    vector <ll> pretend;
    while (last[u] != -1) {
        pretend.emplace_back(last[u]);
        u = index[last[u]].first - 1;
    }
    g.resize(n);
    for (auto i : pretend) {
        auto [li, ri] = index[i];
        for (ll j = 0; j < n; j++) {
            auto [lj, rj] = index[j];
            if (min(ri, rj) > max(li, lj)) {
                g[i].emplace_back(j);
            }
        }
    }
    sort(all(pretend), [] (ll a, ll b) {
        return len(g[a]) > len(g[b]);
    });
    set <ll> ans;
    for (ll i = 0; i < m / 2; i++)
        ans.insert(pretend[i]);
    for (ll i = 0; i < m / 2 && len(ans) != n / 2; i++) {
        for (auto j : g[pretend[i]]) {
            ans.insert(j);
            if (len(ans) == n / 2)
                break;
        }
    }
    for (auto i : ans)
        cout << i + 1 << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}