//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define len(a) (ll) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 1e18;

vector <vector <ll>> g, dp;
vector <ll> w;

void dfs(ll v, ll p) {
    dp[v][1] += w[v];
    for (auto to : g[v]) {
        if (to != p) {
            dfs(to, v);
            dp[v][0] += max(dp[to][0], dp[to][1]);
            dp[v][1] += dp[to][0];
        }
    }
}

void solve() {
    g.clear(), w.clear(), dp.clear();
    ll n, q; cin >> n >> q;
    ll x, y, m; cin >> x >> y >> m;
    g.resize(n);
    for (ll i = 1; i < n; i++) {
        ll a, b; cin >> a >> b; a--, b--;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }
    w.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> w[i] >> w[i];
    }
    dp.resize(n, vector <ll> (2, 0));
    dfs(0, -1);
    ll good = max(dp[0][0], dp[0][1]);
    ll k = 0;
    for (ll i = 1; i <= n; i++)
        k ^= (x * i + y * w[i - 1] * w[i - 1]) % m;
    vector <ll> ans(q, -1);
    for (ll i = 0; i < q; i++) {
        ll v; cin >> v;
        if (v == good)
            ans[i] = k;
    }
    for (auto i : ans)
        cout << i << ' ';
    cout << endl;
    ll ind; cin >> ind;
    while (ind != 0) {
        if (ans[ind - 1] == -1) {
            cout << -1 << endl;
        } else {
            for (auto i : w)
                cout << i << ' ';
            cout << endl;
        }
        cin >> ind;
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
