#include <iostream>
#include <bits/stdc++.h>

#define int long long

using namespace std;

int get_ans(int pred, int x, int len)
{
    if(pred < 0 && x >= 0)
        return 0;
    return  min(pred + 1, len - x);
    
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int h, w, k;
    cin >> h >> w >> k;

    set < int > hor, ver;

    for(int i = 0; i < k; ++i)
    {
        int ri, ci;
        cin >> ri >> ci;
        --ri, --ci;

        ver.insert(ri);
        hor.insert(ci);
    }

    int hor_pred = *(--hor.end()) - w;
    int ver_pred = *(--ver.end()) - h;
    
    int min_w = 1e11;
    int min_h = 1e11;
    int min_ans = -1;
    int min_ans_ver = -1;
    
    for(int x : hor)
    {
        //cout << hor_pred << " " << x << endl;
        
        if(w - (x - hor_pred) + 1 < min_w)
        {
            min_w = w - (x - hor_pred) + 1;
            min_ans = get_ans(hor_pred, x, w);
            hor_pred = x;
            continue;
        }
        if(w - (x - hor_pred) + 1 == min_w)
        {
            min_ans = min(min_ans, get_ans(hor_pred, x, w));
        }
        hor_pred = x;
    }
    
    //cout << "_______Starting vertical computing______\n";

    for(int x : ver)
    {
        //cout << ver_pred << " " << x << endl;

        if(h - (x - ver_pred) + 1 < min_h)
        {
            min_h = h - (x - ver_pred) + 1;
            min_ans_ver = get_ans(ver_pred, x, h);
            ver_pred = x;
            continue;
        }
        if(h - (x - ver_pred) + 1 == min_h)
        {
            min_ans_ver = min(min_ans_ver, get_ans(ver_pred, x, h));
        }
        ver_pred = x;
    }

    cout << min_w * min_h << " " << min_ans + min_ans_ver;
    return 0;
}
