#include <iostream>
#include <bits/stdc++.h>

#define int long long

using namespace std;

int n;
bool is_in_mid(int pred_x, int x, int pred_iter, int type)
{
    if(x < pred_x)
    {
        x += n;
    }
    if(pred_iter < pred_x)
    {
        pred_iter += n;
    }
    if(type == 1)
        return x < pred_iter;
    else
        return x > pred_iter;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int type;
    cin >> type;
    //a = 3;

    int m;
    cin >> m;


    if(type == 1)
    {
        for(int ti = 0; ti < m; ++ti)
        {
            int  k;
            cin >> n >> k;
            map <int, bool> used;
            vector <int> a(k);
            for(int i = 0; i < k; ++i)
            {
                cin >> a[i];
                --a[i];
                used[a[i]] = true;
            }
            vector <int> ans(k);
            int it_ans = 0;
            int pred_iter = -1;
            int pred_x = -1;
            for(int x : a)
            {
                int iter = x;
                if(pred_iter != -1 && is_in_mid(pred_x, x, pred_iter, type))
                    iter = pred_iter;
                while(used[iter]) {
                    iter++;
                    if(iter == n)
                        iter = 0;
                }
                ans[it_ans] = iter;
                it_ans++;
                used[iter] = true;
                pred_iter = iter;
                pred_x = x;
            }
            sort(ans.begin(), ans.end());
            for(int x : ans)
                cout << x + 1 << " ";
            cout << endl;
        }

        cout << endl;
        return 0;
    }

    if(type == 2)
    {

        for(int ti = 0; ti < m; ++ti)
        {
            int n, k;
            cin >> n >> k;
            map <int, bool> used;
            vector <int> a(k);
            for(int i = 0; i < k; ++i)
            {
                cin >> a[i];
                --a[i];
                used[a[i]] = true;
            }
            set <int> ans;
            int pred_x = -1;
            int pred_iter = -1;

            for(int x : a)
            {
                int iter = x;
                if(pred_iter != -1 && is_in_mid(pred_x, x, pred_iter, type))
                    iter = pred_iter;

                while(used[iter]) {
                    iter--;
                    if(iter == -1)
                        iter = n - 1;
                }
                ans.insert(iter);
                used[iter] = true;
                pred_iter = iter;
                pred_x = x;
            }
            for(int x : ans)
                cout << x + 1 << " ";
            cout << endl;
        }

        cout << endl;
        return 0;
    }

    if(type == 3)
    {
        int n, k;
        cin >> n >>  k;
        vector <int> a(k);
        for(int i = 0; i < k; ++i)
            cin >> a[i];

        for(int i = 1; i <= k; ++i)
        {
            for(int j = 0; j < k; ++j)
            {
                a[j] ^= i;
                cout << a[j] << " ";
            }
            cout << endl;
        }


        return 0;
    }

}
