#include <bits/stdc++.h>

using namespace std;
typedef pair<int, int> pp;

struct Seg {
    int l, r, id;
};

bool cmp1(Seg a, Seg b) {
    if (a.r == b.r) {
        return a.l > b.l;
    }
    return a.r < b.r;
}

int max_chain_lg(vector<Seg> a) {
    sort(a.begin(), a.end(), cmp1);
    int r = -1, cnt = 0;
    for (int i = 0; i < a.size(); i++) {
        if (a[i].l > r) {
            r = a[i].r;
            cnt++;
        }
    }
    return cnt;
}

bool cmp2(Seg a, Seg b) {
    return make_pair(a.l, a.r) < make_pair(b.l, b.r);
}

void solve() {
    int n;
    cin >> n;
    vector<Seg> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].l >> arr[i].r;
        arr[i].id = i;
    }
    sort(arr.begin(), arr.end(), cmp2);
    int wish = max_chain_lg(arr) / 2;
    if (max_chain_lg(arr) % 2 == 1) {
        cout << 'x';
        return;
    }
    //cout << max_chain_lg(arr) << '\n';
    while (true) {
        if (max_chain_lg(arr) == wish) {
            break;
        }
        vector<Seg> x = arr, y = arr;

        sort(y.begin(), y.end(), cmp2);//erase from end
        sort(x.begin(), x.end(), cmp1);//erase from beginning
        y.pop_back();
        x.erase(x.begin());

        int v1 = max_chain_lg(x), v2 = max_chain_lg(y);
        if (v1 < v2) {
            arr = x;
        } else {
            arr = y;
        }
        /*
        x.erase(x.begin());
        y.pop_back();
        int v1 = max_chain_lg(x), v2 = max_chain_lg(y);
        if (v1 < v2) {
            arr = x;
        } else {
            arr = y;
        }*/
    }

    while (max_chain_lg(arr) > wish) {
        arr.pop_back();
    }

    sort(arr.begin(), arr.end(), cmp1);
    int r = -1;
    set<int> taken;
    vector<int> ans;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i].l > r) {
            r = arr[i].r;
            taken.insert(arr[i].id);
        }
    }
    int left_to_delete = (int) arr.size() - (n / 2);
    if (left_to_delete < 0) {
        cout << '!';
        return;
    }
    for (auto el: arr) {
        if (taken.find(el.id) != taken.end()) {
            ans.push_back(el.id);
        } else {
            if (left_to_delete > 0) {
                left_to_delete--;
            } else {
                ans.push_back(el.id);
            }
        }
    }
    for (int el: ans) {
        cout << el + 1 << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> q;
    while (q--) {
        solve();
    }
    return 0;
}
