#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
using ll = long long;

ostream& operator<<(ostream& out, const vector<int>& v) {
	for (int x : v) out << x << " ";
	return out;
}

struct t {

	t() {}
	t(int l, int r, int i) : l(l), r(r), i(i) {}

	int l, r, i;

};

int cnt(vector<pair<int, int>> v) {
	sort(all(v), [](pair<int, int> a, pair<int, int> b) {
		return a.second < b.second;
	});
	int ans = 0, r = -1e9;
	for (int i = 0; i < v.size(); i++) {
		if (v[i].first > r) {
			ans++;
			r = v[i].second;
		}
	}
	return ans;
}

// forest
void solve() {
	int n;
	cin >> n;
	vector<t> V(n);
	for (int i = 0; i < n; i++) {
		cin >> V[i].l >> V[i].r;
		V[i].i = i;
	}

	for (int i = 0; i < n / 2; i++) cout << i + 1 << " ";
	cout << "\n";

}

//1
//6
//0 10
//0 5
//0 4
//0 3
//0 2
//6 10

int main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	int T;
	cin >> T;
	while (T--) solve();

}
