#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>
#include <string>
#include <map>
#include <unordered_map>
#include <fstream>
#include <bitset>

using namespace std;

typedef long long ll;


//umap optimizer
//#include <ext/pb_ds/assoc_container.cpp>
//using namespace __gnu_pbds;
//unordered_map gp_hash_table

const ll bssize = 310;

int main() {
	ll n, q; cin >> n >> q;
	vector<ll> vec(n);
	for (ll i = 0; i < n; i++) cin >> vec[i];

	ll z; cin >> z;
	ll V = 0;
	ll num = 1;
	while (q--) {
		ll j, c, d; cin >> j >> c >> d;

		ll k = j - V * z;
		ll a = c - V * z;
		ll b = d - V * z;

		vector<bitset<bssize>> v(bssize);
		v[0][0] = true;

		for (auto p : vec) {
			if (p > k) continue;

			vector<bitset<bssize>> newv = v;

			for (ll i = 0; i < newv.size(); i++) {
				newv[i] |= v[i] << p;
				if (i - p >= 0) newv[i] |= v[i - p];
			}

			v = newv;
		}

		bool check = true;
		for (ll i = 0; i <= a; i++) {
			for (ll j = 0; j <= b; j++) {
				check &= v[i][j];
			}
		}

		if (check) {
			cout << "Yes" << endl;
			V += num;
		} else {
			cout << "No" << endl;
		}

		num++;
	}
}
