#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>
#include <string>
#include <map>
#include <unordered_map>
#include <fstream>
#include <bitset>

using namespace std;

typedef long long ll;

const ll INF = 1e18;


//umap optimizer
//#include <ext/pb_ds/assoc_container.cpp>
//using namespace __gnu_pbds;
//unordered_map gp_hash_table

vector<vector<ll>> vec;
vector<bool> used;

vector<ll> rs;

vector<ll> dp1; //Ответ для поддерева
vector<ll> dp2; //Ответ для поддерева если не брать данную

void dfs(ll i) {
	used[i] = true;
	ll d1 = rs[i], d2 = 0;
	for (auto p : vec[i]) {
		if (!used[p]) {
			dfs(p);
			d1 += dp2[p];
			d2 += dp1[p];
		}
	}
	d1 = max(d1, d2);
	dp1[i] = d1, dp2[i] = d2;
}

int main() {
	ll t; cin >> t;
	while (t--) {
		ll n, q; cin >> n >> q;
		vec.assign(n, vector<ll>(0));
		used.assign(n, false);
		dp1.assign(n, 0);
		dp2.assign(n, 0);
		rs.resize(n, 0);
		ll x, y, m; cin >> x >> y >> m;
		for (ll i = 0; i < n - 1; i++) {
			ll a, b; cin >> a >> b; a--; b--;
			vec[a].push_back(b);
			vec[b].push_back(a);
		}
		for (ll i = 0; i < n; i++) {
			ll a, b; cin >> a >> b;
			rs[i] = b;
		}
		dfs(0);
		ll best = dp1[0];
		ll ans = 0;
		for (ll i = 0; i < n; i++) {
			ll nxt11 = y * rs[i];
			nxt11 %= m;
			nxt11 *= rs[i];
			nxt11 %= m;
			nxt11 += x * (i + 1);
			nxt11 %= m;
			ans ^= nxt11;
		}
		vector<ll> qs;
		for (ll i = 0; i < q; i++) {
			ll v; cin >> v;
			qs.push_back(v);
			if (v == best) {
				cout << ans << " ";
			}
			else {
				cout << -1 << " ";
			}
		}
		cout << endl;
		while (true) {
			ll i; cin >> i;
			if (i == 0) break;
			ll v = qs[i - 1];
			if (v != best) {
				cout << -1 << endl;
			}
			else {
				for (ll j = 0; j < n; j++) {
					cout << rs[j] << " ";
				}
				cout << endl;
			}
		}
	}
}