#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int n, q;
    cin >> n >> q;

    vector<ll> w(n);
    rep(i, 0, n) cin >> w[i];

    vector<pair<ll, ll>> pairs;
    vi mask(n);
    while (!all_of(all(mask), [](int x) { return x == 2; })) {
        array<ll, 3> boxes{};
        rep(i, 0, n) {
            boxes[mask[i]] += w[i];
        }
        pairs.emplace_back(boxes[0], boxes[1]);
        mask[0] += 1;
        rep(i, 0, n - 1) {
            mask[i + 1] += mask[i] / 3;
            mask[i] %= 3;
        }
    }

    std::sort(pairs.begin(), pairs.end());
    pairs.erase(std::unique(pairs.begin(), pairs.end()), pairs.end());

    map<ll, ll> ans;
    for (auto [a, b]: pairs) {
        if (a == 0) {
            if (ans[a] == b - 1) {
                ans[a] = b;
            }
            continue;
        }
        if (!ans.count(a - 1)) {
            ans[a] = -1;
        } else {
            if (ans[a] == b - 1)
                ans[a] = min(b, ans[a - 1]);
        }
    }
    int z;
    cin >> z;

    while (q--) {
        ll k, a, b;
        cin >> k >> a >> b;

        cout << (ans.count(a) && ans[a] <= b? "Yes": "No") << '\n';
    }
}