#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define pb push_back
#define eb emplace_back

vector<pair<int, int>> g;
vector<int> dist;
vector<int> sz;
int n, k, q, t, l, r, u;
vector<int> e;
vector<int> pos;

void dfs(int v, int r) {
	pos[v] = e.size();
	e.pb(v);
	if (g[v].first != -1) {
		dist[g[v].first] = dist[v] + int(r == 1);
		dfs(g[v].first, 0);
		dist[g[v].second] = dist[v] + int(r == 0);
		dfs(g[v].second, 1);
		sz[v] = sz[g[v].first] + sz[g[v].second] + 1;
	}
	else {
		sz[v] = 1;
	}
}

vector<int> tr;

void build(int v, int l, int r) {
	if (l == r - 1) {
		if (g[e[l]].first == -1 && dist[e[l]] <= k) {
			tr[v] = 1;
		}
	}
	else {
		int m = (l + r) / 2;
		build(v * 2 + 1, l, m);
		build(v * 2 + 2, m, r);
		tr[v] = tr[v * 2 + 1] + tr[v * 2 + 2];
	}
}

int get(int v, int l, int r, int lq, int rq) {
	if (lq <= l && r <= rq) {
		return tr[v];
	}
	if (lq >= r || rq <= l) {
		return 0;
	}
	int m = (l + r) / 2;
	return get(v * 2 + 1, l, m, lq, rq) + get(v * 2 + 2, m, r, lq, rq);
}


void solve() {
	cin >> n >> k >> q;
	g.resize(n, { -1, -1 });
	dist.resize(n);
	sz.resize(n);
	pos.resize(n);
	tr.resize(n*4);
	for (int i = 0; i < n; i++) {
		cin >> t;
		if (t == 2) {
			cin >> l >> r;
			g[i] = { l - 1, r - 1 };
		}
	}
	dfs(0, -1);
	build(0, 0, n);
	for (int i = 0; i < q; i++) {
		cin >> u;
		u--;
		cout << get(0, 0, n, pos[u], pos[u] + sz[u]) << '\n';
	}
}

signed main() {
#ifdef LOCAL
	auto f1 = freopen("C:\\Users\\roi\\source\\repos\\input.txt", "r", stdin);
	auto f2 = freopen("C:\\Users\\roi\\source\\repos\\output.txt", "w", stdout);
#endif
	solve();
}