#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ff first
#define ss second
#define pb push_back

const int inf = 1e18;

void zz(vector<pair<int, int>> &a) {
    vector<int> c;
    for (auto i: a) c.pb(i.ff), c.pb(i.ss);
    sort(c.begin(), c.end());
    int cnt = 1;
    map<int, int> mp;
    for (auto i: c) {
        if (mp.find(i) == mp.end()) {
            mp[i] = cnt++;
        }
    }
    for (auto &i: a) i.ff = mp[i.ff], i.ss = mp[i.ss];
}

int get(vector<pair<int, int>> a) {
    int n = (int) a.size();
    int now = 0, last = 0;
    for (int i = 0; i < n; i++) if (a[i].ff > last) last = a[i].ss, now++;
    return now;
}

bool comp(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
    if (a.ff.ss < b.ff.ss) return true;
    if (a.ff.ss > b.ff.ss) return false;
    return a.ff.ff < b.ff.ff;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].ff.ff >> a[i].ff.ss, a[i].ss = i + 1;
    sort(a.begin(), a.end(), comp);
    vector<int> ind(n);
    vector<pair<int, int>> c(n);
    for (int i = 0; i < n; i++) {
        ind[i] = a[i].ss;
        c[i] = a[i].ff;
    }
    zz(c);
    int m = get(c) / 2;
    int b = c.back().ss;
    int dp[n + 1][m + 1][b + 1];
    int ok[n + 1][m + 1][b + 1];
    for (auto &i: dp) for (auto &j: i) for (auto &u: j) u = -inf;
    for (auto &i: ok) for (auto &j: i) for (auto &u: j) u = inf;
    dp[0][0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= m; j++) {
            for (int r = 0; r <= b; r++) {
                if (dp[i][j][r] > dp[i + 1][j][r]) {
                    dp[i + 1][j][r] = dp[i][j][r];
                }
                if (c[i].ff > r) {
                    if (j < m && dp[i][j][r] + 1 > dp[i + 1][j + 1][c[i].ss]) {
                        dp[i + 1][j + 1][c[i].ss] = dp[i][j][r] + 1;
                        ok[i + 1][j + 1][c[i].ss] = r;
                    }
                } else {
                    if (dp[i][j][r] + 1 > dp[i + 1][j][r]) {
                        dp[i + 1][j][r] = dp[i][j][r] + 1;
                    }
                }
            }
        }
    }
//    for (auto i :  c) cout << i.ff << ' ' << i.ss << '\n';
//    for (int i = 0; i <= n; i++) {
//        for (int j = 0; j <= m; j++) {
//            for (int z = 0; z <= 16; z++) cout << dp[i][j][z] << ' ';
//            cout << endl;
//        }
//        cout << endl << endl;
//    }
    int i = n, j = m, r;
    for (r = 0; r <= b; r++) {
        if (dp[i][j][r] >= n / 2) break;
    }
    vector<int> res;
    for (; i > 0; i--) {
        if (dp[i - 1][j][r] == dp[i][j][r]) i = i;
        else if (dp[i - 1][j][r] == dp[i][j][r] - 1) res.pb(i - 1);
        else {
            res.pb(i - 1);
            r = ok[i][j][r];
            j--;
        }
    }
    int y = res.size(), last = 0;
    vector<bool> cc(y);
    int now = 0;
    for (i = 0; i < y; i++) {
        if (c[res[i]].ff > last) {
            last = c[res[i]].ss;
            cc[i] = true;
            now++;
        }
    }
    for (i = 0; i < y && now < n / 2; i++) {
        if (!cc[i]) {
            now++, cc[i] = true;
        }
    }
//    for (auto i : ind) cout << i << ' '; cout << endl;
    for (i = 0; i < y; i++) {
        if (cc[i]) cout << ind[res[i]] << ' ';
    }
    cout << '\n';
}

signed main() {
#ifndef Bebra1488
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra1488
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int tests = 1;
    cin >> tests;
    while (tests--) solve();
}
