#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <unordered_map>
#include <fstream>
#include <chrono>
#include <algorithm>
#include <random>

using namespace std;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define int ll

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

int n, k, q;
vector <vector <int>> g;
vector <int> ans;

int dfs(int v, int used, int dir) {
    if (g[v].size() == 0 && used <= k) {
        ans[v] = 1;
        return 1;
    }
    if (used > k) {
        ans[v] = 0;
        return 0;
    }
    int res = 0;
    res += dfs(g[v][0], (dir == 2 ? used + 1 : used), 1);
    res += dfs(g[v][1], (dir == 1 ? used + 1 : used), 2);
    ans[v] = res;
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    cin >> n >> k >> q;
    g.resize(n);
    ans.assign(n, 0);
    int cnt, t1, t2;
    for (int i = 0 ; i < n; i++) {
        cin >> cnt;
        if (cnt == 2) {
            cin >> t1 >> t2;
            t1--;
            t2--;
            g[i].push_back(t1);
            g[i].push_back(t2);
        }
    }
    dfs(0, 0, 0);
    for (int i = 0 ; i < q; i++) {
        cin >> t1;
        t1--;
        cout << ans[t1] << "\n";
    }
}