#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <numeric>

using namespace std;

#define All(x) (x).begin(), (x).end()

vector<vector<int>> gr;
vector<int> turn, dp;

void dfs(int v, int dir = -1) {
	if (turn[v] < 0) return;
	if (gr[v].empty()) {
		dp[v] = 1;
		return;
	}
	turn[gr[v][0]] = turn[v];
	turn[gr[v][1]] = turn[v];
	if (dir > -1)
		turn[gr[v][dir ^ 1]]--;
	dfs(gr[v][0], 0);
	dfs(gr[v][1], 1);
	dp[v] = dp[gr[v][0]] + dp[gr[v][1]];
}

signed main()
{
	int n, k, q, t, l, r, v;
	cin >> n >> k >> q;
	
	gr.resize(n);
	dp.resize(n, 0);
	turn.resize(n);

	for (int v = 0; v < n; v++) {
		cin >> t;
		if (t > 0) {
			cin >> l >> r;
			l--, r--;
			gr[v] = { l, r };
		}
	}
	turn[0] = k;
	dfs(0);
	while (q--) {
		cin >> v;
		v--;
		cout << dp[v] << '\n';
	}
}