#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace __gnu_pbds;
using namespace std;
//#define int long long
#define all(x) (x).begin(), x.end()
//#define indexed_set tree<pair<int, int>, null_type,
int m;
int n;
vector<pair<int, int>> v;
int getm(vector<int> vp) {
    auto& cv = v;
    int mx = 0;
    sort(all(vp), [&cv](auto a, auto b){
        if (cv[a].first != cv[b].first) return cv[a].first < cv[b].first;
        return cv[a].second < cv[b].second;
    });
    set<pair<int, int>> s;
    int res = 0;
    for (auto i : vp) {
        int l = v[i].first, r = v[i].second;
        while (!s.empty() && s.begin()->first < l) {
            mx = max(mx, s.begin()->second);
            s.erase(s.begin());
        }
        res = max(res, mx + 1);
        s.insert({r, mx + 1});
    }
    return res;
}
uniform_real_distribution<long double> r;
mt19937 mt;
long double getrand() {
    return r(mt);
}
int f(vector<int>& vp) {
    return abs(getm(vp) - m);
}

void solve() {
    cin >> n;

    v.clear();
    v.resize(n);
    for (auto& i : v) cin >> i.first >> i.second;
    int ans;
    vector<int> p1;
    for (int l = 0; l <= 30; ++l) {
        long double temp = 1000;
        p1.clear();
        for (int i = 0; i < n; ++i) p1.push_back(i);
        m = getm(p1) / 2;
        shuffle(all(p1), mt);
        vector<int> p2;
        while (p1.size() > n / 2) {
            p2.push_back(p1.back());
            p1.pop_back();
        }
        ans = f(p1);
        for (int k = 0; k <= 1000 && ans != 0; ++k) {
            temp *= 0.99;
            vector<int> cp1 = p1;
            int a = mt() % (n / 2), b = mt() % (n / 2);
            swap(cp1[a], p2[b]);
            int val = f(cp1);
            swap(cp1[a], p2[b]);
            if (val < ans || getrand() < exp(-abs(ans - val) * temp / k)) {
                ans = val;
                swap(p1[a], p2[b]);
            }
            if (ans == 0) break;
        }
        if (ans == 0) break;
    }
    if (ans != 0) exit(100);
    for (auto i : p1) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    cin.tie(0), ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) solve();
}