#include <vector>
#include <iostream>
#include <algorithm>
#include <chrono>
#include <deque>
#include <cmath>
#include <map>
#include <set>

using namespace std;
typedef long long ll;
#define cout_ cout << "-------------------------\n";

ll mod = 1000000007;

#pragma region prints
void print(vector<ll>& vec)
{
	for (int i = 0; i < vec.size(); i++)
		cout << vec[i] << " ";
	cout << endl;
}

void print(vector<pair<ll, ll>>& vec)
{
	for (int i = 0; i < vec.size(); i++)
	{
		cout << vec[i].first << " " << vec[i].second << endl;
	}
}
#pragma endregion


ll pow2(ll n, ll k)
{
	if (k == 0)
		return 1;
	if (k == 1)
		return n;
	if (k % 2 == 0)
	{
		ll a = pow2(n, k / 2);
		return a * a % mod;
	}
	else
		return pow2(n, k - 1) * n % mod;
}

struct L
{
	ll l, r;
	ll id;
};

bool comp(L& a, L& b)
{
	return a.r < b.r;
}


int main()
{
	ll q;
	cin >> q;
	while (q--)
	{
		ll n;
		cin >> n;
		vector<L> vec(n);
		for (int i = 0; i < n; i++)
		{
			cin >> vec[i].l >> vec[i].r;
			vec[i].id = i;
		}
		
		for (int i = 0; i < n / 2; i++)
			cout << i + 1 << " ";
		cout << endl;
		
	}
}
