#include <bits/stdc++.h>
#define ff first
#define ss second
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

const int N = 200010;
vector <int> g[N];
int le[N], ri[N], a[N], k;
int prf[N];
ll cnt[N];
ll dp0[N], dp1[N], dp0k[N], dp1k[N], cer[N];
pair <ll, int> qr[N];

void prep(int v, int r){
    if (r != -1) {
        int i = find(g[v].begin(), g[v].end(), r) - g[v].begin();
        swap(g[v][i], g[v].back());
        g[v].pop_back();
    }
    for (auto u : g[v]) prep(u, v);
}

void dfs(int v){
    dp0[v] = 0, dp1[v] = a[v];
    dp0k[v] = 0, dp1k[v] = a[v] * (v != k);
    int fl = 0;
    for (auto u : g[v]){
        fl |= u == k;
        dfs(u);
        dp1[v] += dp0[u];
        dp0[v] += max(dp0[u], dp1[u]);
        dp1k[v] += dp0k[u];
        dp0k[v] += (u == k ? dp1k[u] : max(dp0k[u], dp1k[u]));
    }
    if (fl) dp1k[v] = -inf;
}

void solve(){
    int n, q;
    ll x, y, m;
    cin >> n >> q >> x >> y >> m;
    for (int i = 0; i < n; i++) g[i].clear();
    for (int i = 0; i < n - 1; i++){
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    for (int i = 0; i < n; i++) cin >> le[i] >> ri[i], a[i] = le[i];
    for (int i = 0; i < q; i++) cin >> qr[i].ff, qr[i].ss = i, cer[i] = 0;
    sort(qr, qr + q);
    prep(0, -1);
    k = 0;
    dfs(0);
    int ind = 0;
    while (ind < q && qr[ind].ff < max(dp0[0], dp1[0])) cer[qr[ind++].ss] = -1;
    ll cer0 = 0;
    for (int i = 1; i < n; i++) cer0 ^= (x * (i + 1) + y * a[i] % m * a[i]) % m;
    while (ind < q && qr[ind].ff >= max(dp0[0], dp1[0]) && qr[ind].ff <= dp1k[0] + ri[0]) {
        int j = qr[ind].ss;
        prf[j] = 0;
        cnt[j] = qr[ind].ff - dp1k[0];
        cer[j] = cer0 ^ (x + y * cnt[j] % m * cnt[j]) % m;
        ind++;
    }
    a[0] = ri[0];
    cer0 ^= (x + y * a[0] % m * a[0]) % m;
    for (int i = 1; i < n; i++){
        k = i;
        dfs(0);
        cer0 ^= (x * (i + 1) + y * a[i] % m * a[i]) % m;
        while (ind < q && qr[ind].ff >= max(dp0[0], dp1[0]) && qr[ind].ff <= max(dp0k[0], dp1k[0]) + ri[i]) {
            int j = qr[ind].ss;
            prf[j] = i;
            cnt[j] = qr[ind].ff - max(dp0k[0], dp1k[0]);
            cer[j] = cer0 ^ (x * (i + 1) + y * cnt[j] % m * cnt[j]) % m;
            ind++;
        }
        a[i] = ri[i];
        cer0 ^= (x * (i + 1) + y * a[i] % m * a[i]) % m;
    }
    while (ind < q) cer[qr[ind++].ss] = -1;
    for (int i = 0; i < q; i++) cout << cer[i] << " ";
    cout << endl;
    int t;
    cin >> t;
    while (t != 0){
        t--;
        if (cer[t] == -1) cout << -1 << endl;
        else {
            for (int i = 0; i < prf[t]; i++) cout << ri[i] << " ";
            cout << cnt[t] << " ";
            for (int i = prf[t] + 1; i < n; i++) cout << le[i] << " ";
            cout << endl;
        }
        cin >> t;
    }
}

int32_t main(){
#ifdef LOCAL
    auto start = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int ttt = 1;
    cin >> ttt;
    while (ttt--) solve();
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - start) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}