#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define ff first
#define ss second
#define pb push_back
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

#define int long long
void solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("/home/roi/Desktop/kek/read.txt", "r", stdin);
#endif
    int tc = 1;
    // cin >> tc;
    forn(i, tc) {
        solve();
    }
    return 0;
}

vector<vector<int>> gr;
vector<int> val;
vector<bool> leaf;
vector<int> tin, tout;

struct bit {
    int n;
    vector<int> tr;
    bit(int _n) {
        n = _n;
        tr.resize(n);
    }

    void upd(int x) {
        for (; x < n; x |= (x + 1)) {
            tr[x]++;
        }
    }

    int get(int x) {
        int ans = 0;
        for (; x >= 0; x = (x & (x + 1)) - 1) {
            ans += tr[x];
        }
        return ans;
    }
};

void dfs(int v, int cur, int tp) {
    val.pb(cur);
    tin[v] = sz(val) - 1;
    if (gr[v].empty()) {
        leaf.pb(true);
    } else {
        leaf.pb(false);
        if (v != 0) {
            dfs(gr[v][0], cur + tp, 0);
            dfs(gr[v][1], cur + 1 - tp, 1);
        } else {
            dfs(gr[v][0], cur, 0);
            dfs(gr[v][1], cur, 1);
        }
    }
    tout[v] = sz(val) - 1;
}

void solve() {
    int n, k, q;
    cin >> n >> k >> q;
    gr.resize(n);
    forn(i, n) {
        int siz;
        cin >> siz;
        forn(j, siz) {
            int adj;
            cin >> adj;
            --adj;
            gr[i].pb(adj);
        }
    }
    tin.resize(n);
    tout.resize(n);
    dfs(0, 0, -1);
    bit tr(*max_element(all(val)));
    struct que {
        int id, tp;
    };
    vector<vector<que>> pref(n);
    vector<int> ans(q);
    forn(i, q) {
        int u;
        cin >> u;
        --u;
        if (tin[u] - 1 >= 0) {
            pref[tin[u]].pb({i, -1});
        }
        pref[tout[u]].pb({i, 1});
    }
    forn(i, n) {
        if (leaf[i]) {
            tr.upd(val[i]);
        }
        for (auto [ps, tp] : pref[i]) {
            ans[ps] += tp * tr.get(k);
        }
    }
    forn(i, q) cout << ans[i] << '\n';
}
