#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define INF 1e9


bool peresek(pair<int, int> a, pair<int, int> b)
{
	if (a.first > b.first)
	{
		swap(a, b);
	}
	if (b.first <= a.second)
	{
		return true;
	}
	else {
		return false;
	}
}


int main()
{

	int t;

	cin >> t;

	for (int q = 0; q < t; ++q)
	{
		int n, m;
		cin >> n;

		multiset<pair<int, pair<int, int>>> sob;
		multiset<pair<int, pair<int, int>>> st;

		vector<pair<int, int>> v;

		for (int i = 0; i < n; ++i)
		{
			int l, r;
			cin >> l >> r;
			v.push_back({ l, r });
			sob.insert({ r, {1, i} });
			sob.insert({ l, {0, i} });
			st.insert({ r, {l, i} });
		}

		vector<int> g;

		{
			map<int, int> mp;

			int ma = 0;

			for (auto i : sob)
			{
				if (i.second.first == 0)
				{
					mp[i.first] = ma;
				}
				else {
					if (mp[v[i.second.second].first] + 1 > ma)
					{
						ma = mp[v[i.second.second].first] + 1;
						g.push_back(i.second.second);
					}
				}

			}


			m = ma;
		}

		for (int j = 0; j < m/2; ++j)
		{
			vector<vector<int>> per(n);

			int cnt = 0;

			for (auto i : st)
			{
				int l = i.second.first;
				int r = i.first;

				while (l > v[g[cnt]].first)
				{
					cnt = min((int)g.size()-1, cnt + 1);
					if (cnt == g.size()-1)
					{
						break;
					}
				}

				int pp = 0;

				if (peresek({ l, r }, v[g[cnt]]))
				{
					++pp;
				}

				if (cnt != 0 && peresek({ l, r }, v[g[cnt - 1]]))
				{
					++pp;
				}

				if (pp == 1)
				{
					if (peresek({ l, r }, v[g[cnt]]))
					{
						per[g[cnt]].push_back(i.second.second);
					}
					else {
						per[g[cnt - 1]].push_back(i.second.second);
					}
				}

			}

			int num = -1;

			for (int i = 0; i < n; ++i)
			{
				if (per[i].size() == 0)
				{
					continue;
				}

				if (num == -1 || per[num].size() > per[i].size())
				{
					num = i;
				}
			}

			for (int i = 0; i < per[num].size(); ++i)
			{
				int ii = per[num][i];
				int l = v[ii].first;
				int r = v[ii].second;

				st.erase({ r, {l, ii} });
				sob.erase({ l, {0, ii} });
				sob.erase({ r, {1, ii} });
			}
			
			auto buf_g = g;
			g.clear();
			for (int i = 0; i < buf_g.size(); ++i)
			{
				if (buf_g[i] != num)
					g.push_back(buf_g[i]);
			}

		}


		{
			map<int, int> mp;

			int ma = 0;

			for (auto i : sob)
			{
				if (i.second.first == 0)
				{
					mp[i.first] = ma;
				}
				else {
					ma = max(ma, mp[v[i.second.second].first] + 1);
				}

			}

			if (ma > m / 2)
			{
				return 1;
			}

		}


		{
			vector<int> dl;
			map<int, int> mp;

			int ma = 0;

			for (auto i : sob)
			{
				if (i.second.first == 0)
				{
					mp[i.first] = ma;
				}
				else {
					if (mp[v[i.second.second].first] + 1 <= ma)
					{
						dl.push_back(i.second.second);
					}
					ma = max(ma, mp[v[i.second.second].first] + 1);
				}

			}

			for (int i = 0; i < dl.size(); ++i)
			{
				if (sob.size() <= n)
				{
					break;
				}
				sob.erase({ v[dl[i]].first, {0, dl[i]} });
				sob.erase({ v[dl[i]].second, {1, dl[i]} });
			}

		}


		vector<int> ans(n);

		if (sob.size() < n)
		{
			return 1;
		}

		for (auto i : sob)
		{
			ans[i.second.second] = 1;
		}

		for (int i = 0; i < n; ++i)
		{
			if (ans[i] == 1)
			{
				cout << i + 1 << " ";
			}
		}



		cout << '\n';




	}




}