#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()

int get(int x, int n) {
    x %= n;
    if (x == 0) x += n;
    return x;
}

int get_reverse(int x, int n) {
    if (x >= 0) x %= n;

    while (x <= 0) x += n;
    return x;
}

void vyvod(vector<int> a) {
    sort(all(a));

    for (auto i : a) cout << i << ' ';
    cout << endl;
}

int MOD;

int k, n, p;

vector<int> now = {0};

int ans = 0;

int get_mex() {
//    for (int i = 0; i < now.size(); ++i) {
//        if (now[i] != i) return i;
//    }
//    return (int)now.size();
    if (now.back() == now.size() - 1) return (int)now.size();

    int left = 0, right = (int)now.size() - 1;

    while (right - left > 1) {
        int mid = (left + right) / 2;

        if (now[mid] == mid) left = mid;
        else right = mid;
    }

    return right;
}

int get_ultra() {
    int m = get_mex();
    for (int i = 0; i < n; ++i) {
        now[i] ^= (m - 1);
    }

    sort(all(now));

    return m;
}

void check() {
    vector<int> iznach = now;
    map<int, int> cnt;
    vector<int> diff_m;

    while (true) {
        diff_m.push_back(get_ultra());
        cnt[diff_m.back()]++;

        if (cnt[diff_m.back()] == 2) break;
    }

    set<int> r;
    for (int i = 0; i < 1; ++i) {
        r.insert(get_ultra());
    }
    if (r.size() == 1 && *r.begin() == p) {
        ++ans;
//        for (auto i : iznach) cout << i << ' ';
//        cout << endl;
    }
    if (ans >= MOD) ans -= MOD;
}

void gen() {
    if (now.size() == n) {
        vector<int> iznach = now;
        check();
        swap(now, iznach);
        return;
    }

    for (int dop = now.back() + 1; dop <= (1LL << k) - (n - now.size()); ++dop) {
        now.push_back(dop);
        gen();
        now.pop_back();
    }
}

void solve() {
    cin >> k >> n >> p;

    gen();

    cout << ans << '\n';
    ans = 0;
}

signed main() {
    cin >> MOD;
    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}

/*
 * 1
12345
4 2
1 2
3 4

4 2
1 3
2 4

4 2
1 4
2 3

4 2
2 3
4 1

4 2
2 4
3 1

4 2
3 4
1 2

 */