#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double dl;

ll bi(vector <ll>& a)
{
	ll n = a.size(), ma = 0, ans = 0;
	for (auto i : a)
	{
		if (i > ma)
		{
			ans++;
			ma = i;
		}
	}
	return ans;
}
ll le(vector <ll>& a)
{
	ll n = a.size(), mi = 1e18, ans = 0;
	for (auto i : a)
	{
		if (i < mi)
		{
			ans++;
			mi = i;
		}
	}
	return ans;
}

ll ans = 0;
vector <ll> a = { 0 };
ll mex(vector <ll>& a)
{
	ll m = 0;
	for (auto i : a)
	{
		if (i == m - 1) continue;
		else if (i == m) m++;
		else return m;
	}
}
void f(ll n, ll k, ll p)
{
	if (a.size() == n)
	{
		vector <ll> k = a;
		ll last = -1;
		while (1)
		{
			ll m = mex(a);
			vector <ll> s;
			for (auto i : a) s.push_back(i ^ (m - 1));
			sort(s.begin(), s.end());
			if (m == last)
			{
				if (m == p) ans++;
				a = k;
				return;
			}
			a = s;
			last = m;
		}
	}
	for (ll i = a.back() + 1; (1ll << k) - i >= n - a.size(); i++)
	{
		a.push_back(i);
		f(n, k, p);
		a.pop_back();
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll mod, t;
	cin >> mod >> t;
	while (t--)
	{
		ans = 0;
		ll k, n, p;
		cin >> k >> n >> p;
		f(n, k, p);
		cout << ans << "\n";
	}

	/*
	ll t;
	cin >> t;
	while (t--)
	{
		ll n, ans = 0;
		cin >> n;
		vector <ll> a(n);
		for (ll i = 0; i < n; i++) cin >> a[i];
		for (ll i = 1; i < (1 << n) - 1; i++)
		{
			vector <ll> s, k;
			for (ll j = 0; j < n; j++)
			{
				if (i & (1 << j))
				{
					s.push_back(a[j]);
				}
				else
				{
					k.push_back(a[j]);
				}
			}
			ans = max(ans, bi(s) + le(k));
		}
		cout << ans << "\n";
    }
	*/

	/*
	vector <ll> dp(n, 1e18), p1(n, -1);
	ll a1 = 0;
	for (ll i = 0; i < n; i++)
	{
		ll in = lower_bound(dp.begin(), dp.end(), a[i]) - dp.begin();
		if (dp[in] == 1e18) a1++;
		dp[in] = a[i];
		if (in == a1 - 1) p1[a[i] - 1] = a1;
	}
	reverse(a.begin(), a.end());
	vector <ll> dpr(n, 1e18), p2(n, -1);
	ll a2 = 0;
	for (ll i = 0; i < n; i++)
	{
		ll in = lower_bound(dpr.begin(), dpr.end(), a[i]) - dpr.begin();
		if (dpr[in] == 1e18) a2++;
		dpr[in] = a[i];
		if (in == a2 - 1) p2[a[i] - 1] = a2;
	}
	//cout << a1 << " " << a2 << " - dl\n";
	reverse(a.begin(), a.end());
	vector <vector <ll>> s1(n);
	for (ll i = 0; i < n; i++)
	{
		if (p1[i] != -1) s1[p1[i] - 1].push_back(a[i]);
	}
	vector <bool> pol1(n);
	for (ll i = 0; i < n; i++)
	{
		if (s1[i].size() == 1) pol1[s1[i][0] - 1] = true;
	}
	reverse(a.begin(), a.end());
	vector <vector <ll>> s2(n);
	for (ll i = 0; i < n; i++)
	{
		if (p2[i] != -1) s2[p2[i] - 1].push_back(a[i]);
	}
	vector <bool> pol2(n);
	for (ll i = 0; i < n; i++)
	{
		if (s2[i].size() == 1) pol2[s2[i][0] - 1] = true;
	}
	bool g = true;
	for (ll i = 0; i < n; i++)
	{
		bool h = false;
		for (auto j : s1[i])
		{
			if (!pol2[j - 1]) h = true;
		}
		if (!h) g = false;
	}
	for (ll i = 0; i < n; i++)
	{
		bool h = false;
		for (auto j : s2[i])
		{
			if (!pol1[j - 1]) h = true;
		}
		if (!h) g = false;
	}
	if (g) cout << a1 + a2 << "\n";
	else cout << a1 + a2 - 1 << "\n";
	*/

	/*ll t;
	cin >> t;
	if (t == 1)
	{
		ll m;
		cin >> m;
		while (m--)
		{
			ll n, k;
			cin >> n >> k;
			vector <ll> a(k);
			for (ll i = 0; i < k; i++) cin >> a[i];
			if (k == n / 2 && n % 2 == 0)
			{
				vector <bool> used(n);
				for (ll i = 0; i < k; i++) used[a[i] - 1] = true;
				for (ll i = 0; i < n; i++)
				{
					if (!used[i]) cout << i + 1 << " ";
				}
				cout << "\n";
				continue;
			}
			map <ll, ll> mp;
			for (auto i : a) mp[i]++;
			for (ll i = 1; i < n; i++)
			{
				for (ll j = 0; j < k; j++)
				{
					if (a[j] == 1) a[j] = n;
					else a[j]--;
				}
				bool g = true;
				for (auto j : a)
				{
					if (mp.find(j) != mp.end())
					{
						g = false;
						break;
					}
				}
				if (g)
				{
					sort(a.begin(), a.end());
					for (auto i : a) cout << i << " ";
					cout << "\n";
					break;
				}
			}
		}
	}
	else
	{
		ll m;
		cin >> m;
		while (m--)
		{
			ll n, k;
			cin >> n >> k;
			vector <ll> a(k);
			for (ll i = 0; i < k; i++) cin >> a[i];
			if (k == n / 2 && n % 2 == 0)
			{
				vector <bool> used(n);
				for (ll i = 0; i < k; i++) used[a[i] - 1] = true;
				for (ll i = 0; i < n; i++)
				{
					if (!used[i]) cout << i + 1 << " ";
				}
				cout << "\n";
				continue;
			}
			map <ll, ll> mp;
			for (auto i : a) mp[i]++;
			for (ll i = 1; i < n; i++)
			{
				for (ll j = 0; j < k; j++)
				{
					if (a[j] == n) a[j] = 1;
					else a[j]++;
				}
				bool g = true;
				for (auto j : a)
				{
					if (mp.find(j) != mp.end())
					{
						g = false;
						break;
					}
				}
				if (g)
				{
					sort(a.begin(), a.end());
					for (auto i : a) cout << i << " ";
					cout << "\n";
					break;
				}
			}
		}
	}
	*/

	return 0;
}
/*

C

4
5
4 1 2 3 5
10
3 8 10 4 1 2 7 9 5 6
3
1 2 3
6
4 2 5 1 6 3


B

1
2
2 1
1
5 2
1 4

2
2
5 2
2 3
2 1
2


*/