#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

void dfs(const vector<pair<ll, ll>>& a, vector<ll>& dp, ll k, ll i, ll d) {
    if (k < 0) return;
    if (a[i].first == -1) {
        dp[i] = 1;
        return;
    } else {
        dfs(a, dp, k-(d == 1), a[i].first, -1);
        dfs(a, dp, k-(d == -1), a[i].second, 1);
        dp[i] = dp[a[i].first] + dp[a[i].second];
        return;
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    ll n, k, q;
    cin >> n >> k >> q;
    vector<pair<ll, ll>> a(n, {-1, -1});
    for (ll i = 0; i < n; i++) {
        ll t;
        cin >> t;
        if (t == 2) {
            cin >> a[i].first >> a[i].second;
            a[i].first--;
            a[i].second--;
        }
    }
    vector<ll> dp(n, 0);
    dfs(a, dp, k, 0, 0);
    while (q--) {
        ll u;
        cin >> u;
        u--;
        cout << dp[u] << '\n';
    }
    return 0;
}
