#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <math.h>

using namespace std;

#define int long long
#define endl '\n'
#define all(v) v.begin(), v.end()
using ll = long long;
using ld = long double;

mt19937 rnd(777);

const int N = 300 + 9;
const ll INF = 1e18 + 9;

int a[N];
int dp[2][N][N];
int ans[N][N];

struct Q {
	int a, b, k, ind;
};

bool operator <(Q a, Q b) {
	return a.k < b.k;
}

int ansq[N];

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	int n, m, z;
	cin >> n >> m;
	vector<int> val;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(a, a + n);
	cin >> z;
	vector<Q> q(m);
	for (int i = 0; i < m; i++) {
		cin >> q[i].k >> q[i].a >> q[i].b;
		q[i].ind = i;
		q[i].k = upper_bound(a, a + n, q[i].k) - a - 1;
	}
	sort(all(q));
	reverse(all(q));
	while (q.size() && q.back().k == -1)
		q.pop_back();
	dp[0][0][0] = 1;
	
	for (int t = 0; t < n; t++) {
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				dp[1][i][j] = dp[0][i][j];
				if (i >= a[t])
					dp[1][i][j] |= dp[0][i - a[t]][j];
				if (j >= a[t])
					dp[1][i][j] |= dp[0][i][j - a[t]];
			}
		}

		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				dp[0][i][j] = dp[1][i][j];
				if (!i && !j) {
					ans[i][j] = 1;
					continue;
				}
				if (i == 1)
					i = i;
				if (!j)
					ans[i][j] = ans[i - 1][j] && dp[0][i][j];
				else if(!i)
					ans[i][j] = ans[i][j - 1] && dp[0][i][j];
				else 
					ans[i][j] = ans[i - 1][j] && ans[i][j - 1] && dp[0][i][j];
			}
		}
		while (q.size() && q.back().k == t) {
			ansq[q.back().ind] = ans[q.back().a][q.back().b];
			q.pop_back();
		}
	}
	for (int i = 0; i < m; i++) {
		if (ansq[i])
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}