#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e18;

struct Nugget {
	ll r, c;
	Nugget () {}
};

void solve() {
	ll h, w, k;
	cin >> h >> w >> k;

	vector <ll> rows, columns;
	vector <Nugget> nuggets(k);
	for (auto &x: nuggets) {
		cin >> x.r >> x.c;
		rows.push_back(x.r);
		rows.push_back(max(x.r + 1, h));

		columns.push_back(x.c);
		columns.push_back(max(x.c + 1, w));
	}

	sort(rows.begin(), rows.end());
	sort(columns.begin(), columns.end());

	rows.resize(unique(rows.begin(), rows.end()) - rows.begin());
	columns.resize(unique(columns.begin(), columns.end()) - columns.begin());

	auto count_h = [&] (ll move_h) {
		ll min_r = h;
		for (auto &x: nuggets) {
			if (x.r >= move_h) {
				min_r = min(min_r, x.r);
			}
		}

		// cout << "minr " << min_r << '\n';
		ll ha = 1;
		for (auto &x: nuggets) {
			if (x.r < min_r) {
				ha = max(ha, h - min_r + x.r + 1);
			} else {
				ha = max(ha, x.r - min_r + 1);
			}
		}

		return ha;
	};

	auto count_w = [&] (ll move_w) {
		ll min_c = w;
		for (auto &x: nuggets) {
			if (x.c >= move_w) {
				min_c = min(min_c, x.c);
			}
		}

		ll wa = 1;
		for (auto &x: nuggets) {
			if (x.c < min_c) {
				wa = max(wa, w - min_c + x.c + 1);
			} else {
				wa = max(wa, x.c - min_c + 1);
			}
		}

		return wa;
	};

	ll ans_w = INF, ans_h = INF, ans_mh = INF, ans_mw = INF;
	for (ll move_h: rows) {	
		ll new_h = count_h(move_h);
		// cout << move_h << ' ' << new_h << '\n';
		if (new_h < ans_h) {
			ans_h = new_h;
			ans_mh = min(move_h, h - move_h + 1);
		}
	}

	for (ll move_c: columns) {	
		ll new_c = count_w(move_c);
		if (new_c < ans_w) {
			ans_w = new_c;
			ans_mw = min(move_c, w - move_c + 1);
		}
	}

	cout << ans_w * ans_h << ' ' << ans_mh + ans_mw << '\n';
}	

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	solve();
}