#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e9;

void solve() {
	int n;
	cin >> n;

	vector <int> p(n);
	for (int &x: p)
		cin >> x;

	// [i][max][min]
	int dp[n + 1][n + 2][n + 2];
	for (int i = 0; i < n + 1; i++)
		for (int j = 0; j < n + 2; j++)
			for (int k = 0; k < n + 2; k++)
				dp[i][j][k] = -INF;

	dp[0][0][n + 1] = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= n + 1; j++) {
			for (int k = 0; k <= n + 1; k++) {
				dp[i + 1][max(j, p[i])][k] = max(dp[i + 1][max(j, p[i])][k], dp[i][j][k] + (p[i] > j));
				dp[i + 1][j][min(k, p[i])] = max(dp[i + 1][j][min(k, p[i])], dp[i][j][k] + (p[i] < k));				
			}
		}
	}

	int answer = 0;

	for (int j = 0; j < n + 2; j++)
		for (int k = 0; k < n + 2; k++)
			answer = max(answer, dp[n][j][k]);

	cout << answer << '\n';
}	

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int t;
	cin >> t;

	while (t--)
	solve();
}