#include <bits/stdc++.h>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define all(v) (v).begin(), (v).end()

using namespace std;
using ll = long long;
using pii = pair <int, int>;

int const N = 31;

mt19937 rnd(4);

struct S{
    int l, r, id;
};

bool comp(S& a, S& b){
    return a.l < b.l;
}

bool sz_comp(S& a, S& b){
    return (a.r - a.l) < (b.r - b.l);
}

void dfs(int v, vector < vector <int> >& g, vector <int>& way){
    if(g[v].size() == 0){
        way.push_back(v);
    }
    for(auto u : g[v]){
        dfs(u, g, way);
    }
    return;
}

struct T{
    int r, id;
};

void g145(vector <S> v){
    int n = v.size();
    sort(all(v), sz_comp);
    vector < vector <int> > in(n);
    vector < vector <int> > g(n);
    vector <int> p(n, -1);
    vector <int> v0;
    vector <int> q;

    vector <T> t(4 * n);

    for(int i = 0; i < n; ++i){
        for(int k = 0; k < (int)q.size(); ++k){
            int j = q[k];
            if(v[i].l <= v[j].l and v[j].r <= v[i].r){///j in i
                g[v[i].id].push_back(v[j].id);
                p[v[j].id] = v[i].id;
                swap(q[k], q[(int)q.size() - 1]);
                q.pop_back();
                --k;
            }
        }
        q.push_back(i);
    }
    for(int i = 0; i < n; ++i){
        if(p[i] == -1){
            v0.push_back(i);
        }
    }

    vector <int> way;
    for(auto _v0 : v0){
        dfs(_v0, g, way);
    }
    int m = way.size(), sz1 = 0, sz2 = 0;
    int dn = n/2;
    vector <bool> is1(n, 0), is2(n, 0);
    for(int i = 0; i < m/2; ++i){
        int v = way[i];
        while(v != -1 and !is1[v]){
            ++sz1;
            is1[v] = 1;
            v = p[v];
        }
    }
    for(int i = m/2; i < m; ++i){
        int v = way[i];
        while(v != -1 and !is2[v]){
            ++sz2;
            is2[v] = 1;
            v = p[v];
        }
    }

    vector <bool> is(n, 1);

    if(sz1 > sz2){///del 2
        for(int i = 0; i < n; ++i){
            if(is2[i] and !is1[i] and g[i].empty()){
                is[i] = 0;
                --dn;
            }
        }
        for(int i = 0; i < n; ++i){
            if(dn and is[i] and is2[i] and !is1[i]){
                is[i] = 0;
                --dn;
            }
        }
        for(int i = 0; i < n; ++i){
            if(dn and is[i] and is1[i] and g[i].size() != 0){
                is[i] = 0;
                --dn;
            }
        }
    }
    else{
        for(int i = 0; i < n; ++i){
            if(is1[i] and !is2[i] and g[i].empty()){
                is[i] = 0;
                --dn;
            }
        }
        for(int i = 0; i < n; ++i){
            if(dn and is[i] and is1[i] and !is2[i]){
                is[i] = 0;
                --dn;
            }
        }
        for(int i = 0; i < n; ++i){
            if(dn and is[i] and is2[i] and g[i].size() != 0){
                is[i] = 0;
                --dn;
            }
        }
    }

    for(int i = 0; i < n; ++i){
        if(is[i]){
            cout << i + 1 << ' ';
        }
    }
    cout << '\n';
    return;
}

int get_m(vector <S>& v){
    int n = v.size(), ans = 0;
    int s = 2 * N + 2;
    vector <int> dp(s, 0);
    vector <int> ls(s, -1);
    for(auto w : v){
        ls[w.r] = max(ls[w.r], w.l);
    }
    for(int i = 0; i < s; ++i){
        dp[i] = (i == 0 ? 0 : dp[i - 1]);
        if(ls[i] != -1){
            dp[i] = max(dp[i], (ls[i] == 0 ? 0 : dp[ls[i] - 1]) + 1);
        }
        ans = max(ans, dp[i]);
    }
    return ans;
}

void g23(vector <S> v){
    int n = v.size();
    int m = get_m(v);
    vector <int> p(n);
    for(int i = 0; i < n; ++i){
        p[i] = i;
    }
    while(1){
        vector <S> _v(n/2);
        for(int i = 0; i < 5; ++i){
            swap(p[rnd()%(n/2)], p[rnd()%n]);
        }
        for(int i = 0; i < n/2; ++i){
            _v[i] = v[p[i]];
        }
        int _m = get_m(_v);
        if(_m == m/2){
            for(auto w : _v){
                cout << w.id + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    }
//    for(int mask = 0; mask < (1 << n); ++mask){
//        vector <S> _v;
//        for(int i = 0; i < n; ++i){
//            if(mask & (1 << i)){
//                _v.push_back(v[i]);
//            }
//        }
//        if((int)_v.size() != n/2){
//            continue;
//        }
//        int _m = get_m(_v);
//        if(_m == m/2){
//            for(auto w : _v){
//                cout << w.id + 1 << ' ';
//            }
//            cout << '\n';
//            return;
//        }
//    }
    return;
}

void cords(vector <S>& v){
    set <int> st;
    int _x = 0;
    unordered_map <int, int> mp;
    for(auto w : v){
        st.insert(w.l);
        st.insert(w.r);
    }
    for(auto w : st){
        mp[w] = _x++;
    }
    for(auto& w : v){
        w.l = mp[w.l];
        w.r = mp[w.r];
    }
    return;
}

void solve(){
    int n;
    cin >> n;
    vector <S> v(n);
    for(int i = 0; i < n; ++i){
        cin >> v[i].l >> v[i].r;
        v[i].id = i;
    }
    cords(v);
    g145(v);
    return;
    if(n <= 30){
        g23(v);
        return;
    }
//    g145(v);
//    return;
}

signed main(){
    ibase;
    int t;
    cin >> t;
    while(t --> 0){
        solve();
    }
}
/**
1
6
1 6
1 3
1 3
4 6
1 2
4 5

**/

