#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>

using namespace std;

#define int long long

void solve()
{
    int n,q;
    cin>>n>>q;
    vector <int> a(n);
    for (int i=0; i<n; i++) cin>>a[i];
    int blocked;
    cin>>blocked;
    int o=100001;
    vector <vector <int> > dp(o+1,vector <int> (1,0));
    dp[0][0]=1;
    for (int i=0; i<n; i++)
    {
        for (int j=o; j>=0; j--)
        {
            for (int h=0; h>=0; h--)
            {
                if (j+a[i]<=o) dp[j+a[i]][h]=max(dp[j+a[i]][h],dp[j][h]);
            }
        }
    }
    vector <int> maxans(o+1,-1);
    int last=1;
    for (int i=0; i<o+1; i++)
    {
        for (int j=0; j<min(last,o+1); j++)
        {
            if (dp[i][j]) maxans[i]++;
            else
            {
                last=j;
                break;
            }
        }
    }
    for (int i=0; i<q; i++)
    {
        int k,x,y;
        cin>>k>>x>>y;
        if (maxans[x]>=y) cout<<"Yes\n";
        else cout<<"No\n";
    }
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    int t=1;
    //cin>>t;
    while (t--)
    {
        solve();
    }
    return 0;
}