#include <bits/stdc++.h>

#define pb push_back
#define st string
#define vec vector
#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define int long long

#define endl "\n";

using namespace std;
using vi = vec<int>;
using vvi = vec<vi>;
using pi = pair<int, int>;
using vpi = vec<pi>;

vvi g;

int inter(pi &a, pi &b) {
    if (a.ss < b.ff || b.ss < a.ff) {
        return 0;
    }
    return 1;
}

vi col;
vi used;
int cnt = 0;

void dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    int ok = 1;
    for (auto u : g[v]) {
        if (col[u]) {
            ok = 0;
            break;
        }
    }
    if (ok) {
        col[v] = 1;
        cnt++;
    }
}

int check(vpi &a) {
    int n = a.size();
    cnt = 0;
    g = {};
    col.assign(n, 0);
    used.assign(n, 0);
    g.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (inter(a[i], a[j])) {
                g[i].pb(j);
                g[j].pb(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    return cnt;
}

void solve() {
    int n; cin >> n;
    vpi a(n);
    for (int i = 0; i < n; i++) {
        int l, r; cin >> l >> r;
        a[i] = {l, r};
    }
    int m = check(a);
    for (int i = 0; i < (1 << n); i++) {
        vpi nw;
        vi inds;
        for (int j = 0; j < n; j++) {
            if (((1 << j) & i) != 0) {
                nw.pb(a[j]);
                inds.pb(j + 1);
            }
        }
        if (nw.size() == n / 2) {
            int now = check(nw);
            if (now == m / 2) {
                for (auto u : inds) {
                    cout << u << " ";
                }
                cout << endl;
                return;
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}
