#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
using namespace std;

void solve() {
	int n;
	cin >> n;
	vector<pair<int, int>> mp(1, { 0, 0 });
	map<int, vector<int>> coll;
	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		coll[l].push_back(i + 1);
		mp.push_back({ l, r });
	}

	sort(mp.begin(), mp.end());
	vector<int> dp(n + 1);
	vector<int> pr(n + 1);
	set<pair<int, int>> st;

	dp[0] = 0;
	pr[0] = 0;

	for (int i = 1; i <= n; ++i) {
		auto jt = lower_bound(st.begin(), st.end(), make_pair(mp[i].first, 0));

		if (jt == st.end()) {
			dp[i] = dp[i - 1] + 1;
			pr[i] = i - 1;
		}
		else {
			int j = (*jt).second;
			dp[i] = dp[j - 1] + 1;
			pr[i] = j - 1;
		}
		st.insert({ mp[i].second, i });
	}

	vector<int> sol;


	int mx = 0;
	for (int i = 1; i <= n; ++i)
		if (dp[i] > dp[mx])
			mx = i;

	int coln = (n - dp[mx]) / 2, colm = dp[mx] / 2;

	set<int> sta;

	int j = mx;
	vector<int> path;
	while (mx != 0) {
		path.push_back(mx);
		mx = pr[mx];
	}
	reverse(path.begin(), path.end());

	for (int i = 0; i < colm; ++i) {
		sol.push_back(path[i]);
		sta.insert(path[i]);
	}

	for (int i = 1; i <= n; ++i) {
		if (dp[i] <= colm && sta.count(i) == 0) {
			sol.push_back(i);
			if (sol.size() == n / 2) break;
		}
	}


	for (int i = 0; i < sol.size(); ++i)
		cout << sol[i] << " ";

	cout << "\n";
}


signed main(){
	int T = 1;
	cin >> T;
	while (T--) solve();
	return 0x0;
}
