#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> cnt;

void dfs(int u, bool l, int k) {
    //cout << u << ' ' << l << ' ' << k << '\n';
    if (k < 0) {
        return;
    }
    if (g[u].empty()) {
        cnt[u] = 1;
        return;
    }
    dfs(g[u][0], true, k - !l);
    dfs(g[u][1], false, k - l);
    cnt[u] = cnt[g[u][0]] + cnt[g[u][1]];
}

void solve() {
    int n, k, q;
    cin >> n >> k >> q;
    g.resize(n + 1);
    cnt.resize(n + 1);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t) {
            int l, r;
            cin >> l >> r;
            g[i + 1].push_back(l);
            g[i + 1].push_back(r);
        }
    }
    dfs(g[1][0], true, k);
    dfs(g[1][1], false, k);
    cnt[1] = cnt[g[1][0]] + cnt[g[1][1]];
    for (int i = 0; i < q; i++) {
        int u;
        cin >> u;
        cout << cnt[u] << '\n';
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    t = 1;
    for (int i = 0; i < t; i++) solve();
}
