#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define ff first
#define sc second
#define all(a) (a).begin(), (a).end()

vector<vector<int>> genc(int n, int k) {
    if (k == 0) return {{}};
    if (k == n) {
        vector<vector<int>> ans = {{}};
        f (i, 1, n + 1) ans[0].push_back(i);
        return ans;
    }
    vector<vector<int>> ans;
    for (int last = k; last <= n; last++) {
        auto res = genc(last - 1, k - 1);
        for (auto &u : res) {
            u.push_back(last);
            ans.push_back(u);
        }
    }
    return ans;
}

void solve() {
    int n; cin >> n;
    vector<int> p(n);
    for (auto &u : p) cin >> u;
    vector<int> dp(n + 1, 1e9);
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        int L = -1, R = n + 1;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (dp[M] > p[i]) R = M;
            else L = M;
        }
        dp[R] = p[i];
    }
    int nvp = 0;
    f (i, 0, n + 1) {
        if (dp[i] != 1e9) nvp = i;
    }

    if (nvp >= n - 1) {
        cout << n << '\n';
        return;
    }
    vector<int> pos(n + 1, 0);
    f (i, 0, n) pos[p[i]] = i;
    vector<pair<int, int>> ress;
    int maxpos = -1;
    set<int> st;
    for (int i = 0; i < n; i++) {
        if (maxpos > pos[i + 1]) {
            ress.push_back({pos[i + 1], *st.lower_bound(pos[i + 1])});
        }
        st.insert(pos[i + 1]);
        maxpos = max(maxpos, pos[i + 1]);
    }
    for(auto&u:ress)cout<<u.ff<<' '<<u.sc<<'\n';

    if (ress.empty()) {
        cout << nvp + 1 << '\n';
        return;
    }

    random_shuffle(all(ress));
    for (int i = 0; i < min((int)ress.size(), 300); i++) {
        dp[0] = 0;
        int gran = 0;
        for (int j = 0; j < n; j++) {
            if (j == ress[i].ff || j == ress[i].sc) {
                continue;
            }
            int L = -1, R = n + 1;
            while (R - L > 1) {
                int M = (L + R) / 2;
                if (M <= gran && dp[M] < p[j]) L = M;
                else R = M;
            }
            dp[R] = p[j];
            gran = max(gran, R);
        }
        if (gran == nvp) {
            cout << nvp + 2 << '\n';
            return;
        }
    }
    cout << nvp + 1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    //int type; cin >> type;
    //int tt; cin >> tt;
    vector<pair<vector<int>, vector<int>>> matchh = {
            {{1,2,3},{4,5,6}},
            {{2,3,4},{5,6,7}},
            {{1,2,5},{3,4,7}},
            {{1,3,5},{2,4,6}},
            {{1,4,5},{3,6,7}},
            {{1,3,6},{2,4,7}},
            {{2,3,6},{1,4,5}},
            {{1,4,6},{2,5,7}},
            {{2,5,6},{1,4,7}},
            {{1,2,7},{3,4,5}},
            {{3,5,7},{1,4,6}},
            {{1,2,4},{3,5,6}},
            {{1,2,6},{4,5,7}},
            {{1,3,4},{2,6,7}},
            {{1,3,7},{2,4,5}},
            {{1,5,6},{2,3,7}},
            {{1,5,7},{3,4,6}},
            {{2,3,5},{4,6,7}}
    };
    int type,tt;cin>>type>>tt;
    while (tt--) {
        //cout<<"eyes\n";
        int n, k;
        cin >> n >> k;
        vector<int> a(k);
        f (i, 0, k) cin >> a[i];
        if (k == 1) {
            if (type == 1) {
                if (a[0] == n) cout << 1 << '\n';
                else cout << a[0] + 1 << '\n';
            } else {
                if (a[0] == 1) cout << n << '\n';
                else cout << a[0] - 1 << '\n';
            }
            continue;
        }
        if (n % 2 == 0 && k == n / 2) {
            vector<int> used(n + 1, 0);
            f(i, 0, k)used[a[i]] = 1;
            f(i, 1, n + 1) {
                if (!used[i]) {
                    cout << i << ' ';
                }
            }
            cout << '\n';
            continue;
        }
        bool f = false;
        f (i, 0, k - 1) {
            if (a[i + 1] - a[i] == 1) f = true;
        }
        if (a[k - 1] == n && a[0] == 1) f = true;
        if (!f) {
            if (type == 1) {
                vector<int> ans(k);
                f (i, 0, k) {
                    ans[i] = (a[i] == n ? 1 : a[i] + 1);
                }
                sort(all(ans));
                for (auto &u: ans) cout << u << ' ';
                cout << '\n';
            } else {
                vector<int> ans(k);
                f (i, 0, k) {
                    ans[i] = (a[i] == 1 ? n : a[i] - 1);
                }
                sort(all(ans));
                for (auto &u: ans) cout << u << ' ';
                cout << '\n';
            }
            continue;
        }
        if (k == 2) {
            if (type == 1) {
                vector<int> ans;
                ans.push_back((a[0] + 2 <= n ? a[0] + 2 : (a[0] + 2) % n));
                ans.push_back((a[1] + 2 <= n ? a[1] + 2 : (a[1] + 2) % n));
                sort(all(ans));
                for (auto &u: ans) cout << u << ' ';
                cout << '\n';
            } else {
                vector<int> ans;
                ans.push_back((a[0] - 2 >= 1 ? a[0] - 2 : (a[0] - 2 + 2 * n) % n));
                ans.push_back((a[1] - 2 >= 1 ? a[1] - 2 : (a[1] - 2 + 2 * n) % n));
                if (ans[0] == 0)ans[0] = n;
                if (ans[1] == 0)ans[1] = n;
                sort(all(ans));
                for (auto &u: ans) cout << u << ' ';
                cout << '\n';
            }
            continue;
        }
        bool F = false;
        for(int i=0;i<matchh.size();i++){
            if(matchh[i].ff == a&&!F) {
                for(auto&u:matchh[i].sc)cout<<u<<' ';
                cout<<'\n';
                F=true;
            }else if(matchh[i].sc == a&&!F){
                for(auto&u:matchh[i].ff)cout<<u<<' ';
                cout<<'\n';
                F=true;
            }
        }

    }

    return 0;
}