#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<int> solve1(int n, int k, vector<int> v);
vector<int> solve2(int n, int k, vector<int> v);

void print(vector<int> v){
    sort(v.begin(), v.end());
    if (unique(v.begin(), v.end()) != v.end()){
        while (true){

        }
    }
    for (auto el : v){
        cout << el + 1 << ' ';
    }
    cout << endl;
}

tuple<int, int, vector<int>> input(){
    int n, k;
    cin >> n >> k;
    vector<int> v(k);
    for (int i = 0; i < k; ++i) {
        cin >> v[i];
        v[i]--;
    }
    sort(v.begin(), v.end());
    return {n, k, v};
}

signed main(){
    int z;
    int t;
    cin >> z >> t;
    for (int i = 0; i < t; ++i) {
        auto [n, k, v] = input();
        if (z == 1){
            print(solve1(n, k, v));
        } else{
            print(solve2(n, k, v));
        }
        if (solve2(n, k, solve1(n, k, v)) != v){
            while (true){

            }
        }
    }
}




int mex(int n, int k, vector<int> &v){
    srand(n + k);
    return rand() % n;
    set<int> st;
    for (int i = 1; i < n; ++i) {
        st.insert(i);
    }
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            st.erase((v[i] - v[j] + n) % n);
        }
    }
    return *st.begin();
}

vector<int> solve1(int n, int k, vector<int> v){
    int m = mex(n, k, v);
    vector<int> w(k);
    for (int i = 0; i < k; ++i) {
        w[i] = (v[i] + m) % n;
    }
    return w;
}

vector<int> solve2(int n, int k, vector<int> v){
    int m = mex(n, k, v);
    vector<int> w(k);
    for (int i = 0; i < k; ++i) {
        w[i] = (v[i] - m + n) % n;
    }
    return w;
}

