#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

int n, k;

void solve1() {
    cin >> n >> k;
    vector <bool> used(n + 1, false);
    int a;
    for (int i = 0; i < k; i++) {
        cin >> a;
        used[a] = true;
    }
    int cnt = 0;
    vector <int> ans;
    for (int i = 1; i <= n && k; i++) {
        if (cnt && !used[i]) {
            ans.push_back(i);
            used[i] = true;
            cnt--;
            k--;
        } else if(used[i]) {
            cnt++;
        }
    }
    for (int i = 1; i <= n && k; i++) {
        if (!used[i]) {
            ans.push_back(i);
            used[i] = true;
            k--;
        }
    }
    sort(ans.begin(), ans.end());
    for (auto v : ans) {
        cout << v << " ";
    }
    cout << endl;
}

bool check(vector <int> a, vector <int> b) {
    vector <bool> used(n + 1, false);
    int kk = k;
    for (int i = 0; i < kk; i++) {
        used[a[i]] = true;
    }
    int cnt = 0;
    vector <int> ans;
    for (int i = 1; i <= n && kk; i++) {
        if (cnt && !used[i]) {
            ans.push_back(i);
            used[i] = true;
            cnt--;
            kk--;
        } else if(used[i]) {
            cnt++;
        }
    }
    for (int i = 1; i <= n && kk; i++) {
        if (!used[i]) {
            ans.push_back(i);
            used[i] = true;
            kk--;
        }
    }
    sort(ans.begin(), ans.end());
    return ans == b;
}


void solve2() {
    cin >> n >> k;
    vector <bool> usedd(n + 1, false);
    vector <int> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
        usedd[a[i]] = true;
    }
    int cnt = 0;
    int kk = k;
    for (int s = 1; s <= n; s++) {
        if (!usedd[s]) {
            continue;
        }
        vector <bool> used = usedd;
        vector <int> ans;
        kk = k;
        cnt = 0;
        for (int i = s; i >= 1 && kk; i--) {
            if (cnt && !used[i]) {
                ans.push_back(i);
                used[i] = true;
                cnt--;
                kk--;
            } else if(used[i]) {
                cnt++;
            }
        }
        for (int i = n; i > s && kk; i--) {
            if (cnt && !used[i]) {
                ans.push_back(i);
                used[i] = true;
                cnt--;
                kk--;
            } else if(used[i]) {
                cnt++;
            }
        }
        for (int i = s; i >= 1 && kk; i--) {
            if (!used[i]) {
                ans.push_back(i);
                used[i] = true;
                kk--;
            }
        }
        for (int i = n; i > s && kk; i--) {
            if (!used[i]) {
                ans.push_back(i);
                used[i] = true;
                kk--;
            }
        }
        sort(ans.begin(), ans.end());
//        for (auto v : ans) {
//            cout << v << " ";
//        }
        if (check(ans, a)) {
            for (auto v : ans) {
                cout << v << " ";
            }
            cout << endl;
            return;
        }
        break;
    }
    for (int s = n; s >= 1; s--) {
        if (!usedd[s]) {
            continue;
        }
        vector <bool> used = usedd;
        vector <int> ans;
        kk = k;
        cnt = 0;
        for (int i = s; i >= 1 && kk; i--) {
            if (cnt && !used[i]) {
                ans.push_back(i);
                used[i] = true;
                cnt--;
                kk--;
            } else if(used[i]) {
                cnt++;
            }
        }
        for (int i = n; i > s && kk; i--) {
            if (cnt && !used[i]) {
                ans.push_back(i);
                used[i] = true;
                cnt--;
                kk--;
            } else if(used[i]) {
                cnt++;
            }
        }
        for (int i = s; i >= 1 && kk; i--) {
            if (!used[i]) {
                ans.push_back(i);
                used[i] = true;
                kk--;
            }
        }
        for (int i = n; i > s && kk; i--) {
            if (!used[i]) {
                ans.push_back(i);
                used[i] = true;
                kk--;
            }
        }
        sort(ans.begin(), ans.end());
//        for (auto v : ans) {
//            cout << v << " ";
//        }
        if (check(ans, a)) {
            for (auto v : ans) {
                cout << v << " ";
            }
            cout << endl;
            return;
        }
        break;
    }
}

int main() {
    int t;
    cin >> t;
    int m;
    cin >> m;
    if (t == 1) {
        while (m--) {
            solve1();
        }
    } else {
        while (m--) {
            solve2();
        }
    }
}
