#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <cmath>
#include <deque>
using namespace std;
vector<pair<int, int> > a;


vector<int> d;
void sett(int v, int l, int r, int pos, int val) {
	if (l > pos || r < pos) {
		return;

	}
	if (l == r && r == pos) {
		d[v] = val;
		return;
	}
	sett(2 * v + 1, l, (l + r) / 2, pos, val);
	sett(2 * v + 2, (l + r) / 2 + 1, r, pos, val);
	d[v] = max(d[2 * v + 1], d[2 * v + 2]);
}
int ask(int v, int l, int r, int askl, int askr) {
	if (l > askr || r < askl) {
		return 0;
	}
	if (l >= askl && r <= askr) {
		return d[v];
	}
	int aa = ask(2 * v + 1, l, (l + r) / 2, askl, askr);
	int bb = ask(2 * v + 2, (l + r) / 2 + 1, r, askl, askr);
	return max(aa, bb);
}
int sz;
int check(vector<int> ops) {
	int m = ops.size();
	//vector<int> d(m);
	int mval = 0;
	d = vector<int>(4 * sz, 0);
	for (int i = 0; i < m; i++) {
		int pval = ask(0, 0, sz - 1, 0, a[ops[i]].first - 1);
		sett(0, 0, sz - 1, a[ops[i]].second, pval + 1);
		mval = max(mval, pval + 1);
	}
	return mval;
}
vector<int> p;


int main() {
	int tt;
	cin >> tt;
	for (int t = 0; t < tt; t++) {
		int n;
		cin >> n;
		vector<int> nums(n);
		a.resize(n);
		p.clear();
		p.resize(n);
		set<int> st;
		for (int i = 0; i < n; i++) {
			cin >> a[i].first >> a[i].second;
			nums[i] = i;
			st.insert(a[i].first);
			st.insert(a[i].second);
		}
		unordered_map<int, int> shorten;
		

		sort(nums.begin(), nums.end(), [&](int aa, int bb) {
			if (a[aa].first != a[bb].first) {
				return a[aa].first < a[bb].first;
			}
			return a[aa].second > a[bb].second;
			});
		

		vector<int> numpos(n);
		for (int i = 0; i < n; i++) {
			numpos[nums[i]] = i;
		}
		vector<pair<int, int> > evs;
		for (int i = 0; i < n; i++) {
			evs.push_back({ a[i].first,i+1 });
			evs.push_back({ a[i].second,-i-1});
		}

		int bigans = 0;
		


		sort(evs.begin(), evs.end(), [&](pair<int, int> aa, pair<int, int> bb) {
			if (aa.first != bb.first)
				return aa.first < bb.first;
			int pos1 = abs(aa.second) - 1;
			int pos2 = abs(bb.second) - 1;
			int len1 = a[pos1].second - a[pos1].first;
			int len2 = a[pos2].second - a[pos2].first;
			int open = aa.second > 0;
			if (open) {
				return numpos[pos1] < numpos[pos2];
			}
			return numpos[pos1] > numpos[pos2];

			});
		
		set<pair<int, int> > ops;
		deque<int> dq;
		for (auto h : evs) {
			int open = (h.second > 0);
			int pos = abs(h.second) - 1;
			if (open) {
				if (dq.size() == 0) {
					p[pos] = -1;
				}
				else
				p[pos] = dq.back();
				dq.push_back(pos);
			}
			else {
				dq.pop_back();
			}
		}
		vector<int> insize(n);
		for (int i = 0; i < n; i++) {
			if (p[i] != -1) {
				insize[p[i]]++;
			}
		}

		for (int i = 0; i < n; i++) {
			if (insize[i] == 0) {
				bigans++;
			}
		}

		deque<pair<int, int> > ees;
		for (int i = 0; i < n; i++) {
			int pos = nums[i];
			int timestart = i-n/2+1;
			int timeend = timestart+1;
			if (insize[pos] == 0) {
				timeend = i+1;
			}
			ees.push_back({ timestart,1 });
			ees.push_back({ timeend,-1 });
		}
		sort(ees.begin(), ees.end());
		int ans = 0;
		int pos = 0;
		for (int i = 0; i < n; i++) {
			while (ees.size() > 0 && ees.front().first <= i) {
				ans += ees.front().second;
				ees.pop_front();
			}
			if (ans == bigans / 2) {
				pos = i;
				break;
			}
		}
		for (int i = 0; i < n / 2; i++) {
			cout << nums[i + pos]+1 << ' ';
		}
		cout << endl;

		
	}
	


	


}