#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <random>

#define ll long long
#define int ll

using namespace std;

mt19937 rnd;

const int Inf = 1e9 + 10;

const int N = 202;

int pown(int n, int k, int mod) {
	if (k == 0) return 1;
	if (k % 2 == 0) return pown(n * n % mod, k / 2, mod);
	return (n * pown(n, k - 1, mod)) % mod;
}

int C(int n, int k, int mod) {
	if (k < 0) return 0;
	if (n < k) return 0;
	int ans = 1;
	for (int i = 0; i < k; ++i) {
		ans *= (n - i);
	}
	int kk = 1;
	for (int i = 0; i < k; ++i) {
		kk *= (i + 1);
	}
	return ans * pown(kk, mod - 2, mod) % mod;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int Mod;
	cin >> Mod;
	int t;
	cin >> t;
	while (t--) {
		int k;
		cin >> k;
		int n;
		cin >> n;
		int p;
		cin >> p;
		int ans = 0;
		int len = (1 << k);
		int msk = (1 << (len - 1));
		for (int ii = 0; ii < msk; ++ii) {
			vector<int>a;
			a.push_back(0);
			vector<bool>used(len + 1);
			for (int i = 0; i < len - 1; ++i) {
				if (ii & (1 << i)) {
					a.push_back(i + 1);
					used[i + 1] = 1;
				}
			}
			used[0] = 1;

			int lm = -1;
			if (a.size() != n) continue;
			for (int i = 0; i < 100; ++i) {
				int mx = 0;
				for (int j = 0; j <= len; ++j) {
					if (!used[j]) {
						mx = j;
						break;
					}
				}
				if (mx == lm) {
					break;
				}
				lm = mx;
				int m1 = mx - 1;
				used.clear();
				used.resize(len);
				for (int i = 0; i < n; ++i) {
					a[i] ^= m1;
					used[a[i]] = 1;
				}
			}
			if (lm == p) {
				ans = (ans + 1) % Mod;
			}
		}
		cout << ans << '\n';
	}
}
