#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define int ll

pair<int, int> dfs(int v, vector<vector<int>>& g, vector<pair<int, int>>& lr, vector<pair<int, int>>& dp, int p = -1) {
    int with = lr[v].second;
    int without = 0;
    for (auto to : g[v]) {
        if (to != p) {
            auto nw = dfs(to, g, lr, dp, v);
            with += nw.second;
            without += max(nw.first, nw.second);
        }
    }
    dp[v].first = with;
    dp[v].second = without;
    return {with, without};
}

void dfs1(int v, int is, vector<vector<int>>& g, vector<pair<int, int>>& lr, vector<pair<int, int>>& dp, vector<int>& vert, int p = -1) {
    if (is) {
        vert.push_back(is);
        for (auto to : g[v]) {
            if (to != p) {
                dfs1(v, 0, g, lr, dp, vert, v);
            }
        }
    } else {
        for (auto to : g[v]) {
            if (to != p) {
                if (dp[to].second > dp[to].first) {
                    dfs1(v, 0, g, lr, dp, vert, v);
                } else {
                    dfs1(v, 1, g, lr, dp, vert, v);
                }
            }
        }
    }
}

int x, y, m;
int n, q;

int get_cert(vector<int>& plan) {
    int ret = 0;
    for (int i = 0; i < n; ++i) {
        ret ^= ((x * (i + 1) + y * plan[i] % m * plan[i] % m) % m);
    }
    return ret;
}

void solve() {
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> q;
        cin >> x >> y >> m;
        vector<vector<int>> g(n);
        for (int i = 0; i < n - 1; ++i) {
            int u, v;
            cin >> u >> v;
            g[u - 1].push_back(v - 1);
            g[v - 1].push_back(u - 1);
        }
        vector<pair<int, int>> lr(n);
        for (int i = 0; i < n; ++i) {
            cin >> lr[i].first >> lr[i].second;
        }
        vector<int> v(q);
        for (int i = 0; i < q; ++i) {
            cin >> v[i];
        }
        vector<pair<int, int>> dp(n);
        vector<int> vert;
        auto lol = dfs(0, g, lr, dp);
        if (lol.first > lol.second) {
            dfs1(0, 1, g, lr, dp, vert);
        } else  {
            dfs1(0, 0, g, lr, dp, vert);
        }
        int ans = max(lol.first, lol.second);
        for (int i = 0; i < q; ++i) {
            if (v[i] > ans) {
                cout << "-1 ";
            } else {
                vector<int> ns(n);
                int nw = v[i];
                for (auto j : vert) {
                    ns[j] = min(nw, lr[j].second);
                    nw -= ns[j];
                }
                cout << get_cert(ns) << endl;
            }
        }
        cout << endl;
        int inp;
        cin >> inp;
        while (inp) {
            --inp;
            if (v[inp] > ans) {
                cout << "-1" << endl;
            } else {
                vector<int> ns(n);
                int nw = v[inp];
                for (auto j : vert) {
                    ns[j] = min(nw, lr[j].second);
                    nw -= ns[j];
                }
                for (int i = 0; i < n; ++i) {
                    cout << ns[i] << ' ';
                }
                cout << endl;
            }
            cin >> inp;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    solve();
    return 0;
}
