#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()

using namespace std;

void comp(vector<int>& a) {
    sort(all(a));
    a.resize(unique(all(a)) - a.begin());
}

int h, w, k;

pair<int, int> solve(const vector<int>& x, int n) {
    int ans = 0, sq = n;
    for (int i = 0; i < (int)x.size(); ++i) {
        //rightest
        int nowSq = (x[i] - x[0] + 1);
        int tmpAns = 0;
        if (i != (int)x.size() - 1) {
            nowSq = x[i] + 1 + (n - x[i + 1]);
            tmpAns = n - x[i + 1];
        }
        if (nowSq < sq) {
            sq = nowSq;
            ans = tmpAns;
        } else if (nowSq == sq && tmpAns < ans) {
            ans = tmpAns;
        }
    }
    // leftest
    for (int i = 0; i < (int)x.size(); ++i) {
        int nowSq = (x.back() - x[i] + 1);
        int tmpAns = 0;
        if (i != 0) {
            nowSq = (n - x[i] + 1) + x[i - 1] + 1;
            tmpAns = x[i - 1] + 1;
        }
        if (nowSq < sq) {
            sq = nowSq;
            ans = tmpAns;
        } else if (nowSq == sq && tmpAns < ans) {
            ans = tmpAns;
        }
    }
    return {sq, ans};
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> h >> w >> k;
    vector<int> xs, ys;
    for (int i = 0; i < k; ++i) {
        int x, y; cin >> x >> y; x--; y--;
        xs.push_back(x);
        ys.push_back(y);
    }
    comp(xs); comp(ys);
    auto ans1 = solve(xs, h);
    auto ans2 = solve(ys, w);
    cout << ans1.first * ans2.first << ' ' << ans1.second + ans2.second << '\n';
    return 0;
}

