#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()

using namespace std;

vector<int> solve1(const vector<int>& a, set<int>& s, int n) {
    for (auto i : a) {
        s.erase(i);
    }
    vector<int> ans;
    for (auto i : a) {
        auto it = s.lower_bound(i);
        if (*it > n) {
            it = s.begin();
        }
        ans.push_back(*it);
        s.erase(it);
    }
    sort(all(ans));
    for (auto i : a) s.insert(i);
    for (auto i : ans) s.insert(i);
    return ans;
}

vector<int> solve2(const vector<int>& a, set<int>& s, int n) {
    for (auto i : a) {
        s.erase(i);
    }
    vector<int> ans;
    for (auto i : a) {
        auto it = s.lower_bound(i);
        if (it == s.begin()) {
            it = s.lower_bound(n + 1);
        }
        --it;
        ans.push_back(*it);
        s.erase(it);
    }
    sort(all(ans));
    for (auto i : a) s.insert(i);
    for (auto i : ans) s.insert(i);
    return ans;
}

void run() {
    int a, m; cin >> a >> m;
    set<int> s;
    for (int i = 1; i <= 100000; ++i) {
        s.insert(i);
    }
    for (int i = 0; i < m; ++i) {
        int n, k; cin >> n >> k;
        vector<int> v(k);
        for (int j = 0; j < k; ++j) cin >> v[j];
        vector<int> ans;
        if (a == 1) {
            ans = solve1(v, s, n);
        } else {
            ans = solve2(v, s, n);
        }
        for (auto j : ans) {
            cout << j << ' ';
        }
        cout << '\n';
    }
    cout.flush();
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}