#include <bits/stdc++.h>

#define sz(a) int((a).size())

using namespace std;

typedef long long ll;

void encode() {
    int n, k;
    cin >> n >> k;
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    vector<int> b;
    for (int i = 1; i < k; ++i) {
        if (a[i] - a[i - 1] > 1) {
            b.push_back(a[i - 1] + 1);
        } else {
            b.push_back(n - (k - i) + 1);
        }
    }
    sort(b.begin(), b.end());
    for (auto el : b) {
        cout << el << ' ';
    }
    cout << '\n';
}

void decode() {
    int n, k;
    cin >> n >> k;
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    vector<bool> cnt(n + 1, false);
    for (int i = 0; i < k; ++i) {
        cnt[a[i]] = true;
    }
    vector<int> ends(k);
    for (int i = 0; i < k; ++i) {
        if (a[i] <= n - k + 1) {
            ends.push_back(a[i]);
        }
    }
    vector<int> sizes = {1};
    for (int i = n - k + 2; i <= n; ++i) {
        if (cnt[i]) {
            sizes.back()++;
        } else {
            sizes.push_back(0);
        }
    }
    vector<int> b;
    for (int i = 0; i < sz(ends); ++i) {
        for (int j = 0; j < sizes[i]; ++j) {
            b.push_back(ends[i] - 1 - j);
        }
    }
    sort(b.begin(), b.end());
    for (auto el : b) {
        cout << el << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int type;
    cin >> type;
    if (type == 1) {
        int t;
        cin >> t;
        while (t--) encode();
    } else {
        int t;
        cin >> t;
        while (t--) decode();
    }

    return 0;
}