#include <bits/stdc++.h>

#define sz(a) int((a).size())

using namespace std;

typedef long long ll;

const int INF = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> b, c;
    for (int i = 0; i < n; ++i) {
        if (b.empty() || a[b.back()] < a[i]) {
            b.push_back(i);
        } else {
            c.push_back(i);
        }
    }

    vector<int> pref(n + 1, 0), suf(n + 1, 0);

    {
        vector<int> d(n + 1, INF);
        d[0] = -INF;
        for (int i = 0; i < n; ++i) {
            pref[i + 1] = int(upper_bound(d.begin(), d.end(), a[i]) - d.begin());
            *upper_bound(d.begin(), d.end(), a[i]) = a[i];
        }
    }

    {
        vector<int> d(n + 1, INF);
        d[0] = -INF;
        for (int i = 0; i < n; ++i) {
            suf[n - i - 1] = int(upper_bound(d.begin(), d.end(), n + 1 - a[n - i - 1]) - d.begin());
            *upper_bound(d.begin(), d.end(), n + 1 - a[n - i - 1]) = n + 1 - a[n - i - 1];
        }
    }

    int res = min(pref[n] + 1, n);

    int x = 0, y = 0;
    while (x < sz(b) && y < sz(c)) {
        while (x < sz(b) && b[x] < c[y]) {
            x++;
        }
        if (b[x] > c[y]) {
            int cur = (y + 1 + sz(b) - x) + 1;
            if (y != sz(c) - 1) {
                if (a[b[x - 1]] > a[c[y + 1]]) {
                    cur++;
                }
            }
            res = max(res, cur);
        }
        y++;
    }

    cout << res << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}