#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
void solve(){
    ll n, q;
    cin >> n >> q;
    ll x, y, MOD;
    cin >> x >> y >> MOD;
    vector<vector<int>> g(n);
    for(int i = 0; i < n - 1; i++){
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<ll> a(n);
    for(int i = 0; i < n; i++) cin >> a[i] >> a[i];
    vector<ll> Q(q);
    for(int i = 0; i < q; i++) cin >> Q[i];
    ll K = 0;
    for(int i = 0; i < n; i++) K ^= (x * (i + 1) % MOD + y * (a[i] % MOD) % MOD * (a[i] % MOD) % MOD) % MOD;

    vector<pair<ll,ll>> dp(n);
    function<void(int, int)> dfs = [&](int v, int parent){
        ll sum1 = 0;
        ll sum2 = a[v];
        for(int to : g[v]){
            if(to == parent) continue;
            dfs(to, v);
            sum1 += max(dp[to].first, dp[to].second);
            sum2 += dp[to].first;
        }
        dp[v] = {sum1, sum2};
    };
    dfs(0, 0);
    ll mx = max(dp[0].first, dp[0].second);
    for(int i = 0; i < q; i++){
        if(mx == Q[i]) cout << K << " ";
        else cout << -1 << " ";
    }
    cout << endl;
    cout.flush();
    int ii;
    cin >> ii;
    while(ii){
        ii--;
        if(Q[ii] == mx){
            for(int i = 0; i < n; i++) cout << a[i] << " " << "\n";
            cout << endl;
            cout.flush();
        }else{
            cout << "-1\n";
            cout << endl;
            cout.flush();
        }
        cin >> ii;
    }
}
int main() {
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
#endif
    int T = 1;
    cin >> T;
    while(T--){
        solve();
        cout << "\n";
    }
    return 0;
}