#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()

struct seg {
    int l, r, id;
};

bool operator<(const seg &a, const seg &b) {
    if (a.r == b.r)
        return a.l > b.l;
    return a.r < b.r;
}

bool in(const seg& a, const seg& b) {
    return a.l >= b.l && a.r <= b.r;
}

int n1, m1;
vector <vector <int>> g;
vector <bool> used;

void dfs(int v) {
    cout << v << " " << n1 << " " << m1 << endl;
    if (n1 == 0 && m1 == 0)
        return;
    if (g[v].empty()) {
        if (m1 != 0) {
            used[v] = true;
            m1--;
        } else if (n1 != 0) {
            used[v] = true;
            n1--;
        }
        return;
    }
    if (n1 != 0) {
        used[v] = true;
        n1--;
    }
    for (auto to: g[v])
        dfs(to);
    if (n1 != 0 && !used[v]) {
        used[v] = true;
        n1--;
    }
}

void solve() {
    int n;
    cin >> n;
    vector <seg> a(n);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        a[i] = {l, r, i};
    }
    sort(all(a));
    int m = 0;
    int last = 0;
    for (auto el: a) {
        if (el.l > last) {
            last = el.r;
            m++;
        }
    }
    n1=  n / 2, m1 = m / 2;
    n1 -= m1;
    vector <seg> st;
    g.clear();
    g.resize(n);
    used.assign(n, false);
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && in(st.back(), a[i])) {
            g[a[i].id].push_back(st.back().id);
            st.pop_back();
        }
        st.push_back(a[i]);
    }
    cout << "OK\n";
    for (auto el: st) {
        dfs(el.id);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i])
            cout << i + 1 << " ";
    }
    cout << "\n";
}

int main() {
    int t;
    cin >> t;
    while (t--)
        solve();
}
