#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using pii = pair<int, int>;
#define ff first
#define ss second

template<typename T1, typename T2>
void mnr(T1 &a, const T2 &b) {
    if (a > b) {
        a = b;
    }
}


template<typename T1, typename T2>
void mxr(T1 &a, const T2 &b) {
    if (a < b) {
        a = b;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    vector <vector <int> > g(n);
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector <pii> v(n);
    for (auto& [l, r] : v) {
        cin >> l >> r;
    }
    vector <array <int, 2> > dp(n);
    auto dfs = [&](auto& dfs, int cur, int par) -> void {
        int val = v[cur].ff;
        dp[cur][1] = val;
        for (auto to : g[cur]) {
            if (to != par) {
                dfs(dfs, to, cur);
                dp[cur][1] += dp[to][0];
                dp[cur][0] += max(dp[to][1], dp[to][0]);
            }
        }
    };
    dfs(dfs, 0, -1);
    vector <int> taken(n);
    auto recover = [&](auto& recover, int cur, int par, int inst) -> void {
        if (!inst || dp[cur][1] > dp[cur][0]) {
            taken[cur] = 1;
            for (auto to : g[cur]) {
                if (to != par) {
                    recover(recover, to, cur, 0);
                }
            }
        } else {
            for (auto to : g[cur]) {
                if (to != par) {
                    recover(recover, to, cur, 1);
                }
            }
        }
    };
    recover(recover, 0, -1, 1);
    vector <int> qs(q);
    int k = 0;
    int bst = max(dp[0][0], dp[0][1]);
    for (int i = 0; i < n; ++i) {
        k ^= ((x * (i + 1) % m + y * (taken[i] * v[i].ff) % m * (taken[i] * v[i].ss) % m) % m);
    }
    for (auto &i : qs) {
        cin >> i;
    }
    for (auto i : qs) {
        if (i == bst) {
            cout << k << " ";
        } else {
            cout << "-1 ";
        }
    }
    cout << endl;
    int vvod;
    while (true) {
        cin >> vvod;
        if (!vvod) {
            break;
        }
        --vvod;
        if (qs[vvod] == bst) {
            for (int i = 0; i < n; ++i) {
                cout << v[i].ff << " ";
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
//    freopen("inputik.txt", "r", stdin);
//    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}