#include <bits/stdc++.h>

#define int long long

using namespace std;

int solve1(int n, vector <int>& a) {
    vector <int> dp(n, 0), p(n, -1);
    dp[0] = 1;
    for (int i = 1; i < n; ++i) {
        dp[i] = 1;
        for (int j = 0; j < i; ++j) {
            if (a[j] < a[i]) {
                if (dp[i] < dp[j] + 1) {
                    p[i] = j;
                    dp[i] = dp[j] + 1;
                }
                else if (dp[i] == dp[j] + 1 && a[j] < a[p[i]]) {
                    p[i] = j;
                    dp[i] = dp[j] + 1;
                }
            }
        }
    }
    int x = n - 1;
    for (int i = n - 2; i >= 0; --i) {
        if (dp[i] > dp[x] || (dp[i] == dp[x] && a[i] > a[x])) {
            x = i;
        }
    }
    vector <int> q, r, used(n, 0);
    while (x != -1) {
        q.push_back(a[x]);
        used[x] = 1;
        x = p[x];
    }
    sort(q.begin(), q.end());
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            r.push_back(a[i]);
        }
    }
    // for (auto x: q) cout << x << " "; cout << '\n';
    // for (auto x: r) cout << x << " "; cout << '\n';
    int ans = (int)q.size(), y = 1e9;
    for (auto z: r) {
        if (z < y) ans++;
        y = min(y, z);
    }
    return ans;
}

int solve2(int n, vector <int>& p) {
    vector <int> dp(n, 1), pr(n, -1);
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (p[j] > p[i]) {
                if (pr[i] == -1 || dp[j] + 1 > dp[i] || (dp[j] + 1 == dp[i] && p[j] > p[pr[i]])) {
                    dp[i] = dp[j] + 1;
                    pr[i] = j;
                }
            }
        }
    }
    int x = n - 1;
    for (int i = n - 2; i >= 0; --i) {
        if (dp[i] > dp[x] || (dp[i] == dp[x] && p[i] < p[x])) {
            x = i;
        }
    }
    vector <int> q, r, used(n, 0);
    while (x != -1) {
        used[x] = 1;
        r.push_back(p[x]);
        x = pr[x];
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            q.push_back(p[i]);
        }
    }
    int ans = (int)r.size(), X = 0;
    for (auto x: q) {
        if (x > X) ans++;
        X = max(X, x);
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        int n; cin >> n;
        vector <int> p(n);
        for (int i = 0; i < n; ++i) cin >> p[i];
        cout << max(solve1(n, p), solve2(n, p)) << '\n';
    }
    return 0;
}