#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <iomanip>
#include <random>

using namespace std;

int code(int x, int n) {
    if (x == n) {
        return 1;
    }
    if (x == n + 1) {
        return 2;
    }
    return x + 1;
}

int decode(int x, int n) {
    if (x == 1) {
        return n;
    }
    if (x == 0) {
        return n - 1;
    }
    return x - 1;
}

void solve1(int n, int k, vector<int> v) {
    int a, b;
    a = v[0];
    b = v[1];
    vector<int> ans;
    if (a + 1 == b) {
        ans = {code(b, n), code(b + 1, n)};
    } else {
        ans = {code(a, n), code(b, n)};
    }
    sort(ans.begin(), ans.end());
    for (auto i : ans) {
        cout << i << " ";
    }
}

void solve2(int n, int k, vector<int> v) {
    int a, b;
    a = v[0];
    b = v[1];
    vector<int> ans;
    if (a + 1 == b) {
        ans = {decode(a - 1, n), decode(a, n)};
    } else {
        ans = {decode(a, n), decode(b, n)};
    }
    sort(ans.begin(), ans.end());
    for (auto i : ans) {
        cout << i << " ";
    }
}

void solve() {
    int t;
    cin >> t;
    int m;
    cin >> m;
    while (m--) {
        int n, k;
        cin >> n >> k;
        vector<int> v(k);
        for (int i = 0; i < k; ++i) {
            cin >> v[i];
        }
        if (t == 1) {
            solve1(n, k, v);
        } else {
            solve2(n, k, v);
        }
        cout << "\n";
    }
}

signed main() {
#ifdef BENTSA
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}
