#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <set>
#include <vector>
using namespace std;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
typedef long long ll;

const int K = 1e5 + 10;
vector<ll> x, y;

ll f(int x1, int x2, int n) {
	int v = min(x2 - 1, n - x1);
	return min(v, n - v);
}

inline void solve() {
	int h, w, k;
	cin >> h >> w >> k;
	vector<ll> _x, _y;
	for (int i = 0; i < k; i++) {
		ll cx, cy;
		cin >> cy >> cx;
		_x.push_back(cx);
		_y.push_back(cy);
	}
	sort(all(_x));
	sort(all(_y));
	x.push_back(_x[0]);
	for (int i = 1; i < k; i++) {
		if (_x[i] != _x[i - 1]) {
			x.push_back(_x[i]);
		}
	}
	y.push_back(_y[0]);
	for (int i = 1; i < k; i++) {
		if (_y[i] != _y[i - 1]) {
			y.push_back(_y[i]);
		}
	}
	ll ans1 = 3e9, ans2 = 1;
	for (ll i = h; i <= h; i++) {
		for (ll j = w; j <= w; j++) {
			auto yp = lower_bound(all(y), i);
			ll y1, y2;
			if (*yp == y[0]) {
				y1 = y[0];
				y2 = y.back();
			}
			else {
				y1 = *yp;
				y2 = *prev(yp);
			}
			ll dy = (y1 < y2 ? y2 - y1 + 1 : h - y1 + 1 + y2);
			auto xp = lower_bound(all(x), j);
			ll x1, x2;
			if (*xp == x[0]) {
				x1 = x[0];
				x2 = x.back();
			}
			else {
				x1 = *xp;
				x2 = *prev(xp);
			}
			ll dx = (x1 < x2 ? x2 - x1 + 1 : w - x1 + 1 + x2);
			if (dx * dy < ans1) {
				ans1 = dx * dy;
				ans2 = (y1 < y2 ? f(y1, y2, h) : f(y2, y1, h)) +
					(x1 < x2 ? f(x1, x2, w) : f(x2, x1, w));
			}
			else if (dx * dy == ans1) {
				ans2 = min(ans2, (y1 < y2 ? f(y1, y2, h) : f(y2, y1, h)) +
					(x1 < x2 ? f(x1, x2, w) : f(x2, x1, w)));
			}
		}
	}
	cout << ans1 << ' ' << ans2;
}

int main() {
#ifdef OPIUMCAT
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}