#include <iostream>
#include <vector>

using namespace std;

int solve(int n)
{
	auto arr = new int[n];
	auto take = new bool[n];
	vector<pair<int, int>> rec, antirec;
	rec.emplace_back(0, 0);
	antirec.emplace_back(0, n+1);
	int res = 0, max = INT_MAX;
	for (int i = 0; i < n; i++)
	{
		cin >> arr[i];
		take[i] = false;
		if (arr[i] < max)
		{
			res++;
			max = arr[i];
		}
		antirec.emplace_back(res, max);
	}
	max = res;

	for (int i = 1; i < 1 << n; i++)
	{
		int j;
		for (j = n - 1; take[j]; j--)
		{
			take[j] = false;
			res -= rec.back().first - rec[rec.size() - 2].first;
			rec.pop_back();
		}
		take[j] = true;
		res -= antirec.back().first - antirec[antirec.size() - 2].first;
		antirec.pop_back();

		if (rec.back().second < arr[j])
		{
			rec.emplace_back(rec.back().first + 1, arr[j]);
			res++;
		}
		else rec.push_back(rec.back());
		for (j++; j < n; j++)
		{
			if (antirec.back().second > arr[j])
			{
				antirec.emplace_back(antirec.back().first + 1, arr[j]);
				res++;
			}
			else antirec.push_back(antirec.back());
		}

		if (res > max) max = res;
	}

	delete[] arr;
	delete[] take;

	return max;
}

int main()
{
	int t, n;
	cin >> t;

	for (int i = 0; i < t; i++)
	{
		cin >> n;
		cout << solve(n) << endl;;
	}

	return 0;
}
