#pragma GCC optimize("O3, bmi, bmi2, popcnt, lzcnt")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#ifdef LOCAL
#define FAST_IO ;
#else
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define eb emplace_back
#define sz(v) (int)(v.size())
#define mp(a, b) make_pair(a, b)



const int N = 101, MAXW = 5000;



int n, q;
int arr[N];
bitset<MAXW> cur[MAXW], pre[MAXW];


void countDp() {
    pre[0][0] = true;
    for (int i = 1; i <= n; ++i) {
        for (int w1 = 0; w1 < MAXW; ++w1) {
            cur[w1] = pre[w1];
            if (w1 >= arr[i])
                cur[w1] |= pre[w1 - arr[i]];
            cur[w1] |= pre[w1] << arr[i];
        }

        swap(pre, cur);
        for (int w1 = 0; w1 < MAXW; ++w1)
            cur[w1].reset();
    }

    for (int w1 = 0; w1 < MAXW; ++w1)
        pre[w1].flip();
}

int first[MAXW];
int mimi[MAXW];

void findFirst() {
    for (int x = 0; x < MAXW; ++x) {
        first[x] = pre[x]._Find_first();
        mimi[x] = min(first[x], x ? mimi[x - 1] : MAXW);
    }
}


bool check(int a, int b) {
    return mimi[a] > b;
}


signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    cin >> n >> q;
    for (int i = 1; i <= n; ++i)
        cin >> arr[i];
    sort(arr + 1, arr + n + 1);
    int z; cin >> z;

    countDp();
    findFirst();

    while (q--) {
        int k, a, b; cin >> k >> a >> b;
        cout << (check(a, b) ? "YES" : "NO") << endl;
    }

}