#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pikachu push_back
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pll pair<ll, ll>
#define pii pair<int, int>
#define st first
#define nd second

template<typename T>
string to_string(T v) {
    bool f = 1;
    string res = "{";
    for (auto x: v) {
        if (!f) res += ", ";
        res += to_string(x);
        f = 0;
    }
    res += "}";
    return res;
}

void debug_out() {
    cerr << endl;
}

template<typename H, typename... T>
void debug_out(H head, T... tail) {
    cerr << " " << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

template<typename A, typename B>
bool cmax(A &a, const B &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

void run();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
}

const int INF = 1e9;

void task() {
    int n;
    cin >> n;
    vector<int> p(n), mx = {-INF}, mi = {INF};
    for (auto &e: p) {
        cin >> e;
        mx.pikachu(max(mx.back(), e));
        mi.pikachu(min(mi.back(), e));
    }
    vector<array<int, 3>> dp;
    vector<array<int, 3>> dp2;
    dp.pikachu({-INF, INF, 0});
    for (int i = 0; i < n; ++i) {
        for (auto [a, b, w]: dp) {
            if (p[i] > a) dp2.pikachu({p[i], b, w + 1});
            else dp2.pikachu({a, b, w});
            if (p[i] < b) dp2.pikachu({a, p[i], w + 1});
            else dp2.pikachu({a, b, w});
        }
        dp2.resize(unique(all(dp2)) - dp2.begin());
        swap(dp2, dp);
        dp2.clear();
    }
    int ans = 0;
    for (auto [a, b, w]: dp) {
        cmax(ans, w);
    }
    cout << ans << '\n';
}

void run() {
    ll t;
    cin >> t;
    while (t--) {
        task();
    }
}