#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int A = 5000 + 228;

int dp[A], dq[A];

template<typename T>
void ckmax(T &a, T b) {
    if (a < b) a = b;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<ll> w(n);

    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }

    sort(w.begin(), w.end());

    int z;
    cin >> z;

    ll sumV = 0;

    vector<array<ll, 3>> Q(q);
    vector<bool> answer(q);
    vector<vector<int>> queries(n);

    for (int i = 0; i < q; ++i) {
        cin >> Q[i][0] >> Q[i][1] >> Q[i][2];

        ll k = Q[i][0];

        auto it = std::upper_bound(w.begin(), w.end(), k) - w.begin() - 1;

        if (it < 0) {
            answer[i] = Q[i][1] == 0 && Q[i][2] == 0;
        } else {
            queries[it].push_back(i);
        }
    }

    dp[1] = 1;

    ll minX = 1;

    for (int i = 0; i < n; ++i) {
        int a = min(w[i], ll(A));

        if (minX >= a) {
            minX += a;
        }

        minX = min<ll>(minX, A - 2);

        memcpy(dq, dp, sizeof(dp));
        memset(dp, 0, sizeof(dp));

        for (int x = 1; x <= minX; ++x) {
            int y = dq[x];

            if (y >= a) {
                ckmax(dp[x], y + a);
            }

            ckmax(dp[min(A - 1, x + a)], y);

            dp[x] = max(dp[x], dq[x]);
        }

        for (int x = 2; x <= minX; ++x) {
            dp[x] = min(dp[x], dp[x - 1]);
        }

//        for (int x = 1; x <= minX; ++x) {
//            cout << dp[x] << " ";
//        }
//
//        cout << endl;

        for (int j : queries[i]) {
            ll qa = Q[j][1], qb = Q[j][2];

            if (qa < A && dp[qa + 1] > qb) {
                answer[j] = true;
            } else {
                answer[j] = false;
            }
        }
    }

    for (int i = 0; i < q; ++i) {
        if (answer[i]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }

    return 0;
}
