#include <iostream>
#include <algorithm>

using namespace std;

bool ok(pair<int, int> a, pair<int, int> b) {
    return a.second < b.first || b.second < a.first;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> segs;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) p[i] = i;
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        segs.push_back({ l, r });
    }
    for (int i = 0; i < n / 2; ++i) {
        vector<int> cnt(segs.size(), 0);
        for (int i = 0; i < segs.size(); ++i) {
            for (int j = 0; j < segs.size(); ++j) {
                if (ok(segs[i], segs[j])) ++cnt[i];
            }
        }
        int j = max_element(cnt.begin(), cnt.end()) - cnt.begin();
        segs.erase(segs.begin() + j);
        p.erase(p.begin() + j);
    }
    for (int i : p) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
