#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

bool ok(pair<int, int> a, pair<int, int> b) {
    return a.second < b.first || b.second < a.first;
}

void solve() {

}
#define int long long
const int inf = 1e18;
const int maxc = 5001;
int32_t main() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (int& i : w) {
        cin >> i;
    }
    int z;
    cin >> z;
    sort(w.begin(), w.end());
    vector<pair<int, vector<int>>> res;
    vector<int> dp(maxc, -inf);
    dp[0] = 0;
    for (int i : w) {
        vector<int> dpp = dp;
        for (int j = 0; j < maxc; ++j) {
            if (dp[j] + 1 >= i) {
                dpp[j] = max(dpp[j], dp[j] + i);
            }
            if (j >= i) {
                dpp[j] = max(dpp[j], dp[j - i]);
            }
        }
        dp = dpp;
        res.push_back({ i, dp});
    }
    int v = 0;
    while (q--) {
        int j, c, d;
        cin >> j >> c >> d;
        int k = j - v * z;
        int a = c - v * z;
        int b = d - v * z;
        int i = (--upper_bound(res.begin(), res.end(), make_pair(k, vector<int> (1, inf)))) - res.begin();
        if (i < 0) {
            if (a == b && a == 0) {
                cout << "Yes\n";
            } else {
                cout << "No\n";
            }
            continue;
        }
        bool ok = true;
        for (int j = 0; j <= a; ++j) {
            if (res[i].second[j] < b) ok = false;
        }
        if (ok) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
