#include <bits/stdc++.h>
using namespace std;

const int inf = 1e6;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--){
        int n;
        cin >> n;
        vector<int> a(n);
        for(int i=0;i<n;++i)
            cin >> a[i];
        if(n > 2000){
            vector<int> dp(n+1,inf);
            dp[0] = 0;
            for(const auto& e:a){
                int i = upper_bound(dp.begin(),dp.end(),e)-dp.begin();
                dp[i] = min(dp[i],e);
            }
            int l = 0;
            for(int i=0;i<n+1;++i)
                if(dp[i] != inf)
                    l = i;
            cout << (l == n ? n : l+1) << "\n";
            continue;
        }
        vector<map<int,int> > dp(n+1);
        dp[0][0] = n+1;
        for(int i=0;i<n;++i){
            vector<map<int,int> > nw(n+1);
            for(int s=0;s<n+1;++s){
                for(const auto& p:dp[s]){
                    if(a[i] > p.first)
                        nw[s+1][a[i]] = max(p.second,nw[s+1][a[i]]);
                    else
                        nw[s][p.first] = max(p.second,nw[s][p.first]);
                    if(a[i] < p.second)
                        nw[s+1][p.first] = max(a[i],nw[s+1][p.first]);
                    else
                        nw[s][p.first] = max(p.second,nw[s][p.first]);
                }
            }
            dp = nw;
        }
        for(int s=n;s>-1;--s){
            if(!dp[s].empty()){
                cout << s << "\n";
                break;
            }
        }
    }
    return 0;
}