#include <bits/stdc++.h>
using namespace std;

struct node {
    node* son = nullptr;
    int i;
    int q = 1;
    node(int i): i(i) {};
    node* bot() {
        if (this->son == nullptr) return this;
        return this->son->bot();
    }
    void add(node* v) {
        ++this->q;
        if (this->son == nullptr) this->son = v;
        else this->son->add(v);
    }
    void del() {
        --this->q;
        if (this->son == nullptr) return;
        if (this->son->son == nullptr) this->son = nullptr;
        else this->son->del();
    }
};



bool comp1(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
    return a.first.second < b.first.second;
}

bool comp2(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
    return a.first.second > b.first.second;
}

bool comp3(node* a, node* b) {
    return a->q < b->q;
}

bool comp4(node* a, node* b) {
    return a->q > b->q;
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<pair<pair<int, int>, int>> evs(n);
//        evs.resize(n);
        for(int i = 0; i < n; ++i) {
            cin >> evs[i].first.first >> evs[i].first.second;
            evs[i].second = i + 1;
        }

        sort(evs.begin(), evs.end(), comp1);
        int m = 1;
        int p = 0;
        int i = 1;
        while (true) {
            if (i == n) break;
            if (evs[i].first.first > evs[p].first.second) {
                p = i;
                ++m;
            }
            ++i;
        }
        vector<bool> stay(n, 1);

        sort(evs.begin(), evs.end(), comp2);
//        for (auto i : evs) cout << i.first.first << "/" << i.first.second << " ";
//        cout << endl;
        p = 0;
        vector<node*> keys = {new node(p)};
        i = 1;
        while (true) {
            if (i == n) break;
            if (evs[i].first.second < evs[p].first.first) {
                p = i;
                keys.push_back(new node(p));
            } else {
                keys.back()->add(new node(i));
            }
            ++i;
        }
        int n2 = n;
        int m2 = m;
        sort(keys.begin(), keys.end(), comp3);
//        for (auto i : keys) cout << i->i << "/" << i->q << " ";
//        cout << endl;

        for (auto i : keys) {
            if (m2 > m / 2 and i->q <= n2 - n / 2) {
                node* j = i;
//                cout << "&" << j->i << endl;
                while (j->son != nullptr) {
                        j = j->son;
//                        cout << "&" << j->i << endl;
                }
                while (i->q > 0) {
//                    cout << i->q << "/\n";
                    stay[i->bot()->i] = 0;
                    i->del();
                    --n2;
                }
                --m2;
            }
        }
        if (n2 > n / 2) {
            sort(keys.begin(), keys.end(), comp4);
            for (auto i : keys) {
//                cout << i->i << " " << i->q << endl;
                while (i->q > 1 and n2 > n / 2) {
                    stay[i->bot()->i] = 0;
                    i->del();
                    --n2;
                }
            }
        }
        for (int i = 0; i < n; ++i) {
            if (stay[i]) cout << evs[i].second << " ";
        }
        cout << endl;
    }
    return 0;
}
