#pragma GCC optimize ("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define assing assign
#define all(x) x.begin(), x.end()
#define int ll

const int MAXC = 1510;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    sort(all(a));
    vector<vector<vector<bool>>> dp(n + 1,vector<vector<bool>>(MAXC, vector<bool>(MAXC)));
    dp[0][0][0] = 1;
    for (int i = 1; i <= n; ++i)
        for (int x = 0; x < MAXC; ++x)
            for (int y = 0; y < MAXC; ++y)
                if (dp[i - 1][x][y]) {
                    if (x + a[i - 1] < MAXC)
                        dp[i][x + a[i - 1]][y] = 1;
                    if (y + a[i - 1] < MAXC)
                        dp[i][x][y + a[i - 1]] = 1;
                }

    for (int i = 0; i <= n; ++i)
        for (int x = 1; x < MAXC; ++ x)
            for (int y = 1; y < MAXC; ++y)
                dp[i][x][y] = dp[i][x - 1][y] & dp[i][x][y - 1] & dp[i][x][y];

    int z;
    cin >> z;
    while (q--) {
        int k, x, y;
        cin >> k >> x >> y;
        int t = upper_bound(all(a), k) - a.begin();
        cout << (dp[t][x][y] ? "Yes" : "No") << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t=  1;
    //cin >> t;
    while (t--)
        solve();
}
