#include <bits/stdc++.h>
using namespace std;

#define int long long

const int inf = 1e15;

signed main() {
    int h, w, k;
    cin >> h >> w >> k;
    vector<int> r(k), c(k);
    for (int i = 0; i < k; i++) cin >> r[i] >> c[i];
    for (int i = 0; i < k; i++) {
        r[i]--;
        c[i]--;
    }

    sort(r.begin(), r.end());
    sort(c.begin(), c.end());

    int min_h = inf, min_ah = inf, min_w = inf, min_aw = inf;

    if (k == 1) {
        cout << 1 << " " << 0 << "\n";
        exit(0);
    }

    for (int i = 0; i < k - 1; i++) {
        int nxt_steps = h - r[i + 1];
        int curr_h = r[i] + nxt_steps + 1;
        if (curr_h < min_h) {
            min_h = curr_h;
            min_ah = nxt_steps;
        } else if (curr_h == min_h && nxt_steps < min_ah) {
            min_ah = nxt_steps;
        }
    }

    for (int i = 1; i < k; i++) {
        int nxt_steps = r[i - 1] + 1;
        int curr_h = h - (r[i] - nxt_steps);
        if (curr_h < min_h) {
            min_h = curr_h;
            min_ah = nxt_steps;
        } else if (curr_h == min_h && nxt_steps < min_ah) {
            min_ah = nxt_steps;
        }
    }

    {
        int curr_h = (r.back() - r[0] + 1);
        int nxt_steps = 0;
        if (curr_h < min_h) {
            min_h = curr_h;
            min_ah = nxt_steps;
        } else if (curr_h == min_h && nxt_steps < min_ah) {
            min_ah = nxt_steps;
        }
    }

    for (int i = 0; i < k - 1; i++) {
        int nxt_steps = w - c[i + 1];
        int curr_w = c[i] + nxt_steps + 1;
        if (curr_w < min_w) {
            min_w = curr_w;
            min_aw = nxt_steps;
        } else if (curr_w == min_w && nxt_steps < min_aw) {
            min_aw = nxt_steps;
        }
    }

    for (int i = 1; i < k; i++) {
        int nxt_steps = c[i - 1] + 1;
        int curr_w = w - (c[i] - nxt_steps);
        if (curr_w < min_w) {
            min_w = curr_w;
            min_aw = nxt_steps;
        } else if (curr_w == min_w && nxt_steps < min_aw) {
            min_aw = nxt_steps;
        }
    }

    {
        int curr_w = (c.back() - c[0] + 1);
        int nxt_steps = 0;
        if (curr_w < min_w) {
            min_w = curr_w;
            min_aw = nxt_steps;
        } else if (curr_w == min_w && nxt_steps < min_aw) {
            min_aw = nxt_steps;
        }
    }

    cout << min_h * min_w << " " << min_ah + min_aw << "\n";
}