#include <bits/stdc++.h>
using namespace std;

#define B8_FAN

vector<int> tree;
int n;

void update(int i, int x) {
    for (i += n; i > 0; i >>= 1) {
        tree[i >> 1] = max(tree[i], tree[i ^ 1]);
    }
}

int get(int l, int r) {
    int ans = 0;
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) ans = max(ans, tree[l++]);
        if (r & 1) ans = max(ans, tree[--r]);
    }
    return ans;
}

void solve() {
    cin >> n;
    tree.assign(2 * n, 0);
    vector<int> p(n);
    for (int i = 0; i < n; i++) cin >> p[i];
    for (int i = 0; i < n; i++) p[i]--;

    vector<int> lis(n);
    vector<int> lisp(n);
    
    for (int i = 0; i < n; i++) {
        int mx_before = get(0, p[i]);
        lisp[p[i]] = mx_before + 1;
        update(p[i], lisp[p[i]]);
    }

    int lis_sz = get(0, n);

    for (int i = 0; i < n; i++) lis[i] = lisp[p[i]];

    vector<bool> in_lis(n, false);
    int prv = n;
    for (int i = n - 1; i >= 0; i--) {
        if (lis[i] == lis_sz && p[i] < prv) {
            prv = p[i];
            lis_sz--;
            in_lis[i] = true;;
        }
    }

    vector<int> app;
    for (int i = 0; i < n; i++) {
        if (!in_lis[i]) app.push_back(p[i]);
    }

    bool good = true;
    for (int i = 1; i < (int)app.size(); i++) {
        if (app[i] < app[i - 1]) {
            good = false;
            break;
        }
    }

    int ans = lis_sz + 1;
    if (!good) ans++;
    ans = max(ans, n);
    cout << ans << "\n";
}

int main() {
    #ifdef GEOMA
        freopen("input", "r", stdin);
        freopen("output", "w", stdout);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif

    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}