#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>
#include <set>
#include <assert.h>
#include <bitset>
typedef long long ll;
using namespace std;
bool dp[5001][5001];
int sum[5001][5001];
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, q; cin >> n >> q;
	vector <int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	dp[0][0] = 1;
	for (int i = 0; i < n; i++) {
		for (int x = 0; x <= 1500; x++) {
			for (int y = 0; y <= 1500; y++) {
				if (x - a[i] >= 0) dp[x][y] = dp[x - a[i]][y];
				if (y - a[i] >= 0) dp[x][y] = (dp[x][y] | dp[x][y - a[i]]);
			}
		}
	}
	sum[0][0] = 1;
	for (int i = 0; i <= 1500; i++) {
		for (int j = 0; j <= 1500; j++) {
			if (!i && !j) continue;
			if (i) sum[i][j] += sum[i - 1][j];
			if (j) sum[i][j] += sum[i][j - 1];
			if (i && j) sum[i][j] -= sum[i - 1][j - 1];
			if (dp[i][j]) sum[i][j]++;
		}
	}
	int z; cin >> z;
	while (q--) {
		int k, a, b; cin >> k >> a >> b;
		if (sum[a][b] == (a + 1) * (b + 1)) cout << "Yes\n";
		else cout << "No\n";
	}
	return 0;
}