#include "bits/stdc++.h"


using namespace std;
using ll = long long;

#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)


int main() {
	FAST_IO;
	ll h, w, n;
	cin >> h >> w >> n;
	vector<ll> x(n), y(n);
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> y[i];
	}
	sort(x.begin(), x.end());
	sort(y.begin(), y.end());

	ll best_size_x = (x.back() - x.front() + 1), best_size_y = (y.back() - y.front() + 1), best_cnt_x = 0, best_cnt_y = 0;

	//down
	for (int i = 1; i < n; ++i) {
		ll cnt_x = (h - x[i] + 1), cnt_y = (w - y[i] + 1);
		ll size_x = x[0] + cnt_x, size_y = y[0] + cnt_y;
		if (size_x < best_size_x || size_x == best_size_x && cnt_x < best_cnt_x) {
			best_size_x = size_x;
			best_cnt_x = cnt_x;
		}
		if (size_y < best_size_y || size_y == best_size_y && cnt_y < best_cnt_y) {
			best_size_y = size_y;
			best_cnt_y = cnt_y;
		}
	}

	//up
	for (int i = 0; i < n - 1; ++i) {
		ll cnt_x = x[i], cnt_y = y[i];
		ll size_x = h - (x[i + 1] - cnt_x) + 1, size_y = w - (y[i + 1] - cnt_y) + 1;
		if (size_x < best_size_x || size_x == best_size_x && cnt_x < best_cnt_x) {
			best_size_x = size_x;
			best_cnt_x = cnt_x;
		}
		if (size_y < best_size_y || size_y == best_size_y && cnt_y < best_cnt_y) {
			best_size_y = size_y;
			best_cnt_y = cnt_y;
		}
	}
	cout << best_size_x * best_size_y << ' ' << best_cnt_x + best_cnt_y;
}