#include "bits/stdc++.h"


using namespace std;
using ll = long long;

#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)


void encode() {
	int MAX, n;
	cin >> MAX >> n;
	vector<bool> used(MAX);
	vector<pair<int, int>> order(n);
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		used[x - 1] = true;
		order[i] = { x - 1, i };
	}
	sort(order.begin(), order.end());
	int cnt = 0;
	vector<int> ans;
	ans.reserve(n);
	vector<bool> filled(used.size());
	for (int i = 0; i < used.size(); ++i) {
		if (filled[i]) continue;
		if (used[i]) {
			++cnt;
			filled[i] = true;
		}
		else {
			if (cnt) {
				--cnt;
				filled[i] = true;
				ans.push_back(i + 1);
			}
		}
	}
	for (int i = 0; i < used.size(); ++i) {
		if (filled[i]) continue;
		if (used[i]) {
			++cnt;
			filled[i] = true;
		}
		else {
			if (cnt) {
				--cnt;
				ans.push_back(i + 1);
			}
		}
	}
	sort(ans.begin(), ans.end());
	vector<int> true_ans(n);
	for (int i = 0; i < n; ++i) true_ans[i] = ans[order[i].second];
	for (auto it : true_ans) cout << it << ' ';
}


void decode() {
	int MAX, n;
	cin >> MAX >> n;
	vector<bool> used(MAX);
	vector<pair<int, int>> order(n);
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		used[x - 1] = true;
		order[i] = { x - 1, i };
	}
	sort(order.begin(), order.end());
	int cnt = 0;
	vector<int> ans;
	ans.reserve(n);
	vector<bool> filled(used.size());
	for (int i = used.size() - 1; i >= 0; --i) {
		if (filled[i]) continue;
		if (used[i]) {
			++cnt;
			filled[i] = true;
		}
		else {
			if (cnt) {
				--cnt;
				filled[i] = true;
				ans.push_back(i + 1);
			}
		}
	}
	for (int i = used.size() - 1; i >= 0; --i) {
		if (filled[i]) continue;
		if (used[i]) {
			++cnt;
			filled[i] = true;
		}
		else {
			if (cnt) {
				--cnt;
				ans.push_back(i + 1);
			}
		}
	}
	sort(ans.begin(), ans.end());
	vector<int> true_ans(n);
	for (int i = 0; i < n; ++i) true_ans[order[i].second] = ans[i];
	for (auto it : true_ans) cout << it << ' ';
}



int main() {
	FAST_IO;
	int type;
	cin >> type;
	if (type == 1) {
		int t;
		for (cin >> t; t; --t) { encode(); cout << endl; }
	}
	else {
		int t;
		for (cin >> t; t; --t) { decode(); cout << endl; }
	}
}