#include <bits/stdc++.h>
using namespace std;
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int n, k, q;
    cin >> n >> k >> q;
    vector<int> l(n), r(n);
    vector<int> leafs;
    vector<bool> is(n);
    vector<int> rot(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 0) {
            is[i] = true;
            leafs.push_back(i);
        } else {
            cin >> l[i] >> r[i];
            l[i]--, r[i]--;
        }
    }
    vector<int> ord;
    vector<int> L(n), R(n);
    function<void(int, int, int)> dfs = [&](int v, int prv, int cnt) {
        if (!is[v]) {
            if (prv == -1) {
                dfs(l[v], 0, cnt);
                dfs(r[v], 1, cnt);
            } else if (prv == 0) {
                dfs(l[v], 0, cnt);
                dfs(r[v], 1, cnt + 1);
            } else {
                dfs(l[v], 0, cnt + 1);
                dfs(r[v], 1, cnt);
            }
            L[v] = L[l[v]];
            R[v] = R[r[v]];
        } else {
            L[v] = R[v] = ord.size();
            ord.push_back(v);
            rot[v] = cnt;
        }
    };
    dfs(0, -1, 0);
    vector<int> pref(ord.size() + 1);
    for (int i = 0; i < ord.size(); i++) {
        pref[i + 1] = pref[i];
        if (rot[ord[i]] <= k) {
            pref[i + 1]++;
        }
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << pref[R[v] + 1] - pref[L[v]] << "\n";
    }
}