#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
typedef long long ll;
#define endl '\n'

const int N = 100010;

int n;

struct seg
{
	int l, r, i;

	seg() {}
};

seg a[N];
int ans[N];
int gt[N];
int pr[N];
bool ch[N];
vector <int> cro[N];

inline void solve()
{
	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i].l >> a[i].r;
		a[i].i = i;
	}

	sort(a + 1, a + 1 + n, [&](const seg& a, const seg& b) { return a.r < b.r; });

	pair <int, int> mx = { 0, 0 };

	for (int i = 1; i <= n; ++i)
	{
		int l = 0, r = i;
		while (l + 1 < r)
		{
			int mid = (l + r) >> 1;
			if (a[mid].r < a[i].l) l = mid;
			else r = mid;
		}

		if (l == 0)
		{
			ans[i] = 1;
			gt[i] = i;
			pr[i] = 0;
		}
		else
		{
			ans[i] = ans[l] + 1;
			if (mx.first > ans[i])
			{
				ans[i] = mx.first;
				gt[i] = mx.second;
				pr[i] = 0;
			}
			else
			{
				if (ans[i] > mx.first) mx = { ans[i], i };
				gt[i] = i;
				pr[i] = l;
			}
		}
	}

	for (int i = 1; i <= n; ++i) ch[i] = false;

	vector <int> maxi;
	vector <int> oth;
	int u = mx.second;
	while (u)
	{
		ch[u] = true;
		maxi.push_back(u);
		u = pr[u];
	}

	for (int i = 1; i <= n; ++i) if (!ch[i]) oth.push_back(i);
	for (int i = 1; i <= n; ++i) cro[i].clear();

	for (auto i : oth)
	{
		for (auto j : maxi)
		{
			if (!(a[i].r < a[j].l) && !(a[j].r < a[i].l))
			{
				cro[j].push_back(i);
				break;
			}
		}
	}

	vector <pair <int, int>> all;
	for (auto i : maxi)
	{
		all.push_back({ (int)cro[i].size(), i });
	}

	sort(all.rbegin(), all.rend());

	vector <int> ans;
	vector <int> ans2;
	for (int _ = 0; _ < all.size() / 2; ++_)
	{
		auto i = all[_];
		ans.push_back(i.second);
		for (auto j : cro[i.second]) ans2.push_back(j);
	}

	ans2.resize((n - all.size()) / 2);

	vector <int> fin;
	for (auto i : ans) fin.push_back(a[i].i);
	for (auto j : ans2) fin.push_back(a[j].i);

	for (auto i : fin) cout << i << ' ';
	cout << endl;

	return;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}