#include <bits/stdc++.h>
using namespace std;
#define int long long
const int maxn = 2e5 + 500;
vector <int> g[maxn];
int to[maxn];
int k;
bool is_left_child[maxn];
void dfs(int v) {
    if (g[v].empty()) return;
    is_left_child[g[v][0]] = 1;
    if (is_left_child[v]) {
        to[g[v][0]] = to[v];
        to[g[v][1]] = to[v] + 1;
    } else {
        to[g[v][0]] = to[v] + 1;
        to[g[v][1]] = to[v];
    }
    dfs(g[v][0]);
    dfs(g[v][1]);
}

int cnt[maxn];
void dfs2(int v) {
    if (g[v].empty()) {
        if (to[v] <= k) cnt[v] = 1;
        return;
    }
    dfs2(g[v][0]);
    dfs2(g[v][1]);
    cnt[v] = cnt[g[v][0]] + cnt[g[v][1]];
    return;
}
signed main() {
    int n, q;
    cin >> n >> k >> q;
    for (int i = 1; i <= n; i++) {
        int t; cin >> t;
        if (t == 0) continue;
        int l, r;
        cin >> l >> r;
        g[i] = {l, r};
    }
    to[1] = 0;
    is_left_child[g[1][0]] = 1;
    dfs(g[1][0]);
    dfs(g[1][1]);
    dfs2(g[1][0]), dfs2(g[1][1]);
    cnt[1] = cnt[g[1][0]] + cnt[g[1][1]];
    for (int i = 0; i < q; i++) {
        int v; cin >> v;
        cout << cnt[v] << '\n';
    }

}