#include <bits/stdc++.h>
using namespace std;
#define int long long
const int maxn = 505;
int dp[maxn][maxn];
struct event{
    int l, r;
    int num;
};

bool comp(event a, event b) {
    if (a.r == b.r) return a.l < b.l;
    return a.r < b.r;
}
bool comp2(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}
void solve() {
    int n; cin >> n;
    vector <event> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i].l >> a[i].r, a[i].num = i;
    a[0] = {-1, 0, 0};
    std::sort(a.begin(), a.end(), comp);
    vector <int> dp1(n + 1, -1e9);
    vector <int> real(n + 1);
    dp1[0] = 0;
    for (int i = 1; i <= n; i++) {
        int l = 0, r = i;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (a[mid].r < a[i].l) l = mid;
            else r = mid;
        }
        real[i] = dp1[l] + 1;
        dp1[i] = dp1[l] + 1;
        dp1[i] = max(dp1[i], dp1[i - 1]);
    }
    int m = dp1[n];
    // m done correctly



    vector <pair<int, int>> gg(m + 1);
    vector <vector <int>> eq_classes(m + 1);
    int mxnow = 0;
    for (int i = 1; i <= n; i++) {
        if (real[i] > mxnow) {
            gg[real[i]].first = i;
            gg[real[i]].second = 1;
            mxnow = real[i];
        } else {
            gg[real[i]].second++;
        }
        eq_classes[real[i]].push_back(i);
    }


    vector <bool> deleted(n + 1, 0);
    std::sort(gg.begin() + 1, gg.end(), comp2);


    int del_now = 0;
    int ptr_first_alive = m / 2 + 1;
    for (int i = 1; i <= m / 2; i++) {
        if (del_now + gg[i].second <= n / 2) {
            int p = real[gg[i].first];
            del_now += gg[i].second;
            for (int j = 1; j <= n; j++) {
                if (real[j] == p) {
                    deleted[j] = 1;
                }
            }
        } else {
            ptr_first_alive = i;
            break;
        }
    }


    for (int i = ptr_first_alive; i <= m && del_now < n / 2; i++) {
        int p = real[gg[i].first];
        while (eq_classes[p].size() > 1 && del_now < n / 2) {
            deleted[eq_classes[p].back()] = 1;
            eq_classes[p].pop_back();
            del_now++;
        }
    }


    vector <int> c;
    for (int i = 1; i <= n; i++) if (!deleted[i]) c.push_back(a[i].num);
    std::sort(c.begin(), c.end());
    for (int i: c) cout << i << ' ';
    cout << '\n';




}

signed main() {
    int t; cin >> t;
    while (t--) solve();
}