#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(2e18) + 13;

template<typename T> inline bool smin(T&a, T b) {
  if (b < a) {
    a = b;
    return true;
  }
  return false;
}
template<typename T> inline bool smax(T&a, T b) {
  if (a < b) {
    a = b;
    return true;
  }
  return false;
}

constexpr int N = 2e2 + 3;
int dp[N][N][N];
int mnn[N][N], mxx[N][N];
pair<int, int> p[N][N][N];

void Solve() {

  int n;
  cin >> n;
  for (int i = 0; i <= n; ++i)
    for (int j = 0; j <= n; ++j)
      fill(dp[i][j], dp[i][j] + n + 1, -INF);
  dp[0][0][0] = 0;
  vector<int> a(n);
  for (int & i : a) cin >> i;
  for (int i = 0; i < n; ++i)
    mnn[i][i] = mxx[i][i] = a[i];
  for (int i = 0; i < n; ++i) {
    for (int j = i+1; j < n; ++j) {
      mnn[i][j] = min(mnn[i][j - 1], a[j - 1]);
      mxx[i][j] = max(mnn[i][j - 1], a[j - 1]);
    }
  }
  for (int i = 1; i <= n; ++i) {
    for (int mn = 0; mn < i; ++mn) {
      for (int mx = 0; mx < i; ++mx) {
        if (mx != 0 || mn != 0) {
          int lmx = mx == 0 ? -INF : a[mx - 1];
          int lmn = mn == 0 ? INF : a[mn - 1];
          int x = mxx[0][i - 1];
          if (x > lmx && x < lmn) continue;
          x = mnn[0][i - 1];
          if (x > lmx && x < lmn) continue;
        }

        dp[i][mn][mx] = dp[i-1][mn][mx];
        p[i][mn][mx] = { mn, mx };
        if (mx == 0 || a[i-1] > a[mx-1])
          if (smax(dp[i][mn][i], dp[i-1][mn][mx] + 1)) {
            p[i][mn][i] = { mn, mx };
          }
        if (mn == 0 || a[i-1] < a[mn-1])
          if (smax(dp[i][i][mx], dp[i-1][mn][mx] + 1)) {
            p[i][i][mx] = { mn, mx };
          }
      }
    }
  }
  int ans = 0;
  for (int i = 0; i <= n; ++i)
    for (int j = 0; j <= n; ++j)
      if (smax(ans, dp[n][i][j])) {
//        cout << i << ' ' << j << ' ' << ans << endl;
      }
  cout << ans << '\n';
}

int32_t main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int T;
  cin >> T;
  while (T--) {
    Solve();
  }

  return 0;
}
