#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
constexpr int INF = int(1e9) + 7;

template<typename T> inline bool smax(T&a, T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T> inline bool smin(T&a, T b) {
  if (b < a) { a = b; return true; }
  return false;
}

void Solve() {
  int n;
  cin >> n;
  vector<int> vals(n * 2);
  vector<int> l(n), r(n);
  vector<int> ord(n);
  {
    vector<pair<pair<int, int>, int>> x(n);
    for (int i = 0; i < n; ++i) {
      cin >> x[i].first.second >> x[i].first.first;
      x[i].second = i;
      vals[i * 2] = x[i].first.first;
      vals[i * 2 + 1] = x[i].first.second;
    }
    sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
    sort(x.begin(), x.end());
    for (int i = 0; i < n; ++i) {
      tie(r[i], l[i]) = x[i].first;
      ord[i] = x[i].second;
      l[i] = lower_bound(vals.begin(), vals.end(), l[i]) - vals.begin();
      r[i] = lower_bound(vals.begin(), vals.end(), r[i]) - vals.begin();
    }
  }
  auto Len = [&l, &r, &n](int en) {
    int prev = -1, cnt = 0;
    for (int i = 0; i < n; ++i) {
      if (l[i] > prev && (en >> i & 1)) {
        prev = r[i];
        cnt++;
      }
    }
    return cnt;
  };
  int tg = Len((1 << n) - 1) / 2;
  for (int m = 0, mx = 1 << n; m < mx; ++m) {
    if (__builtin_popcount(m) != n / 2) continue;
    if (Len(m) == tg) {
      for (int i = 0; i < n; ++i) {
        if (m >> i & 1) {
          cout << ord[i] + 1 << ' ';
        }
      }
      cout << '\n';
      return;
    }
  }
  assert(false);

}

int main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int T;
  cin >> T;
  while (T--) {
    Solve();
  }

  return 0;
}
