#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
constexpr int INF = int(1e9) + 7;

template<typename T> inline bool smax(T&a, T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T> inline bool smin(T&a, T b) {
  if (b < a) { a = b; return true; }
  return false;
}

void Solve() {
  int n;
  cin >> n;
  vector<int> vals(n * 2);
  vector<pair<int, int>> x(n);
  for (int i = 0; i < n; ++i) {
    cin >> x[i].second >> x[i].first;
    vals[i * 2] = x[i].first;
    vals[i * 2 + 1] = x[i].second;
  }
  sort(vals.begin(), vals.end());
  vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
  sort(x.begin(), x.end());
  vector<int> l(n), r(n);
  for (int i = 0; i < n; ++i) {
    tie(r[i], l[i]) = x[i];
    l[i] = lower_bound(vals.begin(), vals.end(), l[i]) - vals.begin();
    r[i] = lower_bound(vals.begin(), vals.end(), r[i]) - vals.begin();
  }
  int prev = -INF;
  vector<int> opt;
  for (int i = 0; i < n; ++i) {
    if (l[i] <= prev) continue;
    opt.push_back(i);
    prev = r[i];
  }
  int tg = int(opt.size()) / 2;
  vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(tg + 1, vector<int>(n / 2 + 1)));
  vector<vector<vector<int>>> p(n + 1, vector<vector<int>>(tg + 1, vector<int>(n / 2 + 1)));

  dp[0][0][0] = 1;
  for (int i = 1; i <= n; ++i) {
    for (int k = 1; k <= tg; ++k) {
      for (int d = 0; d <= n/2; ++d) {
        int mx = 0;
        for (int j = i-1; j > 0; --j) {
          if (r[j-1] > l[i-1]) continue;
          if (i - j - 1 > d) break;
          if (r[j-1] < mx) break;
          smax(mx, l[j-1]);
          if (dp[j][k-1][d - (i - j - 1)]) {
            dp[i][k][d] = 1;
            p[i][k][d] = j;
            break;
          }
        }
      }
    }
  }
  assert(dp[n][tg][n/2]);

}

int main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int T;
  cin >> T;
  while (T--) {
    Solve();
  }

  return 0;
}
