#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
constexpr int INF = int(1e9) + 7;

template<typename T> inline bool smax(T&a, T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T> inline bool smin(T&a, T b) {
  if (b < a) { a = b; return true; }
  return false;
}

constexpr int N = 500;
bitset<N> bs[2][N];
char ans[N][N];

int32_t main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  int n, q;
  cin >> n >> q;
  vector<ll> w(n);
  for (int i = 0; i < n; ++i) cin >> w[i];
  sort(w.begin(), w.end());
  bs[0][0][0] = 1;
  for (int i = 0; i < n; ++i) {
    for (int x = 0; x < N; ++x) {
      bs[i & 1 ^ 1][x] = bs[i & 1][x] | (bs[i & 1][x] << w[i]);
    }
    for (int x = 0; x < N; ++x) {
      if (x + w[i] < N)
        bs[i & 1 ^ 1][x + w[i]] |= bs[i & 1][x];
    }
  }
  int act = n & 1;
  ans[0][0] = 1;
  for (int i = 1; i < N; ++i) {
    ans[i][0] = ans[i-1][0] && bs[act][i][0];
    ans[0][i] = ans[0][i-1] && bs[act][0][i];
  }
  for (int i = 1; i < N; ++i)
    for (int j = 1; j < N; ++j)
      ans[i][j] = ans[i-1][j] && ans[i][j-1] && bs[act][i][j];
  ll z;
  cin >> z;
  ll v = 0;
  for (int qq = 1; qq <= q; ++qq) {
    ll j, c, d;
    cin >> j >> c >> d;
    ll k = j - v * z;
    ll a = c - v * z;
    ll b = d - v * z;
    cout << (ans[a][b] ? "Yes" : "No") << '\n';
    if (ans[a][b] ) v += qq;
  }

  return 0;
}
