#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

int n, k, q;
vector <vector <int>> gr;
vector <int> ans;

void dfs(int v, int rem, int prev) {
    if (gr[v].size() == 0) {
        ans[v] = 1;
        return;
    }
    if (rem == 0) {
        dfs(gr[v][prev], rem, prev);
        ans[v] += ans[gr[v][prev]];
    } else {
        dfs(gr[v][prev], rem, prev);
        dfs(gr[v][!prev], rem - 1, !prev);
        ans[v] = ans[gr[v][0]] + ans[gr[v][1]];
    }
}

void solve() {
    cin >> n >> k >> q;

    gr.resize(n);
    ans.assign(n, 0);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;

        if (t == 2) {
            int l, r;
            cin >> l >> r;
            l--; r--;

            gr[i].push_back(l);
            gr[i].push_back(r);
        }
    }

    dfs(gr[0][0], k, 0);
    dfs(gr[0][1], k, 1);
    ans[0] = ans[gr[0][0]] + ans[gr[0][1]];

    while (q--) {
        int v;
        cin >> v;
        v--;

        cout << ans[v] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
