#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

int calc(vector <int>& l, vector <int>& r) {
    int n = l.size();
    vector <int> ord(n);
    iota(all(ord), 0);

    vector <int> dp(n, 1);
    for (int i = 1; i < n; i++) {
        for (int j = 0; j < i; j++) {
            if (r[ord[j]] < l[ord[i]])
                dp[i] = max(dp[i], dp[j] + 1);
        }
    }
    return *max_element(all(dp));
}

void solve() {
    int n;
    cin >> n;

    vector <int> l(n), r(n);
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];

    int m = calc(l, r);
    assert(m % 2 == 0);

    for (int mask = 0; mask < (1 << n); mask++) {
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i))
                cnt++;
        }
        if (cnt != n / 2) continue;

        vector <int> nl, nr;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                nl.push_back(l[i]);
                nr.push_back(r[i]);
            }
        }
        if (calc(nl, nr) == m / 2) {
            for (int i = 0; i < n; i++) {
                if (mask & (1 << i)) {
                    cout << i + 1 << " ";
                }
            }
            cout << "\n";
            return;
        }
    }
    assert(false);
}

signed main() {
    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}
