#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct event {
    int l, r, i;

    bool operator<(event b) {
        return pair<int, int>{l, r} < pair<int, int>{b.l, b.r};
    }
};


void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (auto &el: w) {
        cin >> el;
    }
    ll z;
    cin >> z;
    int v = 0;
    vector<vector<bool>> can;
    can.resize(1500 + 1, vector<bool>(1500 + 1, false));
    can[0][0] = true;
    for (auto el: w) {
        for (int i1 = 300; i1 > -1; i1--) {
            for (int b1 = 300; b1 > -1; b1--) {
                if (can[i1][b1]) {
                    if (i1 + el <= 300) {
                        can[i1 + el][b1] = true;
                    }
                    if (b1 + el <= 300) {
                        can[i1][b1 + el] = true;
                    }
                }
            }
        }
    }
    for (int a1 = 0; a1 <= 300; a1++) {
        for (int b1 = 0; b1 <= 300; b1++) {
            if (a1 != 0) {
                can[a1][b1] = can[a1][b1] & can[a1 - 1][b1];
            }
            if (b1 != 0){
                can[a1][b1] = can[a1][b1] & can[a1][b1 - 1];
            }
        }
    }
    for (int i = 0; i < q; i++) {
        ll a, b, k, j1, c, d;
        cin >> j1 >> c >> d;
        k = j1 - v * z;
        a = c - v * z;
        b = d - v * z;
        bool is = can[a][b];
        cout << (is ? "Yes\n" : "No\n");
        v += is;
    }

}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}