
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <random>

using namespace std;

typedef long long ll;

// bitset<2000> dp[2000];
mt19937 rnd(79797);

bool comp(pair<int, int> &a, pair<int, int> &b) {
	return a.second < b.second;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int t;
	cin >> t;

	while (t--) {
		int n;
		cin >> n;
		vector<int> blabla(n);
		for (int i = 0; i < n; i++) {
			blabla[i] = i;
		}
		vector<bool> used1(n);
		shuffle(blabla.begin(), blabla.end(), rnd);
		pair<int, int> arr[n];
		for (int i = 0; i < n; i++) {
			cin >> arr[i].first >> arr[i].second;
		}
		vector<int> inds(n);
		for (int i = 0; i < n; i++) {
			inds[i] = i;
		}
		sort(inds.begin(), inds.end(), [&arr](int a, int b) {
			return comp(arr[a], arr[b]);
			});
		vector<int> aaa;
		int last = -1;
		vector<bool> used(n);
		for (auto i : inds) {
			if (arr[i].first > last) {
				last = arr[i].second;
				aaa.push_back(i);
				used[i] = true;
			}
		}
		int m = aaa.size();
		while (1) {
			shuffle(aaa.begin(), aaa.end(), rnd);
			vector<int> eee;
			for (int i = 0; i < m / 2; i++) {
				eee.push_back(aaa[i]);
			}
			sort(eee.begin(), eee.end(), [&arr](int a, int b) {
				return comp(arr[a], arr[b]);
				});
			int TMP = m / 2;

			for (auto i: blabla) {
				if (!used[i]) {
					int l = -1, r = eee.size();
					while (l + 1 < r) {
						int mid = (l + r) / 2;
						if (arr[eee[mid]].second < arr[i].first) {
							l = mid;
						}
						else {
							r = mid;
						}
					}
					if (l != eee.size() - 1 && arr[eee[r]].first <= arr[i].second && eee[r] != i) {
						TMP++;
					}
				}
			}
			if (TMP >= n / 2) {
				vector<int> ooo = eee;
				for (auto i : blabla) {
					if (!used[i] && ooo.size() != n / 2) {
						int l = -1, r = eee.size();
						while (l + 1 < r) {
							int mid = (l + r) / 2;
							if (arr[eee[mid]].second < arr[i].first) {
								l = mid;
							}
							else {
								r = mid;
							}
						}
						if (l != eee.size() - 1 && arr[eee[r]].first <= arr[i].second && eee[r] != i) {
							ooo.push_back(i);
						}
					}
				}
				/*sort(ooo.begin(), ooo.end(), [&arr](int a, int b) {
					return comp(arr[a], arr[b]);
					});*/
				for (auto el : ooo) {
					used1[el] = true;
				}
				int last = -1;
				TMP = 0;
				for (auto i : inds) {
					if (used1[i] && arr[i].first > last) {
						last = arr[i].second;
						TMP++;
					}
				}
				if (TMP == m / 2 && ooo.size() == n / 2) {
					for (auto el : ooo) {
						cout << el + 1 << ' ';
					}
					cout << '\n';
					break;
				}
				for (auto el : ooo) {
					used1[el] = false;
				}
				
			}
		}
	}
}