#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long ll;


int main() {
	ll w, h, k;
	cin >> w >> h >> k;
	vector<ll>rows, cols;
	for (int i = 0; i < k; i++) {
		ll x, y;
		cin >> x >> y;
		rows.push_back(x);
		cols.push_back(y);
	}
	sort(rows.begin(), rows.end());
	sort(cols.begin(), cols.end());
	rows.erase(unique(rows.begin(), rows.end()), rows.end());
	cols.erase(unique(cols.begin(), cols.end()), cols.end());

	ll best_x = rows.back() - rows[0] + 1, best_y = cols.back() - cols[0] + 1, need_click_x = 0, need_click_y = 0;
	for (int i = rows.size() - 1; i > 0; i--) {
		ll move = w - rows[i] + 1;
		ll new_x = rows[i - 1] + move;

		ll move2 = rows[i - 1];
		ll new_x2 = w - (rows[i] - move2) + 1;

		if (new_x2 < new_x || (new_x2 == new_x && move2 < move)) {
			new_x = new_x2, move = move2;
		}

		if (new_x < best_x || (new_x == best_x && need_click_x > move)) {
			best_x = new_x;
			need_click_x = move;
		}
	}
	for (int i = cols.size() - 1; i > 0; i--) {
		ll move = h - cols[i] + 1;
		ll new_y = cols[i - 1] + move;

		ll move2 = cols[i - 1];
		ll new_y2 = w - (cols[i] - move2) + 1;

		if (new_y2 < new_y || (new_y2 == new_y && move2 < move)) {
			new_y = new_y2, move = move2;
		}

		if (new_y < best_y || (new_y == best_y && need_click_y > move)) {
			best_y = new_y;
			need_click_y = move;
		}
	}
	cout << best_x * best_y << ' ' << need_click_x + need_click_y;
	return 0;
}