#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long ll;

void solve1() {
	int m;
	cin >> m;
	while (m--) {
		int n, k;
		cin >> n >> k;
		int flag_s = n - k + 1;
		int last = 0;
		for (int i = 0; i < n; i++) {
			int x; cin >> x;
			if (last + 1 == x)
				cout << flag_s + i << ' ';
			else
				cout << x - 1 << ' ';
			last = x;
		}
		cout << '\n';
	}
}

void solve2() {
	int m;
	cin >> m;
	while (m--) {
		int n, k;
		cin >> n >> k;
		int flag_s = n - k + 1;
		vector<int>arr(k);
		vector<bool>take_last(k, false);
		vector<int>values;
		for (int i = 0; i < n; i++) {
			int x; cin >> x;
			if (x >= flag_s)
				take_last[x - flag_s] = true;
			values.push_back(x + 1);
		}
		int ind = 0;
		for (int i = 0; i < k; i++) {
			if (take_last[i])
				arr[i] = (i == 0 ? 1 : arr[i - 1]);
			else
				arr[i] = values[ind++];
		}
		for (auto i : arr)
			cout << i << ' ';
		cout << '\n';
	}
}

int main() {
	int a;
	cin >> a;
	if (a == 1)
		solve1();
	else
		solve2();
	cout << endl;
	return 0;
}