#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long ll;

const int mx_b = 5000;

void solve() {
	int n, q;
	cin >> n >> q;
	vector<ll>arr(n);
	for (auto& i : arr)
		cin >> i;
	sort(arr.begin(), arr.end());
	vector<vector<ll>>dp(n + 1, vector<ll>(mx_b + 1, -1e18));
	dp[0][0] = 0;
	for (int i = 1; i <= n; i++) {
		dp[i] = dp[i - 1];
		for (int b = 0; b <= mx_b; b++) {
			if (arr[i - 1] <= dp[i][b] + 1)
				dp[i][b] += arr[i - 1];
			if (b >= arr[i - 1] && dp[i][b - 1] >= dp[i - 1][b - arr[i - 1]])
				dp[i][b] = max(dp[i][b], dp[i - 1][b - arr[i - 1]]);
		}
	}
	int z; cin >> z;
	while (q--) {
		ll k, a, b;
		cin >> k >> a >> b;
		if (b > mx_b)
			return;
		if (dp[n][b] >= a)
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}