#include "iostream"
#include "vector"
#include "string"
#include "set"
#include "map"
#include "algorithm"
#include "cmath"


using namespace std;
typedef long long ll;
#define all(a) a.begin(), a.end()

void solve1();

void solve2();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int x;
    cin >> x;
    ll t = 1;
    cin >> t;
    while (t--) {
        if (x == 1)
            solve1();
        else
            solve2();
        cout << endl;
    }
}

void solve1() {
    int n, k;
    cin >> n >> k;
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    if ((a + 1) % n == b || (b + 1) % n == a) {
        b = (b - 2 + n) % n + 1;
        a = (a - 2 + n) % n + 1;
    } else {
        a = (a - 1 + n) % n + 1;
        b = (b - 1 + n) % n + 1;
    }
    if (a > b)
        swap(a, b);
    cout << a << ' ' << b;
}

void solve2() {
    int n, k;
    cin >> n >> k;
    int a, b;
    cin >> a >> b;

    a--;
    b--;
    if ((a + 1) % n == b || (b + 1) % n == a) {
        a = (a + 2) % n + 1;
        b = (b + 2) % n + 1;
    } else {
        a = (a + 1) % n + 1;
        b = (b + 1) % n + 1;
    }
    if (a > b)
        swap(a, b);
    cout << a << ' ' << b;
}