#include <bits/stdc++.h>
using namespace std;

int run;

void solve() {
    int n, k;
    cin >> n >> k;
    int n0 = n;
    int input_mask = 0;
    for (int i = 0; i < k; i++) {
        int x;
        cin >> x;
        x--;
        input_mask |= (1 << x);
    }
    vector<int> masks;
    for (int mask = 0; mask < (1 << n); mask++) {
        if (__builtin_popcount(mask) == k) {
            masks.push_back(mask);
        }
    }
    n = (int)masks.size();
    vector<vector<int>> g(n);
    for (int u = 0; u < n; u++) {
        for (int v = 0; v < n; v++) {
            if ((masks[u] & masks[v]) == 0) {
                g[u].push_back(v);
            }
        }
    }
    mt19937 rng(42228);
    vector<bool> used(n, false);
    vector<int> to(n, -1);
    while (true) {
        used.assign(n, false);
        to.assign(n, -1);
        for (int u = 0; u < n; u++) {
            shuffle(g[u].begin(), g[u].end(), rng);
        }
        bool good = true;
        for (int u = 0; u < n && good; u++) {
            for (int v : g[u]) {
                if (!used[v]) {
                    to[u] = v;
                    used[v] = true;
                    break;
                }
            }
            if (to[u] == -1) {
                good = false;
            }
        }
        if (good) {
            break;
        }
    }
    int ans = -1;
    if (run == 1) {
        for (int i = 0; i < n; i++) {
            if (masks[i] == input_mask) {
                ans = masks[to[i]];
            }
        }
    } else {
        for (int i = 0; i < n; i++) {
            if (masks[to[i]] == input_mask) {
                ans = masks[i];
            }
        }
    }
    for (int i = 0; i < n0; i++) {
        if ((ans >> i) & 1) {
            k--;
            cout << i + 1 << " \n"[k == 0];
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> run;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}