#include <bits/stdc++.h>

using namespace std;

#define ssize(a) static_cast<ptrdiff_t>(size(a))
#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  solve();
  return 0;
}

void solve() {
  i32 n, q;
  cin >> n >> q;
  vector<i64> w(n);
  for (auto& e : w) cin >> e;
  sort(ALL(w));
  i64 z;
  cin >> z;
  vector<tuple<i64, i64, i64>> query(q);
  for (auto& [k, a, b] : query) cin >> k >> a >> b;
  sort(ALL(query));

  i64 max_a;
  max_a = get<1>(*max_element(ALL(query), [](auto a, auto b) {
    return get<1>(a) < get<1>(b);
  })) + 1;
  vector<i64> max_b(max_a);
  for (int i = 0, j = 0; i < n; ++i) {
    for (i64 k = max_a - 1; k >= 0; --k) {
      if (max_b[k] >= w[i] - 1) max_b[k] += w[i];
      if (k >= w[i]) chmax(max_b[k], max_b[k - w[i]]);
    }
    while (j < q && (get<0>(query[j]) <= w[i] || i == n - 1)) {
      auto [k, a, b] = query[j];
      cout << (b <= max_b[a] ? "Yes" : "No") << "\n";
      j++;
    }
  }
}
