#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;


typedef long long ll;
typedef long double ld;
typedef tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;
vector<vector<ll>> g;
vector<bool> lst;


vector<int> s;
vector<vector<ll>> qs;
ll k;
vector<ll> w;
vector<ll> cnt;

void dfs0(int u, int p, int c) {
    cnt[u] = c;
    if (lst[u]) {
        return;
    }
    if (u == 0) {
        dfs0(g[u][0], u, c);
        dfs0(g[u][1], u, c);
    } else {
        if (s[u] == s[g[u][0]]) {
            dfs0(g[u][0], u, c);
            dfs0(g[u][1], u, c + 1);
        } else {
            dfs0(g[u][0], u, c + 1);
            dfs0(g[u][1], u, c);
        }
    }
}
pair<ordered_set, ll> dfs(int u, int p) {
    ordered_set ans;
    ll c = 0;
    if (lst[u]) {
        ans.insert(0);
        for (int idx: qs[u]) {
            w[idx] = bool(cnt[u] <= k);
        }
        return {ans, 0};
    }
    auto [f1, c1] = dfs(g[u][0], u);
    auto [f2, c2] = dfs(g[u][1], u);
    if (f2.size() > f1.size()) {
        f1.swap(f2);
        swap(c1, c2);
        swap(g[u][0], g[u][1]);
    }
    if (u == 0) {
        ans.swap(f1);
        c = c1;
        for (auto x: f2) {
            ans.insert(x - c1 + c2);
        }
    } else if (s[g[u][0]] == s[u]) {
        ans.swap(f1);
        c = c1;
        for (auto x: f2) {
            ans.insert(x + 1 - c1 + c2);
        }
    } else {
        ans.swap(f1);
        c = c1 + 1;
        for (auto x: f2) {
            ans.insert(x - 1 - c1 + c2);
        }
    }
    for (int idx: qs[u]) {
        w[idx] = ans.order_of_key(k - c - cnt[u]) + 1;
    }
    return {ans, c};

}
void solve() {
    ll n, q;
    cin >> n >> k >> q;
    g.resize(n);
    lst.resize(n);
    s.resize(n);
    cnt.resize(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        lst[i] = bool(t == 0);
        if (t == 2) {
            ll l, r;
            cin >> l >> r;
            l--;
            r--;
            g[i].push_back(l);
            g[i].push_back(r);
            s[l] = 1;
            s[r] = 2;
        }
    }
    dfs0(0, -1, 0);
    qs.resize(n);
    for (int i = 0; i < q; i++) {
        int u;
        cin >> u;
        u--;
        qs[u].push_back(i);
    }
    w.resize(q);
    dfs(0, -1);
    for (auto c: w) {
        cout << c << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    ll t; for (cin >> t; t--;) solve();
    solve();
    return 0;
}
