#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll INF = 1e16;

void solve() {
    ll n;
    cin >> n;
    vector<ll> arr(n + 1);
    for (ll i = 1; i <= n; ++i) {
        cin >> arr[i];
    }

    vector<vector<vector<ll>>> dp(n + 2, vector<vector<ll>>(n + 2, vector<ll>(n + 2, -INF)));
    dp[0][0][n + 1] = 0;

    for (ll i = 1; i <= n; ++i) {
        for (ll prev = 0; prev <= n + 1; ++prev) {
            for (ll prev2 = 0; prev2 <= n + 1; ++prev2) {
                dp[i][max(prev, arr[i])][prev2] = max(dp[i][max(prev, arr[i])][prev2], dp[i - 1][prev][prev2] + ll(arr[i] > prev));
                dp[i][prev][min(arr[i], prev2)] = max(dp[i][prev][min(arr[i], prev2)], dp[i - 1][prev][prev2] + ll(arr[i] < prev2));
            }
        }
    }

    ll mx = 0;
    for (auto &x : dp[n]) {
        for (auto y : x) {
            mx = max(mx, y);
        }
    }

    cout << mx << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t;
    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}