#include "bits/stdc++.h"
#define f first
#define s second
#define all(a) a.begin(), a.end()
#define allr(a) a.rbegin(), a.rend()
#define len(a) (int)a.size()

using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18;
const int MAXI = 1e9 + 1e7;
const ll MOD = 1e9 + 7;

const int MAXN = 5e5;
int n, k, q;
int tin[MAXN], tout[MAXN], pref[MAXN], timer = 0;
int g[MAXN][2];

void dfs(int u, int type = -1, int cnt = 0) {
    tin[u] = timer++;
    pref[tin[u]] = g[u][0] == -1 && cnt <= k;
    for (int i = 0; i <= 1; i++) {
        if (g[u][i] != -1)
            dfs(g[u][i], i, cnt += (type != -1 && type != i));
    }
    tout[u] = timer;
}

int main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin >> n >> k >> q;
    vector<int> leaf;
    for (int u = 0; u < n; u++) {
        int m;
        cin >> m;
        if (m == 2) {
            cin >> g[u][0] >> g[u][1];
            g[u][0]--, g[u][1]--;
        } else {
            g[u][0] = g[u][1] = -1;
            leaf.push_back(u);
        }
    }
    dfs(0);
    for (int i = 0; i < n; i++)
        pref[i + 1] += pref[i];
    for (int i = 0; i < q; i++) {
        int u;
        cin >> u;
        u--;
        int l = tin[u], r = tout[u] - 1;
        cout << pref[r] - (l ? pref[l - 1] : 0) << endl;
    }
    return 0;
}
