#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define ff first
#define ss second
#define pb push_back
#define all(v) v.begin(), v.end()
#define err(x) cerr << "[ " << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[ " << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << '\n';}


const int N = 4e5 + 5;
vector<int> cord;
pair<int, int> f[N];


pair<int, int> get(int r) {
    pair<int, int> res = {0, -1};
    for (; r >= 0; r = (r & (r + 1)) - 1) res = max(res, f[r]);
    return res;
}

void upd(int p, pair<int, int> x) {
    for (; p < cord.size(); p |= (p + 1)) f[p] = max(f[p], x);
}

struct segment {
    int l, r, id;

    bool operator<(const segment &oth) const {
        if (l == oth.l) {
            if (id == oth.id) return id < oth.id;
            else return r < oth.r;
        } else return l < oth.l;
    }
};

bool cross(int l, int r, int l2, int r2) {
    if (r < l2) return false;
    if (r2 < l) return false;
    return true;
}

int calc(vector<segment> v) {
    sort(all(v));
    for(int i = 0;i <= cord.size();i++) f[i] = {0, -1};
    int res = 0;
    for (auto [l, r, id]: v) {
        pair<int, int> best = get(l - 1);
        best.ff++;
        upd(r, {best.ff, 0});
        res = max(res, best.ff);
    }
    return res;
}

void solve() {
    cord.clear();
    int n;
    cin >> n;
    vector<segment> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].l >> v[i].r;
        cord.pb(v[i].l);
        cord.pb(v[i].r);
        v[i].id = i;
    }
    sort(all(cord));
    cord.resize(unique(all(cord)) - cord.begin());
    for (int i = 0; i <= cord.size(); i++) f[i] = {0, -1};
    for (auto &i: v) {
        i.l = lower_bound(all(cord), i.l) - cord.begin();
        i.r = lower_bound(all(cord), i.r) - cord.begin();
    }
    vector<segment> rep = v;
    sort(all(v));
    int t = 0;
    vector<int> par(n, -1);
    vector<int> dp(n, -1);
    for (auto [l, r, id]: v) {
        pair<int, int> best = get(l - 1);
        best.ff++;
        dp[t] = best.ff;
        upd(r, {best.ff, t});
        par[t] = best.ss;
        t++;
    }
    vector<segment> good;
    int p = max_element(all(dp)) - dp.begin();
    int m = dp[p];
    for (; p >= 0; p = par[p]) good.pb(v[p]);
    int rem = n / 2 - m / 2;
    assert(m % 2 == 0);
    vector<bool> used(n, false);
    vector<int> ans;
    int rem2 = m / 2;
//    errv(used);
    while (rem2 > 0) {
        rem2--;
        vector<int> cost(m, 0);
        for (int j = 0; j < m; j++) {
            int ids = good[j].id;
            if (used[ids]) continue;
            for (int k = 0; k < n; k++)
                if (ids != k && !used[k]) {
                    if (cross(rep[ids].l, rep[ids].r, rep[k].l, rep[k].r))
                        cost[j]++;
                }
        }
        int nice = -1;
        for (int j = 0; j < m; j++)
            if (!used[good[j].id] && (nice == -1 || cost[nice] < cost[j]))
                nice = j;
        ans.pb(good[nice].id);
        nice = ans.back();
        used[ans.back()] = true;
        for (int k = 0; k < n; k++)
            if (nice != k && !used[k] && rem > 0) {
                if (cross(rep[nice].l, rep[nice].r, rep[k].l, rep[k].r)) {
                    ans.pb(k);
                    used[k] = true;
                    rem--;
                }
            }
    }
    vector<segment> to_ans;
    for(auto i : ans)
        to_ans.pb(rep[i]);
    assert(calc(to_ans) == m / 2);
    assert(ans.size() == n / 2);
    for (auto i: ans) cout << i + 1 << ' ';
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
}