#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> dp(n + 1), p(n + 1);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < i; j++) {
            if (j == 0 || a[i - 1] > a[j - 1]) {
                if (dp[j] + 1 > dp[i]) {
                    dp[i] = dp[j] + 1;
                    p[i] = j;
                }
            }
        }
    }
    vector<int> nw;
    map<int, bool> bad;
    int mx = 0;
    int id = 0;
    for (int i = 0; i <= n; i++) {
        if (dp[i] > mx) {
            mx = dp[i];
            id = i;
        }
    }
    int now = id;
    while (now > 0) {
        bad[now] = true;
        now = p[now];
    }
    for (int i = 1; i <= n; i++) {
        if (!bad[i]) {
            nw.push_back(a[i - 1]);
        }
    }
    int mn = 1e9;
    for (int i = 0; i < (int) nw.size(); i++) {
        if (nw[i] < mn) {
            ++mx;
        }
        mn = min(mn, nw[i]);
    }
    cout << mx << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
}