#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<vector<int>> dp(n + 2, vector<int>(n + 2));
    for (int ind = 0; ind < n; ++ind) {
        vector<vector<int>> dp_now = dp;
        for (int i = 0; i <= n + 1; ++i) {
            for (int j = 0; j <= n + 1; ++j) {
                if (i > a[ind]) {
                    dp_now[a[ind]][j] = max(dp_now[a[ind]][j], dp[i][j] + 1);
                }
                if (j < a[ind]) {
                    dp_now[i][a[ind]] = max(dp_now[i][a[ind]], dp[i][j] + 1);
                }
                if (a[ind] >= i && a[ind] <= j) {
                    dp_now[i][j] = max(dp_now[i][j], dp[i][j]);
                }
            }
        }
//        for (auto b : dp_now) {
//            for (int x : b) cout << x << " ";
//            cout << endl;
//        }
//        cout << endl;
        dp = dp_now;
    }
    int ans = 0;
    for (int i = 0; i <= n + 1; ++i) {
        for (int j = 0; j <= n + 1; ++j) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}
