#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<vector<int>> dp(n + 2, vector<int>(n + 2, -INF));
    dp[n + 1][0] = 0;
    vector<int> us(n + 2);
    us[0] = 1, us[n + 1] = 1;
    for (int ind = 0; ind < n; ++ind) {
        vector<vector<int>> dp_now(n + 2, vector<int>(n + 2, -INF));
        for (int i = 1; i <= n + 1; ++i) {
            for (int j = 0; j <= n; ++j) {
                if (i == j || !us[i] || !us[j]) continue;
                if (i > a[ind]) {
                    dp_now[a[ind]][j] = max(dp_now[a[ind]][j], dp[i][j] + 1);
                }
                if (j < a[ind]) {
                    dp_now[i][a[ind]] = max(dp_now[i][a[ind]], dp[i][j] + 1);
                }
                if (a[ind] >= i || a[ind] <= j) {
                    dp_now[i][j] = max(dp_now[i][j], dp[i][j]);
                }
            }
        }
        us[a[ind]] = 1;
        dp = dp_now;
    }
    int ans = 0;
    for (int i = 0; i <= n + 1; ++i) {
        for (int j = 0; j <= n + 1; ++j) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}
