#include <iostream>
#include <random>
#include <vector>
#include <algorithm>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(228);

#define int long long

void solve() {
	int n; cin >> n;
	vector <int> v(n); 
	for (auto& x : v) {
		cin >> x;
		--x;
	}

	vector <vector <int>> dp(n + 2, vector <int>(n + 2, -1e18));
	dp[0][n + 1] = 0;
	for (int i = 0; i < n; ++i) {
		vector <vector <int>> dp1 = dp;
		for (int j = -1; j < v[i]; ++j) {
			for (int k = -1; k <= n; ++k) {
				dp1[j + 1][k + 1] = max(dp1[j + 1][k + 1], dp[j + 1][k + 1] + 1);
			}
		}
		for (int j = -1; j <= n; ++j) {
			for (int k = v[i] + 1; k <= n; ++k) {
				dp1[j + 1][k + 1] = max(dp1[j + 1][k + 1], dp[j + 1][k + 1] + 1);
			}
		}
		dp = dp1;
	}

	int ans = 0;
	for (auto& vec : dp) for (auto& x : vec) ans = max(ans, x);

	cout << ans;
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	int32_t t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}