#include <bits/stdc++.h>
#include <unordered_map>
#include <unordered_set>

#define umap unordered_map
#define uset unordered_set

#define spc << ' ' <<
#define space << ' '
#define newl << '\n'
#define endl << endl

#define elif else if
#define pb push_back
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)
#define all(a) (a).begin(), (a).end()

using namespace std;
using ll = long long;
using pll = pair <ll, ll>;
using pii = pair <int, int>;
using vi = vector <int>;
using vvi = vector <vi>;
using vl = vector <ll>;
using vvl = vector <vl>;

void solve() {
    int n;
    cin >> n;
    vector <pair <pll, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second;
        a[i].second = i;
    }
    sort(all(a));

    priority_queue <pii> temp;
    for (int i = 0; i < n; ++i) {
        temp.push({-a[i].first.second, i});
    }

    ll r = -1e18;
    vi pos;
    while (!temp.empty()) {
        if (a[temp.top().second].first.first <= r) {
            temp.pop();
            continue;
        }
        pos.pb(temp.top().second);
        r = -temp.top().first;
    }

    int m = pos.size();
    repeat(m / 2) {
        vi temp(pos.size(), 0);
        int id = 0;
        for (int i = 0; i < (int)pos.size(); ++i) {
            for (int j = 0; j < n; ++j) {
                int ok = 0;
                int l = -1e18;
                if (i != 0) l = a[pos[i - 1]].first.second;
                int r = 1e18;
                if (i + 1 < (int)pos.size()) r = a[pos[i + 1]].first.first;

                if (l < a[j].first.first && a[j].first.first <= a[pos[i]].first.second) ok++;
                if (a[pos[i]].first.first <= a[j].first.second && a[j].first.second < r) ok++;

                if (ok == 2) temp[i]++;
            }
            temp[i]--;
            if (temp[i] < temp[id]) id = i;
        }

        vi newpos;
        for (int i = 0; i < (int)pos.size(); ++i) {
            if (i == id) continue;
            newpos.pb(pos[i]);
        }
        swap(pos, newpos);
    }

    vi used(n, 0);
    int ct = 0;
    for (auto id : pos) {
        cout << a[id].second + 1 space;
        ct++;
        for (int i = 0; i < n; ++i) {
            if (a[i].first.first <= a[id].first.second && a[id].first.first <= a[i].first.second) used[i] = 1;
        }
        used[id] = 0;
    }

    for (int i = 0; i < n && ct < n / 2; ++i) {
        if (used[i]) {
            cout << a[i].second + 1 space;
            ct++;
        }
    }
}

void tests() {
    int t = 1;
    cin >> t;
    repeat(t) {
        solve();
        cout newl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    tests();
}
