#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int q = 1;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        solve();
    }
}

const int MAXN = 500 + 1;

vector<int> g[MAXN];

vector<int> krd;

int get(int x) {
    return lower_bound(all(krd), x) - krd.begin();
}

vector<int> ans, trash;

int cnt = 0;

vector<pair<int, int>> can;

int pred[MAXN];

void dfs(int v, int pr = -1, int dep = 0) {
    if (g[v].empty() && ans.size() < cnt) {
        can.emplace_back(dep, v);
    }
    pred[v] = pr;
    for (auto &to: g[v]) {
        dfs(to, v, dep + 1);
    }
    if (!g[v].empty()) {
        trash.push_back(v);
    }
}

bool ins(int l1, int r1, int l2, int r2) {
    return l1 <= l2 && r2 <= r1;
}

void solve() {
    ans.clear(), trash.clear(), can.clear();
    int n;
    cnt = 0;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto &[x, y]: a) {
        cin >> x >> y;
    }
    a.insert(a.begin(), {0, 0});
    for (int i = 1; i <= n; ++i) {
        g[i].clear();
    }
    vector<int> in(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (i == j) continue;
            if (a[i] == a[j]) {
                if (i < j) {
                    g[i].push_back(j);
                    ++in[j];
                }
            } else if (ins(a[i].X, a[i].Y, a[j].X, a[j].Y)) {
                g[i].push_back(j);
                ++in[j];
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        cnt += g[i].empty();
    }
    int root;
    for (int i = 1; i <= n; ++i) {
        if (in[i] == 0) {
            root = 1;
        }
    }
    assert(root);
    dfs(root);
    sort(all(can), greater<>());
    for (int i = 0; i < cnt / 2; ++i) {
        ans.push_back(can[i].Y);
        int cur = pred[can[i].Y];
        while (cur != -1) {
            trash.push_back(cur), cur = pred[cur];
        }
    }
    sort(all(trash)), trash.resize(unique(all(trash)) - trash.begin());
    while (ans.size() < n / 2) {
        assert(!trash.empty());
        ans.push_back(trash.back());
        trash.pop_back();
    }
    sort(all(ans)), ans.resize(unique(all(ans)) - ans.begin());
    for (auto &el : ans) {
        cout << el + 1 << ' ';
    }
    cout << "\n";
}