#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int q = 1;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        solve();
    }
}

vector<int> krd;

int get(int x) {
    return lower_bound(all(krd), x) - krd.begin() + 1;
}

const int MAXN = 50 + 1;

int dp[MAXN][MAXN][MAXN];
tuple<int, int, int> pred[MAXN][MAXN][MAXN];

int get(vector<pair<int, int>> a, bool f = false) {
    int mx = 0;
    for (auto &[l, r] : a) {
        mx = max({mx, l, r});
        swap(l, r);
    }
    sort(all(a));
    vector<int> clc(mx + 1, 0);
    clc[0] = 0;
    for (auto &[r,l] : a) {
        for (int i =l - 1; i >= 0; --i) {
            clc[r] = max(clc[r], clc[i] + 1);
        }
    }
    return *max_element(all(clc));
}

vector<int> ok(vector<pair<int, int>> a) {
    int mx = 0;
    vector<tuple<int, int, int>> b;
    int ndd = 0;
    for (auto &[l, r] : a) {
        mx = max({mx, l, r});
        b.emplace_back(r, l, ndd++);
        swap(l, r);
    }
    sort(all(a));
    vector<int> clc(mx + 1, 0), pred(mx + 1, 0), nw_ind(mx + 1, 0);
    clc[0] = 0;
    for (auto &[r,l, ind] : b) {
        for (int i =l - 1; i >= 0; --i) {
            if (clc[i] + 1 >= clc[r]) {
                clc[r] = clc[i] + 1;
                nw_ind[r] = ind;
                pred[r] = i;
            }
        }
    }
    mx = max_element(all(clc)) - clc.begin();
    vector<int> nw;
    int s = clc[mx];
    for (int i = 0; i < s; ++i) {
        nw.push_back(nw_ind[mx]);
        mx = pred[mx];
    }
    random_shuffle(all(nw));
    while (nw.size() > s / 2) {
        nw.pop_back();
    }
    return nw;
}

void solve() {
    krd.clear();
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto &[l, r] : a) {
        cin >> l >> r;
        krd.push_back(l), krd.push_back(r);
    }
    sort(all(krd)), krd.resize(unique(all(krd)) - krd.begin());
    for (auto &[l, r] : a) {
        l = get(l), r = get(r);
    }
    int m = get(a) / 2;
    vector<int> usd(n, false);
    auto hv = ok(a);
    for (auto &el : hv) usd[el] = 1;
    vector<pair<int, int>> nw;
    for (auto &el : hv) {
        nw.push_back(a[el]);
    }
    int nd = hv.size();
    vector<int> q;
    for (int i = 0; i < n; ++i) {
        if (!usd[i]) {
            q.push_back(i);
        }
    }
    while (1) {
        random_shuffle(all(q));
        while (!q.empty() && hv.size() < n / 2) {
            int v = q.back();
            q.pop_back();
            auto cur = nw;
            cur.push_back(a[v]);
            if (get(cur) == m) {
                usd[v] = true;
                hv.push_back(v);
                nw.push_back(a[v]);
            }
        }
        if (hv.size() == n/ 2) {
            for (auto &el : hv) {
                cout << el + 1 << ' ';
            }
            cout << "\n";
            break;
        }
    }
}