#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
#define endl '\n'

using namespace std;

mt19937_64 gen(time(nullptr));

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;
    while(t--){
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }/*
        int n = 5;
        vector<int> a(n, 0);
        iota(all(a), 0);
        shuffle(all(a), gen);
        for (auto u : a) {
            cout << u + 1 << ' ';
        }
        cout << endl;*/

        vector<vector<vector<int>>> dp(n, vector<vector<int>>(n + 2, vector<int>(n + 2, 0)));
        for (int i = 0; i < n + 2; ++i) {
            dp[0][a[0]][i] = 1;
            dp[0][i][a[0]] = 1;
        }
        int m_last = 1;
        for (int i = 1; i < n; ++i) {
            //a - upper
            for (int j = 0; j < a[i]; ++j) {
                for (int k = 0; k < n + 2; ++k) {
                    dp[i][a[i]][k] = max({dp[i][a[i]][k], dp[i - 1][j][k] + 1});
                    m_last = max(m_last, dp[i][a[i]][k]);
                }
            }
            //a - lower
            for (int j = a[i] + 1; j < n + 2; ++j) {
                for (int k = 0; k < n + 2; ++k) {
                    dp[i][k][a[i]] = max({dp[i][k][a[i]], dp[i - 1][k][j] + 1});
                    m_last = max(m_last, dp[i][k][a[i]]);
                }
            }
            //a - upper_neutral
            for (int j = a[i]; j < n + 2; ++j) {
                for (int k = 0; k < n + 2; ++k) {
                    dp[i][k][j] = max({dp[i][k][j], dp[i - 1][k][j]});
                }
            }
            //a - lower_neutral
            for (int j = 0; j <= a[i]; ++j) {
                for (int k = 0; k < n + 2; ++k) {
                    dp[i][k][j] = max({dp[i][k][j], dp[i - 1][k][j]});
                }
            }
        }
        cout << m_last << endl;
        //pp
/*
        int b_ans = 0;
        for (int i = 0; i < (1<<(n + 1)); ++i) {
            int s1 = 0, s2 = 0;
            int d1 = -1, d2 = INT32_MAX;
            for (int j = 0; j < n; ++j) {
                if(i & (1<<j)) {
                    if(a[j] > d1){
                        ++s1;
                        d1 = a[j];
                    }
                }else {
                    if(a[j] < d2){
                        ++s2;
                        d2 = a[j];
                    }
                }
            }

            b_ans = max(b_ans, s1 + s2);
        }
        cout << b_ans << endl;*/
    }

    return 0;
}
