#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
#define endl '\n'

using namespace std;

mt19937_64 gen(time(nullptr));

int m_l(vector<int> a){
    int iter = 1;
    int cnt[a.size() + 1];
    int d[a.size() + 1];
    fill(cnt, cnt + a.size() + 1, 0);
    fill(d, d + a.size() + 1, 0);

    for(auto u : a)
        if(u < a.size() + 1)
            ++cnt[u];

    while (true){
        int f = 0;
        for (;; ++f) {
            if(cnt[f] == 0)
                break;
        }
        if(d[f] != 0){
            if(d[f] == iter - 1)
                return f;
            else
                return -1;
        }
        d[f] = iter++;
        for (auto &u : a) {
            if(u < a.size() + 1)
                --cnt[u];
            u ^= f - 1;
            if(u < a.size() + 1)
                ++cnt[u];
        }
    }
}

int k, n, p;
ll ans = 0;
vector<int> d = {0, };

void dfs(int deep = 1, int last = 0, bool good = false){
    if(deep == n){
        if(good){
            ++ans;
            return;
        }
        int f = m_l(d);
        ans += f == p;
        return;
    }
    for (int i = last + 1; i <= (1<<k) - 1; ++i) {
        d.emplace_back(i);
        if(m_l(d) == p and i - last > 1){
            dfs(deep + 1, i, true);
            d.pop_back();
        }else {
            dfs(deep + 1, i);
            d.pop_back();
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int m;
    cin >> m;

    int t;
    cin >> t;
    while(t--){
        cin >> k >> n >> p;
        ans = 0;
        dfs();
        cout << ans % m << endl;
    }

    return 0;
}
