#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define fastIo(a) ios_base::sync_with_stdio(a); cout.tie(a); cin.tie(a)


using ll = long long;
using ld = long double;

const int N = 1503;

bool dp[N][N]; // i, w1, w2 w1 > w2
bool is[N][N];

void solve() {
    int n, q, z;
    cin >> n >> q;
    vector<int> w(n);
    for (auto &i : w) cin >> i;
    sort(all(w));

    cin >> z;

    vector<tuple<int, int, int, int>> qs(q);
    int cind = 0;
    for (auto &[k, a, b, ind] : qs) {
        cin >> k >> a >> b;
        ind = cind++;
        k = min((int)2e5 + 3, k);
    }
    sort(all(qs));

    vector<int> ans(q);

    dp[0][0] = true;

    int i = 0;
    for (auto [k, a, b, ind] : qs) {
        int last = i;
        for (; i < n && w[i] <= k; i++) {
            for (int w1 = N - 1; w1 >= 0; w1--) {
                for (int w2 = N - 1; w2 >= 0; w2--) {
                    if (w1 >= w[i] && dp[w1 - w[i]][w2]) dp[w1][w2] = true;
                    if (w2 >= w[i] && dp[w1][w2 - w[i]]) dp[w1][w2] = true;
                }
            }
        }

        if (last != i) {
            for (int l = 0; l < N; l++) {
                for (int j = 0; j < N; j++) {
                    is[l][j] = dp[l][j] && (l == 0 || is[l - 1][j]) && (j == 0 || is[l][j - 1]);
                }
            }
        }

        ans[ind] = is[a][b];
    }

    for (auto i : ans) {
        if (i == 1) cout << "Yes\n";
        else cout << "No\n";
    }
}

signed main() {
    fastIo(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}