#include <bits/stdc++.h>

using namespace std;

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

int type;

int n, k;

vector<int> run(vector<int>& v) {
    set<int> s_v(all(v));
    vector<int> free(k);
    int ptr = n - 1;
    for (int i = 0; i < k; ++i) {
        while (s_v.find(ptr) != s_v.end()) {
            --ptr;
        }
        free[i] = ptr;
        --ptr;
    }

    vector<char> checked(n);
    for (int x : v) {
        checked[x] = true;
    }
    set<int> used;
    vector<int> st;

    int free_ptr = 0;

    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (checked[i]) {
            if (st.empty()) {
                ans.push_back(free[free_ptr]);
                used.insert(free[free_ptr]);
                ++free_ptr;
            } else {
                ans.push_back(st.back());
                st.pop_back();
            }
        } else if (used.find(i) == used.end()) {
            st.push_back(i);
        }
    }
    return ans;
}

void solve() {
    cin >> n >> k;
    vector<int> v(k);
    for (int& x : v) {
        cin >> x;
        --x;
    }
    vector<int> ans;
    if (type == 1) {
        ans = run(v);
    } else {
        for (int& x : v) {
            x = n - 1 - x;
        }
        ans = run(v);
        for (int& x : ans) {
            x = n - 1 - x;
        }
    }
    sort(all(ans));
    for (int x : ans) {
        cout << x + 1 << ' ';
    }
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> type;
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        solve();
    }
}