#include <bits/stdc++.h>

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

using namespace std;

const int MAX_N = 2e5;

int type[MAX_N];

vector<int> graph[MAX_N];

int tmp_dp[MAX_N];
int dp[MAX_N];

int k;

void dfs(int v) {
    if (graph[v].empty()) {
        dp[v] = tmp_dp[v] <= k;
        return;
    }
    int l = graph[v][0];
    int r = graph[v][1];

    tmp_dp[l] = tmp_dp[v] + (type[v] == 1);
    tmp_dp[r] = tmp_dp[v] + (type[v] == 0);
    dfs(l);
    dfs(r);
    dp[v] += dp[l];
    dp[v] += dp[r];
}


int len;

int n;

void solve() {
    int v;
    cin >> v;
    --v;
    cout << dp[v] << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int q;
    cin >> n >> k >> q;
    type[0] = -1;
    for (int v = 0; v < n; ++v) {
        int t;
        cin >> t;
        if (t) {
            int l, r;
            cin >> l >> r;
            --l;
            --r;
            graph[v] = {l, r};
            type[l] = 0;
            type[r] = 1;
        }
    }
    dfs(0);

    for (int i = 0; i < q; ++i) {
        solve();
    }
}