#include <bits\stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define vec vector

#define endl '\n'
#define int long long

const int INF = 2e9 + 333;

vec<int> dp(3e5);
int n, k, q;
vec<pair<int, int>> g(3e5, {-1, -1});

void dfs(int v, int cnt = 0, int pred = -1) {
    if (g[v].first != -1) {
        if (pred == -1 || pred == 1) dfs(g[v].first, cnt, 1);
        else dfs(g[v].first, cnt + 1, 1);
        if (pred == -1 || pred == 2) dfs(g[v].second, cnt, 2);
        else dfs(g[v].second, cnt + 1, 2);
        dp[v] += dp[g[v].first] + dp[g[v].second];
    }
    else if (cnt <= k) dp[v]++;
    //cout << v << " " << dp[v] << " " << cnt << " " << pred << endl;
}

void solve() {
    cin >> n >> k >> q;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            g[i] = {--l, --r};
        }
    }
    dfs(0);
    for (int i = 0;  i < q; ++i) {
        int v;
        cin >> v;
        cout << dp[v - 1] << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}