#include <iostream>
#include <cassert>
#include <string>
#include <sstream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <iomanip>

using namespace std;

#define wall(X) X.begin(),X.end()
#define ins insert
#define era erase
#define int long long
#define foriab(i,a,b) for(int i=(a);i<(b);++i)
#define fori(i,n) foriab(i,0,n)
#define foris(i,n) fori(i,n.sz())
#define fori1(i,n) foriab(i,1,n)
#define x first
#define y second
#define sz size
#define pb push_back
#define pp pop_back
#define VI vector<int>
#define VVI vector<VI>
#define VS vector<string>
#define byte unsigned char
#define ret return
#define endl '\n'
#define endlf endl<<flush
#define cont continue
#define VB vector<byte>
#define PII pair<int,int>
#define VPII vector<PII>
#define sstream stringstream
#define ANS(X) {cout<<(X)<<endl;ret;}
#define SI set<int>
#define SPII set<PII>
#define MII map<int,int>

template<class A,class B> ostream& operator<<(ostream& o,const pair<A,B>& v){
	ret o<<v.x<<' '<<v.y<<endl;
}
template<class A,class B> istream& operator>>(istream& i,pair<A,B>& v){
	ret i>>v.x>>v.y;
}
template<class T> ostream& operator<<(ostream& o,const vector<T>& v){
	for(const auto& x:v){
		o<<x<<' ';
	}
	ret o<<endl;
}
template<class T> istream& operator>>(istream& i,vector<T>& v){
	for(auto& x:v){
		i>>x;
	}
	ret i;
}
template<class A,class B> bool rmax(A& a,const B& b){
	A tmp=b;
	if(a<tmp){
		a=move(tmp);
		ret 1;
	}
	ret 0;
}
template<class A,class B> bool rmin(A& a,const B& b){
	A tmp=b;
	if(tmp<a){
		a=move(tmp);
		ret 1;
	}
	ret 0;
}

void solve(){
	int n;
	cin>>n;
	VI v(n);
	cin>>v;
	for(auto&x:v){
		--x;
	}
	VVI d(n,VI(n,1));
	/*
	fori(i,n){
		int val=v[i];
		fori(p,n){
			fori(q,n){
				if(q!=val&&p<val){
					rmax(d[val][q],1+d[p][q]);
				}
				if(p!=val&&q>val){
					rmax(d[p][val],1+d[p][q]);
				}
			}
		}
	}
	*/
	fori(i,n){
		fori(j,n){
			if(i==j){
				d[i][j]=1;
				cont;
			}
			fori(k,i){
				if(v[k]<v[i]){
					rmax(d[i][j],1+d[k][j]);
				}
			}
			fori(k,j){
				if(v[k]>v[j]){
					rmax(d[i][j],1+d[i][k]);
				}
			}
		}
	}
	int ma=0;
	fori(i,n){
		fori(j,n){
			rmax(ma,d[i][j]);
		}
	}
	ANS(ma);
}
signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin>>t;
	while(t--){
		solve();
	}
	ret 0;
}
