#include <bits/stdc++.h>
using namespace std;

vector<int> max_points(vector<pair<int, int>>& segments) {
    vector<tuple<int, int, int>> segments2{};
    for (int i = 0; i < segments.size(); i++) {
        segments2.push_back(make_tuple(segments[i].first, segments[i].second, i));
    }
    sort(segments2.begin(), segments2.end());
    int curleft(1e9 + 1);
    vector<int> res{};
    for (int i = segments2.size() - 1; i >= 0; i--) {
        if (get<1>(segments2[i]) < curleft) {
            curleft = get<0>(segments2[i]);
            res.push_back(get<2>(segments2[i]));
        }
    }
    return res;
}

vector<int> what_intersects(vector<int>& pts, vector<pair<int, int>>& segments) {
    vector<tuple<int, int, int>> events{};
    for (auto i : pts) {
        events.push_back(make_tuple(i, 1, 0));
    }
    for (int i = 0; i < segments.size(); i++) {
        events.push_back(make_tuple(segments[i].first, 0, i));
        events.push_back(make_tuple(segments[i].second, 2, i));
    }
    sort(events.begin(), events.end());
    set<int> tmp{};
    vector<int> res{};
    for (auto i : events) {
        if (get<1>(i) == 0) {
            tmp.insert(get<2>(i));
        } else if (get<1>(i) == 2) {
            tmp.erase(get<2>(i));
        } else {
            for (auto j : tmp) {
                res.push_back(j);
            }
            tmp.clear();
        }
    }
    return res;
}

void f() {
    int n, q, r;
    cin >> n;
    vector<pair<int, int>> segments{};
    for (int i = 0; i < n; i++) {
        cin >> q >> r;
        segments.push_back({q, r});
    }
    vector<int> M(max_points(segments));
    /*for (auto i : M) {
        cout << i << " ";
    }
    cout << endl;*/
    set<int> M1{}, M2{};
    vector<int> pts1{}, pts2{};
    for (int i = 0; i < M.size() / 2; i++) {
        pts1.push_back(segments[M[2 * i]].first);
        pts2.push_back(segments[M[2 * i + 1]].first);
        M1.insert(M[2 * i]);
        M2.insert(M[2 * i + 1]);
    }
    vector<int> int1(what_intersects(pts1, segments)), int2(what_intersects(pts2, segments));
    if (int2.size() > int1.size()) {
        swap(int1, int2);
        swap(M1, M2);
    }
    int k(int1.size() - n / 2);
    /*for (auto i : int1) {
        cout << i << " ";
    }
    cout << endl;
    for (auto i : int2) {
        cout << i << " ";
    }
    cout << endl;*/
    //vector<pair<int, int>> answer{};
    for (auto i : int1) {
        if (M1.count(i) == 1) {
            //answer.push_back(segments[i]);
            cout << i + 1 << " ";
        } else if (k == 0) {
            //answer.push_back(segments[i]);
            cout << i + 1 << " ";
        } else {
            k--;
        }
    }
    //cout << endl;
    //cout << answer.size() << " " << n << endl;
    //cout << max_points(answer).size() << " " << M.size() << endl;
    cout << endl;
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        f();
    }
}
