#include<bits/stdc++.h>

#define ll lon long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;

mt19937 rnd(51);

int MOD;

int add(int a, int b) {
    return a + b >= MOD ? a + b - MOD : a + b;
}

map<int, map<int, map<int, int>>> mp;

int mex(vector<int> a) {
    sort(all(a));
    int i = 0;
    while (i < a.size() && a[i] == i) {
        i++;
    }
    return i;
}

int solve(int n, int k, int p) {
    if (mp[n][k].count(p)) {
        return mp[n][k][p];
    }
    k = (1 << k);
    int K = 250;
    int ans = 0;
    for (int i = 1; i < (1 << k); i += 2) {
        vector<int> a;
        for (int b = 0; b < k; b++) {
            if (i & (1 << b)) {
                a.pb(b);
            }
        }
        if (a.size() > n) continue;
        int last_mex = -1, cnt = 0;
        bool good = 0;
        for (int _ = 0; _ < K; _++) {
            int m = mex(a);
            for (int j = 0; j < a.size(); j++) {
                a[j] ^= (m - 1);
            }
            if (m == last_mex && m == p) {
                cnt++;
                if (cnt == 7) {
                    good = 1;
                    break;
                }
            } else {
                cnt = 0;
            }
            last_mex = m;
        }
        if (good) {
            int sz = a.size();
            vector<int> dp(n - sz + 1);
            dp[0] = 1;
            for (int _ = 0; _ < sz; _++) {
                vector<int> dpp(n - sz + 1);
                for (int i = 0; i <= n - sz; i++) {
                    for (int j = i; j <= n - sz; j++) {
                        dpp[j] = add(dpp[j], dp[i]);
                    }
                }
            }
            ans = add(ans, dp[n - sz]);
        }
    }
    mp[n][k][p] = ans;
    return ans;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> MOD;
    int t;
    cin >> t;
    while (t--) {
        int n, k, p;
        cin >> k >> n >> p;
        cout << solve(n, k, p) << endl;
    }
    return 0;
}
