#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <iostream>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;



int main() {
	ios::sync_with_stdio(0); cout.tie(0); cin.tie(0);
	ll n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i) cin >> w[i];
	
	if (n <= 10 && q <= 10) {
		map<pair<ll, ll>, ll> h;
		set<ll> s;
		for (ll mask = 0; mask < (1LL << n); ++mask) {
			for (ll mask2 = 0; mask2 < (1LL << n); ++mask2) {
				if (mask & mask2) continue;
				ll count = 0;
				ll count2 = 0;
				ll mx = 0;
				for (int i = 0; i < n; ++i) {
					if (mask & (1LL << i)) {
						count += w[i];
						mx = max(mx, w[i]);
					}
					if (mask2 & (1LL << i)) {
						count2 += w[i];
						mx = max(mx, w[i]);
					}
				}
				s.insert(count);
				s.insert(count2);
				if (h[{count, count2}]) {
					h[{count, count2}] = min(h[{count, count2}], mx);
				}
				else {
					h[{count, count2}] = mx;
				}
			}
		}
		ll z; cin >> z;
		for (int i = 0; i < q; ++i) {
			ll k, a, b;
			cin >> k >> a >> b;
			if (a > (ll)s.size() || b > (ll)s.size()) {
				cout << "No\n";
			}
			else {
				int ok = 1;
				for (int j = 0; j <= a; ++j) {
					for (int c = 0; c <= b; ++c) {
						if (!j && !c) continue;
						if ((!h[{j, c}] || h[{j, c}] > k) && (!h[{c, j}] || h[{c, j}] > k)) {
							cout << "No\n";
								ok = 0;
								break;
						}
					}
					if (!ok) break;
				}
				if (ok) cout << "Yes\n";
			}
		}
		return 0;
	}
	ll z; cin >> z;
	int ok = 1;
	vector<pair<pair<ll, ll>, ll>> qr(q);
	for (int i = 0; i < q; ++i) {
		ll k, a, b;
		cin >> k >> a >> b;
		qr[i] = { {k, a}, b };
		if (b) ok = 0;
	}
	if (1) {
		vector<ll> dp(1e5 + 1, 1e17);
		dp[0] = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = 1e5 - w[i]; j >= 0; --j) {
				dp[j + w[i]] = min(dp[j + w[i]], max(dp[j], w[i]));
			}
		}
		for (int i = 1; i <= 1e5; ++i) dp[i] = max(dp[i], dp[i - 1]);
		for (int i = 0; i < q; ++i) {
			ll k = qr[i].first.first;
			ll a = qr[i].first.second;
			ll b = qr[i].second;
			cout << (dp[a] <= k ? "Yes\n" : "No\n");
		}
	}
};
