#include <bits/stdc++.h>
 
using namespace std;
 
#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#else
#define dbg(x) 
#endif
 
using ll = long long;
using ld = long double;
 
template <class A>
bool umin(A& x, const A& y) {
    if (x <= y) return false;
    x = y;
    return true;
}
 
template <class A>
bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}
 
// #define int ll
#define sz(x) int((x).size())

void nxt(int& x, int& y, int n) {
    if (x == n - 1 && y == n) {
        x = 1, y = 2;
    } else if (y == n) {
        x = x + 1, y = x + 1;
    } else {
        ++y;
    }
}

void prv(int& x, int& y, int n) {
    if (x == 1 && y == 2) {
        x = n - 1, y = n;
    } else if (x + 1 == y) {
        x = x - 1, y = n;
    } else {
        --y;
    }
}
 
vector<int> encrypt(int n, vector<int> a) {
    int cnt = n * (n - 1) / 2 / 2;

    int x = a[0], y = a[1];
    while (cnt--) {
        nxt(x, y, n);
    }

    return { x, y };
}
 
vector<int> decrypt(int n, vector<int> a) {
    int cnt = n * (n - 1) / 2 / 2;

    int x = a[0], y = a[1];
    while (cnt--) {
        prv(x, y, n);
    }

    return { x, y };
}
 
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
 
    int kok;
    cin >> kok;
 
    int m;
    cin >> m;
 
    for (int i = 0; i < m; ++i) {
        int n, k;
        cin >> n >> k;
 
        vector<int> a(k);
        for (int& x : a) cin >> x;
 
        vector<int> res = ((kok == 2) ? decrypt(n, a) : encrypt(n, a));
        for (int x : res) cout << x << ' ';
        cout << endl;
    }
}