#include <bits/stdc++.h>

using namespace std;

#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#else
#define dbg(x) 
#endif

using ll = long long;
using ld = long double;

template <class A>
bool umin(A& x, const A& y) {
    if (x <= y) return false;
    x = y;
    return true;
}

template <class A>
bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}

// #define int ll
#define sz(x) int((x).size())

void solve() {
    int n;
    cin >> n;

    vector<int> p(n);
    for (int& x : p) cin >> x;

    int ans = 0;

    for (int mask = 0; mask < (1 << n); ++mask) {
        int mi = INT_MAX, ma = INT_MIN, res = 0;
        for (int i = 0; i < n; ++i) {
            if (mask >> i & 1) {
                res += umax(ma, p[i]);
            } else {
                res += umin(mi, p[i]);
            }
        }

        umax(ans, res);
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    cin >> T;

    for (int t = 1; t <= T; ++t) {
        solve();    
    }
}