#include <bits/stdc++.h>

#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#define showTest(x) cout << "_____TEST #" << x << "_____\n";
#else
#define dbg(x)
#define showTest(x)
#endif

using namespace std;

using ll = long long;
using ld = long double;

template <class A> 
inline bool umin(A& x, const A&y) {
    if (x <= y) return false;
    x = y;
    return true;
}

template <class A>
inline bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}

// #define int ll
#define sz(x) int((x).size())

void solve() {
    int n;
    cin >> n;

    vector<pair<int, int>> e(n);
    for (auto& [l, r] : e) {
        cin >> l >> r;
    }

    for (int i = 0; i < n / 2; ++i) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    // cin >> T;

    for (int t = 1; t <= T; ++t) {
        showTest(t);
        solve();
    }
}