#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <iomanip>
#include <stdio.h>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <stack>
#include <queue>
#include <cmath>
#include <random>
#include <climits>

using namespace std;

#define int long long
#define endl '\n'

long long mod = 1e9 + 7;

vector<int> getbin(int x, int c)
{
	vector<int> ret;
	for (int j = 0; j < c; j++)
	{
		ret.push_back(x % 2);
		x /= 2;
	}
	return ret;
}

void calc()
{
	vector<vector<int>> all;
	for (int i = 1; i <= 7; i++)
	{
		for (int j = i + 1; j <= 7; j++)
		{
			for (int k = j + 1; k <= 7; k++)
			{
				vector<int> v = { i,j,k };
				all.push_back(v);
			}
		}
	}

	cout << all.size() << endl;
}

void task1()
{
	int n, k;
	cin >> n >> k;

	if (k == 1)
	{
		int x;
		cin >> x;
		x++;
		if (x == n + 1) x = 1;
		cout << x << endl;
		cout.flush();
	}
	else if (k * 2 == n)
	{
		set<int> s;
		for (int j = 0; j < k; j++)
		{
			int x;
			cin >> x;
			s.insert(x);
		}
		for (int j = 1; j <= n; j++)
		{
			if (s.find(j) == s.end())
			{
				cout << j << ' ';
			}
		}
		cout << endl;
		cout.flush();
	}
	else
	{
		int x, y;
		cin >> x >> y;
		if (x == 1 && y == n)
		{
			swap(x, y);
		}

		if ((y == 1 && x == n) || (y == x + 1))
		{
			x += 2;
			y += 2;
			if (x > n) x -= n;
			if (y > n) y -= n;
			if (x > y) swap(x, y);
			cout << x << ' ' << y << endl;
			cout.flush();
		}
		else
		{
			x++;
			y++;
			if (x > n) x -= n;
			if (y > n) y -= n;
			if (x > y) swap(x, y);
			cout << x << ' ' << y << endl;
			cout.flush();
		}
	}
}

void task2()
{
	int n, k;
	cin >> n >> k;

	if (k == 1)
	{
		int x;
		cin >> x;
		x--;
		if (x == 0) x = n;
		cout << x << endl;
		cout.flush();
	}
	else if (k * 2 == n)
	{
		set<int> s;
		for (int j = 0; j < k; j++)
		{
			int x;
			cin >> x;
			s.insert(x);
		}
		for (int j = 1; j <= n; j++)
		{
			if (s.find(j) == s.end())
			{
				cout << j << ' ';
			}
		}
		cout << endl;
		cout.flush();
	}
	else if (k == 2)
	{
		int x, y;
		cin >> x >> y;
		if (x == 1 && y == n)
		{
			swap(x, y);
		}

		if ((y == 1 && x == n) || (y == x + 1))
		{
			x -= 2;
			y -= 2;
			if (x < 1) x += n;
			if (y < 1) y += n;
			if (x > y) swap(x, y);
			cout << x << ' ' << y << endl;
			cout.flush();
		}
		else
		{
			x--;
			y--;
			if (x < 1) x += n;
			if (y < 1) y += n;
			if (x > y) swap(x, y);
			cout << x << ' ' << y << endl;
			cout.flush();
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	int z;
	cin >> z;

	if (z == 1)
	{
		bool multitest = 1;
		int t = 1;
		if (multitest) cin >> t;
		while (t--) task1();
	}
	else
	{
		bool multitest = 1;
		int t = 1;
		if (multitest) cin >> t;
		while (t--) task2();
	}

	//calc();

	return 0;
}
