#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <climits>
#include <deque>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <iomanip>
#include <stdio.h>

using namespace std;

struct Node
{
	vector<int> to;
	int cnt = 0;
	int dp = 0;
};

vector<Node> graph;

int n, k, q;

void dfs(int v, int p, int dir)
{
	for (int i = 0; i < graph[v].to.size(); i++)
	{
		int u = graph[v].to[i];
		if (dir == -1 || (i == 0 && dir == 0) || (i == 1 && dir == 1))
		{
			graph[u].cnt = graph[v].cnt;
		}
		else
		{
			graph[u].cnt = graph[v].cnt + 1;
		}

		dfs(u, v, i);
	}

	if (graph[v].to.size() == 0)
	{
		if (graph[v].cnt <= k)
		{
			graph[v].dp = 1;
		}
		else
		{
			graph[v].dp = 0;
		}
	}
	else
	{
		for (int i = 0; i < graph[v].to.size(); i++)
		{
			int u = graph[v].to[i];
			graph[v].dp += graph[u].dp;
		}
	}
}

void task()
{
	cin >> n >> k >> q;
	graph.resize(n);

	for (int i = 0; i < n; i++)
	{
		int t;
		cin >> t;
		for (int j = 0; j < t; j++)
		{
			int x;
			cin >> x;
			x--;
			graph[i].to.push_back(x);
		}
	}

	dfs(0, -1, -1);

	for (int i = 0; i < q; i++)
	{
		int x;
		cin >> x;
		cout << graph[x-1].dp << endl;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	bool multitest = 0;
	int t = 1;
	if (multitest) cin >> t;
	while (t--) task();

	return 0;
}
