#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <climits>
#include <deque>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <iomanip>
#include <stdio.h>

using namespace std;

#define int long long
#define endl '\n'

int binpow(int x, int y)
{
	if (y == 0) return 1;
	if (y == 1) return x;

	int k = binpow(x, y / 2);
	if (y % 2 == 0) return k * k;
	else return k * k * x;
}

void task()
{
	int n, q;
	cin >> n >> q;
	vector<int> v(n);
	for (int i = 0; i < n; i++) cin >> v[i];
	sort(v.begin(), v.end());

	int z;
	cin >> z;

	while (q--)
	{
		int k, a, b;
		cin >> k >> a >> b;

		for (int i = n - 1; i >= 0; i--)
		{
			if (v[i] <= k)
			{
				k = i + 1;
				break;
			}
		}

		int f = binpow(3, k);
		set<pair<int, int>> s;
		for (int i = 0; i < f; i++)
		{
			vector<int> r;
			int c = i;
			for (int j = 0; j < k; j++)
			{
				r.push_back(c % 3);
				c /= 3;
			}

			int s1 = 0;
			int s2 = 0;
			for (int j = 0; j < k; j++)
			{
				if (r[j] == 1) s1 += v[j];
				else if (r[j] == 2) s2 += v[j];
			}
			s.insert({ s1,s2 });
		}

		bool flag = true;
		for (int i = 0; i <= a; i++)
		{
			for (int j = 0; j <= b; j++)
			{
				if (s.find({ i,j }) == s.end())
				{
					flag = false;
					break;
				}
			}
			if (!flag) break;
		}

		if (flag) cout << "Yes" << endl;
		else cout << "No" << endl;
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	bool multitest = 0;
	int t = 1;
	if (multitest) cin >> t;
	while (t--) task();

	return 0;
}
