#include<bits/stdc++.h>


using namespace std;


vector<pair<int, int>> g;
vector<vector<int>> tree;
vector<int> a;
vector<pair<int, int>> otv;
int LEFT = 0;
int RIGHT = 1;


pair<int, int> dfs(int v, int pred, int cntr)
{
    int i = v;
    if (g[i].first == -1)
    {
        int sz = a.size();
        a.push_back(cntr);
        otv[v] = {sz, sz + 1};
        return {sz, sz + 1};
    }
    int L1, R1, L2, R2;
    if (pred == RIGHT)
    {
        auto [L, R] = dfs(g[i].first, LEFT, cntr + 1);
        L1 = L;
        R1 = R;
    }
    else
    {
        auto [L, R] = dfs(g[i].first, LEFT, cntr);
        L1 = L;
        R1 = R;
    }
    if (pred == LEFT)
    {
        auto [L, R] = dfs(g[i].second, RIGHT, cntr + 1);
        L2 = L;
        R2 = R;
    }
    else
    {
        auto [L, R] = dfs(g[i].second, RIGHT, cntr);
        L2 = L;
        R2 = R;
    }
    otv[v] = {L1, R2};
    return otv[v];
}


void merge_(vector<int>& ans, vector<int>& c, vector<int>& b)
{
    int i = 0;
    int j = 0;
    ans.resize(c.size() + b.size());
    while (i < c.size() || j < b.size())
    {
        if (c.size() == i)
        {
            ans[i + j] = b[j];
            j++;
        }
        else if (b.size() == j || b[j] > c[i])
        {
            ans[i + j] = c[i];
            i++;
        }
        else
        {
            ans[i + j] = b[j];
            j++;
        }
    }
    return;
}


void build(int k, int l, int r)
{
    if (r - l == 1)
    {
        tree[k] = {a[l]};
        return;
    }
    int mid = (r + l) >> 1;
    build(2 * k, l, mid);
    build(2 * k + 1, mid, r);
    merge_(tree[k], tree[2 * k], tree[2 * k + 1]);
    return;
}


int get_cnt(int k, int l, int r, int lf, int rf, int x)
{
    if (lf >= r || l >= rf)
    {
        return 0;
    }
    if (l >= lf && r <= rf)
    {
        int ans = upper_bound(tree[k].begin(), tree[k].end(), x) - tree[k].begin();
        return ans;
    }
    int mid = (r + l) >> 1;
    return get_cnt(2 * k, l, mid, lf, rf, x) + get_cnt(2 * k + 1, mid, r, lf, rf, x);
}


int main()
{
    int n, k, q;
    cin >> n >> k >> q;
    g.resize(n, {-1, -1});
    otv.resize(n, {-1, -1});
    for (int i = 0; i < n; i++)
    {
        int t;
        cin >> t;
        if (t == 2)
        {
            cin >> g[i].first >> g[i].second;
            g[i].first--;
            g[i].second--;
        }
    }
    dfs(0, -1, 0);
    tree.resize(4 * a.size());
    build(1, 0, a.size());
    for (int Q = 0; Q < q; Q++)
    {
        int u;
        cin >> u;
        u--;
        cout << get_cnt(1, 0, a.size(), otv[u].first, otv[u].second, k) << '\n';
    }
    return 0;
}
