#include<bits/stdc++.h>
# pragma GCC optimize target("avx, avx2")

using namespace std;


bool is_in(int l, int r, int p)
{
    return p >= l && p <= r;
}


bool inter(int l1, int r1, int l2, int r2)
{
    return is_in(l1, r1, l2) || is_in(l1, r1, r2) || is_in(l2, r2, l1) || is_in(l2, r2, r1);
}


int cnt(vector<tuple<int, int, int>>& otr, int n)
{
    set<tuple<int, int, int>> mx;
        vector<int> pred(n, -1);
        int mxpred = 0;
        int pr = -1;
        int mxall = 1;
        int last = 0;
        for (auto [l, r, i]: otr)
        {
            while (mx.size() > 0 && get<0>(*mx.begin()) < l)
            {
                auto [r1, j, mxnw] = *mx.begin();
                mx.erase(mx.begin());
                if (mxnw > mxpred)
                {
                    mxpred = mxnw;
                    pr = j;
                }
            }
            int mxnow = mxpred + 1;
            pred[i] = pr;
            mx.insert({r, i, mxnow});
            if (mxnow > mxall)
            {
                mxall = mxnow;
                last = i;
            }
        }
        vector<int> ans;
        int nw = last;
        vector<bool> used(n);
        while (nw != -1)
        {
            ans.push_back(nw);
            used[nw] = true;
            nw = pred[nw];
        }
    return mxall;
}


int cntbit(int x)
{
    int ans = 0;
    while (x > 0)
    {
        ans += x & 1;
        x >>= 1;
    }
    return ans;
}





int main()
{
    int t;
    cin >> t;
    for (int T = 0; T < t; T++)
    {
        int n;
        cin >> n;
        vector<tuple<int, int, int>> otr(n);
        vector<pair<int, int>> otr1(n);
        for (int i = 0; i < n; i++)
        {
            int l, r;
            cin >> l >> r;
            otr1[i] = {l, r};
            otr[i] = {l, r, i};
        }
        sort(otr.begin(), otr.end());
        int mxall = cnt(otr, n);
        for (int mask = 0; mask < (1 << n); mask++)
        {
            if (cntbit(mask) == n / 2)
            {
                vector<tuple<int, int, int>> otrnw;
                for (int j = 0; j < n; j++)
                {
                    if ((mask >> j) & 1)
                    {
                        otrnw.push_back({otr1[j].first, otr1[j].second, j});
                    }
                }
                sort(otrnw.begin(), otrnw.end());
                int mxnw = cnt(otrnw, n);
                if (mxnw == mxall / 2)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if ((mask >> j) & 1)
                        {
                            cout << j + 1 << ' ';
                        }
                    }
                    cout << endl;
                    break;
                }
            }
        }
    }
    return 0;
}
