#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;

vector<vector<int>> g;
vector<int> order;
vector<int> tin, tout;
int timer = 0, k;
vector<int> cnt;

void dfs(int v, int last = -1) {
    tin[v] = timer++;
    order.push_back(cnt[v] <= k);
    if (!g[v].empty()) {
        if (last == 0) {
            cnt[g[v][0]] = cnt[v];
            cnt[g[v][1]] = cnt[v] + 1;
        } else if (last == 1) {
            cnt[g[v][0]] = cnt[v] + 1;
            cnt[g[v][1]] = cnt[v];
        } else {
            cnt[g[v][0]] = cnt[v];
            cnt[g[v][1]] = cnt[v];
        }
        dfs(g[v][0], 0);
        dfs(g[v][1], 1);
    }
    tout[v] = timer++;
    order.push_back(cnt[v] <= k);
}

void solve() {
    int n, q;
    cin >> n >> k >> q;
    g.resize(n);
    cnt.resize(n);
    tin.resize(n);
    tout.resize(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            l--, r--;
            g[i] = {l, r};
        }
    }
    dfs(0);
    vector<int> pref(2 * n + 1);
    for (int i = 0; i < 2 * n; i++) {
        pref[i + 1] = pref[i] + order[i];
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << (pref[tout[v] + 1] - pref[tin[v]]) / 4 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}