#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;

int x, y, m;

vector<vector<int>> g;

vector<pair<int, int>> dp;

void dfs_calc(int v, int p) {
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs_calc(u, v);
        dp[v].X += dp[u].Y;
        dp[v].Y += max(dp[u].X, dp[u].Y);
    }
}

vector<bool> ans_get_ans;

void dfs_get_ans(int v, int p, int type = -1) {
    ans_get_ans[v] = type == -1 && dp[v].X >= dp[v].Y;
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs_get_ans(u, v, ans_get_ans[v] ? 1 : -1);
    }
}

pair<int, int> calc(int n, const vector<int> &a) {
    dp.assign(n, {});
    for (int i = 0; i < n; i++) {
        dp[i] = {a[i], 0};
    }
    dfs_calc(0, 0);
    int k = 0;
    for (int i = 0; i < n; i++) {
        k ^= (x * (i + 1) + y * ((a[i] * a[i]) % m)) % m;
    }
    ans_get_ans.assign(n, false);
    dfs_get_ans(0, 0);
    return {max(dp[0].X, dp[0].Y), k};
}

void solve() {
    int n, q;
    cin >> n >> q;
    cin >> x >> y >> m;
    g.assign(n, vector<int>());
    for (int i = 0; i < n - 1; i++) {
        int s, f;
        cin >> s >> f;
        s--, f--;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    vector<int> v(q);
    for (int i = 0; i < q; i++) {
        cin >> v[i];
    }
    vector<int> a = r;
    a[0] = 0;
    pair<int, int> ans = calc(n, a);
    vector<pair<int, int>> sort_v(q);
    for (int i = 0; i < q; i++) {
        sort_v[i] = {v[i], i};
    }
    sort(all(sort_v));
    vector<int> cur_a = l;
    vector<int> ans_v(q);
    int now = 1;
    int sum = 0;
    int cur_k = 0;
    for (int i = 0; i < n; i++) {
        cur_k ^= (x * (i + 1) + y * ((l[i] * l[i]) % m)) % m;
        sum += l[i];
    }
    sum -= l[0];
    int cur_k_start = cur_k;
    int sum_l = sum;
    for (int i = 0; i < q; i++) {
        if (l[0] <= sort_v[i].X && sort_v[i].X <= r[0] && sort_v[i].X >= sum_l) {
            ans_v[sort_v[i].Y] = cur_k_start;
            ans_v[sort_v[i].Y] ^= (x + y * ((l[0] * l[0]) % m)) % m;
            ans_v[sort_v[i].Y] ^= (x + y * ((sort_v[i].X * sort_v[i].X) % m)) % m;
        } else if (sum_l <= sort_v[i].X && sort_v[i].X <= ans.X) {
            while (sum < sort_v[i].X) {
                while (!ans_get_ans[now] || cur_a[now] == r[now]) {
                    now++;
                }
                if (sort_v[i].X - sum >= r[now] - cur_a[now]) {
                    sum += r[now] - cur_a[now];
                    cur_k ^= (x * (now + 1) + y * ((cur_a[now] * cur_a[now]) % m)) % m;
                    cur_a[now] = r[now];
                    cur_k ^= (x * (now + 1) + y * ((cur_a[now] * cur_a[now]) % m)) % m;
                } else {
                    cur_k ^= (x * (now + 1) + y * ((cur_a[now] * cur_a[now]) % m)) % m;
                    cur_a[now] += sort_v[i].X - sum;
                    cur_k ^= (x * (now + 1) + y * ((cur_a[now] * cur_a[now]) % m)) % m;
                    sum = sort_v[i].X;
                }
            }
            ans_v[sort_v[i].Y] = cur_k;
        } else {
            ans_v[sort_v[i].Y] = -1;
        }
    }
    for (int w : ans_v) {
        cout << w << ' ';
    }
    cout << endl;
    int ind;
    cin >> ind;
    while (ind != 0) {
        ind--;
        if (l[0] <= v[ind] && v[ind] <= r[0] && v[ind] >= sum_l) {
            cout << v[ind] << ' ';
            for (int i = 1; i < n; i++) {
                cout << l[i] << ' ';
            }
            cout << endl;
        } else if (sum_l <= v[ind] && v[ind] <= ans.X) {
            cur_a = l;
            now = 1;
            sum = sum_l;
            while (sum < v[ind]) {
                while (!ans_get_ans[now] || cur_a[now] == r[now]) {
                    now++;
                }
                if (v[ind] - sum >= r[now] - cur_a[now]) {
                    sum += r[now] - cur_a[now];
                    cur_a[now] = r[now];
                } else {
                    cur_a[now] += v[ind] - sum;
                    sum = v[ind];
                }
            }
            for (int w : cur_a) {
                cout << w << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> ind;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();
}