#include <bits/stdc++.h>

#define int long long
using namespace std;

signed main() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(301, vector<bool>(301, false)));
    for (int i = 0; i < n + 1; ++i) {
        dp[i][0][0] = true;
    }
    sort(w.begin(), w.end());
    for (int i = 1; i < n + 1; ++i) {
        for (int j = 0; j < 301; ++j) {
            for (int l = 0; l < 301; ++l) {
                dp[i][j][l] = dp[i - 1][j][l];
                if (w[i - 1] <= j && dp[i - 1][j - w[i - 1]][l]) {
                    dp[i][j][l] = true;
                }
                if (w[i - 1] <= l && dp[i - 1][j][l - w[i - 1]]) {
                    dp[i][j][l] = true;
                }
            }
        }
    }
    vector<vector<vector<bool>>> pref(n + 1, vector<vector<bool>>(301, vector<bool>(301, false)));
    for (int i = 0; i < 301; ++i) {
        for (int j = 0; j < 301; ++j) {
            pref[0][i][j] = dp[0][i][j];
            for (int k = 1; k < n + 1; ++k) {
                pref[k][i][j] = pref[k - 1][i][j] | dp[k][i][j];
            }
        }
    }
    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < 301; ++j) {
            for (int k = 1; k < 301; ++k) {
                pref[i][j][k] = pref[i][j][k - 1] & pref[i][j][k];
            }
        }
    }
    for (int i = 0; i < n + 1; ++i) {
        for (int j = 0; j < 301; ++j) {
            for (int k = 1; k < 301; ++k) {
                pref[i][k][j] = pref[i][k - 1][j] & pref[i][k][j];
            }
        }
    }
    int z;
    cin >> z;
    while (q--) {
        int k, a, b;
        cin >> k >> a >> b;
        int idx = upper_bound(w.begin(), w.end(), k) - w.begin();
        if (pref[idx][a][b]) {
            cout << "Yes";
        } else {
            cout << "No";
        }
        cout << "\n";
    }
}