#include <iostream>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<ll>> g;

vector<ll> ans, nxt;

void dfs(ll v) {
    ans[v] = 1;
    for (ll to : g[v]) {
        if (ans[to] == -1) {
            dfs(to);
        }
        if (ans[to] + 1 > ans[v]) {
            ans[v] = ans[to] + 1;
            nxt[v] = to;
        }
    }
}


int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        g.assign(n, {});

        vector<pair<ll, ll>> seg(n);
        for (ll i = 0; i < n; i++) cin >> seg[i].first >> seg[i].second;

        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {

                if (seg[i].second < seg[j].first) {
                    g[i].push_back(j);
                }
            }
        }

        ans.assign(n, -1);
        nxt.assign(n, -1);
        for (ll i = 0; i < n; i++) {
            if (ans[i] == -1) {
                dfs(i);
            }
        }

        ll ind = max_element(ans.begin(), ans.end()) - ans.begin();
        ll m = ans[ind] / 2;
        assert(ans[ind] % 2 == 0);
        vector<bool> used(n);
        vector<ll> out;
        ll v = ind;
        for (ll i = 0; i < m; i++) {
            used[v] = true;
            out.push_back(v);
            v = nxt[v];
        }
        for (ll to : g[v]) {
            used[to] = true;
        }

        for (ll i = 0; i < n; i++) {
            if (!used[i] && out.size() < n / 2) {
                out.push_back(i);
            }
        }

        assert(out.size() == n / 2);

        for (ll w : out) cout << w + 1 << " ";
        cout << "\n";
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
