#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define int short

//constexpr int INF = 2e9;
constexpr int INF = 30000;
typedef int64_t ll;

bool STRS;

struct st {
    vector<int> dt;
    vector<int> ps;
    int sz = 0;

    st() {}
    st(int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        dt.resize(sz * 2, -INF);
        ps.resize(sz * 2, INF);
    }

    void push(int id) {
        if (ps[id] == INF) {
            return;
        }
        if (id < sz) {
            ps[id * 2] = ps[id];
            ps[id * 2 + 1] = ps[id];
        }
        dt[id] = ps[id];
        ps[id] = INF;
    }

    int get(int l, int r, int ld, int rd, int id) {
        push(id);
        if (l >= rd || r <= ld) return -INF;
        if (l <= ld && rd <= r) return dt[id];
        return max(get(l, r, ld, (ld + rd) / 2, id * 2), get(l, r, (ld + rd) / 2, rd, id * 2 + 1));
    }

    int get(int l, int r) {
        return get(l, r, 0, sz, 1);
    }

    void set(int l, int r, int vl, int ld, int rd, int id, bool len) {
        push(id);
        if (l >= rd || r <= ld) return;
        if (l <= ld && rd <= r) {
            if (len && dt[id] > vl) {
                return;
            }
            ps[id] = vl;
            push(id);
            return;
        }
        set(l, r, vl, ld, (ld + rd) / 2, id * 2, len);
        set(l, r, vl, (ld + rd) / 2, rd, id * 2 + 1, len);
        dt[id] = max(dt[id * 2], dt[id * 2 + 1]);
    }

    void set(int l, int r, int vl, bool len) {
        set(l, r, vl, 0, sz, 1, len);
    }
};

struct Solution {
    int TEST = -1;

    Solution(int TEST = -1) : TEST(TEST) {}

    signed operator()() {
        int n; cin >> n;
        vector<st> dp_min(n + 2, st(n + 2));
        vector<st> dp_max(n + 2, st(n + 2));
        auto stpt = [&](int i, int j, int vl, bool len) {
            dp_min[i].set(j, j + 1, vl, len);
            dp_max[j].set(i, i + 1, vl, len);
        };
        stpt(n + 1, 0, 0, false);
        for (int _ = 0; _ < n; ++_) {
            int x; cin >> x;
            vector<int> nvl1(n + 2, -INF);
            for (int j = 0; j <= n + 1; ++j) {
                nvl1[j] = dp_max[j].get(x + 1, n + 2);
            }
            vector<int> nvl2(n + 2, -INF);
            for (int i = 0; i <= n + 1; ++i) {
                nvl2[i] = dp_min[i].get(0, x);
            }
            for (int j = 0; j <= n + 1; ++j) {
                stpt(x, j, nvl1[j] + 1, true);
            }
            for (int i = 0; i <= n + 1; ++i) {
                stpt(i, x, nvl2[i] + 1, true);
            }
            for (int i = x + 1; i <= n + 1; ++i) {
                dp_min[i].set(0, x, -INF, false);
            }
            for (int j = 0; j < x; ++j) {
                dp_max[j].set(x + 1, n + 2, -INF, false);
            }
        }
        int ans = 0;
        for (int i = 1; i <= n; ++i) {
            ans = max(ans, dp_min[i].get(1, n + 1));
        }
        cout << ans << "\n";
        return 0;
    }
};

mt19937 rnd(228);

signed main() {
//    cout << SHRT_MAX << endl;
    (*cin.tie(nullptr)).sync_with_stdio(false);
    int t; cin >> t;
    for (int test = 1; test <= t; ++test) {
        int res = Solution(test )();
        if (res != 0) {
            return res;
        }
    }
    return 0;
}
//1
//7
//1 4 2 3 7 6 5

//
//4
//5
//4 1 2 3 5
//10
//3 8 10 4 1 2 7 9 5 6
//3
//1 2 3
//6
//4 2 5 1 6 3

//set print array on
//set print array-indexes on
//set print pretty on

//print -array -array-indexes -pretty --

//ERR 245 SMR: 6 STP: 5
//7
//1 4 2 3 7 6 5


//ERR 372 SMR: 8 STP: 7
//9
//1 2 3 6 4 5 9 8 7