#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
using namespace std;
typedef long long ll;
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n, q;
	cin >> n >> q;
	ll z;
	vector<ll> w(n);
	for (ll i = 0; i < n; ++i) cin >> w[i];
	sort(w.begin(), w.end());
	cin >> z;
	if (n <= 10) {
		while (q--) {
			ll k, a, b;
			cin >> k >> a >> b;
			set<pair<ll, ll>> S;
			ll x = 1;
			for (ll i = 0; i < n && w[i] <= k; ++i) x *= 3;
			for (ll i = 0; i < x; ++i) {
				ll z1 = i, A = 0, B = 0;
				for (ll j = 0; j < n && w[j] <= k; ++j) {
					if (z1 % 3 == 1) A += w[j];
					if (z1 % 3 == 2) B += w[j];
					z1 /= 3;
				}
				if (A <= a && B <= b) S.insert({ A, B });
			}
			if ((ll)S.size() < (a + 1) * (b + 1)) cout << "No\n";
			else cout << "Yes\n";
		}
	}
	else {
		vector<ll> K(q), A(q), B(q);
		ll mxa = 0, mxb = 0;
		for (ll i = 0; i < q; ++i) cin >> K[i] >> A[i] >> B[i], mxa = max(mxa, A[i]), mxb = max(mxb, B[i]);
		vector<vector<vector<ll>>> dp(n, vector<vector<ll>>(mxa + 1, vector<ll>(mxb + 1, 0)));
		for (ll i = 0; i < n; ++i) {
			for (ll j = 0; j <= mxa; ++j) {
				for (ll k = 0; k <= mxb; ++k) {
					if (i) {
						dp[i][j][k] = max(dp[i - 1][j][k], dp[i][j][k]);
						if (j >= w[i] && dp[i - 1][j - w[i]][k]) dp[i][j][k] = 1;
						if (k >= w[i] && dp[i - 1][j][k - w[i]]) dp[i][j][k] = 1;
					}
					else if ((j == 0 && k == 0) || (j == 0 && k == w[i]) || (j == w[i] && k == 0)) dp[i][j][k] = 1;
				}
			}
		}
		for (ll i = 0; i < n; ++i) {
			for (ll j = 0; j <= mxa; ++j) {
				for (ll k = 0; k <= mxb; ++k) {
					if (k) dp[i][j][k] = min(dp[i][j][k], dp[i][j][k - 1]);
					if (j) dp[i][j][k] = min(dp[i][j][k], dp[i][j - 1][k]);
				}
			}
		}
		for (ll i = 0; i < q; ++i) {
			ll k = K[i], a = A[i], b = B[i];
			ll L = -1, R = n;
			while (R - L > 1) {
				ll M = (L + R) / 2;
				if (w[M] > k) R = M;
				else L = M;
			}
			if (L == -1) {
				if (a == 0 && b == 0) cout << "Yes\n";
				else cout << "No\n";
			}
			else if (dp[L][a][b]) cout << "Yes\n";
			else cout << "No\n";
		}
	}
	cout << endl;
	return 0;
}