#include <map>
#include <iostream>
#include <utility>
#include <vector>
#include <stack>
#include <cmath>
#include <algorithm>
using namespace std;
typedef long long ll;
void bt(vector<ll>& V)
{
	int nn = pow(2, int(log(V.size()) / log(2) + 1));
	V.resize(2 * nn);
}
ll rmq_up(vector<ll>& V, int l, int r)
{
	int n = V.size() / 2;
	l += n; r += n;
	ll otv = 0;
	while (l <= r)
	{
		if (l % 2 == 1)
			otv += V[l];
		if (r % 2 == 0)
			otv += V[r];
		l = (l + 1) / 2; r = (r + 1) / 2;
	}
	return otv;
}
void upd(vector<ll>& V, int p, ll x)
{
	int n = V.size() / 2;
	p += n;
	V[p] += x;
	while (p > 1)
	{
		p /= 2;
		V[p] += x;
	}
}
int main()
{
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	//FILE* stream1; freopen_s(&stream1, "input.txt", "r", stdin);
	int n, q;
	cin >> n >> q;
	vector<ll> vv(n);
	for (int i = 0; i < n; i++)
		cin >> vv[i];
	sort(vv.begin(), vv.end());
	int z;
	cin >> z;
	for (int uu = 0; uu < q; uu++)
	{
		ll k, a, b;
		cin >> k >> a >> b;
		int kol = 0;
		for (int i = 0; i < n; i++)
			if (vv[i] <= k)
				kol++;
		if (a > 10000)
		{
			cout << "No" << endl;
			break;
		}
		vector<ll> otvv(a+1);
		
		for (int u = 0; u < pow(2, kol); u++)
		{
			vector<int> aa;
			int buf = u;
			while (buf > 1)
			{
				aa.push_back(buf % 2);
				buf /= 2;
			}
			aa.push_back(buf);
			while (aa.size() < kol)
				aa.push_back(0);
			ll maxx1 = 0, maxx2 = 0;
			for (int i = 0; i < kol; i++)
			{
				if (aa[i])
				{
						maxx1 = maxx1 + vv[i];
				}
				else
				{
					if (vv[i] <= maxx2 + 1)
						maxx2 = maxx2 + vv[i];
				}
			}
			if (maxx1 <= a)
				otvv[maxx1] = max(otvv[maxx1], maxx2);
		}
		string otv = "Yes";
		for (int i = 0; i <= a; i++)
			if (otvv[i] < b)
				otv = "No";
		cout << otv << endl;
	}
	return 0;
}