#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

void solven3(int n) {
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<vector<vector<int>>> dp(2, vector<vector<int>>(n + 2, vector<int>(n + 2, -1000000000)));
    dp[0][n + 1][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int minel = 0; minel <= n + 1; minel++) {
            for (int maxel = 0; maxel <= n + 1; maxel++) {
                dp[(i + 1) & 1][minel][maxel] = -1000000000;
            }
        }
        // cur is min
        for (int maxel = 0; maxel <= n + 1; maxel++) {
            for (int j = a[i] + 1; j <= n + 1; j++) {
                dp[(i + 1) & 1][a[i]][maxel] = max(dp[(i + 1) & 1][a[i]][maxel], dp[i & 1][j][maxel] + 1);
            }
            for (int j = 0; j <= a[i]; j++) {
                dp[(i + 1) & 1][j][maxel] = max(dp[(i + 1) & 1][j][maxel], dp[i & 1][j][maxel]);
            }
        }
        // cur is max
        for (int minel = 0; minel <= n + 1; minel++) {
            for (int j = 0; j < a[i]; j++) {
                dp[(i + 1) & 1][minel][a[i]] = max(dp[(i + 1) & 1][minel][a[i]], dp[i & 1][minel][j] + 1);
            }
            for (int j = a[i]; j <= n + 1; j++) {
                dp[(i + 1) & 1][minel][j] = max(dp[(i + 1) & 1][minel][j], dp[i & 1][minel][j]);
            }
        }
    }
    int bestres = 0;
    for (int minel = 0; minel <= n + 1; minel++) {
        for (int maxel = 0; maxel <= n + 1; maxel++) {
            bestres = max(bestres, dp[n & 1][minel][maxel]);
        }
    }

    cout << bestres << "\n";
}

void solvelis(int n) {
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }

    vector<int> last;
    vector<int> cnt;

    for (int i = 0; i < n; i++) {
        int cadd = upper_bound(last.begin(), last.end(), a[i]) - last.begin();
        if (cadd == (int)last.size()) {
            last.emplace_back(1000000000);
            cnt.emplace_back(0);
        }
        last[cadd] = a[i];
        cnt[cadd]++;
    }

    int lcssize = last.size();
    int maxcnt = 0;
    for (int i = 0; i < lcssize; i++) {
        maxcnt = max(maxcnt, cnt[i]);
    }
    cout << lcssize + maxcnt - 1 << "\n";
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        int n;
        cin >> n;
        solvelis(n);
    }
    return 0;
}