#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define int int_fast64_t
#define nx << ' ' <<
#define all(a) a.begin(), a.end()
#define cft int t; cin >> t; while(t--);

using namespace std;

void encode() {
	set<int> canuse;
	vector<int> nc;
	vector<int> result;
	int n, k;
	cin >> n >> k;
	for (int i = 1; i <= 2 * n; ++i) {
		canuse.insert(i);
	}
	for (int i = 0; i < k; ++i) {
		int l;
		cin >> l;
		nc.push_back(l);
		canuse.erase(l);
	}
	for (auto v : nc) {
		int i = *canuse.lower_bound(v);
		if (i > n) {
			i -= n;
		}
		result.push_back(i);
		canuse.erase(i);
		canuse.erase(i + n);
	}
	sort(all(result));
	for (auto i : result) {
		cout << i << ' ';
	}
	cout << endl;
}

void decode() {
	set<int> canuse;
	vector<int> nc;
	vector<int> result;
	int n, k;
	cin >> n >> k;
	for (int i = 1; i <= n; ++i) {
		canuse.insert(i);
	}
	for (int i = 0; i < k; ++i) {
		int l;
		cin >> l;
		nc.push_back(l);
		canuse.erase(l);
	}
	for (auto v : nc) {
		auto it = canuse.lower_bound(v);
		if (it == canuse.begin()) {
			it = canuse.lower_bound(v + n);
		}
		--it;
		result.push_back(*it);
		canuse.erase(*it);
	}
	sort(all(result));
	for (int i : result) {
		cout << i << ' ';
	}
	cout << endl;
}

signed main() {
	int l;
	cin >> l;
	if (l == 1) {
		int t;
		cin >> t;
		while(t--)
			encode();
	}
	else {
		int t;
		cin >> t;
		while (t--)
			decode();
	}
}