#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr int MAXN = 502;
short dp[2][MAXN][MAXN * 2];
pair<bool, short> src[MAXN][MAXN][MAXN * 2];

void update(int a1, int a2, int a3, int b1, int b2, int b3, int add) {
    //assert(b1 == a1 - 1);
    if (dp[a1%2][a2][a3] < add + dp[b1%2][b2][b3]) {
        dp[a1%2][a2][a3] = add + dp[b1%2][b2][b3];
        src[a1][a2][a3] = {a2 - b2 == 1, b3};
    }
}
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    int t;
    cin >> t;
    while (t --> 0) {
        int n;
        cin >> n;
//        memset(**dp, 0xaf, sizeof(dp));
        for (int i = 0; i <= n; ++i) {
            for (int j = 0; j <= n; ++j) {
                memset(dp[i][j], 0xaf, sizeof(dp[0][0][0]) * (2 * n + 1));
            }
        }
        vector<int> l(n), r(n);
        vector<int> cs(2 * n);
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
            cs[i] = l[i];
            cs[i + n] = r[i];
        }
        std::sort(cs.begin(), cs.end());
        cs.resize(std::unique(begin(cs), end(cs)) - begin(cs));
//        vector<vector<int>> s(cs.size());
        for (int i = 0; i < n; ++i) {
            l[i] = std::lower_bound(cs.begin(), cs.end(), l[i]) - cs.begin();
            r[i] = std::lower_bound(cs.begin(), cs.end(), r[i]) - cs.begin();
//            s[l[i]].push_back(i);
        }
        vector<int> rng(n);
        std::iota(rng.begin(), rng.end(), 0);
        std::sort(rng.begin(), rng.end(), [&](int lhs, int rhs) {
            return make_pair(r[lhs], l[lhs]) < make_pair(r[rhs], l[rhs]);
        });
        dp[0][0][0] = 0;
        for (int i = 0; i < n; ++i) {
//            cerr << rng[i] << ' ';
            for (int prev_c = 0; prev_c <= (int)cs.size(); ++prev_c) {
                for (int prev_skip = 0; prev_skip <= i; ++prev_skip) {
                    if (dp[i%2][prev_skip][prev_c] < 0) {
                        continue;
                    }
                    update(i + 1, prev_skip + 1, prev_c, i, prev_skip, prev_c, 0);
                    if (prev_c <= l[rng[i]]) {
                        update(i + 1, prev_skip, 1 + r[rng[i]], i, prev_skip, prev_c, 1);
                    } else {
                        update(i + 1, prev_skip, prev_c, i, prev_skip, prev_c, 0);
                    }
                }
            }
            memset(dp[i & 1][0], 0xaf, sizeof(dp[0][0][0]) * (2 * n + 1));
        }
        int kek = *max_element(dp[n&1][0], dp[n&1][0] + 2 * n + 1);
        assert(kek % 2 == 0);
//        cerr << kek << '\n';
        int x = n, y = n / 2, z = -1;
        for (int j = 0; j <= (int)cs.size(); ++j) {
            if (dp[n&1][n / 2][j] == kek / 2) {
                z = j;
                break;
            }
        }
        assert(z != -1);
        vector<bool> v(n, true);
        while (x > 0) {
            auto up = src[x][y][z];
            if (!up.first) {
                cout << rng[x - 1] + 1 << ' ';
            }
            --x;
            y -= up.first;
            z = up.second;
        }
        cout << '\n';
    }
    return 0;
}