#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

void group1_1(int n, int k) {
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }

    set<int> ans;
    for (int i = 0; i < k; ++i) {
        ans.insert((a[i] - 1 + (n + 1) / 2) % n + 1);
    }

    for (int x: ans) {
        cout << x << " ";
    }
    cout << endl;
}

void group1_2(int n, int k) {
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }

    set<int> ans;
    for (int i = 0; i < k; ++i) {
        ans.insert((a[i] - 1 - (n + 1) / 2 + n) % n + 1);
    }

    for (int x: ans) {
        cout << x << " ";
    }
    cout << endl;
}

void group3_1(int n, int k) {
    int ai;
    set<int> ans;
    for (int i = 1; i <= n; ++i) {
        ans.insert(i);
    }
    for (int i = 0; i < k; ++i) {
        cin >> ai;
        ans.erase(ai);
    }

    for (int x: ans) {
        cout << x << "\n";
    }
}

void group3_2(int n, int k) {
    int ai;
    set<int> ans;
    for (int i = 1; i <= n; ++i) {
        ans.insert(i);
    }
    for (int i = 0; i < k; ++i) {
        cin >> ai;
        ans.erase(ai);
    }

    for (int x: ans) {
        cout << x << "\n";
    }
}

void group2_1(int n, int k) {
    int a, b;
    cin >> a >> b;

    if (a + 1 == b || a == 1 && b == n) {
        int c = (a + 1) % n + 1, d = (b + 1) % n + 1;
        if (d < c) swap(c, d);

        cout << c << " " << d << endl;
    } else {
        int c = a % n + 1, d = b % n + 1;
        if (d < c) swap(c, d);

        cout << c << " " << d << endl;
    }
}

void group2_2(int n, int k) {
    int a, b;
    cin >> a >> b;

    if (a + 1 == b || a == 1 && b == n) {
        int c = (a - 3 + n) % n + 1, d = (b - 3 + n) % n + 1;
        if (d < c) swap(c, d);

        cout << c << " " << d << endl;
    } else {
        int c = (a - 2 + n) % n + 1, d = (b - 2 + n) % n + 1;
        if (d < c) swap(c, d);

        cout << c << " " << d << endl;
    }
}

map<vector<int>, vector<int>> group7a, group7b;

vector<int> b_to_v(int b) {
    vector<int> v;
    for (int i = 0; i < 7; ++i) {
        if ((b >> i) & 1) {
            v.push_back(i + 1);
        }
    }
    return v;
}

bool is_ok(const vector<int> &a, const vector<int> &b) {
    for (int i = 0; i < a.size(); ++i) {
        for (int j = 0; j < b.size(); ++j) {
            if (a[i] == b[j]) {
                return false;
            }
        }
    }
    return true;
}

void init() {
    for (int i = 0; i < (1 << 7); ++i) {
        if (__builtin_popcount(i) != 3) continue;
        vector<int> a = b_to_v(i);
        for (int j = (1 << 7) - 1; j >= 0; --j) {
            if (__builtin_popcount(j) != 3) continue;
            vector<int> b = b_to_v(j);
            if (!is_ok(a, b)) continue;
            if (group7b.count(b)) continue;

            group7a[a] = b;
            group7b[b] = a;
            break;
        }
    }
//
//    for (auto [x, y] : group7a) {
//        for (int z : x) {
//            cerr << z << " ";
//        }
//        cerr << "<-> ";
//        for (int z : y) {
//            cerr << z << " ";
//        }
//        cerr << "\n";
//    }
//
//    cout << group7a.size() << " " << group7b.size() << "\n";
//    assert(group7a.size() == 35);
//    assert(group7b.size() == 35);
}

void group4_1(int n, int k) {
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }

    vector<int> ans = group7a[a];
    for (int x : ans) {
        cout << x << " ";
    }
    cout << endl;
}

void group4_2(int n, int k) {
    vector<int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }

    vector<int> ans = group7b[a];
    for (int x : ans) {
        cout << x << " ";
    }
    cout << endl;
}

void solve1() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        group1_1(n, k);
    } else if (2 * k == n) {
        group3_1(n, k);
    } else if (k == 2) {
        group2_1(n, k);
    } else {
        group4_1(n, k);
    }
}

void solve2() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        group1_2(n, k);
    } else if (2 * k == n) {
        group3_2(n, k);
    } else if (k == 2) {
        group2_2(n, k);
    } else {
        group4_2(n, k);
    }
}

int main() {
#ifndef NEKSTAS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    init();

    int a, t = 1;
    cin >> a >> t;
    for (int i = 0; i < t; ++i) {
        if (a == 1) {
            solve1();
        } else {
            solve2();
        }
    }
}
