#include <bits/stdc++.h>
#define int long long

using namespace std;

void solve1() {
  const int MAX = 600'001;
  int n, k;
  cin >> n >> k;
  vector<int> a(k);
  set<int> q;
  for (int i = 0; i < k; i++) {
    cin >> a[i];
    q.insert(a[i]);
  }
  set<int> free;
  for (int i = 1; i <= min(n, MAX); i++)
    free.insert(i);
  for (int i = 0; i < k; i++)
    free.erase(a[i]);
  vector<int> ans(k);
  for (int i = 0; i < k; i++) {
    auto R = free.upper_bound(a[i]);
    if (R == free.end()) {
      ans[i] = *free.begin();
      free.erase(free.begin());
    } else {
      ans[i] = *R;
      free.erase(R);
    }
  }
  for (auto& i : ans) cout << i << ' ';
  cout << '\n';
}

void solve2() {
  int n, k;
  cin >> n >> k;
  vector<int> a(k);
  for (auto& i : a) cin >> i;
  for (int i = 0; i < k; i++) {
    if (a[i] == 1) {
      cout << n << ' ';
    } else {
      cout << a[i] - 1 << ' ';
    }
  }
  cout << '\n';
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int run;
  cin >> run;
  if (run == 1) {
    int q;
    cin >> q;
    while (q--) {
      solve1();
    }
  } else {
    int q;
    cin >> q;
    while (q--) {
      solve2();
    }
  }
}